UNIT vactda;
INTERFACE
USES Windows, Messages, SysUtils, Classes,  Graphics, Controls, Forms,
     Dialogs, StdCtrls, ExtCtrls, Grids,    vzlocom,  vactiv0,  varfun,
     vactiv2, vacthlp,  vpeaksr,  vstdcons, vactiv3;

PROCEDURE InputSpecFileNames;
PROCEDURE EnterCalibrationData(nreac:INTEGER);
PROCEDURE InputMarkingData;
PROCEDURE EditMarkingData;
PROCEDURE EnterMarkingEnergies;
PROCEDURE FittheRadCalibr;

IMPLEMENTATION
PROCEDURE FittheRadCalibr;
{ Purpose: To fit data with unordered arguments: calibration case
  Version: Dec 15 1997}
{Purpose: To minimize    [a*X_j+b - E_j]^2  over [a,b];
          where X_j := ARG MIN | E_j - a*X_k - b | over [X_k];
 Version: Sep 10 1997;}
CONST euar:ARRAY[1..10] OF REAL = (121.782, 244.691, 344.267,
      443.940, 778.914, 867.383, 964.070, 1085.835, 1112.065, 1407.974);
      ra226ar:ARRAY[1..7] OF REAL=(186.1, 241.9, 295.2, 352.0,
                                  609.4, 1120.0, 1764.0);
      eu152ar:ARRAY[1..7] OF REAL=(121.7824, 244.6989, 344.2811,
                                   778.925, 964.031, 1085.82, 1408.029);
{CONST chanar:ARRAY[1..17] OF REAL = ( 279.103,  548.540,  555.467,
      767.232,  818.911,  913.763, 985.708, 1719.957, 1912.933,
      2125.412, 2214.553, 2394.927, 2449.159, 2583.336, 2804.774,
      2931.833, 3097.047);}
VAR energar,oxar:ARRAY[1..50] OF REAL; ixar:ARRAY[1..50] OF INTEGER;
    i,j,k,iter,nit,me,jm:INTEGER; r,z,c1,c2,dev:REAL;
    pa0,pax:ARRAY[1..2] OF REAL;
 FUNCTION Ener(x:REAL):REAL;
 BEGIN z:=x/(c2-c1); Ener:=pa[1]*z+pa[2];
 END;
 PROCEDURE SortXs;
 VAR j,k:INTEGER;
 BEGIN FOR j:=1 TO me DO ixar[i]:=0; FOR j:=1 TO me DO
  BEGIN amx:=1.E16; jm:=1; FOR k:=1 TO npeak DO
    {IF((iter>0)AND(ixar[k]=0))THEN}
   BEGIN dev:=ABS(Ener(marka[k])-energar[j]);
   IF(dev<amx)THEN
    BEGIN amx:=dev; jm:=k;
    END;
   END;
  oxar[j]:=marka[jm]; ixar[jm]:=1; {Mark the selected item;}
  {Writeln(fout,energar[j]:9:3,oxar[j]:9:3,Ener(oxar[j]):15:3);}
  END;  {In oxar selected channels}
 arran(oxar,me,1);
 END;
 PROCEDURE ComputeChi;
 VAR i:INTEGER;
 BEGIN chi:=0; FOR i:=1 TO me DO
  chi:=AMAX1(chi,ABS(energar[i]-Ener(oxar[i])));
 END;
BEGIN IF(npeak<10)THEN
 BEGIN ShowMess('Too little peaks for auto-calibration'); Exit;
 END;
L0rec:='Auto energy calibration'; MakeFormV(170,20,330,430,0);
SaveHelp(AutoCal_n,AutoCal);
s:='Select the source for calibration';
OuttoLabel(Form2.Label1,5,20,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=2; indx:=1; ar[1]:='   Ra226'; ar[2]:='   Eu152';
 END;
MakeRadioGroup(1,0,60,50,170,70);
s:='Specify the max energy of spectrum peaks';
OuttoLabel(Form2.Label2,5,150,clMaroon,clWhite,s);
strgrW[0]:=120; strgrW[1]:=100;
strgrT[1]:=' E_min (Kev) ='; strgrNn[1,1]:=100;
strgrT[2]:=' E_max (Kev) ='; strgrNn[2,1]:=1770;
PuttoTable(40,180,2,2,1,8);
s:=' Number of marked peaks for calibration = '+IntToStr(npeak);
OuttoLabel(Form2.Label3,10,250,clMaroon,clWhite,s);
s:=' Max energy of Ra peaks=1770; Eu=1410 KeV.';
OuttoLabel(Form2.Label4,10,270,clMaroon,clWhite,s);

WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 j:=RadioGroup1.ItemIndex;
 FOR i:=1 TO 2 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 CASE j OF
 0: BEGIN k:=0;
    FOR i:=1 TO 7 DO IF(rinfun(ra226ar[i],har[1],har[2]))THEN
     BEGIN Inc(k); energar[k]:=ra226ar[i];
     END;
    me:=k;
    END;
 1: BEGIN k:=0;
    FOR i:=1 TO 10 DO IF(rinfun(eu152ar[i],har[1],har[2]))THEN
     BEGIN Inc(k); energar[k]:=eu152ar[i];
     END;
    me:=k;
    END;
 ELSE END;
 END;
nit:=500; {npeak:=17;} sigi:=1; IF(me<2)THEN
 BEGIN ShowMess('Wrong number of energies'); Exit;
 END;
c1:=marka[1]; c2:=marka[npeak];
pa0[1]:=energar[me]-energar[1]; pa0[2]:=energar[1]-pa0[1]*c1/(c2-c1);
chio:=1E10;

FOR iter:=1 TO nit DO
 BEGIN FOR i:=1 TO me DO ixar[i]:=0;
 pa[1]:=pa0[1]+RNDM(-1)*10; pa[2]:=pa0[2]+RNDM(-1)*1000;
 {Writeln(fout,'* par=',pa[1]:9:3,pa[2]:9:3);}
 {assign channels} SortXs; ComputeChi;
 FOR i:=1 TO 2 DO vec2[i]:=0;
 FOR i:=1 TO 2 DO FOR j:=1 TO 2 DO mat2[i,j]:=0;
 {Refine parameters} FOR j:=1 TO me DO
  BEGIN fex:=energar[j]; r:=Ener(oxar[j]); ffr[1]:=z; ffr[2]:=1;
  FOR i:=1 TO 2 DO vec2[i]:=vec2[i]+sigi*fex*ffr[i];
  mat2[1,1]:=mat2[1,1]+sigi*ffr[1]*ffr[1];
  mat2[1,2]:=mat2[1,2]+sigi*ffr[1]*ffr[2];
  mat2[2,1]:=mat2[2,1]+sigi*ffr[2]*ffr[1];
  mat2[2,2]:=mat2[2,2]+sigi*ffr[2]*ffr[2];
  END;
 det:=AMAX1(0.00001,mat2[1,1]*mat2[2,2]-SQR(mat2[1,2])); {Invert matrix}
 r:=mat2[1,1]/det; mat2[1,1]:=mat2[2,2]/det; mat2[2,2]:=r;
 mat2[1,2]:=-mat2[2,1]/det; mat2[2,1]:=mat2[1,2];
 pa[1]:=mat2[1,1]*vec2[1]+mat2[1,2]*vec2[2];
 pa[2]:=mat2[2,1]*vec2[1]+mat2[2,2]*vec2[2];
 {Writeln(fout,'New par=',pa[1]:9:3,pa[2]:9:3);}
 {FOR i:=1 TO me DO
  Writeln(fout,energar[i]:9:3,oxar[i]:9:3,Ener(oxar[i]):15:3);}
 ComputeChi;
 IF(chi<chio)THEN
  BEGIN chio:=chi; FOR i:=1 TO 2 DO pax[i]:=pa[i];
  END;
 IF(chi<0.1)THEN BREAK;
 END; {Loop end}
FOR i:=1 TO 2 DO pa[i]:=pax[i]; SortXs;
mocan:=1; ncen:=me; encm:=true; FOR i:=1 TO ncen DO WITH enc[i] DO
 BEGIN x:=oxar[i]; y:=energar[i]; e:=1;
 END;
FOR i:=1 TO me DO onl[i]:=oxar[i]; j:=me; arran(onl,j,0);
IF(j<>me)THEN
 BEGIN ShowMess('Calibration failed'); encm:=false; Exit;
 END;
IF(chio>0.5)THEN
 BEGIN s:='Warning, discrepancy more than 0.5KeV; Proceed?';
 i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0); IF(i=mrNo)THEN Exit;
 END;
LinearCalibration;
MakeFormV(170,20,400,430,0); WITH LB1rec DO
 BEGIN ConvertStr(chio,10,2); ar[1]:='Max discrepancy(KeV)= '+sedz;
 ar[2]:=''; ar[3]:='   E_calib   Channel       E fitted'; ar[4]:='';
 FOR i:=1 TO me DO
  BEGIN s:=''; ConvertStr(energar[i],10,3); s:=s+sedz;
  ConvertStr(oxar[i],10,3); s:=s+sedz;
  ConvertStr(Ener(oxar[i]),15,3); s:=s+sedz; ar[4+i]:=s;
  END;
 nitems:=4+me;
 END;
MakeListBox(3,40,380,300); Form2.ShowModal;
END;

PROCEDURE EditMarkingData;
VAR i,j,k,l,n:INTEGER; r:REAL; s:STRING;
BEGIN L0rec:='Check and edit marking data'; MakeFormV(250,20,330,430,0);
MakeMemo(5,290); WITH Form2.Memo1.Lines DO
 BEGIN Clear; FOR i:=1 TO nint DO WITH mauxa[i] DO
  BEGIN Inc(k); r:=-i1; ConvertStr(r,10,0); s:=sedz;
  r:=-i2; ConvertStr(r,8,0); s:=s+' '+sedz; Add(s);
  FOR j:=k1 TO k2 DO
   BEGIN ConvertStr(marka[j],8,1); Add(sedz);
   END;
  END;
 END;
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
l:=0; n:=0; WITH Form2.Memo1.Lines DO
 BEGIN kc:=Count; FOR i:=1 TO kc DO
  BEGIN s:=Strings[i-1]; FCompress(s); IF(s<>'')THEN
   BEGIN fffins(k,s); FOR j:=1 TO k DO
    BEGIN Inc(l); marka[l]:=onl[j]; IF(marka[l]>0)THEN Inc(n);
    IF(l>200)THEN
     BEGIN ShowMess('Error, too many marking points'); Exit;
     END;
    END;
   END;
  END;
 END;
kc:=l; npeak:=n; nint:=(kc-n)DIV 2; marka[kc+1]:=0;
j:=0; l:=0; FOR i:=1 TO nint DO WITH mauxa[i] DO
 BEGIN i1:=ABS(Round(marka[j+1])); i2:=ABS(Round(marka[j+2])); j:=j+2;
 IF(i=1)THEN k1:=1 ELSE k1:=mauxa[i-1].k2+1;
 onl[l+1]:=-i1; Inc(l); n:=0;
 REPEAT Inc(j); IF(marka[j]>0)THEN
  BEGIN onl[l+1]:=marka[j]; Inc(l); Inc(n);
  END;
 UNTIL (marka[j]<0)OR(j>=kc);
 IF(marka[j]<0)THEN Dec(j); onl[l+1]:=-i2; Inc(l); k2:=k1+n-1;
 END;
{IF(debugV.activ)THEN FOR i:=1 TO kc DO Writeln(fout,onl[i]:9:1);}
END;
PROCEDURE EnterMarkingEnergies;
VAR   i,j,k,l:INTEGER;
LABEL Lend;
BEGIN L0rec:='Enter the energy list for marking';
MakeFormV(250,20,330,430,0); SaveHelp(EntMarkEn_n,EntMarkEn);
s:=selops; OuttoLabel(Form2.Label1,5,20,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=2; indx:=1;
 ar[1]:='Enter energies from the screen';
 ar[2]:='Enter energies from a file';
 END;
MakeRadioGroup(1,0,20,60,290,60);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit; i:=RadioGroup1.ItemIndex;
 END;
mrkmod:=2; {Mark by energies}
IF(i=1)THEN {From a file}
 BEGIN GetFilename(fn,0);
 AssignFile(ft,fn); {$I-} Reset(ft); {$I+};
 fffin(ft,1,300,nenm,enmlist);
 CloseFile(ft); GOTO Lend;
 END;
MakeMemo(20,295); WITH Form2.Memo1 DO FOR i:=1 TO nenm DO
 BEGIN ConvertStr(enmlist[i],12,4); Lines.Add(sedz);
 END;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 l:=0; FOR i:=1 TO Memo1.Lines.Count DO
  BEGIN s:=Memo1.Lines.Strings[i-1]; Compress(s); IF(s<>'')THEN
   BEGIN fffins(k,s); FOR j:=1 TO k DO
    BEGIN enmlist[l+1]:=onl[j]; Inc(l);
    END;
   END;
  END;
 END;
nenm:=l;
Lend: MakeFormV(250,20,330,430,0); WITH LB1rec DO
 BEGIN ar[1]:=' Peak energies read in,  '+IntToStr(nenm)+' items';
 ar[2]:=' ';
 ar[3]:=' Now execute command: (key=OPERATION)';
 ar[4]:=' Spectrum Marking by Energies';
 nitems:=4; IF(nenm=0)THEN nitems:=1;
 END;
MakeListBox(5,40,310,120); Form2.ShowModal;
END;
PROCEDURE InputSpecFileNames;
VAR   i,l:INTEGER; s:STRING;
LABEL L1,Lend;
BEGIN L0rec:='Creation of Spectrum Name List';
MakeFormV(250,20,330,430,0); SaveHelp(BlankH_n,BlankH);
OuttoLabel(Form2.Label1,5,40,clGreen,clAqua,'Select the mode:');
WITH CB1rec DO
 BEGIN nitems:=2; indx:=1;
 ar[1]:='Get the list from DialogBox';
 ar[2]:='Enter the list from a file';
 END;
MakeRadioGroup(1,0,25,70,270,60);
WITH LB1rec DO
 BEGIN nitems:=8; ar[1]:=' Dialog Box mode:';
 ar[2]:='click the name set by the mouse';
 ar[3]:=' ';
 ar[4]:='If the names are sequential:';
 ar[5]:=' 1/ Click on the 1st name';
 ar[6]:=' 2/ then Click+Shift on the last;';
 ar[7]:='If the names are randomly accessed:';
 ar[8]:=' Click+Ctrl on each; then on Open';
 END;
MakeListBox(20,160,280,140);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i:=RadioGroup1.ItemIndex;
 IF(i=1)THEN GOTO L1;
 END;
{*}
WITH Form2 DO
 BEGIN WITH OpenDialog1 DO
  BEGIN Title:='      Select the file group'; GetDir(0,s);
  InitialDir:=s; Options:=Options+[ofAllowMultiSelect];
  END;
 IF(OpenDialog1.Execute)THEN WITH OpenDialog1.Files DO
  BEGIN nsfn:=MIN0(Count,200);
  FOR i:=0 TO nsfn-1 DO sfnar[i+1]:=Strings[i];
  END                   ELSE
  BEGIN ModalRes:=0; Exit;
  END;
 WITH OpenDialog1 DO Options:=Options-[ofAllowMultiSelect];
 END;
GOTO Lend;
{*}
L1: MakeFormV(250,20,330,430,0);
OuttoLabel(Form2.Label1,5,40,clGreen,clAqua,
 'specify the list file name:');
L1rec:='The spectrum name file = '; E1rec:=snff;
OuttoLabel(Form2.Label1,10,70,clGreen,clAqua,L1rec);
MakeEdit(Form2.Edit1,200,68,70,E1rec);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 s:=Edit1.Text;
 AssignFile(ft,s); {$I-} Reset(ft); {$I+};
 ok:=(IOresult=0); IF NOT ok THEN
  BEGIN ShowMess('No file '+s); Exit;
  END;
 l:=0; WHILE(NOT EoF(ft))DO
  BEGIN Readln(ft,s); FCompress(s); IF(s<>'')THEN
   BEGIN Inc(l);l:=MIN0(l,100); sfnar[l]:=s;
   END;
  END;
 CloseFile(ft); nsfn:=l;
 END;
{*}
Lend: MakeFormV(250,20,330,430,0); WITH LB1rec DO
 BEGIN nitems:=3; ar[1]:='  Spectrum Name List';
 ar[2]:='   has been created';
 ar[3]:='  '+IntToStr(nsfn)+' items';
 END;
MakeListBox(20,40,270,120); Form2.ShowModal;
END;

PROCEDURE EnterCalibrationData(nreac:INTEGER);
VAR   i,l:INTEGER; ft:TEXTFILE; ss,s:STRING; {ra:CALIBREC;}
BEGIN IF(nreac=0)THEN
 BEGIN L0rec:='Energy calibration '; s:=encf; SaveHelp(InpEnC_n,InpEnC);
 END             ELSE
  BEGIN L0rec:='Efficiency calibration'; s:=efcf;
  SaveHelp(InpEfC_n,InpEfC);
  END;

GetFilename(s,0); IF(ModalRes=0)THEN Exit;

IF(nreac=0)THEN
 BEGIN MakeFormV(250,20,330,430,0); ss:='Specify the calibration mode';
 OuttoLabel(Form2.Label1,5,50,clGreen,clWhite,ss);
 WITH CB1rec DO
  BEGIN ar[1]:=' Non-linear'; ar[2]:=' Linear'; nitems:=2; indx:=1;
  END;
 MakeRadioGroup(1,0,50,75,200,70);
 WITH Form2 DO
  BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
  mocan:=RadioGroup1.ItemIndex;
  END;
 END;

AssignFile(ft,s); {$I-} Reset(ft); {$I+};
l:=0; WHILE(NOT EoF(ft))DO
 BEGIN onl[3]:=0; fffin(ft,1,3,i,onl); Inc(l); l:=MIN0(l,60);
 wenc[l].y:=onl[2]; wenc[l].e:=onl[3]; wenc[l].x:=onl[1];
 CheckZero(ok); IF(NOT ok)THEN Dec(l);
 END;
CloseFile(ft);

ss:='Non-linear'; IF(nreac=0)THEN
 BEGIN ncen:=l; ArrangeEnergCalibr; FOR i:=1 TO l DO enc[i]:=wenc[i];
 encf:=s; encm:=true; IF(mocan=1)THEN
  BEGIN LinearCalibration;  ss:=' Linear';
  END;
 END                         ELSE
  BEGIN ncef:=l; FOR i:=1 TO l DO efc[i]:=wenc[i]; ArrangeEfficCalibr;
  efcf:=s; mocaf:=0; efcm:=true;
  END;

MakeFormV(250,20,330,430,0); WITH LB1rec DO
 BEGIN nitems:=3; ar[1]:=L0rec+' performed'; ar[2]:=' Mode= '+ss;
 ar[3]:=IntToStr(l)+' calibration items';
 END;
MakeListBox(20,40,270,120); Form2.ShowModal;
END;
PROCEDURE InputMarkingData;
VAR i,l,j,k:INTEGER; ok:BOOLEAN; s:STRING; ft:TEXTFILE;
BEGIN L0rec:='Enter the marking data file';
SaveHelp(BlankH_n,BlankH); GetFilename(s,0);
IF(ModalRes=0)THEN Exit;
AssignFile(ft,s); {$I-} Reset(ft); {$I+};
ok:=(IOresult=0); IF NOT ok THEN
 BEGIN ShowMess('No file '+s); Exit;
 END;
l:=0; j:=0; WHILE(NOT EoF(ft))DO
 BEGIN Readln(ft,s); FCompress(s); IF(s<>'')THEN
  BEGIN fffins(k,s); FOR i:=1 TO k DO
   BEGIN Inc(l); marka[l]:=onl[i]; IF(marka[l]>0)THEN Inc(j);
   IF(l>200)THEN
    BEGIN ShowMess('Error, too many marking points'); Exit;
    END;
   END;
  END;
 END;
CloseFile(ft);
kc:=l; npeak:=j; nint:=(l-j)DIV 2;
END;



END.

