UNIT vactfl; {Nov 4 2001}

INTERFACE

USES
  Windows, Messages, SysUtils, Classes,  Graphics, Controls, Forms,
  Dialogs, Grids,    StdCtrls, ExtCtrls, CheckLst, vactiv0,  vacthlp,
  vactiv2, vzlocom,  varfun,   vspectr,  vdata,    vpmodel,  vpeaksr,
  vstdcons, vactiv3;

PROCEDURE InputSpectrumData(VAR ok:BOOLEAN);
PROCEDURE InputtheSpectrum;
PROCEDURE SavetheSummaryTable;
PROCEDURE SaveEnergyCalibration;
PROCEDURE SaveEfficiencyCalibration;
PROCEDURE PutResTable(cali:REAL; ftab:STRING);
PROCEDURE SimulateTheSpectrum;
PROCEDURE CorrectforBlunders;
PROCEDURE SetTestSpectra;
PROCEDURE SaveIniFile;
PROCEDURE CompresstheSpectrum;
PROCEDURE SmoothASpectrum(mo:INTEGER);
PROCEDURE SmoothData(m,mo:INTEGER);

VAR ow:BOOLEAN;

IMPLEMENTATION
PROCEDURE InputtheSpectrum;
VAR   fn:STRING;
 PROCEDURE PromptDialog(VAR s:STRING);
 VAR ss:STRING;
 BEGIN WITH Form2.OpenDialog1 DO
  BEGIN Title:='  Select the file'; ss:=ExtractFileName(s);
  IF(ss='')THEN s:='*.*'; FileName:=s; InitialDir:=dirs;
  Options:=Options-[ofAllowMultiSelect];
  IF(Execute)THEN s:=FileName ELSE
   BEGIN ModalRes:=0; Exit;
   END;
  IF(NOT FileExists(s))THEN
   BEGIN ShowMess('No file '+s); ModalRes:=0;
   END;
  END;
 END;
BEGIN
{*}
MakeFormV(250,20,330,430,0); fn:=spec.sfn; spvar:=0;
PromptDialog(fn); IF(ModalRes=0)THEN Exit; spec.sfn:=fn;
{*}    {Select file type}
SaveHelp(InpSpH_n,InpSpH); s:='Select the file type:';
OuttoLabel(Form2.Label1,10,10,clGreen,clAqua,s);
CB1rec:=SpTypeRec; CB1rec.indx:=spec.smosp;
MakeRadioGroup(1,0,40,30,240,120);
s:='Select the spectrum type:';
OuttoLabel(Form2.Label2,10,160,clGreen,clAqua,s);
WITH CB1rec DO
 BEGIN nitems:=3; ar[1]:=' Skip the header ';
 ar[2]:=' Reverse the bytes ';
 ar[3]:=' Restore ini-bounds ';
 END;
MakeCheckListBox(60,200,200,55);
WITH Form2.CheckListBox1 DO
 BEGIN IF(skiph)THEN Checked[0]:=true ELSE Checked[0]:=false;
 IF(revby)THEN Checked[1]:=true ELSE Checked[1]:=false;
 Checked[2]:=true;
 END;
WITH Form2 DO
 BEGIN ShowModal; LB1rec.ar[1]:=''; IF(ModalRes=0)THEN Exit;
 spec.smosp:=RadioGroup1.ItemIndex+1; spec.tofang:=2;
 WITH CheckListBox1 DO WITH spec DO
  BEGIN IF(Checked[0])THEN skiph:=true ELSE skiph:=false;
  IF(Checked[1])THEN revby:=true ELSE revby:=false;
  a11:=a1; a22:=a2; IF(Checked[2])THEN
   BEGIN a11:=aini1; a22:=aini2;
   END;
  END;
 END;
{*   Read}
InputSpectrumData(ok); WITH spec DO
 BEGIN IF((spx=0)OR(NOT ok))THEN
  BEGIN LB1rec.ar[1]:='++++ Error, wrong reading'; ModalRes:=0; Exit;
  END;
 IF(spx<1)THEN
  BEGIN ShowMess('Poor data scale, max < 1'); spx:=1;
  END;
 LB1rec.ar[1]:=' Spectrum read in. ';
 IF(a22<a11)THEN Irrange2(a11,a22);
 ic1:=Round(a11); ic2:=Round(a22); cadl:=ic2-ic1+1; spin:=true;
 FormSpecErrors;
 END;
END;
PROCEDURE SaveIniFile;
VAR i:INTEGER;
BEGIN AssignFile(fv1,dirn+'\vactiv.tmp'); Rewrite(fv1);
Writeln(fv1,'.......Input the Spectrum');
Writeln(fv1,'* a1   a2   mode skip  reverse /mode:1-2byte,2-4,3-text');
Writeln(fv1,'* spectrum file name');
WITH spec DO
 BEGIN Write(fv1,a1:5,a2:8,smosp:3);
 IF(skiph)THEN Write(fv1,'  1') ELSE Write(fv1,'  0');
 IF(revby)THEN Write(fv1,'  1') ELSE Write(fv1,'  0'); Writeln(fv1);
 Writeln(fv1,sfn);
 Writeln(fv1,'.......Set the Analysis Bounds');
 Writeln(fv1,a11:8,a22:8);
 Writeln(fv1,'.......Enter the Width Information');
 Writeln(fv1,'*      w1   w2  DeltaW');
 Writeln(fv1,w0:9:3,w1:9:4,dw0:9:3);
 Writeln(fv1,'.......Degree of the Background');
 Writeln(fv1,'*  0 <= dback <= 3');
 Writeln(fv1,dback:5);
 END;
IF(ncen>0)THEN
 BEGIN Writeln(fv1,'.......Enter Data for ENergy Calibration');
 Writeln(fv1,'*      npt  mode   pri');
 Writeln(fv1,ncen:5,mocan:3,'  1');
 FOR i:=1 TO ncen DO WITH enc[i] DO Writeln(fv1,x:9:3,y:9:3,e:9:3);
 END;
IF(ncef>0)THEN
 BEGIN Writeln(fv1,'.......Enter Data for EFiciency Calibration');
 Writeln(fv1,'*      npt  mode   pri');
 Writeln(fv1,ncef:5,mocaf:3,'  1');
 FOR i:=1 TO ncef DO WITH efc[i] DO Writeln(fv1,x:9:3,y:9:3,e:9:3);
 END;
Writeln(fv1,'.......Mark the Spectrum');
Writeln(fv1,'* mode   sens    resol   ndf');
Writeln(fv1,mrkmod:5,sens:8:2,res:8:2,defps:5);
Writeln(fv1,'.......Maximum Interval');
Writeln(fv1,linx:5);
Writeln(fv1,'.......STOP'); CloseFile(fv1);
{
*         These are commands used more seldom.
.......Enter the Variable Width Information
*      wvar   dwvar
         .1      4
.......Mark the Spectrum
*      mode sens   res
        1    1     1
        21
    -11   20.0   26.0   30.0   36.0   48.0
          54.0   60.0   67.0
          74.0   81.9
         111.0  124.0
         144.4  145.8
         166.0
   -170
   -180  200 205  -210
.......Set the Control Variables
       covar = .02
       niter=3
       damp=.002
       step=1
       dpos = 4
       end }
END;
PROCEDURE CorrectforBlunders;
VAR i,nz,nbl:INTEGER;
BEGIN L0rec:='Correcting for blunders'; MakeFormV(250,20,330,430,0);
SaveHelp(CorrBl_n,CorrBl);
s:='Check chibc and order';
OuttoLabel(Form2.Label1,5,50,clGreen,clWhite,s);
strgrW[0]:=120; strgrW[1]:=100;
strgrT[1]:=' Chibc= '; strgrT[2]:=' Order= ';
strgrNn[1,1]:=chibc; strgrNn[2,1]:=order;
PuttoTable(40,70,2,2,1,{ndig}8);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO 2 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 END;
chibc:=har[1]; order:=har[2];
WITH spec DO corbc(a1,a2,nbl,nz);
LB1rec.ar[1]:=IntToStr(nbl)+' blunders corrected';
END;
PROCEDURE SetTestSpectra;
VAR i,iop:INTEGER; ftt:TEXTFILE;
BEGIN L0rec:='Set Test Spectra'; MakeFormV(250,20,330,430,0);
s:=selops; OuttoLabel(Form2.Label1,5,10,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=5; indx:=1;
 ar[1]:='Set Negray Spectrum';
 ar[2]:='Set Freycenon Spectrum';
 ar[3]:='Set Frontasyeva Spectrum';
 ar[4]:='Set Eu155 Spectrum';
 ar[5]:='   Set Debug mode';
 END;
MakeRadioGroup(1,0,20,50,290,130);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit; iop:=RadioGroup1.ItemIndex;
 END;
CASE iop OF
0: WITH spec DO WITH negrh DO
    BEGIN sfn:=dirn+'\'+fn; FOR i:=1 TO n DO
     BEGIN y[i]:=negr[i]; e[i]:=SQRT(ABS(negr[i])+1);
     END;
    a1:=1; a11:=1; a2:=n; a22:=n; spin:=true; fismax1;
    w0:=w-0.5; w1:=w+0.5; dw0:=w/2;
    END;
1: WITH spec DO WITH freych DO
    BEGIN FOR i:=1 TO n DO y[i]:=freyc[i]; sfn:=dirn+'\'+fn;
    a1:=1; a11:=a1; a2:=n; a22:=a2; spin:=true; fismax1;
    w0:=w-0.5; w1:=w+0.5; dw0:=w/2;
    END;
2: WITH spec DO WITH fronth DO
    BEGIN FOR i:=1 TO n DO y[i]:=front[i]; sfn:=dirn+'\'+fn;
    a1:=1; a11:=a1; a2:=n; a22:=a2; spin:=true; fismax1;
    w0:=w-0.5; w1:=w+0.5; dw0:=w/2;
    END;
3: WITH spec DO WITH eu155h DO
    BEGIN FOR i:=1 TO n DO y[i]:=eu155[i]; sfn:=dirn+'\'+fn;
    a1:=1; a11:=a1; a2:=n; a22:=a2; spin:=true; fismax1;
    w0:=w-0.5; w1:=w+0.5; dw0:=w/2;
    END;
4:  IF(NOT debugV.activ)THEN
     BEGIN debugV.activ:=true; AssignFile(fout,'adebug.res');
     Rewrite(fout);
     END;
ELSE END;
FormSpecErrors;
END;
PROCEDURE InputSpectrumData(VAR ok:BOOLEAN);
VAR i,i1,i2:INTEGER;
BEGIN ModalRes:=1; IF(nosaved)THEN
 BEGIN i:=MessageDlg
  ('Former results not saved. Proceed?',MtWarning,[mbYes,mbNo],0);
 IF(i=mrNo)THEN
  BEGIN ModalRes:=0; Exit;
  END;
 nosaved:=false;
 END;
WITH spec DO
 BEGIN i1:=Round(a1); i2:=Round(a2);
 CASE smosp OF{READ}
 1: Read2Binary(ok);
 2: Read4Binary(ok);
 3: ReadTxt(i1,i2,ok);
 4: ReadTxt3(i1,i2,ok);
 ELSE END;
 IF(NOT infun(a11,a1,a2))THEN a11:=a1+1; ic1:=a11;
 IF(NOT infun(a22,a1,a2))THEN a22:=a2-1; ic2:=a22;
 fismax1;
 END;
grst:=0; ncl:=0; ntab:=0; ntab0:=0;
END;
PROCEDURE SavetheSummaryTable;
VAR i,j:INTEGER; ss:STRING; sfnar1:ARRAY[1..200] OF STRING;
BEGIN L0rec:='Save the Summary Table'; MakeFormV(250,20,330,430,0);
SaveHelp(SaveRes_n,SaveRes); s:='Saving '+IntToStr(ntab)+' '+
 ExtractFileName(spec.sfn)+' peaks analyzed'; WITH CB1rec DO
 BEGIN nitems:=1; ar[1]:=' LIM format for res-file';
 END;
MakeCheckListBox(40,120,200,20);
OuttoLabel(Form2.Label1,20,40,clGreen,clWhite,s);
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
IF(Form2.CheckListBox1.Checked[0])THEN limm:=true
                                  ELSE limm:=false;
ss:=spec.sfn; i:=Pos('.',ss); Delete(ss,i,1); ss:=ss+'.res';

SaveFileDial(Form2.SaveDialog1,ss,ow); IF(NOT ow)THEN Exit; s:=ss;
{Save Table}PutResTable(cali,s); ntab:=0; ntab0:=0; IF(nsfn=0)THEN Exit;
j:=1; FOR i:=1 TO nsfn DO IF(spec.sfn<>sfnar[i])THEN
 BEGIN sfnar1[j]:=sfnar[i]; Inc(j);
 END;
Dec(nsfn); FOR i:=1 TO nsfn DO sfnar[i]:=sfnar1[i];
END;
PROCEDURE SaveEnergyCalibration;
VAR i:INTEGER; fv3:TEXT;
BEGIN IF(ncen=0)THEN
 BEGIN ShowMess('No calibration data'); Exit;
 END;
ActivateForm2(200,250,250);
s:=encf; SaveFileDial(Form2.SaveDialog1,s,ow); IF(NOT ow)THEN Exit;
encf:=s; AssignFile(fv3,encf); Rewrite(fv3);
Writeln(fv3,'*',' ':20,'Energy calibration data.'); Writeln(fv3);
Writeln(fv3,'*  Channel    Energy     Error');
FOR i:=1 TO ncen DO WITH enc[i] DO Writeln(fv3,x:10:2,y:10:2,e:10:2);
CloseFile(fv3);
END;
PROCEDURE SaveEfficiencyCalibration;
VAR i:INTEGER; fv3:TEXT;
BEGIN IF(ncef=0)THEN
 BEGIN ShowMess('No calibration data'); Exit;
 END;
ActivateForm2(200,250,250);
s:=efcf; SaveFileDial(Form2.SaveDialog1,s,ow); IF(NOT ow)THEN Exit;
efcf:=s; AssignFile(fv3,efcf); Rewrite(fv3);
Writeln(fv3,'*',' ':20,'Efficiency calibration data.'); Writeln(fv3);
Writeln(fv3,'*   Energy    Coefficient          Error');
FOR i:=1 TO ncef DO WITH efc[i] DO Writeln(fv3,x:10:2,y:15:7,e:15:7);
CloseFile(fv3);
END;
PROCEDURE PutResTable(cali:REAL; ftab:STRING);
{prints the final table of the results to file ftab}
{version 85-12, Mar 1 2005}
VAR  i,k,k2:INTEGER;
     r,epmax,pmax,chi,chp,ch,ech,g,eg,sn,esn,s,es,en,een,ai,eai:REAL;
{---------------------------------------------------------------}
BEGIN IF(ntab<=0)THEN Exit;
IF(NOT nomo)THEN
 BEGIN k:=1; ch:=1E15; FOR i:=1 TO ntab DO
  IF(ABS(tab[i].ch-cali)<=ch)THEN
   BEGIN k:=i; ch:=ABS(tab[i].ch-cali);
   END;
 pmax:=AMAX1(1,tab[k].ss); epmax:=AMAX1(0.1,tab[k].ess);
 END;
AssignFile(ft,ftab); Rewrite(ft);
Writeln(ft,' ':20,'SUMMARY TABLE.  '+DateToStr(Now)+' '+TimeToStr(Now));
Writeln(ft); Writeln(ft,' ':20,'File             = '+spec.sfn);
Writeln(ft,' ':20,'Number of peaks  = ',ntab:3,'  Peak model type  = ',
 spmodn[pmod[1].typ]);
IF(NOT nomo)THEN Writeln(ft,' ':20,'Peak_norm, chan. = ',
 pmax:12:1,cali:8:2)
            ELSE Writeln(ft,' ':20,'Ncoef = ',cali:8:2);
Writeln(ft,' ':20,'Sens, Res = ',sens:8:3,res:8:2);
WITH spec DO Writeln(ft,' ':20,'Spectrum interval= ',a11:7,a22:7);
WITH spec DO Writeln(ft,' ':20,'Widths           = ',w0:8:3,w1:8:3);
IF(encm)THEN
 BEGIN Writeln(ft,' ':20,'Energy calibration, ',ncen,' items.');
 FOR i:=1 TO ncen DO Write(ft,enc[i].y:8:2); Writeln(ft);
 FOR i:=1 TO ncen DO Write(ft,enc[i].x:8:2); Writeln(ft);
 END;
Writeln(ft); Writeln(ft,
'   Channel  Energy     Area     Intensity    Width   Norm.area'+
' Crit/Back');
Writeln(ft); FOR i:=1 TO ntab DO
 BEGIN ch:=tab[i].ch; ech:=tab[i].ech; s:=tab[i].ss; es:=tab[i].ess;
 g:=tab[i].g; eg:=tab[i].eg;
 chi:=tab[i].chi2; chp:=tab[i].chip;
 calibr(ch,ech,s,es,en,een,ai,eai);
 IF(limm)THEN ai:=chp;
 IF(NOT nomo)THEN
  BEGIN r:=pmax; sn:=s/r*100;
  esn:=SQRT(SQR(es/r)+SQR(s*epmax/SQR(r)))*100;
  END        ELSE
  BEGIN r:=cali; sn:=s/r; esn:=es/r;
  END;
 k2:=2; IF(sn<0.01)THEN k2:=3;
 Writeln(ft,ch:9:2,en:9:2,s:9:0,ai:14:0,g:9:2,sn:12:k2,chi:10:2);
 Writeln(ft,ech:9:2,een:9:2,es:9:0,eai:14:0,eg:9:2,esn:12:k2,chp:10:2);
 Writeln(ft);
 END;
CloseFile(ft); nosaved:=false;
END;
PROCEDURE SimulateTheSpectrum;
VAR i,j:INTEGER; b1,b0,b,w,x,z:REAL; pos,amp:ARRAY[1..10] OF REAL;
BEGIN Randomize; w:={rndm(-1)*}(3+2)/2; b1:=rndm(-1); b0:=rndm(-1)*300;
FOR j:=1 TO 10 DO WITH spec DO
 BEGIN pos[j]:=a1+rndm(-1)*(a2-a1);  amp[j]:=200+rndm(-1)*500;
 END;
{AssignFile(fout,'b.sav'); ReWrite(fout);
Writeln(fout,'Peaks are simulated (pos, area, width)');
FOR i:=1 TO 10 DO Writeln(fout,pos[i]:10:2,amp[i]:10:2,w:10:2);
CloseFile(fout);}
FOR i:=spec.a1 TO spec.a2 DO
 BEGIN x:=i; b:=b1*x/100+b0;
 FOR j:=1 TO 10 DO
  BEGIN z:=SQRT(ln(2))*(x-pos[j])/w; b:=b+amp[j]*exp(-z*z);
  END;
 spec.y[i]:=AMAX1(b+(rndm(-1)-0.5)*SQRT(b),0);
 END;
spec.fismax1; nscale:=1; spec.sfn:='';
END;
PROCEDURE SmoothData(m,mo:INTEGER);
VAR   mm,mof,li,lj,i:INTEGER; ax,an,rsm:REAL;
LABEL Lend;
BEGIN Bitmap:=TBitmap.Create; WITH Bitmap DO
 BEGIN Width:=exs(516); Height:=exs(323);
 END;
rsm:=1; ax:=sa[1]; an:=sa[1]; FOR i:=1 TO m DO
 BEGIN ax:=AMAX1(ax,sa[i]); an:=AMIN1(an,sa[i]);
 END;
mof:=3; mm:=m;
L0rec:=''; MakeFormV(90,0,530,450,0); Form2.Image2.Visible:=true;
WITH Form2.Image2 DO
 BEGIN Left:=0; Top:=exs(80); Width:=exs(516); Height:=exs(300);
 Form2.Font.Size:=fntsize; Canvas.Pixels[Left+Width-1,Top+Height-1]:=0;
 END;
REPEAT IF(mo=0)THEN smooth(mm,0,rsm,q1,q2)
               ELSE GetEnvelope(m,10,rsm,0.5,0.5);
WITH CB1rec DO
 BEGIN nitems:=3; indx:=mof;
 ar[1]:=' Less smoothing'; ar[2]:=' More smoothing'; ar[3]:=' Quit';
 END;
MakeRadioGroup(1,0,300,0,200,70);
s:='Click on Less or More, then on OK';
OuttoLabel(Form2.Label1,5,30,clGreen,clWhite,s);
s:='If the result is good, click on Quit, then on OK';
OuttoLabel(Form2.Label2,5,50,clGreen,clWhite,s);
WITH Form2.Image2.Canvas DO
 BEGIN Brush.Style:=bsSolid; Brush.Color:=0;
 FillRect(Rect(0,0,exs(516),exs(300)));
 END;
MakeBMFrame(ax,an);
WITH Bitmap.Canvas DO      {Plotting the Graph}
 BEGIN Pen.Style:=psSolid; Pen.Color:=clAqua; FOR i:=1 TO mm DO
  BEGIN li:=exs(Round(Float(i)*512/AMAX0(1,mm)));
  lj:=exs(CalcOrdinate(sa[i],ax,an)); DrawPixelPr(cola[2],li,lj,i,1,1);
  lj:=exs(CalcOrdinate(sd[i],ax,an)); DrawPixelPr(cola[3],li,lj,i,1,1);
  END;
 END;
Form2.Image2.Canvas.Draw(0,0,Bitmap);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN GOTO Lend;
 mof:=Form2.RadioGroup1.ItemIndex+1; IF(mof=3)THEN GOTO Lend;
 END;
IF(mof=1)THEN rsm:=rsm*1.5 ELSE rsm:=rsm/1.5;
UNTIL false;
Lend: Bitmap.Free;
END;
PROCEDURE CompresstheSpectrum;
VAR s,sv:REAL; i,j,l1,l2,ll:INTEGER;
BEGIN L0rec:='Spectrum compression';
MakeFormV(170,20,330,430,0); SaveHelp(blankH_n,blankH);
WITH Form2 DO
 BEGIN OuttoLabel(Label1,10,50,clGreen,clWhite,'Compression factor');
 MakeEdit(Form2.Edit1,170,50,70,IntToStr(cmprs));
 ShowModal; IF(ModalRes=0)THEN Exit;
 Zval(Edit1.Text,s); ll:=ABS(Round(s)); IF(ll<1)THEN
  BEGIN ShowMess('Wrong compression factor'); ModalRes:=0; Exit;
  END;
 END;
{Do} WITH spec DO
 BEGIN l1:=((a1-1) DIV ll)+1; l2:=((a2-1) DIV ll)+1; FOR i:=l1 TO l2 DO
  BEGIN s:=0; sv:=0; spec.x[i]:=x[(i-1)*ll+a1]; FOR j:=1 TO ll DO
   BEGIN k:=(i-1)*ll+a1+j-1; sv:=sv+SQR(e[k]); s:=s+y[k];
   END;
  e[i]:=SQRT(sv); y[i]:=s;
  END;
 FOR i:=1 TO l1-1 DO
  BEGIN e[i]:=1; y[i]:=0;
  END;
 FOR i:=l2+1 TO spec.a2 DO
  BEGIN e[i]:=1; y[i]:=0;
  END;
 a1:=l1; a11:=l1; a2:=l2; a22:=l2; spin:=true; fismax1;
 END;
LB1rec.ar[1]:=' Compression by factor '+IntToStr(ll);
END;
PROCEDURE SmoothASpectrum(mo:INTEGER);
CONST ss:STRING = 'Spectrum smoothed';
CONST se:STRING = 'Background subtracted';
VAR   i,m:INTEGER;
BEGIN L0rec:='Smoothing'; IF(mo=1)THEN L0rec:='Background';
MakeFormV(170,20,330,430,0); SaveHelp(blankH_n,blankH);
WITH Form2 DO WITH spec DO WITH CB1rec DO
 BEGIN nitems:=1;
 CASE mo OF
 0: ar[1]:='Spectrum should be replaced by the smoothed';
 1: ar[1]:='Background should be subtracted';
 ELSE END;
 MakeCheckListBox(20,50,270,20); CheckListBox1.Checked[0]:=false;
 ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=a11 TO a22 DO sa[i-a11+1]:=y[i]; m:=a22-a11+1;
 SmoothData(m,mo); IF(CheckListBox1.Checked[0])THEN
  CASE mo OF
  0: BEGIN FOR i:=1 TO m DO y[i+a11-1]:=sd[i]; LB1rec.ar[1]:=ss;
     END;
  1: BEGIN FOR i:=1 TO m DO y[i+a11-1]:=y[i+a11-1]-sd[i];
     LB1rec.ar[1]:=se;
     END;
  ELSE END;
 END;
END;


END.
