UNIT vactsg;
INTERFACE
USES Windows, Messages, SysUtils, Classes,  Graphics, Controls, Forms,
     Dialogs, StdCtrls, ExtCtrls, Grids,    vzlocom,  vactiv0,  vactiv2,
     vacthlp, vactfl,   varfun,   vspectr,  vpmodel,  vpeaksr,  vgfit,
     vstdcons, vactiv3;
PROCEDURE SetSpectrumData;
PROCEDURE SetMarkingData;
PROCEDURE SetFitData;
PROCEDURE SetScalemode;
PROCEDURE SettheNextSpectrumName;
PROCEDURE TaketheModel;
PROCEDURE FormSpecialPeakModel;
PROCEDURE GraphModel(nmod:INTEGER);
PROCEDURE GraphPeakModel(nmod:INTEGER);
PROCEDURE GraphEnergyCalibration;
PROCEDURE ToggletheFormSize;
PROCEDURE SetWidthDependence;
PROCEDURE SmoothData(m,mo:INTEGER);

IMPLEMENTATION
PROCEDURE SetWidthDependence;
BEGIN WITH spec DO WITH LB1rec DO
 BEGIN cw1:=(w1-w0)/(a22-a11); cw0:=w0-cw1*a11;
 s:='   W(chan) = '+FloatToStrF(cw1,ffGeneral,4,3) + ' * chan + '+
   FloatToStrF(cw0,ffGeneral,4,3); ar[1]:=s;
 s:='     W('+IntToStr(a11) + ') = '+FloatToStrF(w0,ffGeneral,4,3);
 s:=s+';        W('+IntToStr(a22) + ') = '
   +FloatToStrF(w1,ffGeneral,4,3); ar[2]:=s;
 END;
END;
PROCEDURE SmoothData(m,mo:INTEGER);
VAR   mm,mof,li,lj,i:INTEGER; ax,an,rsm:REAL;
LABEL Lend;
BEGIN Bitmap:=TBitmap.Create; WITH Bitmap DO
 BEGIN Width:=exs(516); Height:=exs(323);
 END;
{rsm:=qq.q1; WITH pmrec DO
 BEGIN ax:=amx; an:=amn;
 END;
IF(mo=1)THEN}
 BEGIN rsm:=1; ax:=sa[1]; an:=sa[1]; FOR i:=1 TO m DO
  BEGIN ax:=AMAX1(ax,sa[i]); an:=AMIN1(an,sa[i]);
  END;
 END;
mof:=3; mm:=m;
L0rec:=''; MakeFormV(90,0,530,450,0); Form2.Image2.Visible:=true;
WITH Form2.Image2 DO
 BEGIN Left:=0; Top:=exs(80); Width:=exs(516); Height:=exs(300);
 Form2.Font.Size:=fntsize; Canvas.Pixels[Left+Width-1,Top+Height-1]:=0;
 END;
REPEAT IF(mo=0)THEN smooth(mm,0,rsm,q1,q2)
               ELSE GetEnvelope(m,10,rsm,0.5,0.5);
WITH CB1rec DO
 BEGIN nitems:=3; indx:=mof;
 ar[1]:=' Less smoothing'; ar[2]:=' More smoothing'; ar[3]:=' Quit';
 END;
MakeRadioGroup(1,0,300,0,200,70);
s:='Click on Less or More, then on OK';
OuttoLabel(Form2.Label1,5,30,clGreen,clWhite,s);
s:='If the result is good, click on Quit, then on OK';
OuttoLabel(Form2.Label2,5,50,clGreen,clWhite,s);
WITH Form2.Image2.Canvas DO
 BEGIN Brush.Style:=bsSolid; Brush.Color:=0;
 FillRect(Rect(0,0,exs(516),exs(300)));
 END;
MakeBMFrame(ax,an);
WITH Bitmap.Canvas DO      {Plotting the Graph}
 BEGIN Pen.Style:=psSolid; Pen.Color:=clAqua; FOR i:=1 TO mm DO
  BEGIN li:=exs(Round(Float(i)*512/AMAX0(1,mm)));
  lj:=exs(CalcOrdinate(sa[i],ax,an)); DrawPixelPr(cola[2],li,lj,i,1,1);
  lj:=exs(CalcOrdinate(sd[i],ax,an)); DrawPixelPr(cola[3],li,lj,i,1,1);
  END;
 END;
Form2.Image2.Canvas.Draw(0,0,Bitmap);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN GOTO Lend;
 mof:=Form2.RadioGroup1.ItemIndex+1; IF(mof=3)THEN GOTO Lend;
 END;
IF(mof=1)THEN rsm:=rsm*1.5 ELSE rsm:=rsm/1.5;
UNTIL false;
Lend: Bitmap.Free; {pmrec.lam:=rsm;}
END;
PROCEDURE ToggletheFormSize;
VAR i:INTEGER;
BEGIN L0rec:=''; MakeFormV(100,20,320,430,0);
s:='   Set the screen scale ';
OuttoLabel(Form2.Label1,50,32,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=3; indx:=2; ar[1]:='1'; ar[2]:='1.25'; ar[3]:='1.5';
 END;
MakeRadioGroup(1,0,50,50,200,80);
s:='   Set the font size ';
OuttoLabel(Form2.Label2,50,152,clMaroon,clWhite,s);
 WITH CB1rec DO
 BEGIN nitems:=3; indx:=3;
 ar[1]:=' Small (8)'; ar[2]:=' Regular (10)'; ar[3]:=' Large (12)';
 END;
MakeRadioGroup(2,0,50,170,200,80);
WITH CB1rec DO
 BEGIN nitems:=1;
 ar[1]:=' Use Russian Helps';
 END;
MakeCheckListBox(50,280,200,20);
Form2.CheckListBox1.Checked[0]:=RusHelp;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit; i:=RadioGroup1.ItemIndex;
 RusHelp:=CheckListBox1.Checked[0];
 CASE i OF
 0: scrsize:=1;
 1: scrsize:=1.25;
 2: scrsize:=1.5;
 ELSE END;
 i:=RadioGroup2.ItemIndex;
 CASE i OF
 0: fntsize:=8;
 1: fntsize:=10;
 2: fntsize:=12;
 ELSE END;
 END;
END;
PROCEDURE TaketheModel;
VAR i,j,m:INTEGER;
BEGIN L0rec:='Form the real peak model'; MakeFormV(250,20,330,430,0);
pmod[nmod].FindBackg(spec,g1,g2,j);
s:=' Confirm the bounds ';
OuttoLabel(Form2.Label1,5,30,clMaroon,clWhite,s);
strgrW[0]:=180; strgrW[1]:=70;
strgrT[1]:='  Left bound ='; strgrNn[1,1]:=g1;
strgrT[2]:='  Right bound ='; strgrNn[2,1]:=g2;
strgrT[3]:='  Backgr.edge(chan)= '; strgrNn[3,1]:=j;
PuttoTable(15,60,3,3,1,8);
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
FOR i:=1 TO 3 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
IF(ModalRes=0)THEN ShowMess(wrnum)
              ELSE
 BEGIN Arrange2(har[1],har[2]); pmod[1].ndsign:=true;
 g1:=Round(har[1]); g2:=Round(har[2]); j:=Round(har[3]);
 WITH pmrec DO
  BEGIN im1:=g1; im2:=g2; Lbk:=j; lam:=1;
  END;
 WITH pmod[nmod] DO
  BEGIN camod_Prep(spec,m); IF(ModalRes=0)THEN Exit;
  SmoothData(m,0); IF(ModalRes=0)THEN Exit;
  camod_Make(m); IF(ModalRes=0)THEN Exit;
  END;
 END;
END;
PROCEDURE GraphPeakModel(nmod:INTEGER);
BEGIN L0rec:='Peak Model '+spmodn[pmod[1].typ];
MakeFormV(250,20,330,430,0); GraphModel(1); Form2.Show;
END;
PROCEDURE GraphModel(nmod:INTEGER);
VAR x1,y1,x2,i,j,m,dh:INTEGER; ax,an,rx,x,z,r,del:REAL;
    ii,jj,li,lj:LONGINT;
BEGIN m:=193; x1:=4; x2:=197; y1:=5; dh:=50;
WITH Form2.Image1 DO
 BEGIN Left:=20; Top:=0; Width:=200; Height:=215; Visible:=true;
 END;
y1:=0; ax:=-1E14; an:=1E14; FOR i:=1 TO 193 DO
 BEGIN z:=pmod[1].morr[i]*1000; ax:=AMAX1(ax,z); an:=AMIN1(an,z);
 END;
WITH Form2.Image1.Canvas DO
 BEGIN Pen.Style:=psSolid; Font.Color:=clYellow; Pen.Color:=clLime;
 Brush.Color:=0; FillRect(Rect(2,3,198,212)); Brush.Color:=clGreen;
 del:=(ax-an)/4; FOR i:=1 TO 5 DO
  BEGIN r:=ax-(i-1)*del; lj:=y1+(i-1)*dh+3; li:=x1-2;
  FOR j:=1 TO 102 DO Pixels[li+(j-1)*2-1,lj]:=clLime;
  END;
 FOR i:=1 TO 193 DO
  BEGIN x:=i; j:=Round(x); li:=x1+j;
  rx:=AMAX1(ax-an,0.000001); r:=(pmod[1].morr[i]*1000-an)/rx*200;
  r:=203-r; lj:=y1+Round(r); FOR ii:=-1 TO 1 DO FOR jj:=-1 TO 1 DO
   IF((ABS(ii)+ABS(jj))<2)THEN Pixels[li+ii,lj+jj]:=clFuchsia;
  END;
 FOR i:=1 TO 4 DO
  BEGIN li:=x1+(i-1)*63+1;
  FOR j:=1 TO 57 DO Pixels[li,y1-4+(j-1)*5]:=clLime;
  END;
 END;
END;
PROCEDURE FormSpecialPeakModel;
VAR i,j:INTEGER;
BEGIN L0rec:='Select special model type and number';
MakeFormV(250,20,330,430,0);
SaveHelp(FoSMod_n,FoSMod); WITH CB1rec DO
 BEGIN nitems:=3; ar[1]:=spmodn[1]; ar[2]:=spmodn[3]; ar[3]:=spmodn[7];
 CASE pmod[1].typ OF
 1: indx:=1;
 3: indx:=2;
 7: indx:=3;
 ELSE END;
 IF(NOT(indx IN [1..3]))THEN indx:=1;
 END;
s:=' Type '; OuttoLabel(Form2.Label1,50,20,clMaroon,clWhite,s);
MakeRadioGroup(1,0,170,50,120,160);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit; j:=RadioGroup1.ItemIndex+1;
 WITH pmod[1] DO
 CASE j OF
 1: typ:=1;
 2: typ:=3;
 3: typ:=7;
 ELSE END;
 pmod[1].makesm;
 END;
END;
PROCEDURE SetSpectrumData;
VAR i:INTEGER;
BEGIN L0rec:='Setting the spectrum data'; MakeFormV(250,20,330,430,0);
SaveHelp(IShelp_n,IShelp); strgrW[0]:=150; strgrW[1]:=90;
strgrT[1]:=' Spectrum beginning'; strgrT[2]:=' Spectrum end';
strgrT[3]:=' Interval beginning'; strgrT[4]:=' Interval end';
strgrT[5]:=' Spectrum File Type'; strgrT[6]:=' Small Statistics';
strgrT[7]:=' Covar';
strgrT[8]:=' Order for blunders'; strgrT[9]:=' Chi2 for blunders';
strgrT[10]:=' Width_1(chan)'; strgrT[11]:=' Width_2(chan)';
strgrT[12]:=' Delta Width(chan)';
WITH spec DO
 BEGIN strgrNn[1,1]:=a1; strgrNn[2,1]:=a2;
 strgrNn[3,1]:=a11; strgrNn[4,1]:=a22;
 strgrNn[5,1]:=smosp;
 strgrNn[10,1]:=w0; strgrNn[11,1]:=w1; strgrNn[12,1]:=dw0;
 END;
strgrNn[6,1]:=smast; strgrNn[7,1]:=covar;
strgrNn[8,1]:=order; strgrNn[9,1]:=chibc;
PuttoTable(40,30,12,12,1,{ndig}8);
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
FOR i:=1 TO 12 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
WITH spec DO
 BEGIN a1:=MAX1(1,har[1]); a2:=MIN1(16384,har[2]);
 a11:=Round(AMAX1(1,har[3])); a22:=Round(AMIN1(16384,har[4]));
 IF(NOT infun(a11,a1,a2))THEN a11:=a1+1;
 IF(NOT infun(a22,a1,a2))THEN a22:=a2-1;
 END;
ic1:=spec.a11; ic2:=spec.a22; cadl:=ic2-ic1+1;
spec.smosp:=Round(har[5]); smast:=Round(har[6]); covar:=har[7];
order:=har[8]; chibc:=har[9];
spec.w0:=AMAX1(0.25,har[10]); spec.w1:=AMAX1(0.25,har[11]);
spec.dw0:=har[12]; FormSpecErrors;
END;
PROCEDURE SetMarkingData;
VAR i:INTEGER;
BEGIN L0rec:='Setting the marking data'; MakeFormV(250,20,330,430,0);
SaveHelp(SMDhelp_n,SMDhelp);
strgrW[0]:=140; strgrW[1]:=100;
FOR i:=1 TO 6 DO strgrT[i]:=IDCaptions[1,i-1];
        onl[1]:=rl; onl[2]:=linx; onl[3]:=sens; onl[4]:=res;
strgrNn[1,1]:=rl; strgrNn[2,1]:=linx;
strgrNn[3,1]:=sens; strgrNn[4,1]:=res;
strgrNn[5,1]:=kwmerg; strgrNn[6,1]:=admerg;
PuttoTable(40,30,6,6,1,{ndig}8);
s:='Interval  Length = 2 * kWidth * Width + adInterv';
OuttoLabel(Form2.Label1,10,200,clMaroon,clWhite,s);
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
FOR i:=1 TO 6 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
rl:=har[1]; linx:=MIN0(512,Round(har[2])); sens:=har[3]; res:=har[4];
kwmerg:=har[5]; admerg:=Round(har[6]);
END;
PROCEDURE SetFitData;
VAR i:INTEGER;
BEGIN L0rec:='Setting the fitting data'; MakeFormV(250,20,330,430,0);
SaveHelp(SFDhelp_n,SFDhelp);
strgrW[0]:=140; strgrW[1]:=100;
FOR i:=1 TO 9 DO strgrT[i]:=IDCaptions[3,i-1];
strgrT[9]:=' Peak chan.number N ';
strgrNn[1,1]:=spec.wv; strgrNn[2,1]:=spec.dwv;
strgrNn[3,1]:=niter; strgrNn[4,1]:=step; strgrNn[5,1]:=damp;
strgrNn[6,1]:=ABS(spec.dback); strgrNn[7,1]:=dpos[1];
strgrNn[8,1]:=cali; strgrNn[9,1]:=cali;
PuttoTable(40,30,9,9,1,{ndig}8);
WITH CB1rec DO
 BEGIN nitems:=1; ar[1]:=' Set peak channel number N for normalisation';
 END;
MakeCheckListBox(5,250,310,20);
ok:=true; IF(nomo)THEN ok:=false; Form2.CheckListBox1.Checked[0]:=ok;
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
FOR i:=1 TO 9 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
spec.wv:=har[1]; spec.dwv:=har[2]; niter:=Round(har[3]);
step:=ABS(har[4]); damp:=har[5];
spec.dback:=MIN1(3,ABS(har[6])); dpos[1]:=har[7];
IF(nomo)THEN cali:=har[9] ELSE cali:=har[8];
IF(Form2.CheckListBox1.Checked[0])THEN nomo:=false ELSE nomo:=true;
END;
PROCEDURE SetScalemode;
VAR j:INTEGER;
BEGIN L0rec:='Select the scale mode'; MakeFormV(250,20,330,430,0);
SaveHelp(SScaleM_n,SScaleM); WITH CB1rec DO
 BEGIN ar[1]:='Normal'; ar[2]:='SQRT'; ar[3]:='LN'; ar[4]:='Trimmed';
 nitems:=4; indx:=nscale;
 END;
MakeRadioGroup(1,0,70,20,170,160);
L1rec:='Trimming coefficient = '; ConvertStr(trimm,7,3); E1rec:=sedz;
OuttoLabel(Form2.Label1,30,250,clMaroon,clWhite,L1rec);
MakeEdit(Form2.Edit1,200,248,90,E1rec);
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
nscale:=Form2.RadioGroup1.ItemIndex+1; IF(nscale=4)THEN
 BEGIN Zval(Form2.Edit1.Text,r); IF(ModalRes=0)THEN
  BEGIN ShowMess('Wrong trimming'); Exit;
  END;
 trimm:=r;
 END;
END;
PROCEDURE SettheNextSpectrumName;
VAR i,j,k:INTEGER; s:STRING; ok:BOOLEAN;
BEGIN IF(nsfn=0)THEN
 BEGIN ShowMess('No items in the name list'); Exit;
 END;
L0rec:='Set the current spectrum name'; MakeFormV(250,20,330,430,0);
OuttoLabel(Form2.Label1,5,40,clGreen,clAqua,'Select the name:');
WITH LB1rec DO
 BEGIN nitems:=nsfn; FOR i:=1 TO nsfn DO
  BEGIN s:=ExtractFileExt(sfnar[i]); ExtractFN(sfnar[i],sedz);
  ar[i]:=sedz+s;
  END;
 END;
MakeCombo(25,70,270);
WITH CB1rec DO
 BEGIN nitems:=1; ar[1]:='Spectrum input under default conditions';
 END;
MakeCheckListBox(15,270,290,20);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 k:=ComboBox1.ItemIndex+1; spec.sfn:=sfnar[k];
 IF(CheckListBox1.Checked[0])THEN InputSpectrumData(ok){Input if needed}
                             ELSE InputtheSpectrum;
 END;
IF((NOT ok)OR(ModalRes=0))THEN Exit;
{Finish} L0rec:=''; MakeFormV(250,20,330,430,0); WITH LB1rec DO
 BEGIN nitems:=5;
 ar[1]:='  '+spec.sfn+'-name set';
 ar[2]:=' ';
 ar[3]:='After processing this spectrum';
 ar[4]:='and saving the results, its name';
 ar[5]:='will be deleted from the list';
 END;
MakeListBox(5,40,290,120); Form2.ShowModal;
END;
PROCEDURE GraphEnergyCalibration;
VAR x1,y1,x2,i,j,m,dh:INTEGER; zz,ax,an,rx,x,z,r,del:REAL;
    ii,jj,li,lj:LONGINT;
BEGIN IF(NOT encm)THEN
 BEGIN ShowMess('No energy calibration set up'); Exit;
 END;
L0rec:='Energy calibration'; MakeFormV(250,20,330,430,0);
m:=193; x1:=4; x2:=197; y1:=5; dh:=50; WITH Form2.Image1 DO
 BEGIN Left:=20; Top:=0; Width:=200; Height:=215; Visible:=true;
 END;
y1:=0; ax:=-1E14; an:=1E14; FOR i:=1 TO ncen DO
 BEGIN z:=enc[i].y; ax:=AMAX1(ax,z); an:=AMIN1(an,z);
 END;
WITH Form2.Image1.Canvas DO
 BEGIN Pen.Style:=psSolid; Font.Color:=clYellow; Pen.Color:=clLime;
 Brush.Color:=0; FillRect(Rect(2,3,198,212)); Brush.Color:=clGreen;
 del:=(ax-an)/4; FOR i:=1 TO 5 DO
  BEGIN r:=ax-(i-1)*del; lj:=y1+(i-1)*dh+3; li:=x1-2;
  FOR j:=1 TO 102 DO Pixels[li+(j-1)*2-1,lj]:=clLime;
  END;
 rx:=AMAX1(ax-an,0.000001); FOR i:=1 TO ncen DO
  BEGIN x:=180*(enc[i].x-enc[1].x)/AMAX1(enc[ncen].x-enc[1].x,0.0001);
  j:=Round(x); li:=x1+j+7; calibr(enc[i].x,0,0,0,z,zz,zz,zz);
  r:=(z-an)/rx*190; r:=203-r; lj:=y1+Round(r);
  Pen.Color:=clAqua; IF(i=1)THEN MoveTo(li,lj) ELSE LineTo(li,lj);
  r:=(enc[i].y-an)/rx*190; r:=203-r; lj:=y1+Round(r);
  FOR ii:=-2 TO 2 DO FOR jj:=-1 TO 1 DO
   IF((ABS(ii)+ABS(jj))<8)THEN Pixels[li+ii,lj+jj]:=clFuchsia;
  END;
 FOR i:=1 TO 4 DO
  BEGIN li:=x1+(i-1)*63+1;
  FOR j:=1 TO 57 DO Pixels[li,y1-4+(j-1)*5]:=clLime;
  END;
 END;
Form2.Show;
END;


END.
