UNIT vdomus0;
INTERFACE
USES Forms, Graphics, SysUtils, vzlocom, vspectr;
TYPE HKLDREC = RECORD h,k,l:INTEGER; d:REAL;
               END;
     PEAKAR3 = RECORD x,y,z,V,wx,wy,wz:REAL;
               END;
CONST i32 :LONGINT = 32768;
      cola:ARRAY[1..7] OF LONGINT = (clBlack,clNavy,clTeal,clGreen,
                                     clOlive,clBlue,clAqua);
CONST inicomm:ARRAY[1..25] OF STRING[47] = (
 '...Beginning of the 3-dim.spectrum N-coordinate',
 '...End of the 3-dim.spectrum N-coordinate',
 '...Beginning of the 3-dim.spectrum X-coordinate',
 '...End of the 3-dim.spectrum X-coordinate',
 '...Beginning of the 3-dim.spectrum Y-coordinate',
 '...End of the 3-dim.spectrum Y-coordinate',
 '...Flight Path',
 '...DELAY',
 '...Channel Width (mks)',
 '...2*THeta0',
 '...DthX(m)',
 '...DthY(m)',
 '...L Constant (m)',
 '...Lambda Smoothing',
 '...SENSitivity',
 '...RESolution',
 '...WNmaX',
 '...WXmaX',
 '...WYmaX',
 '...WNmaN',
 '...WXmaN',
 '...WYmaN',
 '...HVMin',
 '...NX in D-scale',
 '...NY in D-scale'                        );
CONST nspi:LONGINT = 262144;
VAR
  l:LONGINT;
  x,y,z,f:REAL;
  sfn,esfn:STRING;           {Spectrum and Effec.Spectrum file names}
  {sp,ssp,hsp,esp:ARRAY[1..1024,1..32,1..16] OF REAL;}
  sp:ARRAY[1..1024,1..32,1..8] OF INTEGER;  {Spectrum}
  ssp:ARRAY[1..1024,1..32,1..8] OF REAL;    {Smoothed Spectrum}
  hsp:ARRAY[1..342,1..16,1..8] OF INTEGER;  {Auxi.Spectrum}
  esp:ARRAY[1..1024,1..32,1..8] OF INTEGER; {Effective Spectrum}
  csp:ARRAY[1..1024] OF REAL;      {XY-Convoluted spectrum}
  nsecar:ARRAY[1..1024] OF REAL;   {N-Section}
  snx:ARRAY[1..1024,1..32] OF INTEGER;{Y-Convoluted spectrum}
  sny:ARRAY[1..1024,1..8] OF INTEGER; {X-Convoluted spectrum}
  i1,i2,j1,j2,k1,k2:INTEGER;  {Bounds of a 3-dimensional spectrum}
  xl1,xl2,dxl,yl1,yl2,dyl,olmax:INTEGER; {bounds to compress large spec}
  mN1,mN2,mx1,mx2,my1,my2:INTEGER; {Bounds of the reversed spectrum}
  spx,spn,snor:REAL;          {Current,normal max/min in the spectrum}
  cspx,cspn,csnor:REAL;       {Current,normal max/min in XY-conv.sp.}
  cxnx,cnnx,cynor:REAL;       {Current,normal max/min in Y-conv.sp.}
  cxny,cnny,cxnor:REAL;       {Current,normal max/min in X-conv.sp.}
  espx:REAL;                  {Max in the effective spectrum}
  aspx:REAL;                  {Max in the additional spectrum}
  grst:INTEGER;               {0=no graph  1=spectrum  2=convol}
  iw,ih,it,ix:LONGINT;        {iwidth, iheight etc. of Image2}
  rl,sens,res:REAL;           {smoothing, sensitivity, resolution}
  wx,wy,wz,                   {peak widths}
  wxxl,wyyl,wzzl:REAL;        {peak width lower bounds}
  wxxu,wyyu,wzzu:REAL;        {peak width upper bounds}
  hvmin:REAL;                 {minimal hypervolume}
  pkar:ARRAY[1..512] OF PEAKAR3;{peak array: x,y,z,V,wx,wy,wz}
  pkai:ARRAY[1..512] OF PEAKAR3;{the same in the reversed space}
  hkldar:ARRAY[1..1024] OF HKLDREC;
  npk:INTEGER;                {number of found peaks}
  Fp:REAL;                    {flight path}
  delay:REAL;                 {delay}
  chw:REAL;                   {channel width}
  Bra:REAL;                   {double Bragg angle 0}
  dthx:REAL;                  {delta thx}
  dthy:REAL;                  {delta thy}
  lm:REAL;                    {additional small flight path}
  sum:REAL;                   {sum of peak areas}

  noefs:BOOLEAN;              {is or not the effective spectrum here}
  noefsc:BOOLEAN;             {Corrected/not for the effective spectrum}
  norevers:BOOLEAN;           {Was the spectrum reversed?}
  noToF:BOOLEAN;              {is/not the TOF information}
  nosaved:BOOLEAN;            {are the results saved?}
  ok1:BOOLEAN;

  ncl,g1,g2:INTEGER;          {n of clicks, beginning,end of zoomed int}
  xgp,ygp:INTEGER;            {x,y of the N-distribution in 3-d.spectr}
  vddir:STRING;               {VDOMUS directory}
  fnhkli,fnhklo:STRING;       {File names for hkl in/out-put files}
  outfn:STRING;               {VDOMUS res-file name}
  ddev:REAL;                  {admissible deviation for d}
  butar:STRING;               {if i=1 button_i enabled}
  spec:TSpectrum;             {spectrum classes}
PROCEDURE ComputeXYZ(ic:LONGINT; VAR i,j,k:INTEGER);
FUNCTION CompCurrMax(snor:REAL):REAL;
PROCEDURE SetTheMaxima;
PROCEDURE ConvoluteTheSpectrum(VAR csnor:REAL; m:INTEGER);
PROCEDURE computeD(ch,x,y:REAL; VAR a,th,d:REAL);
IMPLEMENTATION
PROCEDURE computeD(ch,x,y:REAL; VAR a,th,d:REAL);
{***  Purpose: To compute dk ***  Version: Feb 16 1999 }
CONST jm:INTEGER = 32;
      km:INTEGER = 8;
VAR   pi2,x0,dx,dy,dxx,ang,ca,b,c,dl,rmax,xx,s,sinth:REAL;
      dthxr,dthyr,theta0:REAL;
BEGIN pi2:=pi*0.5; x0:=jm*0.5;
theta0:=Bra/radian; dthxr:=dthx/radian; dthyr:=dthy/radian;
dx:=(x-jm*0.5)*dthxr; dy:=(y-km*0.5)*dthyr; dxx:=x0*dthxr;
ang:=pi2-theta0; IF(theta0 > pi2)THEN ang:=theta0-pi2;
ca:=COS(ang); b:=dxx/ca; dl:=b*SIN(ang); rmax:=lm-dl;
IF(theta0 > pi2)THEN rmax:=lm+dl; dxx:=ABS(x)*dthxr;
{ Determine a,c }
c:=SQRT(SQR(dy)+SQR(dxx)+SQR(rmax)); a:=SQRT(SQR(dx)+SQR(dy)+SQR(lm));
xx:=(SQR(c)+SQR(b)-SQR(a))/(2*c); s:=c*SQRT(SQR(b)-SQR(xx))*0.5;
sinth:=2*s/(a*b); th:=ARCSIN(sinth);
IF(c > SQRT(SQR(a)+SQR(b)))THEN th:=pi-th;
th:=th*0.5; d:=(ch+delay)/(tofcon*(Fp+a)/chw*SIN(th));
END;
PROCEDURE ComputeXYZ(ic:LONGINT; VAR i,j,k:INTEGER);
VAR il,ii:LONGINT;
BEGIN il:=((ic-1) DIV i32)+1; k:=il;
ii:=ic-1-(k-1)*i32; il:=(ii DIV 1024)+1; j:=il;
il:=ii-(j-1)*1024+1; i:=il;
END;
{FUNCTION XYZtoK(x,y,z:INTEGER):LONGINT;
VAR l:LONGINT;
BEGIN l:=(z-1)*i32+(y-1)*1024+x; XYZtoK:=l;
END;}
FUNCTION CompCurrMax(snor:REAL):REAL;
VAR spx:REAL;
BEGIN
CASE nscale OF
1: spx:=snor;
2: spx:=SQRT(ABS(snor));
3: spx:=LN(ABS(snor)+1);
4: spx:=snor*trimm;
ELSE spx:=1; END;
CompCurrMax:=spx;
 END;
PROCEDURE SetTheMaxima;
BEGIN spx:=CompCurrMax(snor); cspx:=CompCurrMax(csnor);
cxnx:=CompCurrMax(cxnor); cxny:=CompCurrMax(cynor);
END;
PROCEDURE ConvoluteTheSpectrum(VAR csnor:REAL; m:INTEGER);
VAR i,j,k:INTEGER; l:LONGINT; t:REAL;
BEGIN csnor:=0; FOR i:=i1 TO i2 DO
 BEGIN CASE m OF
 0: BEGIN t:=0; FOR j:=j1 TO j2 DO FOR k:=k1 TO k2 DO t:=t+ssp[i,j,k];
    csp[i]:=t; IF(t>csnor)THEN csnor:=t;
    END;
 1: FOR j:=j1 TO j2 DO
     BEGIN t:=0; FOR k:=k1 TO k2 DO t:=t+ssp[i,j,k];
     snx[i][j]:=Round(t); IF(t>csnor)THEN csnor:=t;
     END;
 2: FOR k:=k1 TO k2 DO
     BEGIN t:=0; FOR j:=j1 TO j2 DO t:=t+ssp[i,j,k];
     sny[i][k]:=Round(t); IF(t>csnor)THEN csnor:=t;
     END;
       ELSE END;
 END;
END;
{----------}
BEGIN
i1:=1; i2:=1024; j1:=1; j2:=32; k1:=1; k2:=8;
mN1:=1; mN2:=1024; mx1:=1; mx2:=32; my1:=1; my2:=8;
xgp:=(j1+j2)DIV 2; ygp:=(k1+k2)DIV 2; sfn:=''; esfn:='';
rl:=0.5; sens:=1; res:=1;
wxxl:=7; wyyl:=4; wzzl:=1.5; wxxu:=10; wyyu:=5; wzzu:=3; hvmin:=1000;
Fp:=23.75; delay:=-30; chw:=64; Bra:=88;
dthx:=0.0075; dthy:=0.02; lm:=0.51;
trimm:=0.50; grst:=0;
noefs:=true; noefsc:=true; noToF:=true; norevers:=true; nosaved:=false;
ncl:=0; {nresf:=0;}
butar:='1111111111'; nscale:=1;
xl1:=1; xl2:=128; dxl:=4; yl1:=1; yl2:=64; dyl:=8; olmax:=1000;
END.
