UNIT vmdomus; {Jul 11 2002}

INTERFACE
USES Windows,  Classes, Dialogs, SysUtils, Graphics, Forms,  Controls,
     StdCtrls, Grids,  ExtCtrls,
     vzlocom,  varfun,  vmria0,  vmdomus0, vmria3,   vmriahlp;
PROCEDURE DomusSpectrumInput;
PROCEDURE DomusSpectrumGraph(CONST SS:TImage);
VAR MDomus: TVDomus;
IMPLEMENTATION
PROCEDURE DomusSpectrumInput;
BEGIN CheckSavings(ok,s); IF(NOT ok)THEN Exit;
L0rec:='DOMUS = decomposition of multi-dim.spectra';
MakeFormV(250,20,330,430,0); SaveHelp(blankH_n,blankH);
mmsave:=mriamode; mriamode:=5; IF(NOT DOpened)THEN
 BEGIN MDomus:=TVDomus.Create; DOpened:=true;
 END;
WITH Form2 DO WITH MDomus DO
 BEGIN OpenDialog1.Title:='   Select the file';
 OpenDialog1.FileName:=sfn;
 IF(OpenDialog1.Execute)THEN sfn:=OpenDialog1.FileName ELSE Exit;
 IF(NOT FileExists(sfn))THEN ShowMessage('No file '+sfn)
                        ELSE
  BEGIN Read3Binary; IF(spx=0)THEN
   BEGIN ShowMessage('++++ Error, the spectrum is zero-valued'); Exit;
   END                        ELSE WITH Canvas DO
    BEGIN ShowMessage('The spectrum '+sfn+' read in');
    Convolute; SetTheMaxima;
    npeak:=0; noefsc:=true; norevers:=true; nosavedD:=false;
    END;
  END;
 END;
END;
PROCEDURE BrushArea(x1,y1,x2,y2,c:LONGINT; s:TBrushStyle);
{Clear an area}
BEGIN WITH Bitmap.Canvas DO
 BEGIN Brush.Color:=c; Brush.Style:=s; FillRect(Rect(x1,y1,x2,y2));
 END;
END;
PROCEDURE DomusSpectrumGraph(CONST SS:TImage);
VAR i,j,k,n1,n2,ii,kn,c:INTEGER; r,z:REAL; li,lj,lk:LONGINT;
{ PROCEDURE MakeEd(S:TEdit; i,j,k:INTEGER);
 BEGIN WITH S DO
  BEGIN Left:=i; Top:=j; Width:=50; Text:=InttoStr(k); Height:=18;
  Visible:=true;
  END;
 END;}
BEGIN WITH MDomus DO
{WITH Form1 DO
 BEGIN MakeEd(Edit1,280,0,i1); MakeEd(Edit2,280,20,i2);
 MakeEd(Edit3,400,0,j1); MakeEd(Edit4,400,20,k1);
 MakeEd(Edit5,550,5,j1);
 END;}
 BEGIN n1:=((i1-1) DIV 2)+1; n2:=((i2-1) DIV 2)+1;
 SS.Visible:=true; Bitmap:=TBitmap.Create;
WITH Bitmap DO {Main}
 BEGIN Width:=520; Height:=380;
 END;
 BrushArea(0,0,99,380,clGreen,bsSolid);
 SS.Canvas.Draw(0,0,Bitmap); Bitmap.Free;
{MakeBitmaps;} {WITH ProgressBar1 DO
 BEGIN Visible:=true; Left:=0; Top:=51; Width:=100;
 END; }
WITH Bitmap.Canvas DO {Main}
 BEGIN BrushArea(0,0,520,380,clBlack,bsSolid);
 spx:=AMAX1(CompCurrMax(snor),1); FOR k:=k1 TO k2 DO{Graph the spectrum}
  BEGIN r:=k-1; r:=r*100/8; {ProgressBar1.Position:=Round(r); }
  FOR j:=j1 TO j2 DO FOR i:=n1 TO n2 DO
   BEGIN ii:=1+(i-1)*2; z:=(sp[ii,j,k]+sp[ii+1,j,k])*0.5;
   CASE nscale OF
   2: z:=SQRT(ABS(z));
   3: z:=LN(ABS(z)+1);
   4: z:=AMIN1(z,spx);
   ELSE END;
   c:=Round(z*256/spx);
   li:=i; lj:=(33-j); lk:=(8-k)*34;
   Bitmap.Canvas.Pixels[li,lj+lk]:=RGB(0,c,c);
   END;
  END;
 WITH Bitmap.Canvas DO {Horizontal lines}
  BEGIN FOR i:=0 TO 8 DO
   BEGIN lj:=i*34-1; Brush.Color:=ClRed; FillRect(Rect(0,lj,520,lj+1));
   END;
  Brush.Color:=clBlack;
  END;
 kn:=1024 DIV 100+2; {DotArea(0,0,360,kn);}
 BrushArea(0,271,520,306,clMaroon,bsSolid);
 {MakeAbscissae(0,274,kn); xgp:=j1; ygp:=k1;}
 {WITH Image2.Canvas DO
  BEGIN Font.Color:=clWhite; Brush.Color:=clMaroon; Font.Size:=10;
  s:=ExtractFileName(sfn); TextOut(1,20,' '+s+' ');
  Font.Color:=clLime; TextOut(1,1,' SPECTRUM FILE: ');
  TextOut(251,5,'N1= '); TextOut(251,25,'N2= ');
  TextOut(370,5,'X= '); TextOut(370,25,'Y= ');
  TextOut(480,10,'N sect= ');
  END;}
 {Put the marks of the found peaks}
 IF(npeak<>0)THEN FOR ii:=1 TO npeak DO
  BEGIN li:=(Round(parr[1,ii])-i1) DIV 2;
  lj:=33-Round(parr[2,ii])+5; lk:=(8-Round(parr[3,ii]))*34;
  WITH Bitmap.Canvas DO
   BEGIN Pen.style:=psSolid; Pen.Color:=clFuchsia; Brush.Color:=clBlack;
   Moveto(li,lj+lk); lj:=lj-10; Lineto(li,lj+lk);
   lj:=lj+5; li:=li-5; Moveto(li,lj+lk); li:=li+10; Lineto(li,lj+lk);
   END;
  END;
 END;
 END;
SS.Canvas.Draw(0,0,Bitmap); Bitmap.Free; {GraphNSection;
ProgressBar1.Visible:=false; ncl:=-1; grst:=1;
ArrangeButtons(Self); }
END;
{----------}
BEGIN
END.



PROCEDURE DotArea(x1,y1,y2,kn:INTEGER);
VAR i,k:INTEGER; li,lj:LONGINT;
BEGIN WITH Bitmap.Canvas DO
 BEGIN Pen.style:=psSolid; Pen.Color:=clBlue;
 Brush.Color:=clBlack; FOR i:=1 TO kn DO
  BEGIN li:=x1+1+(i-1)*50; IF(li<512)THEN
   BEGIN lj:=y1+1; Moveto(li,lj); lj:=y2; Lineto(li,lj);
   END;
  END;
 END;
END;
PROCEDURE MakeAbscissae(x1,y1,kn:INTEGER);
VAR i,k:INTEGER; li:LONGINT;
BEGIN WITH Bitmap.Canvas DO
 BEGIN Brush.Color:=clBlue; Font.Color:=clWhite; FOR i:=1 TO 12{kn} DO
  BEGIN li:=1+1+(i-1)*50; k:=1+(li-1-1)*2;
  IF((li>15)AND(li<=512))THEN TextOut(li-20,y1,' '+InttoStr(k)+' ');
  END;
 END
END;
PROCEDURE MakeBitmaps;
BEGIN Form1.Image1.Visible:=true; Form1.Image2.Visible:=true;
Form1.Image3.Visible:=true;
Bitmap:=TBitmap.Create; WITH Bitmap DO {Top}
 BEGIN Width:=620; Height:=40;
 END;
BrushArea(0,0,620,40,clMaroon,bsSolid);
Form1.Image2.Canvas.Draw(0,0,Bitmap); Bitmap.Free;
Bitmap:=TBitmap.Create; WITH Bitmap DO {sidelong}
 BEGIN Width:=99; Height:=380;
 END;
BrushArea(0,0,99,380,clGreen,bsSolid);
Form1.Image3.Canvas.Draw(0,0,Bitmap); Bitmap.Free;
Bitmap:=TBitmap.Create; WITH Bitmap DO {Main}
 BEGIN Width:=520; Height:=380;
 END;
END;
