UNIT vmria0; {May 2 2000, restructured on Apr 6 2001,Jan 5 2002}

INTERFACE
USES Forms,   Graphics, comctrls, Dialogs, SysUtils, Controls, vzlocom,
     varfun,  vmriasp,  vspectr,  math,    vpeaksr,  vgfit,    vmria00,
     vmria2,  vmriahlp, vstdcons;

PROCEDURE MakeAnisoPars;
PROCEDURE SetNonDefKeys;
PROCEDURE ImposeLinks;
PROCEDURE FixHKL0(j,mo:INTEGER; hh:REAL);
PROCEDURE PrepareRfPm(mRiPM:INTEGER; VAR showpa:BOOLEAN);
PROCEDURE CheckSpecIntBounds(i1,i2:INTEGER; VAR ok:BOOLEAN);
PROCEDURE CheckAtHKL;
PROCEDURE Get2Thetas(ns:INTEGER);

IMPLEMENTATION
PROCEDURE Get2Thetas(ns:INTEGER);
VAR i:INTEGER;
BEGIN MakeForm(0);
s:=' Specify 2theta values (in degr.) of: ';
OuttoLabel(Form2.Label5,10,40,clMaroon,clWhite,s);
strgrW[0]:=220; strgrW[1]:=80;
strgrT[1]:='1st channel of spectrum interval';
strgrT[2]:='Channel width';
WITH spec[ns] DO
 BEGIN strgrNn[1,1]:=x[a1]; strgrNn[2,1]:=chw;
 PuttoTable(15,60,2,2,1,8);
 WITH Form2 DO
  BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
  FOR i:=1 TO 2 DO Zval(StringGrid1.Cells[0,i-1],har[i]);{c,r}
  x[a1]:=har[1]; chw:=har[2];
  celx1:=0; IF(chw<>0)THEN celx1:=1/chw; celx0:=a1-x[a1]*celx1;
  END;
 END;
END;
PROCEDURE testarith2(i:INTEGER; yy,x:REAL; VAR w,f:REAL);
{The arithmetic procedure for least squares minimization;
    f  = a*(1-s)*exp(-(x-p)^2/w^2) + s/2*exp") Dec 21 2004}
VAR w2,ff,wi,si,r,ex,z,a,sic:REAL; iw,js,j:INTEGER;
BEGIN iw:=2*npeak+7; js:=2*npeak+14; WITH gfit DO
 BEGIN f:=0; wi:=par[iw].p; sic:=par[js].p; w2:=wi*wi;
 FOR j:=1 TO 3 DO
  BEGIN a:=par[j+6].p; z:=(x-par[j+9].p)/wi; ex:=exp(-SQR(z));
  CASE j OF
  1: si:=0;
  2: si:=0;
  3: si:=sic;
  ELSE END;
  ff:=2*SQR(z)-1; r:=(1-si+si*ff/w2); f:=f+a*ex*r; rb0[2+j]:=a*ex*r;
  par[j+6].drv:=ex*r;
  par[j+6+npeak].drv:=-2*a*ex*z/wi*(si-1-si/w2*ff+4*si/w2);
  par[iw].drv:=par[iw].drv+2*a*ex/wi*(z*z*r+(si-4*si*z*z)/w2);
  par[js].drv:=par[js].drv+a*ex*(2*ff/w2-0.5);
  END;
 END;
rb0[1]:=0; rb0[2]:=f;
END;
PROCEDURE TestArith(VAR y,w,f:REAL; i,typ:INTEGER);
{The arithmetic procedure for least squares minimization;
    f  = a*exp(-(x-p)^2/w^2)
 computes function value + 1-st derivatives, Dec 20 2004}
VAR r,ex,x,z:REAL; j:INTEGER;
BEGIN y:=spec[numsp].y[i]; w:=SQRT(y+1); x:=FLOAT(i); WITH testlsm DO
 BEGIN par[7].drv:=0; f:=0; FOR j:=1 TO 3 DO
  BEGIN z:=(x-par[2*j].p)/par[7].p; ex:=exp(-SQR(z));r:=par[2*j-1].p*ex;
  par[2*j-1].drv:=ex; par[2*j].drv:=2*r*z/par[7].p;
  par[7].drv:=par[7].drv+2*r*SQR(z)/par[7].p; f:=f+r;
  END;
 END;
END;
PROCEDURE SetNonDefKeys;
VAR i,j,mo:INTEGER;
BEGIN L0rec:=''; MakeForm(1); SaveHelp(WidthInfo_n,WidthInfo);
CB1rec:=SetWidth; CB1rec.indx:=keyWdt+1; {Width}
OuttoLabel(Form2.Label5,60,10,clMaroon,clWhite,
 '    Set the Width mode  ');
MakeRadioGroup(1,0,15,30,273,160);
CB1rec:=SetBckg; CB1rec.indx:=keyBck+1; {Bkg}
OuttoLabel(Form2.Label7,60,210,clMaroon,clWhite,
 '  Set the Background mode ');
MakeRadioGroup(2,0,15,230,273,70);
WITH CB1rec DO
 BEGIN nitems:=2;
 ar[1]:='Set anisotropic mode';
 ar[2]:='Set m2-mode';
 END;
MakeCheckListBox(30,310,250,40);
Form2.CheckListBox1.Checked[0]:=anis_mod;
Form2.CheckListBox1.Checked[1]:=use_m2;
{s:=' m2-mode is using as peak model: ';
OuttoLabel(Form2.Label8,30,330,clMaroon,clWhite,s);
s:=' m(z)+(a0+a1*x)*m"(z) ';
OuttoLabel(Form2.Label9,75,348,clMaroon,clWhite,s);}
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i:=RadioGroup1.ItemIndex+1; mo:=RadioGroup2.ItemIndex+1;
 keyWdt:=i-1; keyBck:=mo-1;
 anis_mod:=CheckListBox1.Checked[0];
 use_m2:=CheckListBox1.Checked[1];
 IF((anis_mod)AND(nph=1))THEN anisma[1]:=true;
 IF(NOT anis_mod)THEN FOR i:=1 TO nph DO anisma[i]:=false;
 IF((nph>1)AND(anis_mod))THEN
  BEGIN MakeForm(1);
  OuttoLabel(Label6,60,235,clMaroon,clWhite,
   'Tick anisotropic phases'); WITH CB1rec DO
   BEGIN nitems:=nph; FOR j:=1 TO nph DO ar[j]:=' Phase '+IntToStr(j);
   END;
  MakeCheckListBox(60,255,150,nph*18);
  WITH CheckListBox1 DO FOR j:=1 TO nph DO IF(anisma[j])THEN
   Checked[j-1]:=true ELSE Checked[j-1]:=false;
  ShowModal; FOR j:=1 TO nph DO
  IF(CheckListBox1.Checked[j-1])THEN anisma[j]:=true
                                ELSE anisma[j]:=false;
  END;
 END;
IF(keyBck=1)THEN spec[numsp].dback:=6;
IF(anis_mod OR use_m2)THEN
 BEGIN MakeAnisoPars; MakeParComments;
 END;
END;
PROCEDURE MakeAnisoPars;
VAR i,j,iph:INTEGER;
BEGIN FOR iph:=1 TO nph DO WITH lat[iph] DO
 BEGIN j:=GetNAddiPar(1)+(iph-1)*npani;
 FOR i:=1 TO npani DO WITH parar[j+i] DO IF(anisma[iph])THEN
  BEGIN pl:=-1E15; p:=anisa[i]; pu:=1E15; a:=1; b:=0; n:=j+i;
  {IF(syng >= 4)THEN parar[j+2].n:=j+1;}
  IF(syng IN [5,7])THEN parar[j+3].n:=j+1;
  IF(syng IN [5,7])THEN parar[j+2].n:=j+1;
  IF((mriamode=2)AND((i-1)<3))THEN
   BEGIN pl:=0; p:=0; pu:=0;
   END;
  END;
 END;
IF(use_m2)THEN
 BEGIN j:=GetNAddiPar(2); FOR i:=1 TO 2 DO WITH parar[j+i] DO
  BEGIN pl:=-1E15; p:=m2para[i]; pu:=1E15; a:=1; b:=0; n:=j+i;
  END;
 END;
END;
PROCEDURE ImposeLinks;
VAR   i,j1,j2:INTEGER;
LABEL Lbeg;
BEGIN L0rec:=''; MakeForm(0);
s:='To quit click on Cancel';
OuttoLabel(Form2.Label8,5,350,clMaroon,clWhite,s);
s:='Between phases'; OuttoLabel(Form2.Label5,5,10,clMaroon,clWhite,s);
s:='(left phase < right phase)';
OuttoLabel(Form2.Label7,140,10,clMaroon,clWhite,s);
Lbeg: CB1rec:=Num4Rec; CB1rec.nitems:=6;
MakeRadioGroup(1,0,10,30,140,170);
MakeRadioGroup(2,0,160,30,140,170);
s:='impose links on parameters';
OuttoLabel(Form2.Label6,5,210,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=3;
 ar[1]:='Scale'; ar[2]:='Unit cell'; ar[3]:='Width';
 END;
MakeCheckListBox(70,230,90,58);
Form2.CheckListBox1.Checked[0]:=false;
Form2.CheckListBox1.Checked[1]:=false;
Form2.CheckListBox1.Checked[2]:=false;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 j1:=RadioGroup1.ItemIndex+1; j2:=RadioGroup2.ItemIndex+1;
 IF(j1>j2)THEN
  BEGIN Irrange2(j1,j2); GOTO Lbeg;
  END;
 IF(MAX0(j1,j2)>nph)THEN
  BEGIN ShowMess('Wrong phase'); GOTO Lbeg;
  END;
 IF(j1=j2)THEN
  BEGIN ShowMess('Same phase'); GOTO Lbeg;
  END;
 s:='Done for phases '+IntToStr(j1)+','+IntToStr(j2);
 WITH CheckListBox1 DO
  BEGIN j1:=Geti0(j1); j2:=Geti0(j2);
  IF(Checked[0])THEN WITH parar[j2+1] DO IF(pl<>pu)THEN n:=j1+1;
  IF(Checked[1])THEN FOR i:=2 TO 7 DO WITH parar[j2+i] DO
   IF(pl<>pu)THEN n:=j1+i;
  IF(Checked[2])THEN FOR i:=8 TO 10 DO WITH parar[j2+i] DO
   IF(pl<>pu)THEN n:=j1+i;
  END;
 END;
OuttoLabel(Form2.Label9,200,210,clYellow,clBlue,s);
IF(nph=2)THEN Exit ELSE GOTO Lbeg;
END;
PROCEDURE FixHKL0(j,mo:INTEGER; hh:REAL);
BEGIN WITH parar[j] DO
IF(mo=0)THEN
 BEGIN pl:=-100; p:=hh; pu:=100;
 END    ELSE
 BEGIN pl:=hh; p:=hh; pu:=hh;
 END;
END;
PROCEDURE PrepareRfPm(mRiPM:INTEGER; VAR showpa:BOOLEAN);
{mRiPM = 0: Rietveld,  mRiPM = 2: PowderMatch}
VAR   i0,i,j,k,iph,isp,iatom,np,nbk,ips:INTEGER;
      symch,ateql,okr:BOOLEAN;
      absym:BOOLEAN; {symmetry links on atomic pars}
      betwph:BOOLEAN; {links between phases}
      atomeq:ARRAY[1..6] OF BOOLEAN;
      thr,tt,xx,ch,amn,rplus,rminus:REAL;
LABEL Lend,L1;

BEGIN symch:=false; showpa:=false;
L0rec:='Preparing parameter array'; MakeForm(1);{Cadre 1}
WITH CB1rec DO
 BEGIN ar[1]:='   Use available parameter array'; nitems:=5;
 ar[2]:='   Set non-default width-bckg keys';
 ar[3]:='   Display STOP-button while fitting';
 ar[4]:='   All ANIS-atoms -> equivalents';
 ar[5]:=ar[4]+' (with links)';
 {IF((lat[1].nsg=1)OR(nph>1))THEN
  BEGIN ar[4]:=''; ar[5]:='';
  END;}
 END;
MakeCheckListBox(5,80,300,85); WITH Form2.CheckListBox1 DO
 BEGIN Checked[0]:=false; IF(inipar[mRiPM]=1)THEN Checked[0]:=true;
 Checked[2]:=true; Checked[3]:=false; Checked[4]:=false;
 END;
OuttoLabel(Form2.Label6,5,170,clMaroon,clWhite,
 ' ANIS-atoms = atoms of anisotropic phase ');
MakeBevel(5,200,300,70+21,1);
strgrW[0]:=130; strgrW[1]:=50; strgrW[2]:=50;
strgrT[1]:=' Spectrum '+IntToStr(numsp);
strgrNn[1,1]:=spec[numsp].a11; strgrNn[1,2]:=spec[numsp].a22;
OuttoLabel(Form2.Label5,70,210,clGreen,clWhite,
 '   Spectrum interval(s):   ');
PuttoTable(40,230,1,1,2,8);

Form2.ShowModal; IF(ModalRes=0)THEN Exit;
{*}
WITH spec[numsp] DO
 BEGIN Zval(Form2.StringGrid1.Cells[0,0],har[1]); j:=Round(har[1]);
 IF(NOT infun(j,a1,a2))THEN
  BEGIN ShowMess('Wrong spectrum bound - '+IntToStr(j)); Exit;
  END;
 a11:=j;
 Zval(Form2.StringGrid1.Cells[1,0],har[1]); j:=Round(har[1]);
 IF(NOT infun(j,a1,a2))THEN
  BEGIN ShowMess('Wrong spectrum bound - '+IntToStr(j)); Exit;
  END;
 a22:=j; Irrange2(a11,a22);
 END;
WITH Form2.CheckListBox1 DO
 BEGIN IF(Checked[2])THEN dispbut:=true ELSE dispbut:=false;
 IF(Checked[1])THEN SetNonDefKeys;
 IF(Checked[0])THEN okr:=true ELSE okr:=false; {Use avail.par array}

 atomeq[1]:=Checked[3]; ateql:=Checked[4];
 IF(ateql)THEN atomeq[1]:=true;
 END;
IF(atomeq[1])THEN
 BEGIN okr:=false; FOR iph:=1 TO nph DO IF(anisma[iph])THEN
  BEGIN IF(lat[iph].nsg=1)THEN ShowMess('Symmetry already triclinic')
                          ELSE MakeSymmAtoms(iph,2);
  END;
 END;
WITH cw DO IF(NOT cb_init[mriamode+1])THEN    {Form CB}
 BEGIN gfit.FormCB; cw:=gfit.cb; step:=0.99; damp:=0.01; gnit:=6;eps:=0;
 IF(mRiPM=2)THEN
  BEGIN step:=0.25; damp:=0.1; gnit:=20;
  END;
 {IF(keyWdt IN [3,4])THEN
  BEGIN step:=0.15; damp:=0.1; gnit:=50;
  END;}
 END;
GetNumofPar(np,mRiPM); gfit.npar:=np; IF(np>gfit.mpoint)THEN
 ShowMess('Warning, N of parameters > N of channels');
pararmod:=mRiPm;
IF(okr)THEN {Use available parameters}
 BEGIN IF(np<>npold)THEN
  ShowMess('New number of parameters differs from old');
 noprep[mRiPM+1]:=false; Exit;
 END;

{* Make new parameters}
IF(mRiPm=0)THEN SaveHelp(PrepRiet_n,PrepRiet)
           ELSE SaveHelp(FitStrFacs_n,FitStrFacs);
L0rec:='Prepare '+modestr[mRiPM]; MakeForm(1);
strgrW[0]:=220; strgrW[1]:=65;
strgrT[1]:=' For Unit Cell parameters(%)';
strgrT[2]:=' '; IF(mRiPM=0)THEN strgrT[2]:=' For Atomic parameters(%)';
strgrT[3]:=' '; strgrT[4]:=' '{' Number of Peak widths'};
strgrT[5]:=' Background degree for Spec.'+IntToStr(numsp);
strgrNn[5,1]:=spec[numsp].dback;
nbk:=5; FOR iph:=1 TO nph DO WITH lat[iph] DO
 BEGIN strgrNn[1,1]:=lerrc;
 IF(mRiPM=0)THEN strgrNn[2,1]:=aerrc ELSE strgrNn[2,1]:=0;
 strgrNn[3,1]:=0{keycos}; strgrNn[4,1]:=0;
 MakeBevel(5,80,300,230,1);
 PuttoTable(10,130,nbk,nbk,1,8);
 s:='Enter for phase '+IntToStr(iph)+' : ';
 OuttoLabel(Form2.Label8,25,90,clGreen,clWhite,s);
 s:='  accuracies to build parameter bounds';
 OuttoLabel(Form2.Label9,10,106,clGreen,clWhite,s);
 WITH CB1rec DO
  BEGIN nitems:=2; ar[1]:='Impose symmetry links on atom coordinates';
  ar[2]:='Impose links between phases';
  END;
 IF(iph>1)THEN WITH Form2.CheckListBox1 DO
  BEGIN MakeCheckListBox(2,315,310,38);
  Checked[0]:=false; Checked[1]:=false;
  END;
 IF(mRiPM=2)THEN
  BEGIN MakeBevel(5,3,300,67,3); OuttoLabel(Form2.Label7,27,4,
   clGreen,clAqua,'Thresholds for');
  L1rec:='merging close peaks(chan) = '; E1rec:=FloatToStr(FSFthresh);
  L2rec:='zeroing weak peaks level'; E2rec:=FloatToStr(Athresh);
  MakeEdits(10,230,22,70,2);
  END;

 Form2.ShowModal; IF(ModalRes=0)THEN Exit; WITH Form2.CheckListBox1 DO
  BEGIN absym:=Checked[0]; betwph:=Checked[1];
  END;
 IF(absym AND(syng=6))THEN
  BEGIN ShowMess('Not applicable to hexagonal symmetry'); Exit;
  END;
 IF(absym AND(iph>1))THEN WITH lat[iph-1] DO
  BEGIN i:=nut*(ntlv+1)*(1+csym); IF(i<>lat[iph].nat)THEN
   BEGIN s:='Number of atoms not that of symmetry transforms';
   s:=s+crc+'To form all symmetric atoms make it by key Rietveld';
   ShowMess(s); Exit;
   {sequence= transformed basic atoms, then those of central symm.}
   END;
  END;
 FOR i:=1 TO nbk DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 IF(nbk=5)THEN spec[numsp].dback:=Round(AMIN1(AMAX1(har[5],-1),6));
 lerrc:=har[1]; aerrc:=har[2]; nbk:=4;
 IF(mRiPM=2)THEN
  BEGIN Zval(Form2.Edit1.Text,FSFthresh); thr:=FSFthresh;
  Zval(Form2.Edit2.Text,Athresh);
  END;
 END;

{Form TOF parameters}
FOR j:=1 TO gfit.npar DO WITH parar[j] DO
 BEGIN n:=j; a:=1; b:=0; p:=0; pl:=-1E11; pu:=1E12; e:=0;
 END;
isp:=numsp; nofit[mRiPM+1]:=true; WITH parar[1] DO
 BEGIN p:=spec[numsp].FPath; pl:=p; pu:=p;
 END;
WITH parar[2] DO
 BEGIN pl:=0; pu:=0;
 END;
WITH parar[3] DO
 BEGIN p:=spec[numsp].delay; pl:=p-1; pu:=p+1;
 END;
{Form background parameters} MakeBackPars(4);
WITH parar[10] DO
 BEGIN pl:=-1; pu:=1;
 END;
{Form unit cell parameters}
FOR iph:=1 TO nph DO
 BEGIN FormLatMatrix(iph); i0:=Geti0(iph);
 rplus:=1+lat[iph].lerrc/100; rminus:=1-lat[iph].lerrc/100;
 parar[i0+1].p:=1;
 WITH lat[iph] DO
  BEGIN parar[i0+2].p:=a11; parar[i0+3].p:=a22; parar[i0+4].p:=a33;
  parar[i0+5].p:=a23; parar[i0+6].p:=a13; parar[i0+7].p:=a12;
  END;
 parar[i0+8].p:=spec[isp].W0; parar[i0+9].p:=spec[isp].W1;
 parar[i0+10].p:=0; parar[i0+10].pl:=0; parar[i0+10].pu:=0;
 parar[i0+1].pl:=AMIN1(0.001,parar[i0+1].p/20); parar[i0+1].pu:=1E12;
 parar[i0+8].pl:=AMAX1(parar[i0+8].p-spec[isp].dW0,0.1);
 parar[i0+8].pu:=parar[i0+8].p+spec[isp].dW0;
 parar[i0+9].pl:=parar[i0+9].p-spec[isp].dW1;
 parar[i0+9].pu:=parar[i0+9].p+spec[isp].dW1;
 IF(mRiPM=2)THEN WITH parar[i0+1] DO  {for Powder Match}
  BEGIN p:=1; pl:=1; pu:=1;
  END;
 IF(mRiPM=2)THEN WITH parar[i0+10] DO  {for Powder Match}
  BEGIN p:=0; pl:=0; pu:=0;
  END;
 FOR i:=i0+2 TO i0+7 DO WITH parar[i] DO
 IF(p>0)THEN
  BEGIN pl:=p*rminus; pu:=p*rplus;
  END   ELSE
  BEGIN pu:=p*rminus; pl:=p*rplus;
  END;
 j:=lat[iph].syng;
 CASE j OF
 2: BEGIN parar[i0+5].p:=0; parar[i0+5].pl:=0; parar[i0+5].pu:=0;
    IF(lat[iph].sett=2)THEN i:=i0+7 ELSE i:=i0+6;
    parar[i].p:=0; parar[i].pl:=0; parar[i].pu:=0;
    END;
 3,4,5,6: BEGIN parar[i0+5].p:=0; parar[i0+5].pl:=0; parar[i0+5].pu:=0;
    parar[i0+6].p:=0; parar[i0+6].pl:=0; parar[i0+6].pu:=0;
    IF(j<>6)THEN
     BEGIN parar[i0+7].p:=0; parar[i0+7].pl:=0; parar[i0+7].pu:=0;
     END    ELSE
     BEGIN parar[i0+7].pl:=parar[i0+7].p; parar[i0+7].pu:=parar[i0+7].p;
     END;
    IF(j>3)THEN parar[i0+3].n:=parar[i0+2].n;
    IF(j=5)THEN parar[i0+4].n:=parar[i0+2].n;
     IF(j=6)THEN
      BEGIN parar[i0+7].n:=parar[i0+2].n;
      parar[i0+7].pl:=parar[i0+2].pl;
      parar[i0+7].pu:=parar[i0+2].pu;
      END;
    END;
 7: BEGIN parar[i0+3].n:=parar[i0+2].n; parar[i0+4].n:=parar[i0+2].n;
    parar[i0+6].n:=parar[i0+5].n; parar[i0+7].n:=parar[i0+5].n;
    END;
 ELSE END;
 IF(mRiPM=2)THEN {Str.Factor parameters for Powder Match}
  BEGIN FOR i:=1 TO lat[iph].nhkl DO WITH lat[iph] DO WITH spec[isp] DO
   BEGIN ch:=spec[isp].dtoch(hkla[i,iph].dk); k:=i0+10+i; j:=Round(ch);
   xx:=(y[j]-spn)/(ABS(e[j])+1);
   tt:=SQR(hkla[i,iph].Fkc)+SQR(hkla[i,iph].Fks); WITH parar[k] DO
   {IF((ABS(xx)<0)OR(tt/Fkmax<Athresh)OR(NOT infun(j,ic1,ic2)))THEN}
   IF(NOT infun(j,a11,a22))THEN
    BEGIN pl:=0; p:=0; pu:=0;
    END                    ELSE
    BEGIN p:=AMAX1(tt,Athresh); pl:=Athresh; pu:=1E+13;
    END;
   END;
  FOR i:=2 TO lat[iph].nhkl DO WITH spec[isp] DO
   IF(ABS(dtoch(hkla[i,iph].dk)-dtoch(hkla[i-1,iph].dk))<thr)THEN
   parar[i0+10+i].n:=parar[i0+9+i].n; {Exclude if too close peaks}
  GOTO L1;
  END;

{Atomic for Rietveld}
 rplus:=1+lat[iph].aerrc/100; rminus:=1-lat[iph].aerrc/100;
 FOR iatom:=1 TO lat[iph].nat DO WITH atoms[iatom,iph] DO
  BEGIN k:=i0+iatom*10; WITH parar[k+1] DO
   BEGIN p:=occ; IF(keyma[iph]=1)THEN p:=occ*ABS(mgmom);
   pl:=p; pu:=p;
   END;
  WITH parar[k+2] DO
   BEGIN p:=x; pl:=AMIN1(p*rminus,p*rplus); pu:=AMAX1(p*rminus,p*rplus);
   IF(GenPos(p))THEN
    BEGIN pl:=p; pu:=p;
    END;
   END;
  WITH parar[k+3] DO
   BEGIN p:=y; pl:=AMIN1(p*rminus,p*rplus); pu:=AMAX1(p*rminus,p*rplus);
   IF(GenPos(p))THEN
    BEGIN pl:=p; pu:=p;
    END;
   END;
  WITH parar[k+4] DO
   BEGIN p:=z; pl:=AMIN1(p*rminus,p*rplus); pu:=AMAX1(p*rminus,p*rplus);
   IF(GenPos(p))THEN
    BEGIN pl:=p; pu:=p;
    END;
   END;
  parar[k+5].p:=T11; parar[k+6].p:=T12; parar[k+7].p:=T13;
  parar[k+8].p:=T22; parar[k+9].p:=T23; parar[k+10].p:=T33;
  FOR i:=5 TO 10 DO WITH parar[k+i] DO
   BEGIN pl:=p; pu:=p;
   END;
  END;
 L1:;
 END;
IF(ateql)THEN PutAtomLinks(1); symch:=symch OR atomeq[1];
                  {Anisotropic par.}
IF(anis_mod OR use_m2)THEN MakeAnisoPars;

{Magnetic par.} FOR iph:=1 TO nph DO WITH lat[iph] DO
 BEGIN j:=GetNAddiPar(0)+(iph-1)*3+1; IF(keyma[iph]=1)THEN
  BEGIN FixHKL0(j,0,h0); FixHKL0(j+1,0,k0); FixHKL0(j+2,0,l0);
  IF(h0<>0)THEN FixHKL0(j,1,h0) ELSE
   IF(k0<>0)THEN FixHKL0(j+1,1,k0) ELSE FixHKL0(j+2,1,l0);
  IF(h0=0)THEN FixHKL0(j,1,h0);
  IF(k0=0)THEN FixHKL0(j+1,1,k0);
  IF(l0=0)THEN FixHKL0(j+2,1,l0);
  IF(lat[iph].syng=5)THEN FOR i:=j TO j+2 DO WITH parar[i] DO
   BEGIN pl:=p; pu:=p; a:=1; b:=0;
   END;
  {IF(lat[iph].syng IN [4,6,7])THEN
   BEGIN parar[j+1].n:=parar[j].n; parar[j+2].n:=parar[j].n;
   END;
   }
  {ShowMess('Set links on scale,cell & widths'+crc+
           'using Impose Links on Parameters');}
  END;
 IF((keyma[iph]=0)AND(magfl))THEN FOR i:=j TO j+2 DO WITH parar[i] DO
  BEGIN pl:=0; p:=0; pu:=0; a:=1; b:=0;
  END;
 IF((mriamode=2)AND(magfl))THEN FOR i:=j TO j+2 DO WITH parar[i] DO
  BEGIN pl:=0; p:=0; pu:=0; a:=1; b:=0;
  END;
 IF(absym AND(iph>1))THEN PutAtomLinksNext(iph);
 END;
IF(betwph AND(nph>1))THEN ImposeLinks;
{*}
Lend: MakeParComments; FOR i:=1 TO gfit.npar DO gfit.par[i]:=parar[i];
gfit.GetNFreePar(i); IF(i>nmmax)THEN
 BEGIN ShowMess('Number of free parameters > 200'+crc+
       ' Take shorter interval'); ModalRes:=0; Exit;
 END;
MakeForm(1); WITH LB1rec DO
 BEGIN nitems:=6; ar[1]:=''; ar[2]:='    Parameter array prepared.';
 ar[3]:=' Check and correct if needed';
 ar[4]:=' parameter dependences,'; ar[5]:=' using CheckBox or command:';
 ar[6]:='     INFO about Parameters';
 IF(symch)THEN
  BEGIN ar[7]:='Symmetry changing took place'; nitems:=7;
  END;
 END;
MakeListBox(20,125,270,120);
WITH CB1rec DO
 BEGIN nitems:=1; ar[1]:=' Check the prepared parameters';
 END;
MakeCheckListBox(10,260,280,20); Form2.CheckListBox1.Checked[0]:=true;
SetNoPrep(13,true); noprep[mRiPM+1]:=false; SetNoFit(13,true);
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
showpa:=Form2.CheckListBox1.Checked[0];
END;
PROCEDURE CheckSpecIntBounds(i1,i2:INTEGER; VAR ok:BOOLEAN);
BEGIN ok:=true; IF(ABS(i2-i1)<2)THEN
 BEGIN msinf:='Wrong interval'; ok:=false;
 END;
IF((i2-i1+1)>nintmax)THEN
 BEGIN msinf:='Error, too long interval '+IntToStr(i2-i1+1); ok:=false;
 END;
IF(ok)THEN Exit; ShowMess(msinf);
END;
PROCEDURE CheckAtHKL;
VAR i:INTEGER; s:STRING;
BEGIN ModalRes:=1; FOR i:=1 TO nph DO WITH lat[i] DO
 BEGIN s:='Phase '+IntToStr(i);
 IF((nat=0)AND(mriamode=0))THEN
  BEGIN msinf:=s+'= No atoms for '+modestr[0]; ModalRes:=0;
  END;
 IF(nhkl=0)THEN
  BEGIN msinf:=s+'= No hkls'; ModalRes:=0; Exit;
  END;
 IF(nhkl>2000)THEN
  BEGIN msinf:=s+'= Too many hkls, > 2000'; ModalRes:=0;
  END;
 END;
END;
{----------}
BEGIN
END.
