UNIT vmria00; {Feb 1 2007}

INTERFACE
USES Forms,   Graphics, comctrls, Dialogs, SysUtils, Controls, vzlocom,
     varfun,   vmriasp,  vspectr, vgfit,   vpeaksr,  math;
TYPE HKLIND  = RECORD h,k,l:INTEGER; Fkc,Fks:REAL; END;
     HKLREC =  RECORD h,k,l,mul:INTEGER; Fkc,Fks,Fkm,dk,txtc:REAL;
               ass:BOOLEAN;
               END;
     PEAKFR = RECORD x,y,z,v:REAL; END;
     LATREC  = RECORD a,b,c,alpha,beta,gamma:REAL; END;
     FOUREC  = RECORD biso,sens,x0,x1,y0,y1,z0,z1,dx,dy,dz:REAL;
               zc:INTEGER;
               END;
TYPE DETSTEP = RECORD st:REAL; nst,nprod:INTEGER; END;
     LATTICE = RECORD
               lpd,lpi,lpd0,lper:LATREC; {direct,inverse,old,err}
               vol,vol0,voli:REAL;       {volumes}
               coW,Wl0,Wl1:REAL;         {width coefficient}
               a11,a22,a33,a12,a13,a23:REAL;{transformed lat.par}
               o11,o22,o33,o12,o13,o23:REAL;{old aij}
               ascx,bscx,cscx:REAL;      {max abc sizes of unit cell}
               Fkmax,Fmmax:REAL;         {Max ABS Str. & Magn.factors}
               syng,nlatt,nsg,sett,laue:INTEGER;
               csym:INTEGER;             {1=symm, 0=non}
               schoe,stand:STRING;       {Schoenf.,stand.names}
               nat:INTEGER;              {Number of atoms}
               nhkl:INTEGER;             {Number of hkls}
               nut,ntlv:INTEGER;         {Number of transforms}
               lerrc,aerrc:REAL;         {error coef.:latt,atoms}
               ut:ARRAY[1..9,1..48] OF REAL; {Sym.transforms}
               shv:ARRAY[1..3,1..48] OF REAL;{Shift vector}
               tlv:ARRAY[1..3,1..3] OF REAL; {Translations}
               mut:ARRAY[1..9,1..48] OF REAL; {Magnetic Sym.transforms}
               h0,k0,l0:REAL;            {plane, normal to mag. moment}
               anisa:ARRAY[1..12] OF REAL;  {Anisotropic + m2 pars}
               hklx4,hklx2:REAL;        {max of h^4+k^4+l^4,h^2+k^2+l^2}
               END;
     ATOM    = RECORD occ,x,y,z,t11,t12,t13,t22,t23,t33:REAL;
               eoc,ex,ey,ez,e11,e12,e13,e22,e23,e33:REAL;
               name:STRING;                  {Mendeleev name}
               aw:REAL;                      {Atomic weight}
               rad:REAL;                     {Atomic radius}
               scat:REAL;                    {scattering length}
               sigs:REAL;                    {Absorption 1}
               siga:REAL;                    {Absorption 2}
               ident:BOOLEAN;                {identified?}
               Ab,al,Bb,bl,Cb,cl,Db:REAL;    {coef.of magnetic form-fac}
               ionname:STRING;               {ion name, if magnetic}
               mgmom:REAL;                   {magnetic moment value}
               magat:BOOLEAN;                {atom magnetic}
               isotr:BOOLEAN;                {isotropic or not}
               END;
     DSPACING= RECORD d,e,th,x,xc:REAL;      {d,d_err,d_calc,x,x_calc}
               h,k,l,irfl,ph:INTEGER;        {hkl,i_refl,its phase}
               ass:BOOLEAN;
               END;
     PARAERR = RECORD ipa:INTEGER; erb:ARRAY[1..7] OF BOOLEAN;
               ra:ARRAY[1..7] OF REAL;
               END;
CONST npmax:INTEGER = 2000;   {maximum numbers of parameters}
      nintmax:INTEGER = 16384;{max number of channels in interval}
      upintx:INTEGER = 16384; {max number of channels in UPEAK interval}
      natmax:INTEGER = 100;   {max number of atoms}
      nhklmax:INTEGER = 2000; {max number of hkls}
      nphmax:INTEGER  = 6;    {max number of phases}
      npani:INTEGER   = 12;   {number of anisotropic parameters}
      syngar:ARRAY[1..7,0..2] OF STRING[12] = (
       ('triclinic','','(1-2)'),
       ('monoclinic','(PABC)','(3-15)'),
       ('orthorhombic','(PABCFI)','(16-74)'),
       ('tetragonal','(PI)','(75-142)'),
       ('cubic','(PFI)','(195-230)'),
       ('hexagonal','(P)','(168-194)'),
       ('rhombohedral','(R)','(143-167)'));
      nlatar:ARRAY[1..7] OF CHAR =('P','A','B','C','F','I','R');
      strin1:STRING = 'Number of Model (1=beg,2=end)';
      hkltx:STRING[5] = 'hkl  ';
      strmsa:STRING = 'Are you sure you need many-spectrum analysis?';
      aapi:STRING ='Powder Indexing';
      cnohkl:STRING = 'No HKLs for phase ';
      slupd:STRING = 'Update the unit cell? The new destroys old one';
      SampleTypeRec:LREC = (ar:(' Cylinder',' Plane ','Sphere',
        '','','','','','','','','',''); nitems:3; indx:1;);
      SetWidth:LREC = (ar:(' W = W0 + W1*x',' W = W0 + W1*x^2',
      ' W = SQRT(w0 + W1*d^2)','','',
      {' W = anisotr-strain',' W = anisotr-cryst'}
      '','','','','','','','');
      nitems:3; indx:1;);
      SetIndx:LREC = (ar:(' Indexing only',' Full powder indexing',
      ' Unit cell determination','','','','','','','','','','');
      nitems:3; indx:2;);
      modestr:ARRAY[0..3] OF STRING = (' Rietveld analysis ',
        ' PowderIndexing ',' PowderMatch ',' Upeak analysis ');
      cynpar:ARRAY[1..3,0..1] OF STRING = (
             ('FlightPath','Lambda'),
             ('Theta',''),
             ('Delay(ch)','0-shift')      );
      ipnchcc:STRING =
      ' If parameters not changed,  exit by Cancel ';
      colph:ARRAY[1..6] OF INTEGER =
        (clLime,clRed,clYellow,clWhite,clBlue,clTeal);
      colphtx:ARRAY[1..6] OF STRING[6] =
       ('Lime','Red','Yellow','White','Blue','Teal');
      phas:STRING = ' Phase';
      m2_np:INTEGER = 9{11}; {Number of m2 parameters}
CONST sptyp:ARRAY[0..2] OF STRING = ('ToF','Angular','Any');
CONST comm0:ARRAY[1..48] OF STRING = ('FlightPath','dTheta0','Delay',
      'Bckg-const','Bckg-linear','Bckg-quadra','Bckg-cubic','Bckgr.4',
      'Bckgr.5','Spectr.Corr',
      'Scale Phase','(a*)^2','(b*)^2','(c*)^2','2b*c*cos_a*',
      '2a*c*cos_b*','2a*b*cos_g*','Width 0','Width 1','Extinction',
      'Occupation','X','Y','Z','T11','T12','T13','T22','T23','T33',
      'Phi_a','Phi_b','Phi_c','OccMagM',
      'AnisX    ','AnisY    ','AnisZ    ',
      'Anisotr_H','Anisotr_K','Anisotr_L',
      'AniGamma ','AniBeta  ','AniAlpha ',
      'AniH2    ','AniK2    ','AniL2    ',
      'm"_0     ','m"_1     ');
VAR
  lat:ARRAY[1..6] OF LATTICE; {phase lattices}
  atoms:ARRAY[1..200,1..6] OF ATOM; {atoms}
  hkla:ARRAY[1..4000,1..6] OF HKLREC; {hkls}
  dspa:ARRAY[1..200] OF DSPACING; {dspacings for autoindexing}
  mdsp:INTEGER;               {number of d-spacings}
  parar:ARRAY[1..2000] OF PARREC;{auxi-par.array,for auto current optim}
  refla:ARRAY[1..500] OF PEAKFR; {3-dim.peak array, nfr items}

  numsp:INTEGER;        {Actual spectrum number: 0(eff),1,2,3,4}
  nsp:INTEGER;          {Number of Rietveld fitted spectra}
  numph:INTEGER;        {Phase number 1,2,3,4}
  nph:INTEGER;          {Number of phases}
  nupmod:INTEGER;       {Number of UPEAK used peak models}
  nexp:INTEGER;         {Number of exponentials}
  neqexp:BOOLEAN;       {(Non)-equidistant channels}
  npold:INTEGER=0;      {old number of parameters}
  phassp:INTEGER;       {0=phase models  1=spectrum models}
  keyWdt:INTEGER;       {0=norm width 1=quadr 2=SQRT  3,4=anis(str,cry)}
  keyBck:INTEGER;       {0=polyn.background 1=real}
  keyma:ARRAY[1..6] OF INTEGER; {0=no magn.phase  1=is magn}
  keyAuto:INTEGER;      {-1=autoindexing 0=norm 1=lattice par.}
  auparmod:INTEGER;     {0-usual  1=as in mria}
  keylatt:INTEGER;      {0=fit only lattice;   1=also F,dtheta,D0}
  keynorm:INTEGER;      {sp.normaliz.  0=DN2   1=normal, also Fourier}
  Nittot:INTEGER;       {total number of fit-iterations}
  imod1,imod2:INTEGER;  {beginning, end for real peak model}
  ncl,xg,yg:INTEGER;    {n of clicks, beg. and end of marked int.}
  grst:INTEGER;         {mode for the graphs
                         0=no graphs  1=normal graph  2=fit.graphs
                         3=mark point 4=mark points  5=assign mod
                         6=plane dist}
  cadl,ic1,ic2:INTEGER; {number,Length,bounds of graph cadre}
  grwhole:INTEGER;      {grwhole=0: graph whole spec.  1: interval}
  mriamode:INTEGER;     {0=mria  1=autox  2=fitSFacs  3=UPEAK
                         4=ACTIV 5=DOMUS}
  mmsave:INTEGER;       {for saving mriamode}
  ntab:INTEGER;         {Number of fit result table items stored}
  nzer:INTEGER;         {number of zeroing weights intervals, in iar}
  sfcount:INTEGER;      {number of selected files to form Fourier sp}
  nreac2:INTEGER;       {number of reaction on clicking form2.image1}
  iph_gl:INTEGER;       {phase number for direct passing to programs}
  pararmod:INTEGER;     {mode par.array was formed in}
  tam:ARRAY[1..200] OF INTEGER; {peak model pointers}
  inipar:ARRAY[0..3] OF INTEGER; {parameters(mriamode) initialized?}
  nut0,nt0,nat0,ncsym0:INTEGER; {old Nums of transf,transl,atoms,csymm}

  use_m2:BOOLEAN= false;{use or not as model m(x)+(a0+a1*z)*m"(x)}
  anis_mod:BOOLEAN;     {true=anisotropy;   false=no anis}
  anisma:ARRAY[1..6] OF BOOLEAN;{true=ith phase anisotropic; false=not}
  nosavedR:BOOLEAN;     {are Rietveld results saved?}
  nosavedA:BOOLEAN;     {are autoindexing results saved?}
  nosavedS:BOOLEAN;     {are StrFacFit results saved?}
  nosavedU:BOOLEAN;     {are UPEAK results saved?}
  nosavedAc:BOOLEAN;    {are ACTIV results saved?}
  nosavedD:BOOLEAN;     {are DOMUS results saved?}
  nophasi:BOOLEAN;      {is phase information available?}
  noprep:ARRAY[1..4] OF BOOLEAN; {is data for fitting ready?}
  nofit:ARRAY[1..4] OF BOOLEAN;  {has been fitting?}
  BadRMes:BOOLEAN;      {measures against bad reflections?}
  argff:BOOLEAN;        {Arg=channels(false)/d-spacings(true)}
  success:BOOLEAN;      {Was an operation successful?}
  psucc:PARAERR;        {Parameter array errors}
  dispbut:BOOLEAN;      {display or not STOP-button while fitting}
  batchmo:BOOLEAN = false; {batch or dialog mode}
  ok1:BOOLEAN;
  nonssgfl:BOOLEAN = false; {non-standard space group from file}
  nonssgsc:BOOLEAN = false; {non-standard space group from screen}
  noeventf:BOOLEAN;     {The event file has not been input}
  cb_init:ARRAY[1..4] OF BOOLEAN; {was cb initialized by user?}
  psclass:BOOLEAN;      {Peak search class opened?}
  auclass:BOOLEAN;      {Aufit class opened?}
  saveDm:BOOLEAN =false;{SaveDialog mode?}
  skipmo:BOOLEAN = false; {skip errors while ini-file input}
  ErrGrM:BOOLEAN = false; {error graph mode. false: no errors graphed}
  LongArr:BOOLEAN = false; {long arrows as reflection indicators}
  positexp:BOOLEAN =false;{true=positronexp, false= normal exp analysis}
  morozm:INTEGER;       {0=fit resolution, 1=t_0   in EXP-analysis}
  scfrmt:BOOLEAN;       {Scientific format for sp.output?}
  ch_ang:BOOLEAN = false; {Channels or angles?}

  rb0:ARRAY[1..302] OF REAL;
  w0_old:ARRAY[1..6] OF REAL; {0 values of peaks widths}
  FSFthresh:REAL;       {threshold for merging close peaks Pow.Match}
  Athresh:REAL;         {threshold for zeroing weak peaks Pow.Match}
  b1,b2:REAL;           {max,min,interval bounds for graphs}
  do1,do2:ARRAY[1..6] OF INTEGER; {a11,a22 old, for which hkls set}
  rsmooth:REAL;         {smoothing}
  amx,amn:REAL;         {spectrum max in an interval}
  wh:REAL;              {Weight of ith spectrum channel}
  cali:REAL;            {For peak area normalization}
  xarg,sarg:REAL;       {chan,isp if typ for armrit is 4}
  q_old:REAL;           {qold to be passed to StructFact}
  frp,frb,frw,fre,fie,fi2:ARRAY[1..6] OF REAL; {R-factors}
  dani:ARRAY[1..6] OF REAL; {derivatives to anisotropic parameters}
  m2para:ARRAY[1..2] OF REAL; {parameters for M2 Mode}


  ftab:STRING;
  parfn:STRING;         {Parameter file name}
  savfn:STRING;         {Fit result file name}
  outfn:STRING;         {Result file name}
  strfn:STRING;         {Structure factor file name}
  evfn:STRING;          {event file name}
  spgfn:STRING;         {file name for non-st.space group}
  vmdir:STRING;         {VMRIA directory}
  defspdir:STRING;      {default for spectrum dir}
  butar:STRING;         {set(reset) buttons}
  indi:STRING;          {if indi[i]=x then the spectrum_i is graphed}
  fnout:STRING;         {file name for output}

  cw:CBREC;             {permanent fit control array for cb}
  db,fin:TEXTFILE;      {Debug,Ini,OutRes File}
  lp:LATREC;
  lpa:ARRAY[1..3] OF LATREC;
  wparr:ARRAY[1..6] OF PARREC;
             {3Dim.Fourier}
VAR hklaf:ARRAY OF HKLIND; {h,k,l,Fc,Fs while 3-dim.Fourier, ic items}
    nfr:INTEGER;           {number of peaks found by F-synthesis}
    frec:FOUREC;
    amap:ARRAY[0..31,0..31,0..31] OF REAL; {Fourier surface}
             {AutoIndexing}
    hmax,hmin,kmax,kmin,lmax:ARRAY[1..6] OF INTEGER;
    nasr,nasm:ARRAY[1..6] OF INTEGER;
    ihklx,ihkln:ARRAY[1..6] OF INTEGER; {To display the hkl range}
    dmin,dmax,vmax,vmin,qv:ARRAY[1..6] OF REAL;
    hklr:HKLREC;           {hkls work record}
    ds:DSPACING;           {work ds record}
    ntrT:INTEGER;          {Total number of trials}
    Faph:ARRAY[1..6] OF REAL; {Average phase deviations}
    Fapx:ARRAY[1..6] OF REAL; {Maximum phase deviations}
    Fapxg:REAL;            {Global maximum phase deviations}
    epsauto:REAL;          {constant error of ds}
    eps_av:REAL;           {average error of experimental ds}
    dsfn:STRING;           {name of D-Spacing file}
    au_comm:STRING;        {comment for autoindex.output}
    nstact:BOOLEAN = false;{was dstepnst activated?}
    ntrnd_0:INTEGER;       {number of points to select from determ.bin}
    dstepnst:ARRAY[1..6,1..6] OF INTEGER; {array of determ.step numbers}
    ddstep:ARRAY[1..27] OF DETSTEP;{st,nst,nprod-for steps in trial fit}
    aubhkl:BOOLEAN;        {hkl bounds initialized?}
    autovol:BOOLEAN;       {volumes autoset?}
    aui:BOOLEAN;           {automatic mode for AI parameter forming}
    dispfit:BOOLEAN;       {display current fitting results?}
    mracell:BOOLEAN;       {yes=most rectang already;}
    volc:BOOLEAN = true;   {true=volume restriction is kept}
    usespg:BOOLEAN;        {if true use space group for indexing}
    vmintyp:INTEGER;       {0=min V as a^2+b^2+c^2;   1= as abc}
    dstype:INTEGER;        {0=ds 1=theta 2=2theta 3=chan}
    dignum:INTEGER;        {Number of digits after comma for AUTOX}
    i:INTEGER;
      {Classes}
    gfit:TParameter;       {fitting class}
    spec:ARRAY[0..4] OF TSpectrum; {spectrum classes}
PROCEDURE GetNumofPar(VAR np:INTEGER; m:INTEGER);
FUNCTION GetNAddiPar(mo:INTEGER):INTEGER;
FUNCTION Geti0(iph:INTEGER):INTEGER;
FUNCTION Getj0(isp:INTEGER):INTEGER;
FUNCTION PointChan(x:INTEGER):REAL;
FUNCTION nofx(s:STRING):INTEGER;
PROCEDURE CheckSavings(VAR ok:BOOLEAN; VAR s:STRING);
PROCEDURE whdec(i:INTEGER);
PROCEDURE SetNoPrep(c:INTEGER; v:BOOLEAN);
PROCEDURE SetNoFit(c:INTEGER; v:BOOLEAN);
PROCEDURE SetIniPar(c,v:INTEGER);
PROCEDURE InverseLatPar(
          CONST l1:LATREC; VAR l2:LATREC; VAR vol:REAL; mo:INTEGER);
PROCEDURE CheckSpecErr(ns:INTEGER);
PROCEDURE ProcAtomName(CONST ss:STRING; iph,k:INTEGER; VAR ok:BOOLEAN);
PROCEDURE CopySpectrum(i1,i2:INTEGER);
PROCEDURE MakeMostRectAng(VAR a,b,c,al,be,ga,v:REAL; isy:INTEGER);
PROCEDURE MonoclinicMRA(VAR c,be:REAL; a:REAL);
FUNCTION DCellVolume(a,b,c,ca,cb,cg:REAL):REAL;
FUNCTION getvol(CONST lp:LATREC):REAL;
PROCEDURE MakeParComments;
FUNCTION CheckSyng_Latt(syng,nlat:INTEGER):BOOLEAN;
PROCEDURE GetAlBeGa(VAR alpha,beta,gamma:REAL; syng:INTEGER);
PROCEDURE GetDirCellPars(iph:INTEGER);
PROCEDURE GetRealUpNMod(VAR n:INTEGER);
PROCEDURE ssmaxn(CONST indi:STRING; VAR amx,amn:REAL);
PROCEDURE FormLatMatrix(iph:INTEGER);
PROCEDURE CalcHKLNMax;
PROCEDURE CopySpectrVar(i1,i2:INTEGER);
FUNCTION magfl:BOOLEAN;
PROCEDURE InterPhAStrF;
PROCEDURE GetFmDer(iph,mo,md,h,k,l,mu:INTEGER; VAR Fm,dfa,dfb,dfc:REAL);
PROCEDURE GetMagMomAngles(iph,mo:INTEGER);
FUNCTION iHKLNorm(iph,h,k,l:INTEGER):REAL;
FUNCTION rHKLNorm(iph:INTEGER; h,k,l:REAL):REAL;
FUNCTION ScalarP(iph,h,k,l:INTEGER; h0,k0,l0:REAL):REAL;
PROCEDURE ftrstr(it,iph:INTEGER; VAR s:STRING);
PROCEDURE DefInfo(CONST sf:STRING; mo:INTEGER);
PROCEDURE ResetVMria;
PROCEDURE MakeSymmAtoms(iph,mo:INTEGER);
PROCEDURE MoveAtoms(i1,i2,iph1,iph2:INTEGER);
PROCEDURE PutAtomLinksNext(iph:INTEGER);
PROCEDURE PutAtomLinks(iph:INTEGER);
FUNCTION GenPos(x:REAL):BOOLEAN;
PROCEDURE UpdateSpectroInfo;
PROCEDURE FindSpaceGroup(CONST spg:STRING; VAR sg:INTEGER);
PROCEDURE CalcDmaxn(VAR dmax:REAL; VAR dmin:REAL);
PROCEDURE CheckForIsotropy(mo:INTEGER);
PROCEDURE MakeBackPars(ibeg:INTEGER);
PROCEDURE ResetAtoms;
PROCEDURE SetIniAtom(iph:INTEGER);
PROCEDURE SetSpaceGroupInfo(iph:INTEGER);
PROCEDURE MakeSpZero(ns,i1,i2:INTEGER);
PROCEDURE ArrangeDSpacings;

IMPLEMENTATION
PROCEDURE GetNumofPar(VAR np:INTEGER; m:INTEGER);
VAR iph,np0:INTEGER;
 PROCEDURE AccountForAddi;
 BEGIN IF((magfl)AND(mriamode=0))THEN np:=np0+3*nph; np0:=np; {Mag pars}
 IF(anis_mod)THEN{anisotropic params for width}
  BEGIN np:=np0+npani*nph; np0:=np;
  END;
 IF(use_m2)THEN np:=np0+2; np0:=np; {params for m"(x)}
 END;

BEGIN np:=10;
CASE m OF
0: WITH gfit DO {Rietveld}
 BEGIN FOR iph:=1 TO nph DO WITH lat[iph] DO np:=np+(nat+1)*10;
 np0:=np; AccountForAddi;
 END;
1: np:=6*nph+keylatt*3;   {AUTOX}
2: WITH gfit DO {Powder Match}
 BEGIN FOR iph:=1 TO nph DO WITH lat[iph] DO np:=np+nhkl+10; np0:=np;
 AccountForAddi;
 END;
3: BEGIN IF(nexp=0)THEN np:=14+2*npeak ELSE np:=14+2*nexp; {UPEAK}
   IF(positexp)THEN np:=5; IF(use_m2)THEN np:=np+2;
   END;
ELSE END;
IF(np>npmax)THEN
 BEGIN ShowMess('Too many parameters - cut!'); np:=npmax;
 END;
END;
FUNCTION GetNAddiPar(mo:INTEGER):INTEGER;
{Get the base for additional parameters  Feb 7 2006
 mo=0 - magnetic   1 = anisotropic  2 = for m"(x)}
VAR   iph,i:INTEGER;
BEGIN i:=10;
CASE mriamode OF
0: BEGIN FOR iph:=1 TO nph DO i:=i+(lat[iph].nat+1)*10;
   END;
2: FOR iph:=1 TO nph DO i:=i+10+lat[iph].nhkl;
3: i:=2*npeak+14;
ELSE END;
CASE mo OF
0: ;
1: IF(magfl)THEN i:=i+nph*3;
2: CASE mriamode OF
   0,2: BEGIN IF(magfl)THEN i:=i+nph*3; IF(anis_mod)THEN i:=i+nph*npani;
        END;
   ELSE END;
ELSE END;
GetNAddiPar:=i; {base for address in mo-th case}
END;
FUNCTION Geti0(iph:INTEGER):INTEGER;
{To get beginning of iph-th phase common parameters, Feb 2 2001}
VAR ii,i0:INTEGER;
BEGIN i0:=10;
CASE mriamode OF
0: FOR ii:=1 TO iph-1 DO i0:=i0+(lat[ii].nat+1)*10;
2: FOR ii:=1 TO iph-1 DO i0:=i0+10+lat[ii].nhkl;
ELSE END;
Geti0:=i0;
END;
FUNCTION Getj0(isp:INTEGER):INTEGER;
{To get beginning of isp-th spectrum common parameters, Mar 28 2001}
VAR ii,j0:INTEGER;
BEGIN IF(isp=1)THEN j0:=0 ELSE
 BEGIN j0:=10; FOR ii:=1 TO nph DO j0:=j0+(lat[ii].nat+1)*10;
 j0:=j0+(10+3*nph)*(isp-2);
 END;
Getj0:=j0;
END;
PROCEDURE ResetAtoms;
VAR i,j:INTEGER;
BEGIN FOR i:=1 TO 6 DO FOR j:=1 TO 100 DO WITH atoms[j,i] DO
 BEGIN name:=' '; occ:=1; x:=0; y:=0; z:=0; scat:=0;
 t11:=0.2; t12:=0; t13:=0; t22:=0; t23:=0; t33:=0; magat:=false;
 Ab:=0; al:=0; Bb:=0; bl:=0; Cb:=0; cl:=0; Db:=0; mgmom:=1;
 END;
END;
FUNCTION arccoz(x:REAL):REAL;
VAR r,arg:REAL;
BEGIN IF((x<-1)OR(x>1))THEN x:=sign(x);
IF(ABS(x)<0.0001)THEN arg:=pi/2{1.57079625} ELSE
IF(x>= 1)THEN arg:=0          ELSE
IF(x<=-1)THEN arg:=pi{3.1415925}  ELSE
 BEGIN r:=SQRT(ABS(1-x*x)); arg:=arctan(r/ABS(x));
 IF(x<0)THEN arg:=3.1415925-arg;
 END;
arccoz:=arg;
END;
PROCEDURE GetMagMomAngles(iph,mo:INTEGER);
{Aug 26 2005;  Get angles of magnetic moment
 mo:  "0" -> from lat[iph], "1" -> from parameters,}
VAR j:INTEGER; r,h0m,hh,kk,ll,a1,a2,a3:REAL;
BEGIN WITH gfit DO WITH lat[iph] DO WITH lat[iph].lpi DO
 BEGIN r:=0.000001; j:=GetNAddiPar(0)+(iph-1)*3+1;
 CASE mo OF
  0: BEGIN hh:=lat[iph].h0; kk:=lat[iph].k0; ll:=lat[iph].l0;
     END;
  1: BEGIN hh:=par[j].p; kk:=par[j+1].p; ll:=par[j+2].p;
     END;
 ELSE END;
 a1:=COS(alpha/radian); a2:=COS(beta/radian); a3:=COS(gamma/radian);
 h0m:=AMAX1(r,(o11*hh+o12*kk+o13*ll)*hh+(o22*kk+o23*ll)*kk+o33*ll*ll);
 har[1]:=a*hh+b*a3*kk+c*a2*ll;
 har[2]:=a*a3*hh+b*kk+c*a1*ll;
 har[3]:=a*a2*hh+b*a1*kk+c*ll;
 r:=SQRT(ABS(h0m));
 {DEBUG!!!}
 {Writeln(fout,iph:3,h0:9:3,k0:9:3,l0:9:3,h0m:9:4);
 Writeln(fout,'    ',har[1]:9:3,har[2]:9:3,har[3]:9:3,a1:9:3,r:9:3);}
 IF(r<>0)THEN har[1]:=arccoz(har[1]/r)*radian ELSE har[1]:=90;
 IF(r<>0)THEN har[2]:=arccoz(har[2]/r)*radian ELSE har[2]:=90;
 IF(r<>0)THEN har[3]:=arccoz(har[3]/r)*radian ELSE har[3]:=90;
 {DEBUG!!!}
 {Writeln(fout,'after ',iph:3,har[1]:9:3,har[2]:9:3,har[3]:9:3);}
 END;

END;
PROCEDURE GetFmDer(iph,mo,md,h,k,l,mu:INTEGER; VAR Fm,dfa,dfb,dfc:REAL);
{Get magnetic structure factor Fm: sin(eta), Jul 13 2005
 mo=0(1) -> h0,k0,l0 from latt-info (from pars);
 md=1(0) -> (no) derivatives dfa,dfb,dfc calculation.}
VAR r,rh,rk,rl,hN,h0N,h0N2,h0_h,hh0,cose:REAL; j,ht,kt,lt:INTEGER;
    dsa,dsb,dsc,dna,dnb,dnc:REAL;
BEGIN Fm:=1; IF(keyma[iph]=1)THEN WITH lat[iph] DO WITH gfit DO
 BEGIN IF(mo=0)THEN {Info from Lattice}
  BEGIN rh:=h0; rk:=k0; rl:=l0;
  END          ELSE {Info from Parameters}
  BEGIN j:=GetNAddiPar(0)+(iph-1)*3+1;
  rh:=par[j].p; rk:=par[j+1].p; rl:=par[j+2].p;
  END;
 h0N:=rHKLNorm(iph,rh,rk,rl); {|H0|}
 {Sum over equivalents} Fm:=0; dfa:=0; dfb:=0; dfc:=0; h0N2:=h0N*h0N;
 FOR j:=1 TO nut DO {Loop in symmetry transformations}
  BEGIN ht:=Round(ut[1,j]*h+ut[4,j]*k+ut[7,j]*l);
  kt:=Round(ut[2,j]*h+ut[5,j]*k+ut[8,j]*l);
  lt:=Round(ut[3,j]*h+ut[6,j]*k+ut[9,j]*l);
  hN:=iHKLNorm(iph,ht,kt,lt); {|H|}
  h0_h:=ScalarP(iph,ht,kt,lt,rh,rk,rl); {(H,H0)}
  hh0:=hN*h0N; cose:=h0_h/hh0; {cos(eta)}
  Fm:=Fm+AMAX1(0,1-SQR(cose))/nut; {sin(eta)}
  IF(md=0)THEN CONTINUE; {Derivatives}
  dsa:=(o11*ht+o12*kt+o13*lt);
  dsb:=(o22*kt+o12*ht+o23*lt);
  dsc:=(o33*lt+o13*ht+o23*kt);
  dna:=(o11*rh+o12*rk+o13*rl)/h0N;
  dnb:=(o22*rk+o12*rh+o23*rl)/h0N;
  dnc:=(o33*rl+o13*rh+o23*rk)/h0N;
  r:=h0N2*hN;
  dfa:=dfa+(dsa*h0N2-dna*hh0)/r/nut;
  dfb:=dfb+(dsb*h0N2-dnb*hh0)/r/nut;
  dfc:=dfc+(dsc*h0N2-dnc*hh0)/r/nut;
  END;
 Fm:=SQRT(Fm); {sin(eta)}
 END;
END;
PROCEDURE FormLatMatrix(iph:INTEGER);
{Purpose: To compute lattice matrix:
     a*^2, b*^2, c*^2 2*a*b*cos(gam), 2*a*c*cos(bet),  2*b*c*cos(alpha),
 Version: 15.02.1990, delphi=Sep 23 2000,   Jul 29 2003}
VAR q:REAL;
BEGIN WITH lat[iph] DO
 BEGIN a11:=lpi.a; a22:=lpi.b; a33:=lpi.c; a12:=COS(lpi.gamma/radian);
 a13:=COS(lpi.beta/radian); a23:=COS(lpi.alpha/radian);
 IF(ABS(a23)<1E-7)THEN a23:=0 ELSE a23:=2*a22*a33*a23;
 IF(ABS(a13)<1E-7)THEN a13:=0 ELSE a13:=2*a11*a33*a13;
 IF(ABS(a12)<1E-7)THEN a12:=0 ELSE a12:=2*a11*a22*a12;
 a11:=SQR(a11); a22:=SQR(a22); a33:=SQR(a33);
 o11:=a11; o23:=a23; o13:=a13; o22:=a22; o12:=a12; o33:=a33;
 IF((keyma[iph]=1)AND(mriamode=0))THEN
  BEGIN q:=(o11*h0+o12*k0+o13*l0)*h0+(o22*k0+o23*l0)*k0+o33*l0*l0;
  IF(q<=0)THEN ShowMess('Mag.moment=0');
  END;
 END;
END;
PROCEDURE InterPhAStrF;
VAR i:INTEGER;
BEGIN FOR i:=1 TO nph DO WITH lat[i] DO
 IF(keyma[i]=1)THEN onl[i]:=Fmmax ELSE onl[i]:=Fmmax*Fkmax;
r:=0; FOR i:=1 TO nph DO r:=AMAX1(r,onl[i]); r:=AMAX1(r,0.000001);
FOR i:=1 TO nph DO onl[i]:=onl[i]/r;
END;
FUNCTION magfl:BOOLEAN;
VAR i:INTEGER;
BEGIN magfl:=false; FOR i:=1 TO nph DO IF(keyma[i]=1)THEN magfl:=true;
END;
PROCEDURE GetDirCellPars(iph:INTEGER);
{puts direct cell parameters to lpa}
VAR i,i0:INTEGER; l1:LATREC; aa,bb,cc,a0,b0,c0:REAL;
 PROCEDURE KeepPars;
 BEGIN WITH lp DO
  BEGIN a:=ABS(har[1]); b:=ABS(har[2]); c:=ABS(har[3]);
  alpha:=har[4]; beta:=har[5]; gamma:=har[6];
  END;
 END;
 PROCEDURE PutToLR(mo:INTEGER); {0=divide by a0,b0,c0 1=by aa,bb,cc}
 BEGIN {Rietveld or Powder Match}
 IF(mriamode IN [0,2])THEN WITH l1 DO
  BEGIN a:=ABS(har[1]); b:=ABS(har[2]); c:=ABS(har[3]);
  alpha:=har[4]/2; beta:=har[5]/2; gamma:=har[6]/2; IF((a*b*c)=0)THEN
   BEGIN ModalRes:=0; Exit;
   END;
  a:=SQRT(a); b:=SQRT(b); c:=SQRT(c); IF(mo=0)THEN
   BEGIN a0:=a; b0:=b; c0:=c;
   END;
  aa:=a; bb:=b; cc:=c; IF(mo=1)THEN
   BEGIN aa:=a0; bb:=b0; cc:=c0;
   END;
  gamma:=gamma/(aa*bb); beta:=beta/(aa*cc); alpha:=alpha/(bb*cc);
  InverseLatPar(l1,lp,r,1);
  END;
 IF(mriamode=1)THEN WITH lp DO  {Autoindexing}
  BEGIN a:=ABS(har[1]); b:=ABS(har[2]); c:=ABS(har[3]);
  alpha:=har[4]; beta:=har[5]; gamma:=har[6];
  IF((a*b*c)=0)THEN
   BEGIN ModalRes:=0; Exit;
   END;
  alpha:=arccos(alpha)*radian; beta:=arccos(beta)*radian;
  gamma:=arccos(gamma)*radian;
  END;
 END;
BEGIN ModalRes:=1;
i0:=Geti0(iph)+1; IF(mriamode=1)THEN i0:=(iph-1)*6;
FOR i:=1 TO 6 DO har[i]:=parar[i0+i].p;
IF(((har[1]>1)OR(har[2]>1)OR(har[3]>1))AND(mriamode IN [0,2]))THEN
 KeepPars ELSE PutToLR(0);
lpa[2]:=lp;
FOR i:=1 TO 6 DO har[i]:=parar[i0+i].pl;
IF(((har[1]>1)OR(har[2]>1)OR(har[3]>1))AND(mriamode IN [0,2]))THEN
 KeepPars ELSE PutToLR(1);
lpa[1]:=lp;
FOR i:=1 TO 6 DO har[i]:=parar[i0+i].pu;
IF(((har[1]>1)OR(har[2]>1)OR(har[3]>1))AND(mriamode IN [0,2]))THEN
 KeepPars ELSE PutToLR(1);
lpa[3]:=lp;
Arrange2(lpa[1].a,lpa[3].a); Arrange2(lpa[1].b,lpa[3].b);
Arrange2(lpa[1].c,lpa[3].c);
Arrange2(lpa[1].alpha,lpa[3].alpha); Arrange2(lpa[1].beta,lpa[3].beta);
Arrange2(lpa[1].gamma,lpa[3].gamma);
IF(lat[iph].syng=6)THEN
 BEGIN lpa[1].gamma:=120; lpa[3].gamma:=120;
 END;
END;
PROCEDURE ssmaxn(CONST indi:STRING; VAR amx,amn:REAL);
VAR i,j:INTEGER; r:REAL;
BEGIN amx:=-1E14; amn:=1E14; FOR j:=1 TO 5 DO IF(indi[j]<>' ')THEN
 BEGIN FOR i:=ic1 TO ic2 DO
  BEGIN r:=spec[j-1].y[i]; IF(r>amx)THEN amx:=r; IF(r<amn)THEN amn:=r;
  END;
 END;
IF(amx<1)THEN amx:=1; amn:=AMIN1(amn,0);
END;
PROCEDURE GetRealUpNMod(VAR n:INTEGER);
VAR i,j:INTEGER; ml:ARRAY[1..6] OF BYTE;
BEGIN FOR i:=1 TO 6 DO ml[i]:=0; FOR i:=1 TO npeak DO
 BEGIN j:=tam[i]; IF(NOT(j IN [1..6]))THEN
  BEGIN ShowMess('Illegal model '+IntToStr(j));
  END                                 ELSE ml[j]:=1;
 END;
n:=0; FOR i:=1 TO 6 DO n:=n+ml[i];
END;
PROCEDURE GetAlBeGa(VAR alpha,beta,gamma:REAL; syng:INTEGER);
BEGIN
CASE syng OF
2: alpha:=90;
3,4,5: BEGIN alpha:=90; beta:=90; gamma:=90;
       END;
6: BEGIN alpha:=90; beta:=90; gamma:=120;
   END;
ELSE END;
END;
FUNCTION CheckSyng_Latt(syng,nlat:INTEGER):BOOLEAN;
VAR ok:BOOLEAN;
BEGIN ok:=false;
CASE syng OF
1: ok:=nlat=0;
2: ok:=(nlat IN [0,1,2,3]);
3: ok:=(nlat IN [0..5]);
4: ok:=(nlat IN [0,5]);
5: ok:=(nlat IN [0,4,5]);
6: ok:=nlat=0;
7: ok:=nlat=6;
ELSE END;
CheckSyng_Latt:=ok;
END;
FUNCTION getvol(CONST lp:LATREC):REAL;
{Purpose: To compute a cell volume; Version: February 18 1993}
VAR ca,cb,cg,r:REAL;
BEGIN WITH lp DO
 BEGIN ca:=COS(alpha/radian); cb:=COS(beta/radian);
 cg:=COS(gamma/radian);
 r:=AMAX1(0,1-SQR(ca)-SQR(cb)-SQR(cg)+2*ca*ca*cg);
 getvol:=a*b*c*SQRT(r);
 END;
END;
FUNCTION DCellVolume(a,b,c,ca,cb,cg:REAL):REAL;
{Compute the direct cell values volume: links(Ang). angles(COS)
 Version: February 18 1993, DELPHI Apr 3 2003}
BEGIN r:=AMAX1(0,1-SQR(ca)-SQR(cb)-SQR(cg)+2*ca*cb*cg);
DCellVolume:=a*b*c*SQRT(r);
END;
PROCEDURE MakeParComments;
{To make parameter comments; Dec 25 2003}
CONST comm1:ARRAY[1..3] OF STRING = ('Lambda','','Zero-shift');
CONST comm2:STRING = 'SF';
CONST commb:ARRAY[1..5] OF STRING = ('Ampl_b0','Ampl_b1','Pos_b',
      'Width_b0','Width_b1');
VAR   i,j,iph,i0,j0,k,k1,iat,i1,i2,ips:INTEGER; s:STRING;
LABEL Lup,Lau;
 PROCEDURE MakeM2Comm;
 VAR i:INTEGER;
 BEGIN IF(use_m2)THEN
  BEGIN k:=GetNAddiPar(2); FOR i:=1 TO 2 DO parar[k+i].com:=comm0[46+i];
  END;
 END;
{*******}
BEGIN
CASE mriamode OF
1: GOTO Lau;
3: GOTO Lup;
ELSE END;
{Rietveld or Powder Match}
FOR i:=1 TO 10 DO parar[i].com:=comm0[i];
IF(spec[numsp].tofang=1)THEN FOR i:=1 TO 3 DO parar[i].com:=comm1[i];
IF(keyBck=1)THEN FOR i:=2 TO 6 DO parar[i+3].com:=commb[i-1];
FOR iph:=1 TO nph DO
 BEGIN i0:=Geti0(iph)+1; parar[i0].com:=comm0[11]{+IntToStr(iph)};
 FOR i:=i0+1 TO i0+9 DO parar[i].com:=comm0[i-i0+11];
 IF(spec[numsp].tofang=1)THEN parar[i0+9].com:='Width 2';
 {loop with respect to atoms;}
 j0:=i0+10; IF(mriamode=0)THEN FOR iat:=1 TO lat[iph].nat DO{Rietveld}
  BEGIN k:=(iat-1)*10+j0; k1:=k+9; parar[k].com:=comm0[21];
  FOR i:=k+1 TO k1 DO parar[i].com:=comm0[i-k+21];
  IF(keyma[iph]=1)THEN parar[k].com:=comm0[34];
  END                     ELSE                             {PowderMatch}
   FOR i:=1 TO lat[iph].nhkl DO WITH hkla[i,iph] DO
    BEGIN ConvertStr(dk,7,4); Compress(sedz);
    parar[i+j0-1].com:=comm2+IntToStr(iph)+'d='+sedz;
    END;
 END;
IF(magfl)THEN FOR iph:=1 TO nph DO {magnetic}
 BEGIN k:=GetNAddiPar(0)+(iph-1)*3; FOR i:=1 TO 3 DO
  IF(keyma[iph]=1)THEN parar[k+i].com:=comm0[30+i]
                  ELSE parar[k+i].com:=' ';
  IF(keyma[iph]=1)THEN WITH parar[k+1] DO com:=com+phas+IntToStr(iph);
 END;
IF(anis_mod)THEN FOR iph:=1 TO nph DO {anisotropic}
 BEGIN k:=GetNAddiPar(1)+(iph-1)*npani; FOR i:=1 TO npani DO
  IF(anisma[iph])THEN parar[k+i].com:=comm0[34+i]
                 ELSE parar[k+i].com:=' ';
 IF((anisma[iph])AND(nph>1))THEN parar[k+1].com[9]:=Chr(iph+48);
 END;
MakeM2Comm;
Exit; {Upeak}
Lup: parar[1].com:=comm0[4]; FOR i:=2 TO 6 DO WITH parar[i] DO
      IF(keyBck=0)THEN com:=comm0[i+3] ELSE com:=commb[i-1];
FOR i:=7 TO 6+npeak DO parar[i].com:=' Ampl.'+IntToStr(i-6);
FOR i:=7+npeak TO 6+npeak*2 DO
 BEGIN j:=i-6-npeak; parar[i].com:=
  'Pos'+IntToStr(j)+' mod'+IntToStr(tam[j]);
 END;
FOR i:=7+npeak*2 TO 7+npeak*2+3 DO
 parar[i].com:='Width0 mod'+IntToStr(i-6-npeak*2);
FOR i:=7+npeak*2+4 TO 7+npeak*2+7 DO
 parar[i].com:='Width1 mod'+IntToStr(i-6-npeak*2-4);
MakeM2Comm;
Exit; {AUTOX}
Lau: FOR iph:=1 TO nph DO                                   {Autox}
 BEGIN j:=(iph-1)*6; parar[j+1].com:=' A'; parar[j+2].com:=' B';
 parar[j+3].com:=' C'; parar[j+4].com:='cos(alpha)';
 parar[j+5].com:='cos( beta)'; parar[j+6].com:='cos(gamma)';
 IF(nph<>1)THEN
  BEGIN FOR i:=1 TO 3 DO parar[j+i].com:=parar[j+i].com+IntToStr(iph);
  FOR i:=4 TO 6 DO Insert(IntToStr(iph),parar[j+i].com,10);
  END;
 END;
IF(spec[numsp].tofang=0)THEN j:=0 ELSE j:=1;
IF(keylatt<>0)THEN FOR i:=1 TO 3 DO parar[nph*6+i].com:=cynpar[i,j];
END;
PROCEDURE CheckSpecErr(ns:INTEGER);
VAR i:INTEGER; rc,re:REAL;
BEGIN ModalRes:=1;
IF((mriamode<3)AND(spec[ns].tofang=2))THEN
 ShowMess('Warning, the spectrum is no TOF/angular one');
rc:=0; WITH spec[ns] DO FOR i:=a11 TO a22 DO rc:=AMAX1(rc,ABS(y[i]));
re:=0; WITH spec[ns] DO FOR i:=a11 TO a22 DO re:=AMAX1(re,ABS(e[i]));
IF((rc*re)<>0)THEN Exit; IF(rc=0)THEN s:='counts' ELSE s:='errors';
s:='Zero-valued '+s+' at spectrum interval '+IntToStr(ns);
i:=MessageDlg(s,MtWarning,[mbOK,mbAbort],0); IF(i<>mrOK)THEN
 BEGIN ModalRes:=0; Exit;
 END;
END;
FUNCTION nofx(s:STRING):INTEGER;
VAR i,j:INTEGER; {Number of x in string}
BEGIN j:=0; FOR i:=1 TO 5 DO IF(s[i]<>' ')THEN Inc(j); nofx:=j;
END;
FUNCTION PointChan(x:INTEGER):REAL;
VAR i:INTEGER;
BEGIN i:=x-exs(x1graph); r:=(ic2-ic1+1); PointChan:=r*i/exs(512)+ic1;
END;
PROCEDURE CheckSavings(VAR ok:BOOLEAN; VAR s:STRING);
CONST pns:STRING[22] = ' parameters not saved.';
VAR i,j:INTEGER;
BEGIN ok:=true;
IF(nosavedR)THEN
 BEGIN ok:=false; s:='Rietveld'+pns; j:=0;
 END;
IF(nosavedA)THEN
 BEGIN ok:=false; s:=modestr[1]+pns; j:=1;
 END;
IF(nosavedS)THEN
 BEGIN ok:=false; s:=modestr[2]+pns; j:=2;
 END;
IF(nosavedU)THEN
 BEGIN ok:=false; s:='UPEAK'+pns; j:=3;
 END;
IF(nosavedAc)THEN
 BEGIN ok:=false; s:='ACTIV'+pns; j:=4;
 END;
IF(nosavedD)THEN
 BEGIN ok:=false; s:='DOMUS'+pns; j:=5;
 END;
IF(NOT ok)THEN
 BEGIN i:=MessageDlg(s+' Ignore?',MtWarning,[mbYes,mbCancel],0);
 IF(i=mrYes)THEN
  BEGIN ok:=true;
  CASE j OF
  0: nosavedR:=false;
  1: nosavedA:=false;
  2: nosavedS:=false;
  3: nosavedU:=false;
  4: nosavedAc:=false;
  5: nosavedD:=false;
  ELSE END;
  END;
 END;
END;
PROCEDURE whdec(i:INTEGER);
{calculates the weight of i-th point of spectrum, version 85.10.30}
BEGIN wh:=ABS(spec[numsp].e[i]); IF(wh<>0)THEN wh:=1/(wh*wh);
END;
PROCEDURE SetNoPrep(c:INTEGER; v:BOOLEAN);
BEGIN IF((c AND 1)=1)THEN noprep[1]:=v;
IF((c AND 2)=2)THEN noprep[2]:=v; IF((c AND 4)=4)THEN noprep[3]:=v;
IF((c AND 8)=8)THEN noprep[4]:=v;
END;
PROCEDURE SetNoFit(c:INTEGER; v:BOOLEAN);
BEGIN IF((c AND 1)=1)THEN nofit[1]:=v;
IF((c AND 2)=2)THEN nofit[2]:=v; IF((c AND 4)=4)THEN nofit[3]:=v;
IF((c AND 8)=8)THEN nofit[4]:=v;
END;
PROCEDURE SetIniPar(c,v:INTEGER);
VAR i:INTEGER;
BEGIN FOR i:=0 TO 3 DO inipar[i]:=0; inipar[c]:=v;
END;
PROCEDURE InverseLatPar(
          CONST l1:LATREC; VAR l2:LATREC; VAR vol:REAL; mo:INTEGER);
{Purpose: toggle the direct and inverse unit cell parameters
          alpha,beta,gamma = cosines of angles(mo=1) or angles(mo=0);
          Version:  6.05.1989}
VAR aa,bb,cc,ca,cb,cg,sa,sb,sg,om,r1,r2,r3,eps:REAL;
BEGIN WITH l1 DO
 BEGIN aa:=a; bb:=b; cc:=c; IF(mo<>0)THEN
  BEGIN ca:=alpha; cb:=beta; cg:=gamma;
  END                                ELSE
   BEGIN ca:=COS(alpha/radian); cb:=COS(beta/radian);
   cg:=COS(gamma/radian);
   END;
 END;
WITH l2 DO
 BEGIN sa:=SQRT(ABS(1-SQR(ca))); sb:=SQRT(ABS(1-SQR(cb)));
 sg:=SQRT(ABS(1-SQR(cg)));
 r1:=(cb*cg-ca)/AMAX1((sb*sg),0.00000001);
 r2:=(ca*cg-cb)/AMAX1((sa*sg),0.00000001);
 r3:=(ca*cb-cg)/AMAX1((sa*sb),0.00000001);
 alpha:=sign(r1)*AMIN1(1,ABS(r1));
 beta:=sign(r2)*AMIN1(1,ABS(r2));
 gamma:=sign(r3)*AMIN1(1,ABS(r3));
 om:=SQRT(ABS(1-SQR(alpha)-SQR(beta)-SQR(gamma)+2*alpha*beta*gamma));
 om:=AMAX1(om,0.00000001);
 sa:=SQRT(ABS(1-SQR(alpha))); sb:=SQRT(ABS(1-SQR(beta)));
 sg:=SQRT(ABS(1-SQR(gamma)));
 a:=sa/(aa*om); b:=sb/(bb*om); c:=sg/(cc*om);
 alpha:=arccos(alpha)*radian; beta:=arccos(beta)*radian;
 gamma:=arccos(gamma)*radian; vol:=a*b*c*om;
 eps:=0.00001; IF(ABS(alpha)<eps)THEN alpha:=0;
 IF(ABS(beta)<eps)THEN beta:=0; IF(ABS(gamma)<eps)THEN gamma:=0;
 IF(ABS(alpha-90)<eps)THEN alpha:=90;
 IF(ABS(beta-90)<eps)THEN beta:=90; IF(ABS(gamma-90)<eps)THEN gamma:=90;
 END;
END;
PROCEDURE ProcAtomName(CONST ss:STRING; iph,k:INTEGER; VAR ok:BOOLEAN);
VAR   i:INTEGER; s:STRING;
LABEL L1;
BEGIN s:=ss; UpCaseStr(s); Compress(s); ok:=false;
IF(s='')THEN Exit; i:=Length(s);
IF(i>=2)THEN IF(NOT (s[2] IN ['A'..'Z']))THEN s:=' '+s[1]
                                         ELSE s:=Copy(s,1,2)
        ELSE s:=' '+s[1];
FOR i:=1 TO 100 DO IF(s=elch[i])THEN GOTO L1;
ShowMess('No match in Mendeleev table for '+s); Exit;
L1: ok:=true; WITH atoms[k,iph] DO
 BEGIN name:=ss; rad:=radius[i]; aw:=atomwt[i]; sigs:=afsigs[i];
 siga:=afsiga[i]; {scat}r:=sctlen[i];
 IF((scat<>0)AND(ABS(scat-r)>0.0000001)AND(keyma[iph]<>1))THEN
  BEGIN s:=s+' '+FlToSt(scat,4)+crc+'Scattering length non-standard'+
   crc+'Keep (Yes) or change to standard (No)?';
  i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0); IF(i=mrNo)THEN scat:=r;
  END                     ELSE scat:=r;
 END;
END;
PROCEDURE CopySpectrVar(i1,i2:INTEGER);
VAR i:INTEGER;
BEGIN WITH spec[i1] DO
 BEGIN FOR i:=1 TO 6 DO spec[i2].bkpar[i]:=bkpar[i];
 spec[i2].sfn:=sfn; spec[i2].efn:=efn;
 spec[i2].smosp:=smosp; spec[i2].emosp:=emosp;
 spec[i2].a1:=a1; spec[i2].a2:=a2;
 spec[i2].spx:=spx; spec[i2].spn:=spn;
 spec[i2].tofang:=tofang; spec[i2].nconst:=nconst;
 spec[i2].abs1:=abs1; spec[i2].abs2:=abs2; spec[i2].shape:=shape;
 spec[i2].spin:=spin; spec[i2].effn:=effn; spec[i2].absn:=absn;
 spec[i2].dback:=dback; spec[i2].acor:=acor;
 spec[i2].chw:=chw; spec[i2].delay:=delay; spec[i2].theta:=theta;
 spec[i2].FPath:=FPath; spec[i2].w0:=w0; spec[i2].dw0:=dw0;
 spec[i2].w1:=w1; spec[i2].dw1:=dw1; spec[i2].lambda:=lambda;
 END;
END;
PROCEDURE CopySpectrum(i1,i2:INTEGER);
VAR i:INTEGER;
BEGIN IF(spec[i1].NoSpectrum(i1))THEN
 BEGIN ModalRes:=0; Exit;
 END;
WITH spec[i1] DO
 BEGIN FOR i:=1 TO nspch DO spec[i2].y[i]:=y[i];
 FOR i:=1 TO nspch DO spec[i2].x[i]:=x[i];
 FOR i:=1 TO nspch DO spec[i2].e[i]:=e[i];
 CopySpectrVar(i1,i2); spec[i2].a11:=a11; spec[i2].a22:=a22;
 END;
END;
PROCEDURE MonoclinicMRA(VAR c,be:REAL; a:REAL);
{Reduce a monoclinic cell.
 c=max link (Angs), a=link (Angs), be=angle between them (COS)
 Version: Dec 11 2003}
VAR r:REAL; va,vc,vt:VECTOR;
BEGIN r:=arccos(be); IF(r>pi/2)THEN r:=pi-r;
vc.x:=c*COS(r); vc.y:=c*SIN(r); va.x:=a; va.y:=0; vc.z:=0;
vt:=vc; vt.x:=vc.x-a;
r:=EuclNorm(vt); IF(r<EuclNorm(vc))THEN
 BEGIN mracell:=false; c:=r; be:=(vt.x*va.x)/(EuclNorm(vt)*a);
 END;
END;
PROCEDURE TriclinicMRA(VAR a,b,c,al,be,ga:REAL);
{Reduce a triclinic cell. c=maximum link  Version: Nov 29 2003}
VAR   va,vb,vc,vta,vtb,vtc:VECTOR; at:INTEGER;
      sca:REAL;
LABEL Lend;
 PROCEDURE GetEucliCoors(a,b,c,al,be,ga:REAL; VAR va,vb,vc:VECTOR);
 {         a   /                    a   \
 at:=0;   /   /            at:=1;    \   \
         /   c -----                  \   c-----
        0---------b                    0------b
 angle(a,0,b) = ga; angle(a,0,c) = be; angle(c,0,b) = al;
 Descarte coord (Ax,Ay,Az) (Bx,By,Bz) (Cx,Cy,Cz) Version: Dec 2 2003}
 VAR r02,r05,r26,rz5,angg:REAL;
 BEGIN angg:=ga-pi/2; IF(at=0)THEN angg:=pi/2-ga; rz5:=c*SIN(al);
 r02:=c*COS(be)/COS(angg); r05:=c*COS(al); r26:=r05*SIN(angg)/COS(angg);
 WITH va DO
  BEGIN x:=a*COS(ga); y:=a*SIN(ga); z:=0;
  END;
 WITH vb DO
  BEGIN x:=b; y:=0; z:=0;
  END;
 WITH vc DO
  BEGIN x:=r05; y:=r02-r26; IF(at=1)THEN y:=r02+r26;
  z:=SQRT(AMAX1(0,SQR(rz5)-SQR(y)));
  END;
 END;
{*************************}
BEGIN al:=arccos(al); be:=arccos(be); ga:=arccos(ga);
{Writeln(fout,al*radian:10:3,be*radian:10:3,ga*radian:10:3);}
at:=0; IF(al>pi/2)THEN at:=at+4; IF(be>pi/2)THEN at:=at+2;
IF(ga>pi/2)THEN at:=at+1;
CASE at OF
0: at:=0;
1: at:=1;
2: BEGIN al:=pi-al; ga:=pi-ga; al:=pi-al; be:=pi-be; at:=1;
   END;
3: BEGIN be:=pi-be; ga:=pi-ga; at:=0;
   END;
4: BEGIN be:=pi-be; ga:=pi-ga; al:=pi-al; be:=pi-be; at:=1;
   END;
5: BEGIN al:=pi-al; ga:=pi-ga; at:=0;
   END;
6: BEGIN al:=pi-al; be:=pi-be; at:=0;
   END;
7: BEGIN al:=pi-al; be:=pi-be; at:=1;
   END;
ELSE END;
IF(AMAX3(ABS(ga-pi/2),ABS(be-pi/2),ABS(al-pi/2))<0.001)THEN GOTO Lend;
GetEucliCoors(a,b,c,al,be,ga,va,vb,vc);
vtc:=vc; vtc.x:=vc.x-b; r:=EuclNorm(vtc);
IF(r<EuclNorm(vc))THEN
 BEGIN al:=arccos(vtc.x/EuclNorm(vtc)); mracell:=false;
 sca:=0; WITH vtc DO sca:=x*va.x+y*va.y+z*va.z;
 be:=arccos(sca/(EuclNorm(vtc)*EuclNorm(va))); c:=r;
 END;
Lend: al:=COS(al); be:=COS(be); ga:=COS(ga);
END;
PROCEDURE MakeMostRectAng(VAR a,b,c,al,be,ga,v:REAL; isy:INTEGER);
{Compute the optimum cell for monoclinic and triclinic
 a,b,c in Aengs, angles in rad. Version: Dec 10 2003}
LABEL Lend;
BEGIN mracell:=true; IF(isy=2)THEN {Monoclinic case.}
 BEGIN IF(a>=c)THEN MonoclinicMRA(a,be,c) ELSE MonoclinicMRA(c,be,a);
 GOTO Lend;
 END;
IF(c>=AMAX1(a,b))THEN {Triclinic case.}
 BEGIN TriclinicMRA(a,b,c,al,be,ga);
 IF(a>b)THEN
  BEGIN TriclinicMRA(b,c,a,be,ga,al); TriclinicMRA(c,a,b,ga,al,be);
  END   ELSE
   BEGIN TriclinicMRA(c,a,b,ga,al,be); TriclinicMRA(b,c,a,be,ga,al);
   END;
 END;
IF(b>=AMAX1(a,c))THEN
 BEGIN TriclinicMRA(a,c,b,al,ga,be);
 IF(a>c)THEN
  BEGIN TriclinicMRA(c,b,a,ga,be,al); TriclinicMRA(b,a,c,be,al,ga);
  END   ELSE
   BEGIN TriclinicMRA(b,a,c,be,al,ga); TriclinicMRA(c,b,a,ga,be,al);
   END;
 END;
IF(a>=AMAX1(b,c))THEN
 BEGIN TriclinicMRA(c,b,a,ga,be,al);
 IF(b>c)THEN
  BEGIN TriclinicMRA(a,c,b,al,ga,be); TriclinicMRA(b,a,c,be,al,ga);
  END   ELSE
   BEGIN TriclinicMRA(b,a,c,be,al,ga); TriclinicMRA(a,c,b,al,ga,be);
   END;
 END;
Lend: v:=DCellVolume(a,b,c,al,be,ga);
END;
PROCEDURE CalcHKLNMax;
VAR iph,i:INTEGER; r:INTEGER;
BEGIN FOR iph:=1 TO nph DO WITH lat[iph] DO
 BEGIN hklx4:=0; hklx2:=0; FOR i:=1 TO nhkl DO WITH hkla[i,iph] DO
  BEGIN r:=h; q1:=PowerRI(r,4); r:=k; q2:=PowerRI(r,4);
  r:=l; q3:=PowerRI(r,4); hklx4:=AMAX1(hklx4,AMAX3(q1,q2,q3));
  q1:=h*h; q2:=k*k; q3:=l*l; hklx2:=AMAX1(hklx2,AMAX3(q1,q2,q3));
  END;
 END;
END;
FUNCTION iHKLNorm(iph,h,k,l:INTEGER):REAL;
VAR r:REAL;
BEGIN WITH lat[iph] DO
 BEGIN r:=(h*h*o11+k*k*o22+l*l*o33)+2*(h*k*o12+h*l*o13+k*l*o23); {|H|}
 END;
iHKLNorm:=AMAX1(SQRT(ABS(r)),0.0000001);
END;
FUNCTION rHKLNorm(iph:INTEGER; h,k,l:REAL):REAL;
VAR r:REAL;
BEGIN WITH lat[iph] DO
 BEGIN r:=(h*h*o11+k*k*o22+l*l*o33)+2*(h*k*o12+h*l*o13+k*l*o23); {|H|}
 END;
rHKLNorm:=AMAX1(SQRT(ABS(r)),0.0000001);
END;
FUNCTION ScalarP(iph,h,k,l:INTEGER; h0,k0,l0:REAL):REAL;
VAR r:REAL;
BEGIN WITH lat[iph] DO
 BEGIN r:=(h*h0*o11+k*k0*o22+l*l0*o33)+
    ((h*k0+h0*k)*o12+(l*h0+l0*h)*o13+(k*l0+k0*l)*o23);
 END;
ScalarP:=r;
END;
PROCEDURE ftrstr(it,iph:INTEGER; VAR s:STRING);
{Purpose: To form the transformation string, Version: May 13 2000}
CONST chxyz:ARRAY[1..3] OF CHAR = ('x','y','z');
VAR i,j,jj:INTEGER; r4:REAL; ii:ARRAY[1..3] OF INTEGER;
    ch4,st:STRING[4]; ch:ARRAY[1..3] OF STRING[2];
BEGIN s:=' '; WITH lat[iph] DO FOR j:=1 TO 3 DO
 BEGIN ii[1]:=Round(ut[(j-1)*3+1,it]); ii[2]:=Round(ut[(j-1)*3+2,it]);
 ii[3]:=Round(ut[(j-1)*3+3,it]); r4:=shv[j,it]; Str(r4:4:2,st);
 ch4:=st; IF(r4=0)THEN ch4:='    '; IF(r4>0)THEN ch4[1]:='+';
 FOR i:=1 TO 3 DO
  BEGIN ch[i]:='  '; jj:=sign(ii[i]);
  CASE jj OF
  -1: BEGIN ch[i][1]:='-'; ch[i][2]:=chxyz[i];
      END;
  1: BEGIN ch[i][1]:='+'; ch[i][2]:=chxyz[i];
     END;
  ELSE END;
  END;
  CASE j OF
  1: s:=ch[1]+ch4+ch[2]+ch[3]+',  ';
  2: s:=s+ch[1]+ch[2]+ch4+ch[3]+',  ';
  3: s:=s+ch[1]+ch[2]+ch[3]+ch4;
  ELSE END;
 END;
IF(s[1]='+')THEN s[1]:=' '; FOR i:=1 TO Length(s)-3 DO
 BEGIN j:=Pos(',  +',s); IF(j<>0)THEN s[j+3]:=' ';
 END;
END;
PROCEDURE DefInfo(CONST sf:STRING; mo:INTEGER);
{mo=0: read defaults;       mo=1: write defaults}
VAR   i:INTEGER;
LABEL Lwri;
BEGIN IF(mo=1)THEN GOTO Lwri; i:=1;
AssignFile(ft,sf); {$I-} Reset(ft); {$I+}; IF(IOResult<>0)THEN Exit;
EnterStr(ft); defspdir:=sedz; WITH spec[1] DO
 BEGIN EnterStr(ft); fffins(i,sedz); r:=onl[1]; IF(r<>0)THEN chw:=r;
 EnterStr(ft); fffins(i,sedz); r:=onl[1]; IF(r<>0)THEN delay:=r;
 EnterStr(ft); fffins(i,sedz); r:=onl[1]; IF(r<>0)THEN theta:=r;
 EnterStr(ft); fffins(i,sedz); r:=onl[1]; IF(r<>0)THEN FPath:=r;
 EnterStr(ft); fffins(i,sedz); r:=onl[1]; IF(r<>0)THEN w0:=r;
 EnterStr(ft); fffins(i,sedz); r:=onl[1]; IF(r<>0)THEN lambda:=r;
 END;
CloseFile(ft); Exit;
Lwri: AssignFile(ft,sf); {$I-} Rewrite(ft); {$I+}; IF(IOResult=0)THEN
 BEGIN Writeln(ft,defspdir); WITH spec[1] DO
  BEGIN Writeln(ft,chw:12);
  Writeln(ft,delay:12);
  Writeln(ft,theta:12);
  Writeln(ft,FPath:12);
  Writeln(ft,w0:12);
  Writeln(ft,lambda:12);
  END;
 END;
CloseFile(ft);
END;
PROCEDURE ResetVMria;
VAR i,j,iph:INTEGER;
BEGIN FOR i:=1 TO 200 DO tam[i]:=1; FOR i:=0 TO 3 DO inipar[i]:=0;
au_comm:=''; aubhkl:=true; autovol:=true; aui:=true; dispbut:=false;
FOR i:=1 TO 4 DO cb_init[i]:=false;
keyWdt:=0; keyBck:=0; phassp:=0; keylatt:=0; morozm:=0; positexp:=false;
FOR i:=1 TO nphmax DO
 BEGIN keyma[i]:=0; anisma[i]:=false;
 END;
argff:=false; nosavedR:=false; nosavedA:=false; nosavedS:=false;
nsp:=1; nph:=1; sfcount:=0; nscale:=1; trimm:=0.5; ErrGrM:=false;
npeak:=0; sens:=1; res:=1; nupmod:=1; grst:=0;
mdsp:=0; epsauto:=0.001; BadRMes:=false; usespg:=false;
use_m2:=false; anis_mod:=false;
vmintyp:=0; dstype:=0;
FOR i:=1 TO 27 DO ddstep[i].nst:=1;
FOR i:=1 TO 4 DO noprep[i]:=true;
nophasi:=true; FOR iph:=1 TO 6 DO
 BEGIN hmax[iph]:=4; hmin[iph]:=-4; kmax[iph]:=4; kmin[iph]:=-4;
 lmax[iph]:=4; vmax[iph]:=5000; vmin[iph]:=0; jja[iph]:=1;
 FOR j:=1 TO npani DO lat[iph].anisa[j]:=0;
 END;
FOR i:=1 TO 2 DO m2para[i]:=0;
SetNoPrep(15,true); SetNoFit(15,true);
numsp:=1; indi:=' x    ';
xscale:=false; pixelm:=0; neqexp:=false; nstact:=false;
rsmooth:=1; auparmod:=0;
FSFthresh:=0.5; Athresh:=1; frec.sens:=0.25; dignum:=5;
WITH frec DO
 BEGIN sens:=0.25; x0:=0; x1:=1; y0:=0; y1:=1; z0:=0; z1:=1;
 dx:=1/30; dy:=1/30; dz:=1/30;
 END;
END;
PROCEDURE MoveAtoms(i1,i2,iph1,iph2:INTEGER);
BEGIN atoms[i2,iph2].occ:=atoms[i1,iph1].occ;
atoms[i2,iph2].x:=atoms[i1,iph1].x;
atoms[i2,iph2].y:=atoms[i1,iph1].y;
atoms[i2,iph2].z:=atoms[i1,iph1].z;
atoms[i2,iph2].t11:=atoms[i1,iph1].t11;
atoms[i2,iph2].t12:=atoms[i1,iph1].t12;
atoms[i2,iph2].t13:=atoms[i1,iph1].t13;
atoms[i2,iph2].t22:=atoms[i1,iph1].t22;
atoms[i2,iph2].t23:=atoms[i1,iph1].t23;
atoms[i2,iph2].t33:=atoms[i1,iph1].t33;
atoms[i2,iph2].name:=atoms[i1,iph1].name;
atoms[i2,iph2].aw:=atoms[i1,iph1].aw;
atoms[i2,iph2].rad:=atoms[i1,iph1].rad;
atoms[i2,iph2].scat:=atoms[i1,iph1].scat;
atoms[i2,iph2].sigs:=atoms[i1,iph1].sigs;
atoms[i2,iph2].siga:=atoms[i1,iph1].siga;
atoms[i2,iph2].ident:=atoms[i1,iph1].ident;
atoms[i2,iph2].Ab:=atoms[i1,iph1].Ab;
atoms[i2,iph2].al:=atoms[i1,iph1].al;
atoms[i2,iph2].Bb:=atoms[i1,iph1].Bb;
atoms[i2,iph2].bl:=atoms[i1,iph1].bl;
atoms[i2,iph2].Cb:=atoms[i1,iph1].Cb;
atoms[i2,iph2].cl:=atoms[i1,iph1].cl;
atoms[i2,iph2].Db:=atoms[i1,iph1].Db;
atoms[i2,iph2].ionname:=atoms[i1,iph1].ionname;
atoms[i2,iph2].mgmom:=atoms[i1,iph1].mgmom;
atoms[i2,iph2].magat:=atoms[i1,iph1].magat;
END;
PROCEDURE MakeSymmAtoms(iph,mo:INTEGER);
{Version Oct 29 2005
 mo=0  make symmetric atoms for next phase
 mo=1  make symmetric atoms for next phase only for magnetic
 mo=2  make symmetric atoms for current phase
 }
VAR i,j,j1,iat,ic,it,il,im:INTEGER; c,xtj,ytj,ztj,xj,yj,zj:REAL;
    tr:ARRAY[1..3] OF REAL;
BEGIN c:=1; il:=0; j1:=1; im:=1;
IF(mo=2)THEN
 BEGIN il:=lat[iph].nat; im:=0; j1:=2;
 END;
WITH lat[iph] DO FOR i:=1 TO csym+1 DO
 BEGIN IF(i<>1)THEN c:=-1; FOR it:=1 TO ntlv+1 DO
  BEGIN FOR ic:=1 TO 3 DO IF(it=1)THEN tr[ic]:=0
                                  ELSE tr[ic]:=tlv[ic,it-1];
  FOR j:=j1 TO nut DO FOR iat:=1 TO nat DO WITH atoms[iat,iph] DO
   IF(((mo=1)AND(atoms[iat,iph].magat))OR(mo<>1))THEN
    BEGIN xj:=x; yj:=y; zj:=z;
     BEGIN Inc(il); MoveAtoms(iat,il,iph,iph+im);
     xtj:=ut[1,j]*xj+ut[2,j]*yj+ut[3,j]*zj+shv[1,j]+tr[1];
     ytj:=ut[4,j]*xj+ut[5,j]*yj+ut[6,j]*zj+shv[2,j]+tr[2];
     ztj:=ut[7,j]*xj+ut[8,j]*yj+ut[9,j]*zj+shv[3,j]+tr[3];
     WITH atoms[il,iph+im] DO
      BEGIN x:=c*xtj; y:=c*ytj; z:=c*ztj;
      END;
     END;
    END;
  j1:=1;
  END;
 END;
WITH lat[iph+im] DO
 BEGIN nut0:=nut; nt0:=ntlv+1; nat0:=nat; ncsym0:=csym+1;
 nat:=il; syng:=1; nsg:=1; sett:=1; csym:=0; ntlv:=0; nut:=1;
 END;
END;
PROCEDURE PutAtomLinksNext(iph:INTEGER);
{put links on parameters of the next phase}
VAR i,j,iat,ic,it,i0,k1,k2,ii:INTEGER;
    b1,b2,b3,c:REAL; t:ARRAY[1..3] OF REAL;
BEGIN i0:=Geti0(iph-1); c:=1; ii:=0; WITH lat[iph-1] DO
 FOR iat:=1 TO nat DO IF(atoms[iat,iph-1].magat)THEN
  FOR i:=1 TO csym+1 DO
 BEGIN IF(i<>1)THEN c:=-1; k1:=i0+iat*10; FOR it:=1 TO ntlv+1 DO
  BEGIN FOR ic:=1 TO 3 DO IF(it=1)THEN t[ic]:=0
                                  ELSE t[ic]:=tlv[ic,it-1];
  FOR j:=1 TO nut DO
   BEGIN Inc(ii); k2:=Geti0(iph)+ii*10;
   b1:=c*(shv[1,j]+t[1]); b2:=c*(shv[2,j]+t[2]); b3:=c*(shv[3,j]+t[3]);
   IF(ut[1,j]<>0)THEN WITH parar[k2+2] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+2; a:=c*ut[1,j]; b:=b1;
    END;
   IF(ut[2,j]<>0)THEN WITH parar[k2+2] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+3; a:=c*ut[2,j]; b:=b1;
    END;
   IF(ut[3,j]<>0)THEN WITH parar[k2+2] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+4; a:=c*ut[3,j]; b:=b1;
    END;
   IF(ut[4,j]<>0)THEN WITH parar[k2+3] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+2; a:=c*ut[4,j]; b:=b2;
    END;
   IF(ut[5,j]<>0)THEN WITH parar[k2+3] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+3; a:=c*ut[5,j]; b:=b2;
    END;
   IF(ut[6,j]<>0)THEN WITH parar[k2+3] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+4; a:=c*ut[6,j]; b:=b2;
    END;
   IF(ut[7,j]<>0)THEN WITH parar[k2+4] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+2; a:=c*ut[7,j]; b:=b3;
    END;
   IF(ut[8,j]<>0)THEN WITH parar[k2+4] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+3; a:=c*ut[8,j]; b:=b3;
    END;
   IF(ut[9,j]<>0)THEN WITH parar[k2+4] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+4; a:=c*ut[9,j]; b:=b3;
    END;
   END;
  END;
 END;
END;
PROCEDURE PutAtomLinks(iph:INTEGER);
{put links on parameters of the next phase}
VAR i,j,iat,ic,it,i0,k1,k2:INTEGER;
    b1,b2,b3,c:REAL; t:ARRAY[1..3] OF REAL;
BEGIN i0:=Geti0(iph); c:=1; WITH lat[iph] DO FOR i:=1 TO ncsym0 DO
 BEGIN IF(i<>1)THEN c:=-1;  FOR it:=1 TO nt0 DO
  BEGIN FOR ic:=1 TO 3 DO IF(it=1)THEN t[ic]:=0
                                  ELSE t[ic]:=tlv[ic,it-1];
  FOR j:=1 TO nut0 DO FOR iat:=1 TO nat0 DO
   BEGIN k1:=i0+iat*10;
   k2:=k1+((i-1)*nut0*nat0*nt0+(it-1)*nut0*nat0+(j-1)*nat0)*10;
   b1:=c*(shv[1,j]+t[1]); b2:=c*(shv[2,j]+t[2]); b3:=c*(shv[3,j]+t[3]);
   IF(ut[1,j]<>0)THEN WITH parar[k2+2] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+2; a:=c*ut[1,j]; b:=b1;
    END;
   IF(ut[2,j]<>0)THEN WITH parar[k2+2] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+3; a:=c*ut[2,j]; b:=b1;
    END;
   IF(ut[3,j]<>0)THEN WITH parar[k2+2] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+4; a:=c*ut[3,j]; b:=b1;
    END;
   IF(ut[4,j]<>0)THEN WITH parar[k2+3] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+2; a:=c*ut[4,j]; b:=b2;
    END;
   IF(ut[5,j]<>0)THEN WITH parar[k2+3] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+3; a:=c*ut[5,j]; b:=b2;
    END;
   IF(ut[6,j]<>0)THEN WITH parar[k2+3] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+4; a:=c*ut[6,j]; b:=b2;
    END;
   IF(ut[7,j]<>0)THEN WITH parar[k2+4] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+2; a:=c*ut[7,j]; b:=b3;
    END;
   IF(ut[8,j]<>0)THEN WITH parar[k2+4] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+3; a:=c*ut[8,j]; b:=b3;
    END;
   IF(ut[9,j]<>0)THEN WITH parar[k2+4] DO IF(NOT GenPos(p))THEN
    BEGIN n:=k1+4; a:=c*ut[9,j]; b:=b3;
    END;
   END;
  END;
 END;
END;
FUNCTION GenPos(x:REAL):BOOLEAN;
VAR z:REAL;
BEGIN GenPos:=false; z:=ABS(x);
IF((z=0)OR(z=0.25)OR(z=0.5)OR(z=0.75)OR(z=1))THEN GenPos:=true;
END;
PROCEDURE UpdateSpectroInfo;
VAR i,j,i0,j0,iph:INTEGER;
BEGIN WITH spec[numsp] DO WITH gfit DO
 BEGIN j0:=0; i0:=Geti0(1); IF(mriamode IN [0,2])THEN
  BEGIN FPath:=par[j0+1].p; theta:=theta+par[j0+2].p;
  delay:=par[j0+3].p; acor:=par[j0+10].p;
  FOR j:=1 TO 6 DO bkpar[j]:=par[j0+j+3].p;
  W0:=AMAX1(par[i0+8].p,0.01); W1:=par[i0+9].p;
  FOR i:=1 TO nph DO WITH lat[i] DO WITH gfit DO
   BEGIN i0:=Geti0(i); Wl0:=AMAX1(par[i0+8].p,0.01); Wl1:=par[i0+9].p;
   END;
  END;
 IF(mriamode=3)THEN
  BEGIN W0:=AMAX1(par[2*npeak+7].p,0.01); W1:=par[2*npeak+11].p;
  END;
 END;
END;
PROCEDURE FindSpaceGroup(CONST spg:STRING; VAR sg:INTEGER);
{Purpose: find the space group by standard name
 Version: Nov 26 2005}
VAR   i,j,isg,n:INTEGER; s,s1:STRING;
BEGIN s1:=spg; UpCaseStr(s1); i:=1; ModalRes:=1;
WHILE(i<2963)DO {Loop in space groups}
 BEGIN Val(Copy(space_asc[i],1,4),isg,j);
 Val(Copy(space_asc[i],9,4),n,j);
 s:=Copy(space_asc[i+1],35,7); UpCaseStr(s); i:=i+2+n;
 IF(s1=s)THEN
  BEGIN sg:=ABS(isg); Exit;
  END;
 END;
ShowMess('No space group with name '+spg); ModalRes:=0;
END;
PROCEDURE CalcDmaxn(VAR dmax:REAL; VAR dmin:REAL);
BEGIN WITH spec[numsp] DO
 BEGIN dmin:=chtod(AMAX0(a11-7,a1)); dmax:=chtod(AMIN0(a22+3,a2));
 Arrange2(dmin,dmax);
 END;
END;
PROCEDURE CheckForIsotropy(mo:INTEGER);
VAR j,iph,iatom:INTEGER; sum:REAL; ok:BOOLEAN;
BEGIN FOR iph:=1 TO nph DO WITH lat[iph] DO
 BEGIN WITH lpd DO
  BEGIN ascx:=a; bscx:=b; cscx:=c;
  END;
 FOR iatom:=1 TO nat DO WITH atoms[iatom,iph] DO WITH gfit DO
  BEGIN j:=iatom*10+Geti0(iph); ok:=false;
  CASE mo OF
  0: BEGIN ok:=true; sum:=ABS(t22)+ABS(t33);
     END;
  1: BEGIN WITH par[j+8] DO ok:=(pl=pu);
     WITH par[j+10] DO ok:=ok AND(pl=pu);
     sum:=ABS(par[j+8].p)+ABS(par[j+10].p);
     END;
  ELSE END;
  ok:=ok AND(sum=0); isotr:=false; IF(ok)THEN isotr:=true;
  END;
 END;
END;
PROCEDURE MakeBackPars(ibeg:INTEGER);
VAR i,j,iph:INTEGER; amx,r,r1,r2:REAL;
BEGIN WITH spec[numsp] DO
 BEGIN FOR i:=ibeg TO ibeg+5 DO parar[i].p:=bkpar[i-ibeg+1]; j:=dback;
 r1:=AMIN3(y[a11],y[a11+1],y[a11+2]);
 r2:=AMIN3(y[a22],y[a22-1],y[a22-2]);
 CASE j OF {form background}
 -1:   BEGIN FOR i:=ibeg TO ibeg+5 DO WITH parar[i] DO
        BEGIN p:=0; pl:=0; pu:=0;
        END;
       END;
 0..5: BEGIN FOR i:=ibeg+j+1 TO ibeg+5 DO WITH parar[i] DO
        BEGIN pl:=0; p:=0; pu:=0;
        END;
       WITH parar[ibeg] DO IF(p=0)THEN p:=(r1+r2)*0.5;;
       WITH parar[ibeg+1] DO IF((p=0)AND(j>0))THEN p:=(r2-r1)*0.25;
       END;
 6:    BEGIN amx:=-1E14; r:=(a11+a22)DIV 2;
       FOR i:=a11 TO a22 DO amx:=AMAX1(amx,y[i]);
       parar[ibeg].p:=(r1+r2)/2; parar[ibeg].pl:=1;
       parar[ibeg+1].p:=amx; parar[ibeg+1].pl:=1;
       parar[ibeg+2].p:=0;
       parar[ibeg+3].p:=r/2; parar[ibeg+3].pu:=a11;
       parar[ibeg+3].pu:=a22;
       parar[ibeg+4].p:=r; parar[ibeg+4].pl:=1;
       parar[ibeg+5].p:=0;
       END;
 ELSE END;
 END;
END;
PROCEDURE SetIniAtom(iph:INTEGER);
BEGIN WITH atoms[1,iph] DO
 BEGIN occ:=1; x:=0.345678; y:=0.7531; z:=0.314159;
 T11:=0; T12:=0; T13:=0; T22:=0; T23:=0; T33:=0; scat:=1;
 END;
END;
PROCEDURE SetSpaceGroupInfo(iph:INTEGER);
{Purpose: To input the space group information from file SPACE.ASC
 Version: 3 Aug 1990}
VAR   i,j,isg,k,ii,ij,jj,jjj,kk,kkk,nspg:INTEGER; r1,r2,r3:REAL;
      inl:ARRAY[1..30] OF INTEGER; chs:STRING; found:BOOLEAN;
LABEL L1;
BEGIN ModalRes:=1; WITH lat[iph] DO IF(nsg<>0)THEN
 BEGIN found:=false; i:=1; nspg:=ABS(nsg); IF(sett=2)THEN nspg:=-nspg;
 WHILE(i<2963)DO {Loop in space groups}
  BEGIN Val(Copy(space_asc[i],1,4),isg,j);
  Val(Copy(space_asc[i],9,4),nut,j); IF(isg=nspg)THEN
   BEGIN found:=true;
   Val(Copy(space_asc[i],5,4),laue,j);
   Val(Copy(space_asc[i],13,4),csym,j);
   Val(Copy(space_asc[i],17,4),ntlv,j);
   chs:=Copy(space_asc[i],26,30);
   Val(Copy(space_asc[i+1],1,2),nlatt,j);
   schoe:=Copy(space_asc[i+1],28,7); stand:=Copy(space_asc[i+1],35,7);
   IF(nut>48)THEN ShowMess('Error, number of transformations  > 48');
   nut:=MIN0(nut,48);
   FOR j:=1 TO 30 DO inl[j]:=Ord(chs[j])-48;
   {Lattice translation vectors}
   FOR k:=1 TO 3 DO
    BEGIN kk:=(k-1)*6;
    r1:=inl[kk+1]; r1:=r1/AMAX0(inl[kk+2],1);
    r2:=inl[kk+3]; r2:=r2/AMAX0(inl[kk+4],1);
    r3:=inl[kk+5]; r3:=r3/AMAX0(inl[kk+6],1);
    tlv[1,k]:=r1; tlv[2,k]:=r2; tlv[3,k]:=r3;
    END;
   END;
   {Extract the transformation matrix and the vector}
  IF(NOT found)THEN i:=i+2+nut ELSE FOR j:=1 TO nut DO
   BEGIN FOR ii:=1 TO 15 DO
    Val(Copy(space_asc[i+1+j],ii*3-2,3),inl[ii],ij);
   FOR jj:=1 TO 3 DO
    BEGIN jjj:=(jj-1)*5; kkk:=(jj-1)*3;
    ut[kkk+1,j]:=inl[jjj+3]; ut[kkk+2,j]:=inl[jjj+4];
    ut[kkk+3,j]:=inl[jjj+5]; shv[jj,j]:=inl[jjj+1]/AMAX0(inl[jjj+2],1);
    END;
   END;
  IF(found)THEN Exit;
  END;
 IF(NOT found)THEN
  BEGIN ShowMess('No group '+IntToStr(nsg)+', setting '+IntToStr(sett));
  ModalRes:=0;
  END;
 END;
END;
PROCEDURE MakeSpZero(ns,i1,i2:INTEGER);
VAR i:INTEGER;
BEGIN WITH spec[ns] DO
 BEGIN FOR i:=i1 TO i2 DO
  BEGIN y[i]:=0; e[i]:=1; x[i]:=i;
  END;
 spin:=true;
 END;
END;
PROCEDURE ArrangeDSpacings;
VAR i,j:INTEGER; w:REAL;
BEGIN {Arrange} FOR i:=1 TO mdsp-1 DO FOR j:=1 TO mdsp-1 DO
 BEGIN IF(dspa[j].d>dspa[j+1].d)THEN CONTINUE;
 ds:=dspa[j]; dspa[j]:=dspa[j+1]; dspa[j+1]:=ds;
 END;
{CheckDsp}
FOR i:=1 TO mdsp DO WITH dspa[i] DO IF((d<=0)OR(e<0)OR(x<0))THEN
 BEGIN ConvertStr(d,10,4); s:='d='+sedz;
 ConvertStr(e,10,4); s:=s+' e='+sedz;
 ConvertStr(x,10,2); s:=s+' x='+sedz;
 ShowMess('Warning, d-spacing= '+s);
 END;
{Remove the coincidences}FOR i:=1 TO mdsp-1 DO
 IF(dspa[i].d=dspa[i+1].d)THEN dspa[i].d:=0;
j:=0; FOR i:=1 TO mdsp DO IF(dspa[i].d<>0)THEN
 BEGIN Inc(j); dspa[j]:=dspa[i];
 END;
mdsp:=j;
{Make the weight} w:=0; FOR i:=1 TO mdsp DO WITH dspa[i] DO
 BEGIN {ass:=false;} w:=w+e;
 END;
eps_av:=w/AMAX0(j,1);
IF(w=0)THEN
 BEGIN epsauto:=AMAX1(epsauto,0.00001); ConvertStr(epsauto,8,5);
 ShowMess('D-errors = 0. Assigned '+sedz);
 FOR i:=1 TO mdsp DO dspa[i].e:=epsauto; eps_av:=epsauto;
 END;
END;
{----------}
BEGIN spgfn:='vm.spg';  noeventf:=true; fnout:='';
psclass:=false; auclass:=false; nosavedAc:=false; nosavedD:=false;
END.

