UNIT vmriahkl;
INTERFACE
USES  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
      Dialogs, Menus,    StdCtrls, Grids,   ExtCtrls, vzlocom,  vmria0,
      vmria00, vmriasp, varfun,   vmria2,   vmriahlp;
PROCEDURE fmagtrstr(it,iph:INTEGER; VAR s:STRING);
PROCEDURE StructFactor(mo,iph,h,k,l,mu,i0:INTEGER; VAR Fc,Fs,Fm:REAL);
PROCEDURE FindMaxSF(VAR r,mg:REAL; iph:INTEGER);
PROCEDURE FormMillerIndices(dmin,dmax:REAL; iph:INTEGER);
PROCEDURE UpdateLatAt;
PROCEDURE GetForbidden(iph:INTEGER; VAR nforbd:INTEGER);
VAR  maskf:ARRAY[1..10,1..3] OF INTEGER;  {for forbidden}
     ntypef,ndenf:ARRAY[1..10] OF INTEGER;
{-----------------------------------------------}
IMPLEMENTATION
PROCEDURE StructFactor(mo,iph,h,k,l,mu,i0:INTEGER; VAR Fc,Fs,Fm:REAL);
{Purpose: To compute the structure factor for given hkl;
          F = SUM b*exp(2pi(i)(h*x+k*y+l*z))*exp(-0.25*(TH,H))
          (TH,H) = T11*(h*a_)^2+T22*(k*b_)^2+T33*(l*c_)^2+
                   2*(T12*h*k*a_*b_+T13*h*l*a_*c_+T23*k*l*b_*c_)
          mo=0 information from ATOMS
          mo=1 information from PARAMETERS
          Magnetic: b=formfactor(d)*sin^2(eta_H)
 Version: 31 Jan 1990,  Nov 18 1997  Jul 1 2005}

VAR i,j,ic,iatom,it,natom,iii:INTEGER; {isot:BOOLEAN;}
    tr:ARRAY[1..3] OF REAL;
    cscf,crr,xtj,ytj,ztj,arg,expb,thm,cosa,sina,ht,kt,lt:REAL;
    bj,xj,yj,zj,b11,b12,b13,b22,b23,b33,sumb:REAL;
    rsc,hh0,dfa,dfb,dfc:REAL;
 FUNCTION mvsign(j:INTEGER):REAL;
 VAR msum:REAL; i:INTEGER;
 BEGIN msum:=0; WITH lat[iph] DO FOR i:=1 TO 9 DO msum:=msum+mut[i,j];
 mvsign:=msum;
 END;

BEGIN Fc:=0; Fs:=0; natom:=lat[iph].nat;
FOR iatom:=1 TO natom DO WITH atoms[iatom,iph] DO {Main loop (in atoms)}
 BEGIN IF(mo=0)THEN {Info from Atoms}
  BEGIN bj:=occ; xj:=x; yj:=y; zj:=z;
  b11:=t11; b12:=t12; b13:=t13; b22:=t22; b23:=t23; b33:=t33;
  END                                   ELSE WITH gfit DO
   BEGIN iii:=iatom*10+i0; bj:=par[iii+1].p; {Info from Parameters}
   xj:=par[iii+2].p; yj:=par[iii+3].p; zj:=par[iii+4].p;
   b11:=par[iii+5].p; b12:=par[iii+6].p; b13:=par[iii+7].p;
   b22:=par[iii+8].p; b23:=par[iii+9].p; b33:=par[iii+10].p;
   END;

 {sumb:=ABS(b22)+ABS(b33); isot:=false; IF(sumb=0)THEN isot:=true;}

 IF(keyma[iph]=0)THEN cscf:=atoms[iatom,iph].scat {Coherent scat.ampl.}
                 ELSE {Magnetic Form-factor}
  BEGIN r:=0.25*q_old;
  cscf:=SIGN(mgmom)*(Ab*EXP(-al*r)+Bb*EXP(-bl*r)+Cb*EXP(-cl*r)+Db);
  cscf:=cscf*0.539;
  END;

 crr:=bj*cscf; WITH lat[iph] DO FOR it:=1 TO ntlv+1 DO
  BEGIN FOR ic:=1 TO 3 DO {Loop in translations}
   IF(it=1)THEN tr[ic]:=0
           ELSE tr[ic]:=tlv[ic,it-1];
  FOR j:=1 TO nut DO {Loop in symmetry transformations}
   BEGIN xtj:=ut[1,j]*xj+ut[2,j]*yj+ut[3,j]*zj+shv[1,j]+tr[1];
   ytj:=ut[4,j]*xj+ut[5,j]*yj+ut[6,j]*zj+shv[2,j]+tr[2];
   ztj:=ut[7,j]*xj+ut[8,j]*yj+ut[9,j]*zj+shv[3,j]+tr[3];
   arg:=pi2*(xtj*h+ytj*k+ztj*l); {imaginary exponential argument}
   IF(isotr)THEN expb:=EXP(-b11*q_old*0.25)  {the thermal factor}
            ELSE
    BEGIN ht:=ut[1,j]*h+ut[4,j]*k+ut[7,j]*l;
    kt:=ut[2,j]*h+ut[5,j]*k+ut[8,j]*l;
    lt:=ut[3,j]*h+ut[6,j]*k+ut[9,j]*l; WITH lat[iph] DO
     BEGIN ht:=ht/ascx; kt:=kt/bscx; lt:=lt/cscx;
     END;
    thm:=(b11*ht+2*b12*kt+2*b13*lt)*ht+(b22*kt+2*b23*lt)*kt+b33*lt*lt;
    expb:=EXP(-thm);
    END;

   expb:=expb*crr*(ntlv+1); cosa:=COS(arg); sina:=SIN(arg);
   {IF(keyma[iph]=1)THEN
    BEGIN iii:=Round(mvsign(j)); IF(mvsign(j)<>3)THEN expb:=-expb;
    END;}
   IF(csym=1)THEN {the structure factor}
    BEGIN Fc:=Fc+2*cosa*expb; Fs:=0;  {Centro-symmetric}
    END      ELSE
     BEGIN Fc:=Fc+cosa*expb; Fs:=Fs+sina*expb;
     END;
   END;
  END; {Loop end}
 END;
GetFmDer(iph,mo,0,h,k,l,mu,Fm,dfa,dfb,dfc);
END;
PROCEDURE FormMillerIndices(dmin,dmax:REAL; iph:INTEGER);
{Purpose: To form the Miller indices, Version 0: 11.4.1989
          Last version: February 13 1991; May 15 2000}
VAR   i,j,isp,icl,hmax,kmax,lmax,ih2,ik2,il2,ich,ick:INTEGER;
      lh,lk,ll,icnt,icnt1,mh,mk,ml,ne,kref,nn,n1,nref,m,ipar:INTEGER;
      nfbd,ihkl,ih,ik,il:INTEGER; coinc:BOOLEAN; Fm:REAL; ch:CHAR;
      ht,kt,lt,r,ah,bk,cl,q,q12,dk0,eps,Fkcc,Fksc,cosa,cosb,cosg:REAL;
      mmh,mmk,mml:ARRAY[1..1000] OF INTEGER;
LABEL L360,L369,L370,L600,L9;
BEGIN WITH lat[iph] DO {loop with respect to phase}
 BEGIN hmax:=Round(3*lpd.a)+1; kmax:=Round(3*lpd.b)+1;
 lmax:=Round(3*lpd.c)+1; ih2:=hmax*2+1; ik2:=kmax*2+1; il2:=lmax+1;
 ascx:=lpd.a; bscx:=lpd.b; cscx:=lpd.c;
 {IF(debugV)THEN GetForbidden(iph,nfbd)}; {Rewrite(fout);}
 nref:=0; r:=radian; WITH lpi DO
  BEGIN cosa:=COS(alpha/r); cosb:=COS(beta/r); cosg:=COS(gamma/r);
  END;
 {Writeln(fout,'* ph=',iph:2,ih2:4,ik2:4,il2:4,dmin:10:5,dmax:10:5);}
 {**********   loop with respect to reflections   ***************}
 FOR ich:=1 TO ih2 DO FOR ick:=1 TO ik2 DO FOR icl:=1 TO il2 DO
  BEGIN lh:=ich-hmax; lk:=ick-kmax; ll:=icl-1;
  WITH lpi DO
   BEGIN ah:=a*lh; bk:=b*lk; cl:=c*ll;
   q:=ah*ah+bk*bk+cl*cl+2*(ah*bk*cosg+bk*cl*cosa+cl*ah*cosb);
   END;
  IF(q<=0)THEN GOTO L9; dk0:=1/SQRT(q);
  IF((dk0<dmin)OR(dk0>dmax))THEN GOTO L9;
  {Remove lattice absences for  P   A   B   C   F   I   R   H}
  CASE nlatt OF
  1: IF(((ll+lk)MOD 2)<>0)THEN GOTO L9; {A face centred}
  2: IF(((lh+ll)MOD 2)<>0)THEN GOTO L9; {B face centred}
  3: IF(((lh+lk)MOD 2)<>0)THEN GOTO L9; {C face centred}
  4: IF((((lh+lk)MOD 2)<>0)OR(((lk+ll)MOD 2)<>0))THEN GOTO L9;{Fcented}
  5: IF(((lh+lk+ll)MOD 2)<>0)THEN GOTO L9; {I(body) centred}
  6: IF(((-lh+lk+ll)MOD 3)<>0)THEN GOTO L9; {R centred}
  ELSE END;
  {Check for forbidden hkls}  {..........}
  {Check for zero structure factor; dk = D-position of the reflection}
  q_old:=q; StructFactor(0,iph,lh,lk,ll,1,0,Fkcc,Fksc,Fm);
  eps:=SQRT(SQR(Fkcc)+SQR(Fksc));
  {Writeln(fout,'hkl,d,Fk = ',lh:4,lk:4,ll:4,dk0:10:5,eps:14:8);}
  IF(eps < (1.E-9))THEN GOTO L9;
  {Define multiplicities and convenient h,k,l (icnt items)} icnt:=0;
  icnt1:=0;{Total number of equiv.indices}
  {Loop in symmetry transformations}
  FOR i:=1 TO nut DO
   BEGIN ht:=ut[1,i]*lh+ut[4,i]*lk+ut[7,i]*ll;
   kt:=ut[2,i]*lh+ut[5,i]*lk+ut[8,i]*ll;
   lt:=ut[3,i]*lh+ut[6,i]*lk+ut[9,i]*ll;
   mh:=Round(ht); mk:=Round(kt); ml:=Round(lt);
   ne:=0; IF(i=1)THEN GOTO L360;
   {Check for identical indices}
   REPEAT FOR j:=1 TO icnt1 DO
    IF((mh=mmh[j])AND(mk=mmk[j])AND(ml=mml[j]))THEN GOTO L369;
   L360: icnt:=icnt+1; {Multipl.}
   L369: icnt1:=icnt1+1; mmh[icnt1]:=mh; mmk[icnt1]:=mk; mml[icnt1]:=ml;
   IF(ne=1)THEN GOTO L370;
   ne:=1; mh:=-mh; mk:=-mk; ml:=-ml;
   UNTIL false;
   L370:;
   END;
  {Choose convenient indices h,k,l}
  ch:='*'; j:=-1000; FOR i:=1 TO icnt1 DO
   BEGIN IF(debugV.hkli)THEN
    Writeln(fout,ch,mml[i]:5,mmk[i]:5,mml[i]:5);
   ch:=' '; ipar:=0; IF(mmh[i]<0)THEN GOTO L600;
   IF(mmk[i]>=0)THEN ipar:=ipar+100; IF(mml[i]>=0)THEN ipar:=ipar+10;
   IF(ABS(mmh[i])>ABS(mml[i]))THEN ipar:=ipar+5;
   IF(ABS(mmh[i])>ABS(mmk[i]))THEN ipar:=ipar+3;
   IF(ABS(mmk[i])>ABS(mml[i]))THEN ipar:=ipar+1;
   IF(ipar<=j)THEN GOTO L600; j:=ipar; ihkl:=i;
   L600:;
   END;
  ih:=mmh[ihkl]; ik:=mmk[ihkl]; il:=mml[ihkl]; WITH lpi DO
   BEGIN ah:=a*ih; bk:=b*ik; cl:=c*il;
   q:=ah*ah+bk*bk+cl*cl+2*(ah*bk*cosg+bk*cl*cosa+cl*ah*cosb);
   END;
  q12:=SQRT(q); dk0:=1/q12;
  IF(nref=0)THEN {1st reflection}
   BEGIN hkla[1,iph].h:=ih; hkla[1,iph].k:=ik; hkla[1,iph].l:=il;
   hkla[1,iph].mul:=icnt; hkla[1,iph].dk:=dk0;
   hkla[1,iph].Fkc:=Fkcc; hkla[1,iph].Fks:=Fksc; hkla[1,iph].Fkm:=Fm;
   nref:=1; GOTO L9;
   END;
  FOR j:=1 TO nref DO WITH hkla[j,iph] DO{Drop the coincident}
   BEGIN
   IF((ih=h)AND(ik=k)AND(il=l))THEN GOTO L9;
   END;
  nn:=nref+1; FOR i:=1 TO nref DO
   BEGIN IF(dk0<hkla[i,iph].dk)THEN CONTINUE;
   FOR j:=nref DOWNTO i DO hkla[j+1,iph]:=hkla[j,iph]; nn:=i;
   BREAK;
   END;
  hkla[nn,iph].h:=ih; hkla[nn,iph].k:=ik; hkla[nn,iph].l:=il;
  hkla[nn,iph].mul:=icnt; hkla[nn,iph].dk:=dk0;
  hkla[nn,iph].Fkc:=Fkcc; hkla[nn,iph].Fks:=Fksc; hkla[nn,iph].Fkm:=Fm;
  Inc(nref); IF(nref>nhklmax)THEN
   BEGIN ShowMess('Curtail the interval - too many hkls');
   nhkl:=nref; Exit;
   END;
  L9:;
  END;
 nhkl:=nref; WITH lat[iph] DO FindMaxSF(Fkmax,Fmmax,iph);
 do1[numsp]:=spec[numsp].a11; do2[numsp]:=spec[numsp].a22;
 END;
END;
PROCEDURE GetForbidden(iph:INTEGER; VAR nforbd:INTEGER);
{maskI(4) - mask for indices 1-h(=1), 2-k(=3), 3-l(=5), 4-0
 nforbd - obtained number of extinction conditions
 mask(3,10) - mask for rules
 maskf(3,10) - onbtained rules;  ntypef(10) - obtained types of rules
 type  mask() definition
 1 - 1,2,2 (hkk)  4 - 1,2,1 (hkh)  7 - 1,1,3 (hhl)
 2 - 4,2,3 (0kl)  5 - 1,4,3 (h0l)  8 - 1,2,4 (hk0)
 3 - 1,4,4 (h00)  6 - 4,2,4 (0k0)  9 - 4,4,3 (00l)  10 - 1,-1,3(h-hl)
 ndenf(10) - extinction denominator (2,3,4 or 6)
 shift(7) - mask for shift (1/2, 1/3, 2/3 etc.)
 nshift(7) - mask for denominators
 maskI/1,3,5,0,-1/	! arbitrary h,k,l = 1,3,5;}
CONST mask:ARRAY[1..10,1..3] OF INTEGER =(
           (1,2,2), (4,2,3), (1,4,4), (1,2,1), (1,4,3),
           (4,2,4), (1,1,3), (1,2,4), (4,4,3), (1,5,3) );
    {arbitrary h,k,l=1,3,5} maskI:ARRAY[1..5] OF INTEGER = (1,3,5,0,-1);
      shift:ARRAY[1..7] OF REAL =
       (0.5,0.333,0.667,0.25,0.75,0.167,0.833);
      nshift:ARRAY[1..7] OF INTEGER = ( 2, 3, 3, 4, 4, 6, 6);
VAR   i,j,i9,l,mtmp,jtmp,n,nmin,nmax:INTEGER;
      tmp,eps,tnabs,ht,kt,lt:REAL;
      ih,newih:ARRAY[1..3] OF INTEGER;
      tn:ARRAY[1..3] OF REAL;
LABEL L21,L22,L888;
BEGIN ok:=false; eps:=0.01; nforbd:=0;
FOR i9:=1 TO 10 DO  {Loop in types}
 BEGIN FOR j:=1 TO 3 DO ih[j]:=maskI[mask[i9,j]];
 {Writeln(fout,ih[1]:4,ih[2]:4,ih[3]:4);}
 {Calculate for the equivalents}  WITH lat[iph] DO FOR i:=1 TO nut DO
  BEGIN tnabs:=0; FOR j:=1 TO 3 DO
   BEGIN tn[j]:=ABS(shv[j,i]); tnabs:=tnabs+tn[j];
   END;
  IF(tnabs=0)THEN GOTO L888;
  ht:=ut[1,i]*ih[1]+ut[4,i]*ih[2]+ut[7,i]*ih[3];
  kt:=ut[2,i]*ih[1]+ut[5,i]*ih[2]+ut[8,i]*ih[3];
  lt:=ut[3,i]*ih[1]+ut[6,i]*ih[2]+ut[9,i]*ih[3];
  newih[1]:=Round(ht); newih[2]:=Round(kt); newih[3]:=Round(lt);
  FOR j:=1 TO 3 DO IF(newih[j]<>ih[j])THEN GOTO L22; GOTO L21;
  L22: IF(csym=0)THEN GOTO L888; FOR j:=1 TO 3 DO
   BEGIN mtmp:=-newih[j]; IF(mtmp<>ih[j])THEN GOTO L888;
   END;
  L21: {Equal indices} Inc(nforbd); IF(nforbd>10)THEN Exit;
  ntypef[nforbd]:=i9; ndenf[nforbd]:=0;
 {Writeln(fout,ih[1]:4,ih[2]:4,ih[3]:4,'  eq; tnabs= ',tnabs:10:4);}
  FOR j:=1 TO 3 DO
   BEGIN jtmp:=1; IF((ih[j]=0)OR(tn[j]=0))THEN jtmp:=0;
   maskf[nforbd,j]:=jtmp;
   IF((jtmp=0)OR(ndenf[nforbd]>0))THEN CONTINUE;
   FOR l:=1 TO 7 DO
    BEGIN tmp:=ABS(tn[j]-shift[l]); IF(tmp>eps)THEN CONTINUE;
    ndenf[nforbd]:=nshift[l];
    {Writeln(fout,ndenf[nforbd]:4,tmp:10:4);}
    BREAK;
    END;
   END;
  IF(ndenf[nforbd]=0)THEN
   BEGIN Dec(nforbd); GOTO L888;
   END;
   {Writeln(fout,'nforb= ',nforbd:4)}
  {Check for previous rules}
  mtmp:=nforbd-1; IF(mtmp=0)THEN GOTO L888;
  FOR j:=1 TO mtmp DO
   BEGIN IF(ntypef[j]<>ntypef[nforbd])THEN CONTINUE;
   FOR l:=1 TO 3 DO IF(maskf[j,l]<>maskf[nforbd,l])THEN CONTINUE;
   nmin:=MIN0(ndenf[j],ndenf[nforbd]);
   nmax:=MAX0(ndenf[j],ndenf[nforbd]); Dec(nforbd);
   IF(nmax=nmin)THEN GOTO L888;
   n:=(nmax MOD nmin);
   IF(n=0)THEN ndenf[j]:=nmax ELSE ndenf[j]:=nmax*nmin;
   END;
  L888:;
  END;
 END;
Writeln(fout,nforbd:4,' formulae');
FOR j:=1 TO nforbd DO FOR i:=1 TO 3 DO
 BEGIN Write(fout,maskf[j,i]:10); IF(i=3)THEN Writeln(fout);
 END;
FOR j:=1 TO nforbd DO Write(fout,ndenf[j]:3); Writeln(fout);
FOR j:=1 TO nforbd DO Write(fout,ntypef[j]:3); Writeln(fout);
END;
PROCEDURE fmagtrstr(it,iph:INTEGER; VAR s:STRING);
{Purpose: form the magnetic transformation string, Version: May 13 2000}
CONST chxyz:ARRAY[1..3] OF CHAR = ('x','y','z');
VAR i,j,jj:INTEGER; ii:ARRAY[1..3] OF INTEGER;
    {st:STRING[4];} ch:ARRAY[1..3] OF STRING[2];
BEGIN s:=' '; WITH lat[iph] DO FOR j:=1 TO 3 DO
 BEGIN ii[1]:=Round(ut[(j-1)*3+1,it]); ii[2]:=Round(ut[(j-1)*3+2,it]);
 ii[3]:=Round(ut[(j-1)*3+3,it]);
 FOR i:=1 TO 3 DO
  BEGIN ch[i]:='  '; jj:=sign(ii[i]);
  CASE jj OF
  -1: BEGIN ch[i][1]:='-'; ch[i][2]:=chxyz[i];
      END;
  1: BEGIN ch[i][1]:='+'; ch[i][2]:=chxyz[i];
     END;
  ELSE END;
  END;
  CASE j OF
  1: s:=ch[1]+ch[2]+ch[3]+',  ';
  2: s:=s+ch[1]+ch[2]+ch[3]+',  ';
  3: s:=s+ch[1]+ch[2]+ch[3];
  ELSE END;
 END;
IF(s[1]='+')THEN s[1]:=' '; FOR i:=1 TO Length(s)-3 DO
 BEGIN j:=Pos(',  +',s); IF(j<>0)THEN s[j+3]:=' ';
 END;
END;
PROCEDURE FindMaxSF(VAR r,mg:REAL; iph:INTEGER);
VAR i:INTEGER;
BEGIN r:=0; mg:=0; FOR i:=1 TO lat[iph].nhkl DO WITH hkla[i,iph] DO
 BEGIN r:=MAXZ(r,SQRT(SQR(Fkc)+SQR(Fks))); r:=MAXZ(r,0.0001);
 mg:=MAXZ(mg,Fkm); mg:=MAXZ(mg,0.0001);
 END;
END;
PROCEDURE UpdateLatAt;
{Replace initial parameters by the fitted ones version Feb 2 2001,
 Version Oct 27 2006}
VAR   u11,u22,u33,u12,u13,u23:REAL; ok:BOOLEAN; i,j,kk,iph,i0:INTEGER;
      q,ah,bk,cl,cosa,cosb,cosg,da,db,dc,dal,dbe,dga,v,r:REAL;
LABEL L1;
BEGIN FOR iph:=1 TO nph DO WITH gfit DO
 BEGIN {Update cell pars} lat[iph].lpd0:=lat[iph].lpd; i0:=Geti0(iph);
 u11:=ABS(par[i0+2].p); u22:=ABS(par[i0+3].p); u33:=ABS(par[i0+4].p);
 u23:=par[i0+5].p/2; u13:=par[i0+6].p/2; u12:=par[i0+7].p/2;
 da:=ABS(par[i0+2].e); db:=ABS(par[i0+3].e); dc:=ABS(par[i0+4].e);
 dal:=par[i0+5].e/2; dbe:=par[i0+6].e/2; dga:=par[i0+7].e/2;
 u11:=SQRT(u11); u22:=SQRT(u22); u33:=SQRT(u33);
 IF((u11*u22*u33)=0)THEN
  BEGIN ShowMess('Wrong unit cell parameters'); CONTINUE;
  END;
 u12:=u12/(u11*u22); u13:=u13/(u11*u33); u23:=u23/(u22*u33);
 da:=0.5*da/SQRT(ABS(u11)); db:=0.5*db/SQRT(ABS(u22));
 dc:=0.5*dc/SQRT(ABS(u33));
 dal:=SQRT(SQR(dal)+SQR(u23*db/u33)+SQR(u23*dc/u22));
 dbe:=SQRT(SQR(dbe)+SQR(u13*da/u33)+SQR(u23*dc/u11));
 dga:=SQRT(SQR(dga)+SQR(u12*da/u22)+SQR(u12*db/u11));
 dal:=dal/SQRT(1-AMIN1(SQR(u23),0.99));
 dbe:=dbe/SQRT(1-AMIN1(SQR(u13),0.99));
 dga:=dga/SQRT(1-AMIN1(SQR(u12),0.99));
 WITH lat[iph].lpi DO
  BEGIN u12:=arccos(u12)*radian; u13:=arccos(u13)*radian;
  u23:=arccos(u23)*radian;
  a:=u11; b:=u22; c:=u33; alpha:=u23; beta:=u13; gamma:=u12;
  GetAlBeGa(alpha,beta,gamma,lat[iph].syng);
  IF(lat[iph].syng=6)THEN gamma:=60;
  END;
 WITH lat[iph] DO
  BEGIN vol0:=vol; voli:=getvol(lpi);
  END;
 WITH lat[iph] DO InverseLatPar(lpi,lpd,vol,0);
 WITH lat[iph] DO
  BEGIN lper.a:=lpd.a*(da/u11); lper.b:=lpd.b*(db/u22);
  lper.c:=lpd.c*(dc/u33); lper.alpha:=lpd.alpha*(dal/u23);
  lper.beta:=lpd.beta*(dbe/u13); lper.gamma:=lpd.gamma*(dga/u12);
  END;
 WITH lat[iph].lpd DO
  BEGIN
  ok:=(ABS(COS(gamma))>1)OR(ABS(COS(beta))>1)OR(ABS(COS(alpha))>1);
  IF(ok)THEN ShowMess('Error, the lattice cosines are wrong.');
  END;
 IF(keyma[iph]=1)THEN WITH lat[iph] DO
  BEGIN kk:=GetNAddiPar(0)+(iph-1)*3+1;
  h0:=par[kk].p; k0:=par[kk+1].p; l0:=par[kk+2].p;
  END;
 FormLatMatrix(iph); IF(mriamode<>0)THEN CONTINUE;
 {Update atoms}
 CheckForIsotropy(1);
 FOR i:=1 TO lat[iph].nat DO WITH atoms[i,iph] DO
  BEGIN kk:=i0+i*10; r:=par[kk+1].p; q:=occ; IF(q=0)THEN q:=1;
  IF(keyma[iph]=1)THEN mgmom:=SIGN(mgmom)*r/q ELSE occ:=r;
  x:=par[kk+2].p; y:=par[kk+3].p; z:=par[kk+4].p;
  T11:=par[kk+5].p; T12:=par[kk+6].p; T13:=par[kk+7].p;
  T22:=par[kk+8].p; T23:=par[kk+9].p; T33:=par[kk+10].p;
  eoc:=par[kk+1].e;
  ex:=par[kk+2].e; ey:=par[kk+3].e; ez:=par[kk+4].e;
  e11:=par[kk+5].e; e12:=par[kk+6].e; e13:=par[kk+7].e;
  e22:=par[kk+8].e; e23:=par[kk+9].e; e33:=par[kk+10].e;
  END;
 END;
{Update dk and Fkc,Fks,Fkm in hkla}
L1: FOR iph:=1 TO nph DO WITH lat[iph].lpi DO
  BEGIN r:=radian;
  cosa:=COS(alpha/r); cosb:=COS(beta/r); cosg:=COS(gamma/r);
  FOR i:=1 TO lat[iph].nhkl DO WITH hkla[i,iph] DO
   BEGIN ah:=a*h; bk:=b*k; cl:=c*l;
   q:=ah*ah+bk*bk+cl*cl+2*(ah*bk*cosg+bk*cl*cosa+cl*ah*cosb);
   IF(q>0)THEN dk:=1/SQRT(q) ELSE dk:=0.000001;
   i0:=Geti0(iph); q_old:=q;
   IF(mriamode=0)THEN StructFactor(1,iph,h,k,l,mul,i0,Fkc,Fks,Fkm);
   END;
  IF(mriamode=0)THEN FindMaxSF(lat[iph].Fkmax,lat[iph].Fmmax,iph);
  END;
{Update aniso}
IF(anis_mod)THEN WITH gfit DO
 FOR iph:=1 TO nph DO IF(anisma[iph])THEN WITH lat[iph] DO
  BEGIN j:=GetNAddiPar(1)+(iph-1)*9;
  FOR i:=1 TO 9 DO anisa[i]:=par[j+i].p;
  END;
{Update m"}
IF(use_m2)THEN WITH gfit DO
  BEGIN j:=GetNAddiPar(2); FOR i:=1 TO 2 DO m2para[i]:=par[j+i].p;
  END;
{Update magnetic}
IF(magfl)THEN WITH gfit DO
 FOR iph:=1 TO nph DO IF(keyma[iph]=1)THEN WITH lat[iph] DO
  BEGIN j:=GetNAddiPar(0)+(iph-1)*3;
  h0:=par[j+1].p; k0:=par[j+1].p; l0:=par[j+1].p;
  END;
END;
{-----------------------------------------------}
BEGIN
END.
