UNIT vmriainf;
INTERFACE
USES Windows,  Messages, SysUtils, Classes, Graphics, Controls, Forms,
     Dialogs,  StdCtrls, ExtCtrls, Grids,   vzlocom,  vmria0,   vmria2,
     vmriasp,  vmriarit, vmriahkl, vmriahlp,vspectr,  vpeaksr,  vgfit,
     vmriarix, vpmodel,  vstdcons, vmria00, vmriacry, vmria3,   varfun;
PROCEDURE InfoaboutPhases;
PROCEDURE InfoaboutHKLs;
PROCEDURE InfoaboutAtoms;
PROCEDURE InfoaboutSpectrum;
PROCEDURE ShowParameterArray;
PROCEDURE ReadParameters(VAR wr:BOOLEAN);
PROCEDURE ShowFitControls;
PROCEDURE InfoaboutAutoindexing;
PROCEDURE InfoaboutINIfile;
PROCEDURE pTOsedz(p:REAL; n:INTEGER);
PROCEDURE PutParameters(i,nc:INTEGER);
PROCEDURE FormRAParTable;
PROCEDURE FormPMParTable;
PROCEDURE FormAIParTable;
PROCEDURE FormUParTable;
PROCEDURE InfoaboutSetofPoints;
PROCEDURE ShowFitQuality;
PROCEDURE CheckParameterArray(ip:INTEGER);
PROCEDURE ShowParErrors;
PROCEDURE ChangeCellPars;
PROCEDURE InfoaboutVariance;
PROCEDURE CheckToFAInfo(i:INTEGER; VAR ok:BOOLEAN);
PROCEDURE CheckSpectrumInfo(VAR s:STRING; isp:INTEGER; VAR ok:BOOLEAN);

IMPLEMENTATION

PROCEDURE CheckSpectrumInfo(VAR s:STRING; isp:INTEGER; VAR ok:BOOLEAN);
VAR i:INTEGER; ss:STRING;
BEGIN {i:=Pos('=',s); IF(i<>0)THEN ss:=Copy(s,i+1,128) ELSE ss:='';}
L0rec:='Spectrum '+IntToStr(isp); ss:=spec[isp].sfn;
MakeForm(1); WITH spec[isp] DO
 BEGIN strgrT[1]:='Beginning =';          strgrNn[1,1]:=a1;
 strgrT[2]:='End =';                strgrNn[2,1]:=a2;
 strgrT[3]:='Interval beginning ='; strgrNn[3,1]:=a11;
 strgrT[4]:='Interval end =';       strgrNn[4,1]:=a22;
 strgrT[5]:='Background Mode =';    strgrNn[5,1]:=dback;
 strgrT[6]:='Channel width (mks) ='; strgrNn[6,1]:=chw;
 strgrT[7]:='Delay(chan) =';        strgrNn[7,1]:=delay;
 strgrT[8]:='Bragg angle(deg) =';   strgrNn[8,1]:=theta;
 strgrT[9]:='Flight Path(m) =';  strgrNn[9,1]:=FPath;
 strgrT[10]:='Width 0 (chan) =';     strgrNn[10,1]:=w0;
 strgrT[11]:='Delta Width0(chan) ='; strgrNn[11,1]:=dw0;
 strgrT[12]:='Width 1 = ';          strgrNn[12,1]:=w1;
 strgrT[13]:='Delta Width1 =';      strgrNn[13,1]:=dw1;
 strgrT[14]:='ToF=0 / Angular=1 / Any=2'; strgrNn[14,1]:=tofang;
 IF(tofang=1)THEN
  BEGIN strgrT[6]:='Channel width (deg) =';
  strgrT[7]:='Zero shift(deg) =';
  strgrT[9]:='Wave length(Angs) ='; strgrNn[9,1]:=lambda;
  END;
 L1rec:='SpName='; E1rec:=sfn; MakeEdits(3,75,300,70,1);
 Form2.Edit1.Width:=exs(245);
 CASE smosp OF
 1: s:=' 2 byte binary    ';
 2: s:=' 4 byte binary    ';
 3: s:=' ASCII free field ';
 4: s:=' X,Y,[err]        ';
 ELSE END;
 OuttoLabel(Form2.Label5,75,327,clGreen,clWhite,s);
 IF((isp<>0)AND(spec[isp].tofang=0))THEN
  BEGIN s:=' normalized for eff.spectrum ';
  IF(NOT effn)THEN s:=' not '+s;
  OuttoLabel(Form2.Label6,15,342,clGreen,clWhite,s);
  s:=' corrected for absorption    '; IF(NOT absn)THEN s:=' not '+s;
  OuttoLabel(Form2.Label7,15,357,clGreen,clWhite,s);
  END;
 strgrW[0]:=180; strgrW[1]:=100; PuttoTable(20,0,14,14,1,8);
 Form2.ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO 14 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 IF(NOT infun(Round(har[5]),-1,7))THEN har[5]:=1;
 IF(NOT rinfun(har[3],har[1],har[2]))THEN har[3]:=har[1];
 IF(NOT rinfun(har[4],har[1],har[2]))THEN har[4]:=har[2];
 CheckSpecIntBounds(Round(har[1]),Round(har[2]),ok);
 IF(NOT ok)THEN Exit;
 a1:=Round(har[1]); a2:=Round(har[2]); Irrange2(a1,a2);
 a11:=Round(har[3]); a22:=Round(har[4]); Irrange2(a11,a22);
 dback:=Round(har[5]);
 chw:=har[6]; delay:=har[7]; theta:=har[8]; FPath:=har[9];
 w0:=har[10]; dw0:=har[11]; w1:=har[12]; dw1:=har[13];
 tofang:=Round(har[14]);
 IF(tofang=1)THEN lambda:=har[9];
 ss:=Form2.Edit1.Text; Compress(ss); sfn:=ss; CheckToFAInfo(isp,ok);
 IF(NOT ok)THEN Exit;
 END
END;
PROCEDURE CheckToFAInfo(i:INTEGER; VAR ok:BOOLEAN);
BEGIN ok:=true; s:=' for spectrum '+IntToStr(i); WITH spec[i] DO
 BEGIN IF((tofang=0)AND(FPath<=0))THEN
  BEGIN ShowMess('Wrong Flight path'+s); ok:=false;
  END;
 IF((tofang=1)AND(lambda<=0))THEN
  BEGIN ShowMess('Wrong Lambda'+s); ok:=false;
  END;
 IF((tofang=0)AND(chw<=0))THEN
  BEGIN ShowMess('Wrong channel width'+s); ok:=false;
  END;
 IF((tofang=0)AND(theta<=0))THEN
  BEGIN ShowMess('Wrong Bragg angle'+s); ok:=false;
  END;
 IF((w0<=0)AND(i<>0))THEN
  BEGIN ShowMess('Wrong width0'+s); ok:=false;
  END;
 END;
END;
PROCEDURE InfoaboutSpectrum;
VAR isp:INTEGER; s:STRING; ok:BOOLEAN;
BEGIN SaveHelp(InfoSpec_n,InfoSpec);
FOR isp:=1 TO 4 DO
 BEGIN s:='Spectrum '+IntToStr(isp)+' = '+spec[isp].sfn;
 CheckSpectrumInfo(s,isp,ok);
 IF((ModalRes=0)OR(NOT ok))THEN Exit;
 END;
s:='Effective Spectrum = '+spec[0].sfn; CheckSpectrumInfo(s,0,ok);
END;
PROCEDURE InfoaboutVariance;
VAR i,isp:INTEGER; s:STRING; u,r:REAL;
BEGIN SaveHelp(1,bblank); FOR isp:=1 TO 4 DO WITH spec[isp] DO
 BEGIN L0rec:='Spectrum '+IntToStr(isp)+' = '+sfn;
 MakeFormV(10,20,520,430,1);
 r:=0; FOR i:=a11 TO a22 DO r:=r+e[i]; r:=r/(ABS(a22-a11)+1);
 u:=0; FOR i:=a11 TO a22 DO u:=u+y[i]; u:=u/(ABS(a22-a11)+1);
 s:=' Variance '+IntToStr(isp)+' = '+efn;
 OuttoLabel(Form2.Label5,5,20,clMaroon,clWhite,s);
 {s:=ExtractFileName(s);
 IF(NOT FileExists(s))THEN
  OuttoLabel(Form2.Label7,50,40,clBlack,clRed,' No file name ! ')
                      ELSE
  BEGIN} ConvertStr(r,15,1); Compress(sedz);
  s:=' Interval average error/counts = '+sedz;
  ConvertStr(u,15,1); Compress(sedz); s:=s+' / '+sedz;
  OuttoLabel(Form2.Label6,5,80,clMaroon,clWhite,s);
  {END;}
 Form2.ShowModal; IF(ModalRes=0)THEN Exit;
 END;
END;
PROCEDURE InfoaboutPhases;
VAR i,j,iph:INTEGER; s:STRING;
BEGIN IF(nophasi)THEN
 BEGIN ShowMess('No phase information'); Exit;
 END;
FOR iph:=1 TO nph DO WITH lat[iph] DO WITH LB1rec DO
 BEGIN L0rec:='Phase '+IntToStr(iph)+' information';
 MakeFormV(170,20,430,430,1);
 ConvertStr(lpd.a,9,5); ar[1]:='Direct lattice  = '+sedz+' ';
 ConvertStr(lpd.b,9,5); ar[1]:=ar[1]+sedz+' ';
 ConvertStr(lpd.c,9,5); ar[1]:=ar[1]+sedz;
 ConvertStr(lpd.alpha,9,2); ar[2]:='                 '+sedz+' ';
 ConvertStr(lpd.beta,9,2); ar[2]:=ar[2]+sedz+' ';
 ConvertStr(lpd.gamma,9,2); ar[2]:=ar[2]+sedz;
 ConvertStr(lpi.a,7,4); ar[3]:='Inverse lattice =  '+sedz+'   ';
 ConvertStr(lpi.b,7,4); ar[3]:=ar[3]+sedz+'   ';
 ConvertStr(lpi.c,7,4); ar[3]:=ar[3]+sedz;
 r:=radian; ConvertStr(COS(lpi.alpha/r),7,4);
 ar[4]:='                   '+sedz+'   ';
 ConvertStr(COS(lpi.beta/r),7,4); ar[4]:=ar[4]+sedz+'   ';
 ConvertStr(COS(lpi.gamma/r),7,4); ar[4]:=ar[4]+sedz;
 ConvertStr(lpi.alpha,7,2); ar[5]:='                  ('+sedz+'   ';
 ConvertStr(lpi.beta,7,2); ar[5]:=ar[5]+sedz+'   ';
 ConvertStr(lpi.gamma,7,2); ar[5]:=ar[5]+sedz+')';
 ConvertStr(vol,8,2); s:='Volume = '+sedz;
 ConvertStr(voli,8,5); ar[6]:=s+'    Volume inverse = '+sedz;
 ar[7]:='Number of atoms = '+IntToStr(nat);
 ar[8]:='Number of hkls = '+IntToStr(nhkl);
 nitems:=9;
 IF(lat[iph].nsg=0)THEN ar[9]:='Warning, no space group'
                   ELSE
  BEGIN ar[9]:='Space group = '+IntToStr(nsg)+'  Setting = '+
   IntToStr(sett);
  s:='C-symmetric'; IF(csym=0)THEN s:='non '+s;
  ar[10]:=syngar[syng,0]+',  '+nlatar[nlatt+1]+'-lattice,  '+s;
  ar[11]:='          '+schoe+'  '+stand;
  IF(keyma[iph]=1)THEN ar[11]:=ar[11]+'   Magnetic';
  ar[12]:=' ';
  ar[13]:='   Translations,  '+IntToStr(ntlv)+' item[s]';
  s:=''; FOR i:=1 TO ntlv DO
   BEGIN FOR j:=1 TO 3 DO
    BEGIN ConvertStr(tlv[j,i],5,2); s:=s+sedz;
    END;
   s:=s+'  ';
   END;
  ar[14]:=s; ar[15]:='   Symmetries ('+IntToStr(nut)+' item[s])';
  FOR i:=1 TO nut DO
   BEGIN ftrstr(i,iph,s); ar[i+15]:=s;
   END;
  nitems:=15+nut;
  IF(keyma[iph]=1)THEN
   BEGIN ar[nitems+1]:='   Magnetic symmetry set';
   FOR i:=1 TO nut DO
    BEGIN ftrstr(i,iph,s); ar[nitems+1+i]:=s;
    END;
   nitems:=15+2*nut+1;
   s:='   h0   k0   l0   for mag. moment plane';
   ar[nitems+1]:=s; Inc(nitems);
   ConvertStr(h0,8,2); s:=sedz; ConvertStr(k0,8,2); s:=s+sedz;
   ConvertStr(l0,8,2); s:=s+sedz;
   ar[nitems+1]:=s; Inc(nitems);
   END;
  IF(anisma[iph])THEN
   BEGIN ar[nitems+1]:='   Anisotropic, aXYZ, aHKL, aGaBeAl'; s:='';
   FOR i:=1 TO 3 DO
    BEGIN ConvertStr(anisa[i],9,3); s:=s+sedz;
    END;
   ar[nitems+2]:=s; s:=''; FOR i:=4 TO 6 DO
    BEGIN ConvertStr(anisa[i],9,3); s:=s+sedz;
    END;
   ar[nitems+3]:=s; s:=''; FOR i:=7 TO 9 DO
    BEGIN ConvertStr(anisa[i],9,3); s:=s+sedz;
    END;
   ar[nitems+4]:=s; nitems:=nitems+4;
   END;
  END;
 MakeListBox(5,0,411,370); Form2.ShowModal; IF(ModalRes=0)THEN Exit;
 END;
END;
PROCEDURE InfoaboutAtoms;
VAR iph,i,j:INTEGER; r:REAL;
BEGIN L0rec:='Atomic information.'; MakeFormV(20,20,600,430,1);
SaveHelp(BlankH_n,BlankH); WITH LB1rec DO
 BEGIN j:=0; FOR iph:=1 TO nph DO IF(lat[iph].nat=0) THEN
 ShowMess('No atoms for phase '+IntToStr(iph))    ELSE
 FOR i:=1 TO lat[iph].nat DO WITH atoms[i,iph] DO
  BEGIN IF(i=1)THEN
   BEGIN Inc(j); ar[j]:=tblank+'PHASE '+IntToStr(iph);
   END;
  s:=name; IF(keyma[iph]=1)THEN s:=s+' magnetic';
  ar[j+1]:=s+'  (occupation, X, Y, Z, Tij) =';
  s:=''; ConvertStr(occ,7,2); s:=s+sedz; ConvertStr(x,7,4); s:=s+sedz;
  ConvertStr(y,7,4); s:=s+sedz; ConvertStr(z,7,4); s:=s+sedz;
  ConvertStr(t11,7,2); s:=s+sedz; ConvertStr(t12,7,2); s:=s+sedz;
  ConvertStr(t13,7,2); s:=s+sedz; ConvertStr(t22,7,2); s:=s+sedz;
  ConvertStr(t23,7,2); s:=s+sedz; ConvertStr(t33,7,2); s:=s+sedz;
  ar[j+2]:=s;
  {s:=''; ConvertStr(eoc,7,2); s:=s+sedz; ConvertStr(ex,7,4); s:=s+sedz;
  ConvertStr(ey,7,4); s:=s+sedz; ConvertStr(ez,7,4); s:=s+sedz;
  ConvertStr(e11,7,2); s:=s+sedz; ConvertStr(e12,7,2); s:=s+sedz;
  ConvertStr(e13,7,2); s:=s+sedz; ConvertStr(e22,7,2); s:=s+sedz;
  ConvertStr(e23,7,2); s:=s+sedz; ConvertStr(e33,7,2); s:=s+sedz;
  ar[j+4]:=s;}
  ConvertStr(aw,9,1);  s:='Weight = '+sedz;
  ConvertStr(rad,9,2); s:=s+'  Radius = '+sedz;
  r:=scat; IF(keyma[iph]=1)THEN r:=0;
  ConvertStr(r,9,3);s:=s+'  Scatt. = '+sedz; ar[j+3]:=s;
  ConvertStr(sigs,9,2);s:='Absor1 = '+sedz;
  ConvertStr(siga,9,2);s:=s+'  Absor2 = '+sedz; ar[j+4]:=s;
  IF(keyma[iph]=1)THEN
   BEGIN ConvertStr(mgmom,8,3); s:='Mag.moment= '+sedz;
   ar[j+5]:=s+'  Ionname= '+ionname; j:=j+1;
   END;
  ar[j+5]:=' '; j:=j+5; nitems:=j;
  END;
 END;
IF(j=0)THEN Exit; MakeListBox(5,10,580,350); Form2.ShowModal;
END;
PROCEDURE InfoaboutHKLs;
VAR i,iph:INTEGER; s:STRING[71]; F,ch,Fmax,Fmx:REAL;
BEGIN IF(NOT spec[numsp].spin)THEN
 ShowMess('No spectral info for channel calculation');
SaveHelp(infohkls_n,infohkls); FOR iph:=1 TO nph DO WITH lat[iph] DO
 BEGIN L0rec:='Phase '+IntToStr(iph)+' HKLs';
 MakeFormV(0,20,600,430,1);
 IF(nhkl=0)THEN ShowMess(cnohkl+IntToStr(iph))
           ELSE WITH LB1rec DO
  BEGIN FindMaxSF(Fmax,Fmx,iph); ConvertStr(Fmax,10,5);
  ar[1]:='Max Structure Factor = '+sedz;
  IF(Fmax=0)THEN
   BEGIN ar[1]:='Warning! '+ar[1]; Fmax:=1;
   END;
  ar[2]:=' '; IF(keyma[iph]=1)THEN
   BEGIN ConvertStr(Fmx,10,5); ar[2]:='Max Magnetic Factor = '+sedz;
   IF(Fmx=0)THEN
    BEGIN ar[2]:='Warning! '+ar[2]; Fmx:=1;
    END;
   END;
  ar[3]:=
'   N   h   k   l  mult.   dk     chan.   Abs(F)   Fcos    Fsin     Fm';
  FOR i:=1 TO nhkl DO WITH hkla[i,iph] DO
   BEGIN sedz:=IntToStr(i); AdjustSt(sedz,4); s:=sedz;
   r:=h; ConvertStr(r,4,0); s:=s+sedz;
   r:=k; ConvertStr(r,4,0); s:=s+sedz;
   r:=l; ConvertStr(r,4,0); s:=s+sedz;
   r:=mul; ConvertStr(r,4,0); s:=s+sedz; ConvertStr(dk,10,4); s:=s+sedz;
   ch:=0; WITH spec[numsp] DO ch:=dtoch(dk);
   ConvertStr(ch,10,1); s:=s+sedz;
   F:=SQRT(SQR(Fkc)+SQR(Fks)); ConvertStr(F,9,3); s:=s+sedz;
   F:=Fkc/Fmax; ConvertStr(F,8,3); s:=s+sedz;
   F:=Fks/Fmax; ConvertStr(F,8,3); s:=s+sedz;
   ConvertStr(Fkm,8,3); s:=s+sedz;
   ar[i+3]:=s;
   END;
  nitems:=nhkl+3; MakeListBox(1,0,590,370);
  Form2.ShowModal; IF(ModalRes=0)THEN Exit;
  END;
 END;
END;
PROCEDURE ShowParameterArray;
VAR   np:INTEGER; wr:BOOLEAN;
LABEL Lbeg;
BEGIN L0rec:='Parameter array. Mode= '+modestr[mriamode];
Lbeg:MakeFormV(10,20,610,430,0); wr:=false;
CASE mriamode OF
0,2,3: IF(gfit.npar=0)THEN wr:=true;
1:     IF(NOT auclass)THEN wr:=true ELSE IF(aufit.npar=0)THEN wr:=true;
ELSE END;
IF(wr)THEN
 BEGIN msinf:='No parameters'; Exit;
 END;
MaketheButton(Form2.Button4,420,375,145,20,'Show direct lattice');
WITH Form2.Button4 DO
 IF(mriamode=3)THEN Enabled:=false ELSE Enabled:=true;
IF(mriamode<>pararmod)THEN
 ShowMess('Warning, old par.array was formed for other mode');
GetNumofPar(np,mriamode); MakeParStrGr(Form2.StringGrid1,np);
OuttoLabel(Form2.Label5,150,357,clMaroon,clWhite,ipnchcc);
CASE mriamode OF
0: BEGIN Savehelp(PrepRiet_n,PrepRiet); FormRAParTable;
   END;
1: BEGIN Savehelp(AIParA_n,AIParA); FormAIParTable;
   END;
2: BEGIN Savehelp(FSFparam_n,FSFparam); FormPMParTable;
   END;
3: BEGIN Savehelp(UParA_n,UParA); FormUParTable;
   END;
ELSE END;
Form2.ShowModal;
IF(ModalRes=0)THEN
 BEGIN ModalRes:=1; Exit;
 END;
ReadParameters(wr); IF(wr)THEN GOTO Lbeg;
END;
PROCEDURE ShowAnisoPars;
VAR i,j,iph:INTEGER;
BEGIN WITH Form2.StringGrid1 DO
 BEGIN IF(anis_mod)THEN FOR iph:=1 TO nph DO
  BEGIN j:=GetNAddiPar(1)+(iph-1)*npani; Cells[0,j+1]:=parar[j+1].com;
  IF(NOT anisma[iph])THEN Cells[0,j+1]:='';
  FOR i:=2 TO npani DO Cells[0,j+i]:=parar[j+i].com;
  FOR i:=1 TO npani DO PutParameters(j+i,4);
  END;
 IF(use_m2)THEN
  BEGIN j:=GetNAddiPar(2); FOR i:=1 TO 2 DO PutParameters(j+i,6);
  FOR i:=1 TO 2 DO Cells[0,j+i]:=parar[j+i].com;
  END;
 END;
END;
PROCEDURE FormRAParTable;    {Rietveld}
VAR i,j,k,iph,isp,np,i0:INTEGER; s:STRING;
BEGIN WITH Form2.StringGrid1 DO
 BEGIN FOR i:=1 TO 10 DO Cells[0,i]:=parar[i].com;
 FOR iph:=1 TO nph DO
  BEGIN i0:=Geti0(iph); Cells[0,i0+1]:=parar[i0+1].com+IntToStr(iph);
  FOR i:=i0+2 TO i0+10 DO Cells[0,i]:=parar[i].com;
  FOR i:=1 TO lat[iph].nat DO
   FOR j:=i*10+i0+1 TO i*10+i0+10 DO Cells[0,j]:=parar[j].com;
  END;
 PutParameters(1,5); PutParameters(2,2); PutParameters(3,2);
 FOR i:=4 TO 9 DO PutParameters(i,1); PutParameters(10,3);
 FOR iph:=1 TO nph DO
  BEGIN i0:=Geti0(iph); PutParameters(i0+1,5);
  FOR i:=i0+2 TO i0+7 DO PutParameters(i,6);
  FOR i:=i0+8 TO i0+10 DO PutParameters(i,2);
  FOR j:=1 TO lat[iph].nat DO
   BEGIN i:=i0+10+(j-1)*10;
   s:='+'; IF(atoms[j,iph].mgmom<0)THEN s:='-';
   IF(keyma[iph]=0)THEN s:='';
   Cells[0,i+1]:=s+parar[i+1].com+IntToStr(j);
   PutParameters(i+1,5); FOR k:=1 TO 3 DO
    BEGIN PutParameters(i+k+1,5);
    Cells[0,i+k+1]:=parar[i+k+1].com+' of '+atoms[j,iph].name;
    END;
   FOR k:=1 TO 6 DO PutParameters(i+k+4,4);
   END;
  END;
 GetNumofPar(np,0);
 IF(magfl)THEN FOR iph:=1 TO nph DO {IF(keyma[iph]=1)THEN}
  BEGIN j:=GetNAddiPar(0)+(iph-1)*3+1;
  Cells[0,j]:=parar[j].com+IntToStr(iph);
  IF(keyma[iph]=0)THEN Cells[0,j]:='';
  FOR i:=j+1 TO j+2 DO Cells[0,i]:=parar[i].com;
  FOR i:=j TO j+2 DO PutParameters(i,4);
  END;
 END;
ShowAnisoPars;
END;
PROCEDURE FormAIParTable;
VAR i,j,iph:INTEGER;
BEGIN WITH Form2.StringGrid1 DO FOR iph:=1 TO nph DO
 BEGIN j:=(iph-1)*6; FOR i:=j+1 TO j+6 DO Cells[0,i]:=parar[i].com;
 FOR i:=1 TO 3 DO
  BEGIN PutParameters(j+i,5); PutParameters(j+i+3,6);
  END;
 END;
IF(keylatt=1)THEN WITH Form2.StringGrid1 DO
 BEGIN j:=nph*6; FOR i:=1 TO 3 DO
  BEGIN Cells[0,j+i{-1}]:=parar[j+i].com; PutParameters(j+i,5);
  END;
 END;
END;
PROCEDURE FormPMParTable;
VAR i,j,iph,i0:INTEGER;
BEGIN WITH Form2.StringGrid1 DO
 BEGIN FOR i:=1 TO 10 DO Cells[0,i]:=parar[i].com;
 FOR iph:=1 TO nph DO
  BEGIN i0:=Geti0(iph);  Cells[0,i0+1]:=parar[i0+1].com+IntToStr(iph);
  FOR i:=i0+2 TO i0+10 DO Cells[0,i]:=parar[i].com;
  FOR i:=1 TO lat[iph].nhkl DO
   Cells[0,i0+10+i]:=parar[i0+10+i].com;
  END;
 PutParameters(1,6); PutParameters(2,0); PutParameters(3,2);
 FOR i:=4 TO 9 DO PutParameters(i,1); PutParameters(10,3);
 FOR iph:=1 TO nph DO
  BEGIN i0:=Geti0(iph); PutParameters(i0+1,5);
  FOR i:=i0+2 TO i0+7 DO PutParameters(i,6);
  FOR i:=i0+8 TO i0+10 DO PutParameters(i,2);
  FOR j:=1 TO lat[iph].nhkl DO PutParameters(i0+10+j,4);
  END;
 END;
ShowAnisoPars;
END;
PROCEDURE FormUParTable;
VAR i,np:INTEGER;
BEGIN GetNumofPar(np,mriamode); WITH Form2.StringGrid1 DO
 BEGIN FOR i:=1 TO np DO Cells[0,i]:=parar[i].com;
 IF(positexp)THEN
  BEGIN FOR i:=1 TO 5 DO PutParameters(i,2); Exit;
  END;
 FOR i:=1 TO 6 DO PutParameters(i,2);
 FOR i:=7 TO 6+npeak DO PutParameters(i,2);
 FOR i:=7+npeak TO 6+npeak*2 DO PutParameters(i,3);
 FOR i:=7+npeak*2 TO 7+npeak*2+3 DO PutParameters(i,3);
 FOR i:=7+npeak*2+3 TO 7+npeak*2+7 DO PutParameters(i,4);
 IF(use_m2)THEN FOR i:=2*npeak+15 TO 2*npeak+16 DO PutParameters(i,6);
 END;
END;
PROCEDURE ReadParameters(VAR wr:BOOLEAN);
VAR i,j,np:INTEGER;
BEGIN wr:=false; GetNumofPar(np,mriamode);
j:=0; FOR i:=1 TO np DO
 BEGIN CheckParameterArray(i); WITH psucc DO
 IF(success)THEN WITH parar[i] DO
  BEGIN n:=Round(ra[1]); pl:=ra[2]; p:=ra[3]; pu:=ra[4]; a:=ra[5];
  b:=ra[6];
  END
            ELSE WITH LB1rec DO
  BEGIN wr:=true; Inc(j); ar[j]:='Parameter '+IntToStr(i);
  IF(erb[1])THEN
   BEGIN Inc(j); ar[j]:=' Wrong n number';
   END;
  IF(erb[2])THEN
   BEGIN Inc(j); ar[j]:=' Wrong lower bound';
   END;
  IF(erb[3])THEN
   BEGIN Inc(j); ar[j]:=' Wrong parameter value';
   END;
  IF(erb[4])THEN
   BEGIN Inc(j); ar[j]:=' Wrong upper bound';
   END;
  IF(erb[5])THEN
   BEGIN Inc(j); ar[j]:=' Wrong a coefficient';
   END;
  IF(erb[6])THEN
   BEGIN Inc(j); ar[j]:=' Wrong b coefficient';
   END;
  IF(erb[7])THEN
   BEGIN Inc(j); ar[j]:=' Independent par. has a=1,b=0';
   END;
  END;
 END;
 IF(wr)THEN
 BEGIN L0rec:=''; MakeForm(1);
 s:=' +++Parameter array is wrong ';
 OuttoLabel(Form2.Label5,50,10,clMaroon,clWhite,s); LB1rec.nitems:=j;
 MakeListBox(20,40,280,320); Form2.ShowModal;
 END;
FOR i:=1 TO np DO IF(mriamode<>1)THEN gfit.par[i]:=parar[i]
                                 ELSE aufit.par[i]:=parar[i];
IF(mriamode<>1)THEN gfit.CheckLinDepend(i)
               ELSE aufit.CheckLinDepend(i);
FOR i:=1 TO np DO IF(mriamode<>1)THEN parar[i]:=gfit.par[i]
                                 ELSE parar[i]:=aufit.par[i];
IF(mriamode<>1)THEN gfit.npar:=np ELSE aufit.npar:=np;
END;
PROCEDURE CheckParameterArray(ip:INTEGER);
VAR   j,k:INTEGER;
LABEL Lend;
BEGIN FOR j:=1 TO 7 DO psucc.erb[j]:=false; success:=true;
WITH Form2.StringGrid1 DO WITH psucc DO
 BEGIN s:=Cells[1,ip];
 FOR j:=1 TO Length(s) DO IF(s[j] IN ['*','B','W'])THEN s[j]:=' ';
 Cells[1,ip]:=s; Zval(Cells[1,ip],ra[1]); k:=Round(ra[1]);
 IF((k>ip)OR(ModalRes=0))THEN erb[1]:=true;
 Zval(Cells[2,ip],ra[2]); IF(ModalRes=0)THEN erb[2]:=true;
 Zval(Cells[3,ip],ra[3]); IF(ModalRes=0)THEN erb[3]:=true;
 Zval(Cells[4,ip],ra[4]); IF(ModalRes=0)THEN erb[4]:=true;
 Zval(Cells[5,ip],ra[5]); IF(ModalRes=0)THEN erb[5]:=true;
 Zval(Cells[6,ip],ra[6]); IF(ModalRes=0)THEN erb[6]:=true;
 IF((k=ip)AND((ra[5]<>1)OR(ra[6]<>0)))THEN erb[7]:=true;
 IF(k<>ip)THEN GOTO Lend;
 IF(ra[3]<ra[2])THEN erb[3]:=true;
 IF(ra[4]<ra[3])THEN erb[4]:=true;
 Lend: FOR j:=1 TO 7 DO IF(erb[j])THEN
  BEGIN ipa:=ip; success:=false;
  END;
 END;
END;
PROCEDURE pTOsedz(p:REAL; n:INTEGER);
VAR uu,p10:REAL;
BEGIN uu:=p-Trunc(p); p10:=powerRI(10,n);
IF(p=0)THEN sedz:='0' ELSE
IF((ABS(p)>100000)OR(ABS(p)<(1/p10)))THEN ftos(p,15,6,sedz) ELSE
IF(uu=0)THEN ConvertStr(p,10,0) ELSE ftoa(p,10,n,sedz); Compress(sedz);
END;
PROCEDURE PutParameters(i,nc:INTEGER);
BEGIN WITH Form2.StringGrid1 DO WITH parar[i] DO
 BEGIN Cells[1,i]:=IntToStr(n);
 pTOsedz(pl,nc); Cells[2,i]:=sedz;
 pTOsedz(p,nc);  Cells[3,i]:=sedz;
 pTOsedz(pu,nc); Cells[4,i]:=sedz;
 pTOsedz(a,nc);  Cells[5,i]:=sedz;
 pTOsedz(b,nc);  Cells[6,i]:=sedz;
 IF(n<i)THEN Exit;
 IF((pl>p)OR(pu<p)OR(pl>pu))THEN Cells[1,i]:=Cells[1,i]+' *W' ELSE
 IF((pl<>pu)AND((pl=p)OR(pu=p)))THEN Cells[1,i]:=Cells[1,i]+' *B' ELSE ;
 END;
END;
PROCEDURE ShowParErrors;
VAR i:INTEGER;
BEGIN L0rec:='Check the Parameters and Errors';
MakeFormV(170,13,330,430,1); SaveHelp(BlankH_n,BlankH);
IF(mriamode<>1)THEN
 WITH LB1rec DO WITH gfit DO
  BEGIN nitems:=npar; FOR i:=1 TO npar DO
   BEGIN ConvertStr(FLOAT(i),5,0); ar[i]:=sedz;
   ConvertStr(par[i].p,15,4); ar[i]:=ar[i]+sedz;
   ConvertStr(par[i].e,12,4); ar[i]:=ar[i]+' +- '+sedz;
   END;
  END          ELSE
 WITH LB1rec DO WITH aufit DO
  BEGIN nitems:=npar; FOR i:=1 TO npar DO
   BEGIN ConvertStr(FLOAT(i),5,0); ar[i]:=sedz;
   ConvertStr(par[i].p,15,4); ar[i]:=ar[i]+sedz;
   ConvertStr(par[i].e,12,4); ar[i]:=ar[i]+' +- '+sedz;
   END;
  END;
MakeListBox(5,20,310,320); Form2.ShowModal;
END;
PROCEDURE ShowFitControls;
VAR i:INTEGER; ok:BOOLEAN;
BEGIN L0rec:='Check the Fit Controls'; MakeForm(1);
SaveHelp(InfoFCont_n,InfoFCont);
strgrW[0]:=120; strgrW[1]:=100;
strgrT[1]:=' GN-iter.=';
strgrT[2]:=' step   = ';
strgrT[3]:=' damp   = ';
strgrT[4]:=' Eps req.=';
strgrT[5]:=' Delta  = ';
strgrT[6]:=' Beta   = ';
strgrT[7]:=' Alpha  = ';
strgrT[8]:=' skip   = ';
WITH cw DO
 BEGIN strgrNn[1,1]:=gnit; strgrNn[2,1]:=step; strgrNn[3,1]:=damp;
 strgrNn[4,1]:=eps; strgrNn[5,1]:=delta; strgrNn[6,1]:=beta;
 strgrNn[7,1]:=alpha; strgrNn[8,1]:=skip;
 END;
PuttoTable(40,5,8,8,1,8);
s:=' Specify the modes ';
OuttoLabel(Form2.Label5,5,180,clMaroon,clWhite,s);
ok:=mriamode<>1; WITH CB1rec DO
 BEGIN nitems:=3;
 IF(ok)THEN indx:=gfit.cb.iconv+1 ELSE indx:=aufit.cb.iconv+1;
 ar[1]:=' Free convergence';
 ar[2]:=' Break if inconvergence'; ar[3]:=' Guaranteed convergence';
 END;
MakeRadioGroup(2,0,40,195,230,80);
WITH CB1rec DO
 BEGIN nitems:=2; indx:=cw.liqu;
 ar[1]:=' Modulus (robust) fitting'; ar[2]:=' Least square fitting';
 END;
MakeRadioGroup(1,0,40,280,230,50);
WITH CB1rec DO
 BEGIN nitems:=2; ar[1]:=' Use non-equidistant channels ';
 ar[2]:=' Use constant weights ';
 END;
MakeCheckListBox(40,335,230,38); WITH Form2.CheckListBox1 DO
 BEGIN Checked[0]:=neqexp; Checked[1]:=cw.cowei;
 END;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 IF(CheckListBox1.Checked[0])THEN neqexp:=true ELSE neqexp:=false;
 IF(CheckListBox1.Checked[1])THEN cw.cowei:=true ELSE cw.cowei:=false;
 cw.liqu:=RadioGroup1.ItemIndex+1; cw.iconv:=RadioGroup2.ItemIndex;
 FOR i:=1 TO 8 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 END;
WITH cw DO
 BEGIN gnit:=Round(har[1]); step:=AMIN1(1,har[2]); damp:=har[3];
 eps:=har[4]; delta:=har[5]; beta:=har[6]; alpha:=har[7];
 skip:=MAX1(1,har[8]);
 END;
END;
PROCEDURE ShowFitQuality;
VAR ra:RBREC;
BEGIN L0rec:='Check the Fit Quality'; MakeFormV(170,13,330,430,1);
SaveHelp(InfoFCont_n,InfoFCont);
IF(mriamode<>1)THEN
 BEGIN ra:=gfit.rb; WITH LB1rec DO WITH gfit DO
  BEGIN ar[2]:=compstr; ar[3]:=fixdepstr; ar[4]:=freepstr;
  ar[5]:=parnumstr;
  END;
 END           ELSE
 BEGIN ra:=aufit.rb; WITH LB1rec DO WITH aufit DO
  BEGIN ar[2]:=compstr; ar[3]:=fixdepstr; ar[4]:=freepstr;
  ar[5]:=parnumstr;
  END;
 END;
WITH LB1rec DO
 BEGIN nitems:=15; ar[1]:='';
 s:='OK'; IF(ra.pconv=0)THEN s:='NOT OK'; ar[6]:=' Convergence=    '+s;
 s:='OK'; IF(ra.pminv=0)THEN s:='NOT OK'; ar[7]:=' Mat.Inversion=  '+s;
 ar[8]:=' GN-iterations=  '+IntToStr(ra.gnit);
 ConvertStr(ra.chir,10,2); ar[9]:=' Chi_regul    =  '+sedz;
 s:='OK'; IF(ra.pobi=1)THEN s:='NOT OK'; ar[10]:=' Par on boundary= '+s;
 ConvertStr(ra.chi2,10,2); FCompress(sedz);
 ar[11]:=' Chi2/df =       '+sedz;
 ConvertStr(ra.chipl,5,2); ar[12]:=' Chi+   =        '+sedz;
 ConvertStr(ra.epsf,8,1); ar[13]:=' Eps achieved=   '+sedz;
 ConvertStr(ra.gpoin,5,2); ar[14]:=' Good par.=      '+sedz;
 ConvertStr(ra.chidev,5,2); ar[15]:=' Chi-deviation=  '+sedz;
 END;
MakeListBox(5,20,310,320); Form2.ShowModal;
END;
PROCEDURE InfoaboutAutoindexing;
VAR i,j:INTEGER;
BEGIN IF(mdsp=0)THEN
 BEGIN ShowMess('No d-spacings'); Exit;
 END;
SaveHelp(1,bblank); L0rec:='Dspacings'; MakeFormV(10,20,520,430,1);
WITH LB1rec DO
 BEGIN ar[1]:='   N   d_exp   error';
 CASE dstype OF
 0: ar[1]:=ar[1]+' d_calc ';
 1,2: ar[1]:=ar[1]+' ang_calc ';
 3: ar[1]:=ar[1]+' ch_calc ';
 ELSE END;
 ar[1]:=ar[1]+'  ang/ch      hkl    phase';
 FOR i:=1 TO mdsp DO WITH dspa[i] DO
  BEGIN s:=IntToStr(i); AdjustSt(s,4);
  r:=d; ConvertStr(r,8,4); s:=s+sedz;
  r:=e; ConvertStr(r,8,4); s:=s+sedz;
  r:=th; j:=4; IF(dstype<>0)THEN
   BEGIN r:=xc; j:=2;
   END;
  ConvertStr(r,8,j); s:=s+sedz;
  r:=x; ConvertStr(r,8,2); s:=s+sedz;
  r:=h; ConvertStr(r,4,0); s:=s+sedz;
  r:=k; ConvertStr(r,4,0); s:=s+sedz;
  r:=l; ConvertStr(r,4,0); s:=s+sedz;
  r:=ph; ConvertStr(r,4,0); IF(nph=1)THEN sedz:='    '; s:=s+sedz;
  IF(ass)THEN s:=s+'    OK'; ar[i+1]:=s;
  END;
 ConvertStr(eps_av,12,5); ar[mdsp+2]:='Average exp-error = '+sedz;
 nitems:=mdsp+2; i:=nitems;
 CASE dstype OF
 0: s:='dspacings';
 1: s:='thetas';
 2: s:='2thetas';
 3: s:='TOFchans';
 ELSE END;
 Inc(i); ar[i]:='Fitted data = '+s; WITH spec[numsp] DO
  BEGIN ConvertStr(Fpath,9,4); s:='Fpath= '+sedz; Inc(i); ar[i]:=s;
  ConvertStr(lambda,8,5); s:='Lambda= '+sedz; Inc(i); ar[i]:=s;
  ConvertStr(theta,8,2); s:='Bragg angle= '+sedz; Inc(i); ar[i]:=s;
  s:='Delay= '; IF(dstype IN [1,2])THEN s:='0-shift= ';
  ConvertStr(delay,14,4); Compress(sedz); s:=s+sedz; Inc(i); ar[i]:=s;
  ConvertStr(chw,8,4); s:='Chan.width= '+sedz; Inc(i); ar[i]:=s;
  s:='cyn.par.fitting'; IF(keylatt=0)THEN s:='No '+s; Inc(i); ar[i]:=s;
  nitems:=i; FOR j:=i-6 TO i DO ar[j]:=bblank+ar[j];
  END;
 MakeListBox(1,0,500,370); Form2.ShowModal;
 END;
END;
PROCEDURE InfoaboutINIfile;
VAR s:STRING; i:INTEGER;
BEGIN s:=inifn; i:=Pos('.',s); IF(i=0)THEN s:=s+'.ini';
L1rec:='Enter INI-file name'; GetFilename(s,0);
IF(ModalRes<>0)THEN MakeTxtFile(s); inifn:=s;
END;
PROCEDURE InfoaboutSetofPoints;
VAR i,j,k:INTEGER; s:STRING;
BEGIN L0rec:=IntToStr(npeak)+' points and model numbers';
MakeForm(1); SaveHelp(InfoSetP_n,InfoSetP);
MakeMemo(15,290); WITH Form2.Memo1 DO
 BEGIN Clear; FOR i:=1 TO npeak DO
  BEGIN s:=IntToStr(Round(marka[i]))+'   '+IntToStr(tam[i]);
  Lines.Add(s);
  END;
 END;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit; j:=0; WITH Memo1.Lines DO
  BEGIN npeak:=Count; FOR i:=1 TO npeak DO
   BEGIN s:=Strings[i-1]; fffins(k,s); Inc(j); IF(j>200)THEN
    BEGIN ShowMess('Too many points,>200'); BREAK;
    END;
   marka[j]:=Round(onl[1]); tam[j]:=Round(onl[2]);
   END;
  END;
 npeak:=j;
 END;
END;

PROCEDURE ChangeCellPars;
VAR i,j,iph,i0,ii0:INTEGER; r,a0,b0,c0:REAL;
BEGIN L0rec:=''; MakeFormV(170,20,350,430,0);
SaveHelp(chancp_n,chancpH);
s:=' Edit unit cell parameters if needed';
OuttoLabel(Form2.Label6,5,1,clMaroon,clWhite,s);
strgrW[0]:=80; strgrW[1]:=80; strgrW[2]:=80; strgrW[3]:=80;
FOR iph:=1 TO nph DO
 BEGIN s:='Phase'+IntToStr(iph)+'    Lower       Parameter       Upper';
 OuttoLabel(Form2.Label5,30,21,clMaroon,clWhite,s); GetDirCellPars(iph);
 strgrT[1]:=' A '; strgrT[2]:=' B '; strgrT[3]:=' C ';
 strgrT[4]:=' ALPHA'; strgrT[5]:=' BETA'; strgrT[6]:=' GAMMA';
 strgrNn[1,1]:=lpa[1].a; strgrNn[1,2]:=lpa[2].a; strgrNn[1,3]:=lpa[3].a;
 strgrNn[2,1]:=lpa[1].b; strgrNn[2,2]:=lpa[2].b; strgrNn[2,3]:=lpa[3].b;
 strgrNn[3,1]:=lpa[1].c; strgrNn[3,2]:=lpa[2].c; strgrNn[3,3]:=lpa[3].c;
 strgrNn[4,1]:=lpa[1].alpha; strgrNn[4,2]:=lpa[2].alpha;
 strgrNn[4,3]:=lpa[3].alpha;
 strgrNn[5,1]:=lpa[1].beta; strgrNn[5,2]:=lpa[2].beta;
 strgrNn[5,3]:=lpa[3].beta;
 strgrNn[6,1]:=lpa[1].gamma; strgrNn[6,2]:=lpa[2].gamma;
 strgrNn[6,3]:=lpa[3].gamma;
 PuttoTable(5,40,6,6,3,8);
 WITH Form2 DO
  BEGIN ShowModal;
  FOR j:=1 TO 3 DO FOR i:=1 TO 6 DO WITH Form2.StringGrid1 DO
   BEGIN Zval(Cells[j-1,i-1],har[i]); IF(ModalRes=0)THEN
    BEGIN ShowMess('Wrong number='+Cells[j-1,i-1]); Exit;
    END;
   CASE i OF
   1: lpa[j].a:=har[1];
   2: lpa[j].b:=har[2];
   3: lpa[j].c:=har[3];
   4: lpa[j].alpha:=COS(har[4]/radian);
   5: lpa[j].beta:=COS(har[5]/radian);
   6: lpa[j].gamma:=COS(har[6]/radian);
   ELSE END;
   END;
  IF((har[1]*har[2]*har[3])=0)THEN
   BEGIN ShowMess('Wrong number='+'0'); Exit;
   END;
  END;
 IF(mriamode IN [0,2])THEN
  BEGIN FOR j:=1 TO 3 DO
   BEGIN InverseLatPar(lpa[j],lp,r,1); lpa[j]:=lp;
   END;
  a0:=lpa[2].a; b0:=lpa[2].b; c0:=lpa[2].c;
  FOR j:=1 TO 3 DO WITH lpa[j] DO
   BEGIN alpha:=2*b0*c0*COS(alpha/radian);
   beta:=2*a0*c0*COS(beta/radian); gamma:=2*a0*b0*COS(gamma/radian);
   a:=SQR(a); b:=SQR(b); c:=SQR(c);
   END;
  END;
 Arrange2(lpa[1].a,lpa[3].a); Arrange2(lpa[1].b,lpa[3].b);
 Arrange2(lpa[1].c,lpa[3].c);
 Arrange2(lpa[1].alpha,lpa[3].alpha);
 Arrange2(lpa[1].beta,lpa[3].beta);
 Arrange2(lpa[1].gamma,lpa[3].gamma);
 i0:=Geti0(iph)+1; IF(mriamode=1)THEN i0:=(iph-1)*6;
 parar[i0+1].pl:=lpa[1].a; parar[i0+1].p:=lpa[2].a;
 parar[i0+1].pu:=lpa[3].a;
 parar[i0+2].pl:=lpa[1].b; parar[i0+2].p:=lpa[2].b;
 parar[i0+2].pu:=lpa[3].b;
 parar[i0+3].pl:=lpa[1].c; parar[i0+3].p:=lpa[2].c;
 parar[i0+3].pu:=lpa[3].c;
 parar[i0+4].pl:=lpa[1].alpha; parar[i0+4].p:=lpa[2].alpha;
 parar[i0+4].pu:=lpa[3].alpha;
 parar[i0+5].pl:=lpa[1].beta; parar[i0+5].p:=lpa[2].beta;
 parar[i0+5].pu:=lpa[3].beta;
 parar[i0+6].pl:=lpa[1].gamma; parar[i0+6].p:=lpa[2].gamma;
 parar[i0+6].pu:=lpa[3].gamma;
 FOR i:=4 TO 6 DO IF(ABS(parar[i0+i].pl)<0.1E-6)THEN parar[i0+i].pl:=0;
 FOR i:=4 TO 6 DO IF(ABS(parar[i0+i].p)<0.1E-6)THEN parar[i0+i].p:=0;
 FOR i:=4 TO 6 DO IF(ABS(parar[i0+i].pu)<0.1E-6)THEN parar[i0+i].pu:=0;
 WITH parar[i0+1] DO IF(pl<>pu)THEN
  CASE lat[iph].syng OF
  4,6: parar[i0+2].n:=i0+1;
  5: BEGIN parar[i0+2].n:=i0+1; parar[i0+3].n:=i0+1;
     END;
  7: BEGIN parar[i0+2].n:=i0+1; parar[i0+3].n:=i0+1;
     parar[i0+5].n:=i0+4; parar[i0+6].n:=i0+4;
     END;
  ELSE END;
 END;
MakeFormV(170,20,350,430,0);
WITH CB1rec DO
 BEGIN nitems:=1; ar[1]:='Set links between the unit cells';
 END;
MakeCheckListBox(20,100,270,18);
Form2.CheckListBox1.Checked[0]:=false;
WITH Form2 DO
 BEGIN ShowModal;
 IF((ModalRes=0)OR(NOT CheckListBox1.Checked[0])OR(nph=1))THEN Exit;
 END;
ii0:=Geti0(1)+1; IF(mriamode=1)THEN ii0:=0; FOR iph:=2 TO nph DO
 BEGIN i0:=Geti0(iph)+1; IF(mriamode=1)THEN i0:=(iph-1)*6;
 FOR j:=1 TO 6 DO WITH parar[i0+j] DO IF(pl<>pu)THEN n:=ii0+j;
 END;
END;


END.
