UNIT vmriaini;

INTERFACE

USES Windows,  Messages, SysUtils, Classes,  Graphics, Controls, Forms,
     Dialogs,  StdCtrls, ExtCtrls, Grids,    vzlocom,  varfun,   vmria0,
     vmria2,   vmriahkl, vmriahlp, vmriatr,  vpeaksr,  vspectr,  vmria4,
     vmriasp,  vmriacry, vpmodel,  vmriafl,  vmriarit, vmriarix, vgfit,
     vmriainf, vstdcons, vmria00;

PROCEDURE InputInifile(iniq:BOOLEAN);
PROCEDURE IniSetNPhase;
PROCEDURE IniSetNSpectrum;
PROCEDURE IniSetMagnPhase;
PROCEDURE IniInfoLattice;
PROCEDURE IniInfoAtoms;
PROCEDURE IniInputSp(ta:INTEGER);
PROCEDURE IniInfoRealModel(mo:INTEGER);
PROCEDURE IniInputParameterArray(mo:INTEGER; VAR okp:BOOLEAN);
PROCEDURE IniInputVariance;
PROCEDURE IniInputEffectSp;
PROCEDURE IniInfoFitControls;
PROCEDURE IniNormCorrAbsor(mo:INTEGER);
PROCEDURE SaveInifile(mo:BOOLEAN);
PROCEDURE MakeaFrameofINIFile;
PROCEDURE OutputParameters(VAR fin:TEXTFILE; VAR Me:TMemo; mo:INTEGER);
PROCEDURE IniEnterRealModel(mo:INTEGER);
PROCEDURE IniSetDeterMode;
PROCEDURE IniSetHKLBounds;
PROCEDURE IniSetVolumes;
PROCEDURE IniSetVolumeMin;
PROCEDURE PutParameterI(i:INTEGER);
PROCEDURE IniFitS;

VAR   recog:BOOLEAN;

IMPLEMENTATION
PROCEDURE OutputParameters(VAR fin:TEXTFILE; VAR Me:TMemo; mo:INTEGER);
{To update the parameter file for VMRIA,  Version: 12 Apr 1990,
 Dec 14 2001}
VAR   stl,st,stu,sta,stb:STRING; s:STRING;
      i,iph,i0,j0,k,k1,iat{,isp,i1,i2}:INTEGER;
 PROCEDURE Out;
 BEGIN IF(mo=0)THEN Writeln(fin,s) ELSE Me.Lines.Add(s);
 END;
 PROCEDURE ParOut(pp:PARREC);
 { To print a line, Version: February 10 1994, Nov 3 2003}
 BEGIN WITH pp DO
  BEGIN ftos(pl,13,5,stl); ftos(p,13,5,st); ftos(pu,13,5,stu);
  ConvertStr(a,7,3); sta:=sedz; ConvertStr(b,7,3); stb:=sedz;
  IConvertStr(n,3); s:=sedz+stl+st+stu+sta+stb+' '+com;
  IF(mo=0)THEN Writeln(fin,s) ELSE Me.Lines.Add(s);
  END;
 END;
LABEL L1;
{***}
BEGIN IF(mriamode=2)THEN Exit;
CASE mriamode OF
0: s:='*   Rietveld analysis parameters';
1: s:='*   Powder indexing parameters';
3: s:='*   Peak(Exp) analysis parameters';
ELSE END;
Out;
s:='* Npar     BoundL     Parameter       BoundU    ai    bi'; Out;
IF(mriamode=1)THEN WITH aufit DO
 BEGIN FOR i:=1 TO npar DO ParOut(par[i]); Exit;
 END;
IF(mriamode=3)THEN WITH gfit DO
 BEGIN FOR i:=1 TO npar DO ParOut(par[i]); Exit;
 END;
FOR i:=1 TO 10 DO ParOut(gfit.par[i]);
{Rietveld} {loop with respect to phases}
FOR iph:=1 TO nph DO
 BEGIN s:='*                PHASE No '+IntToStr(iph); Out;
 i0:=Geti0(iph)+1; ParOut(gfit.par[i0]);
 FOR i:=i0+1 TO i0+9 DO ParOut(gfit.par[i]);
 {loop with respect to atoms;}
 j0:=i0+10; FOR iat:=1 TO lat[iph].nat DO
  BEGIN s:='*         Atom No '+IntToStr(iat)+'   '+atoms[iat,iph].name;
  Out; k:=(iat-1)*10+j0; k1:=k+9; FOR i:=k TO k1 DO ParOut(gfit.par[i]);
  END;
 END;
{loop with respect to additional spectra}
{FOR isp:=2 TO nsp DO
 BEGIN s:='*                   Spectrum No'+IntToStr(isp); Out;
 i0:=Getj0(isp); i1:=i0+1; i2:=i0+10;
 FOR i:=i1 TO i2 DO ParOut(gfit.par[i]);
 i0:=i0+10; FOR i:=1 TO nph DO
  BEGIN s:='*              PHASE No'+IntToStr(i); Out; i1:=i0+(i-1)*3+1;
  ParOut(gfit.par[i1]); ParOut(gfit.par[i1+1]); ParOut(gfit.par[i1+2]);
  END;
 END;}
{constWL, magnetic and texture}
IF(magfl)THEN
 BEGIN s:='*        Magnetic par-s'; Out;
 FOR iph:=1 TO nph DO FOR i:=1 TO 3 DO
  BEGIN k:=GetNAddiPar(0)+(iph-1)*3+i; ParOut(gfit.par[k]);
  END;
 END;
IF(anis_mod)THEN
 BEGIN s:='*        Aniso-parameters'; Out;
 FOR iph:=1 TO nph DO
  BEGIN j:=GetNAddiPar(1)+(iph-1)*npani;
  FOR i:=1 TO npani DO ParOut(gfit.par[j+i]);
  END;
 END;
IF(use_m2)THEN
 BEGIN s:='*        M2 Mode parameters'; Out;
 j:=GetNAddiPar(2); FOR i:=1 TO 2 DO ParOut(gfit.par[j+i]);
 END;
END;
PROCEDURE PutParameterI(i:INTEGER);
 BEGIN WITH parar[i] DO
  BEGIN n:=Round(onl[1]); pl:=onl[2]; p:=onl[3]; pu:=onl[4]; a:=onl[5];
  b:=onl[6];
  END;
 END;
PROCEDURE IniInputParameterArray(mo:INTEGER; VAR okp:BOOLEAN);
 PROCEDURE MakeCos;
 VAR i,j:INTEGER;
 BEGIN FOR j:=1 TO nph DO FOR i:=4 TO 6 DO WITH parar[(j-1)*6+i] DO
  BEGIN IF(ABS(pl)>1)THEN pl:=COS(pl/radian);
  IF(ABS(pu)>1)THEN pu:=COS(pu/radian);
  IF(ABS(p)>1)THEN p:=COS(p/radian); Arrange2(pl,pu);
  END;
 END;
{-------}
VAR   i,j,i0,np,iph:INTEGER; ft:TEXTFILE; wp:BOOLEAN;
LABEL La1;
BEGIN GetNumofPar(np,mriamode); i:=0; sedz:=inifn; okp:=true;
IF(mriamode=1)THEN
 BEGIN np:=6*nph+3*keylatt; IF(NOT auclass)THEN
  BEGIN aufit:=TAulsm.Create(24,24,mdsp); auclass:=true;
  WITH aufit DO
   BEGIN mpoint:=mdsp; FormCB; cb.eps:=0.1; cb.step:=0.99;
   cb.damp:=0.01; npar:=24; FormParameters; npar:=0; cw:=cb; {cb}
   END;
  END;
 END;
IF(mo=0)THEN {from a separate file}
 BEGIN EnterStr(fin); Compress(sedz);
 IF((NOT FileExists(sedz))OR(sedz=''))THEN
  BEGIN ShowMess('No parameter file '+sedz); ModalRes:=0; okp:=false;
  Exit;
  END;
 parfn:=sedz; AssignFile(ft,sedz); {$I-} Reset(ft); {$I+}; i:=0;
 ok:=false; WHILE(NOT EoF(ft))DO
  BEGIN EnterStr(fin); fffins(j,sedz);
  IF((i=0)AND(onl[1]<>1))THEN wp:=true; Inc(i); PutParameterI(i);
  END;
 IF(i<>np)THEN wp:=true; CloseFile(ft);
 END    ELSE {from ini-file} WHILE(NOT EoF(fin))DO
  BEGIN EnterStr(fin); fffins(j,sedz);
  IF((i=0)AND(onl[1]<>1))THEN wp:=true; Inc(i); PutParameterI(i);
  IF(i=np)THEN BREAK;
  END;
IF(i<>np)THEN wp:=true; IF(wp)THEN ShowMess('Parameter array is wrong');
MakeParComments;
IF(mriamode=1)THEN                    {AU}
 BEGIN MakeCos; aufit.npar:=np; aui:=false; GOTO La1;
 END;
gfit.npar:=np; IF(mriamode=3)THEN     {UPEAK}
 BEGIN IF(nexp<>0)THEN
  BEGIN j:=6+2*nexp; FOR i:=1 TO nexp DO WITH parar[j+i] DO
   BEGIN dpos[i]:=Round(p); dwi0[i]:=Round(ABS(pu-pl)*0.5);
   END;
  END;
 IF(nexp=0)THEN
  BEGIN j:=6+2*npeak;
  FOR i:=1 TO npeak DO marka[i]:=parar[6+npeak+i].p;
  FOR i:=1 TO 4 DO WITH parar[j+i] DO dwi0[i]:=ABS(pu-pl)*0.5;
  FOR i:=1 TO 4 DO WITH parar[j+i+4] DO dwi1[i]:=ABS(pu-pl)*0.5;
  END;
 GOTO La1;
 END;
IF(mriamode=0)THEN
 BEGIN ok:=false; FOR iph:=1 TO nph DO       {Riet or PM}
  BEGIN i0:=Geti0(iph); FOR i:=2 TO 7 DO WITH parar[i0+i] DO
   IF((ABS(pl)>1)OR(ABS(p)>1)OR(ABS(pu)>1))THEN ok:=true;
  FOR i:=2 TO 4 DO WITH parar[i0+i] DO
   IF((ABS(pl)=0)OR(ABS(p)=0)OR(ABS(pu)=0))THEN ok:=true;
  END;
 IF(ok)THEN ChangeCellPars;
 END;
La1: FOR i:=1 TO np DO
 IF(mriamode=1)THEN aufit.par[i]:=parar[i]
               ELSE gfit.par[i]:=parar[i];
IF(wp)THEN SetIniPar(mriamode,0) ELSE SetIniPar(mriamode,1); npold:=np;
noprep[mriamode+1]:=false; recog:=true; IF(mo=0)THEN CloseFile(ft);
END;
PROCEDURE SaveInifile(mo:BOOLEAN);
{mo=true, in any file; false=in vmria.ini}
VAR   i,isp,iph:INTEGER;  ok:BOOLEAN; ss,s:STRING;
LABEL Lpa,Lpb;
 PROCEDURE ParsOut(ok:BOOLEAN);
 BEGIN IF(ok)THEN
  BEGIN Writeln(fin,'.......Info about the Parameters');
  OutputParameters(fin,Form2.Memo1,0);
  END                       ELSE
  BEGIN ShowMess('No preparing yet performed'+crc+
   'INI-file without parameters created');
  END;
 END;
BEGIN L0rec:='Saving ini-file'; SaveHelp(SavIni_n,SavIni);
L1rec:='Enter the name for ini-file'; isp:=numsp;
IF(mo)THEN
 BEGIN
 Form2.SaveDialog1.Filter:='Files(.ini)|*.ini|All|*.*';
 SaveFileDial(Form2.SaveDialog1,inifn,ok); s:=inifn;
 IF((ModalRes=0)OR(NOT ok))THEN Exit;
 END  ELSE s:='vmria.ini';
ss:=ExtractFileExt(s); UpCaseStr(ss);
IF(ss<>'.INI')THEN
 BEGIN i:=MessageDlg('Extention not .ini;  Replace?',
  MtWarning,[mbYes,mbNo],0);
 IF(i=mrYes)THEN s:=s+'.ini'; inifn:=s;
 END;
WITH Form2 DO
 BEGIN AssignFile(fin,s); Rewrite(fin);
 Writeln(fin,'.......Set the Mode');
 Writeln(fin,'* 0=Rietveld  1=Powder index. 2=PowderMatch  3=Upeak');
 Writeln(fin,mriamode:3);
 IF(mriamode IN [0,2])THEN
  BEGIN {Writeln(fin,'.......Set Number of Spectra');
  Writeln(fin,nsp);}
  Writeln(fin,'.......Set Number of Phases');
  Writeln(fin,nph);
  END;
 IF((nexp=0)AND(mriamode=3))THEN
  BEGIN Writeln(fin,'.......Set Number of Peaks for Upeak');
  Writeln(fin,npeak);
  END;
 IF((nexp<>0)AND(mriamode=3))THEN
  BEGIN Writeln(fin,'.......Set Number of Exponentials for Upeak');
  Writeln(fin,nexp);
  END;
 {*}
 IF(mriamode=1)THEN                                {AUTOX}
  BEGIN Writeln(fin,'.......Enter D-Spacings');
  Writeln(fin,dstype:10,
   ' * data_type: 0-ds  1-theta  2-2theta  3-TOFchans');
  WITH spec[numsp] DO
   BEGIN Writeln(fin,Fpath:10:5,' * Fpath');
   Writeln(fin,lambda:10:5,' * lambda');
   Writeln(fin,theta:10:3,' * theta (Bragg angle)');
   Writeln(fin,delay:10:4,' * 0-shift (delay)');
   Writeln(fin,chw:10:4,' * channel width');
   END;
  Writeln(fin,keylatt:10,' * if 1 = fit cynematic parameters; 0 = no');
  Writeln(fin,'*  d      err    ang/chan');
  FOR i:=1 TO mdsp DO WITH dspa[i] DO Writeln(fin,d:9:4,e:9:4,x:9:4);
  Writeln(fin,'/');
  Writeln(fin,'.......Set Number of Phases');
  Writeln(fin,nph:3);
  Writeln(fin,'.......Set the Symmetries for AutoIndexing');
  Writeln(fin,
   '* 1=tricl 2=monocl 3=orthorh 4=tetra 5=cubic 6=hexa 7=rhombohed');
  FOR i:=1 TO nph DO Writeln(fin,lat[i].syng:3);
  Writeln(fin,'.......Set the Volumes');
  Writeln(fin,'* for all the phases');
  FOR i:=1 TO nph DO Writeln(fin,vmax[i]:10:1);
  Writeln(fin,'.......Set the Volume Minimizers');
  Writeln(fin,'* multiples providing for "most rectangular" unit cell');
  FOR i:=1 TO nph DO Writeln(fin,vmin[i]:15:7);
  Writeln(fin,'.......Set the HKL Bounds');
  Writeln(fin,'* hmax  hmin kmax  kmin  lmax   (lmin=0)');
  FOR i:=1 TO nph DO
   Writeln(fin,hmax[i]:4,hmin[i]:4,kmax[i]:4,kmin[i]:4,lmax[i]:4);
  IF(aufit.ntrnd<>0)THEN
   BEGIN Writeln(fin,'.......Set Deterministic Mode');
   Writeln(fin,'* N of steps in each bin');
   Writeln(fin,'* for the phase 1 also number of tries in each bin');
   FOR iph:=1 TO nph DO
    BEGIN FOR i:=1 TO 6 DO Write(fin,dstepnst[iph,i]:4);
    IF(iph=1)THEN Write(fin,aufit.ntrnd:5); Writeln(fin);
    END;
   END;
  ParsOut(aufit.npar<>0); GOTO Lpa;
  END;
 {FOR isp:=1 TO nsp DO}
 WITH spec[isp] DO IF(sfn<>' ')THEN  {MRIA}
  BEGIN s:='.......Info about the '; IF(tofang=1)THEN s:=s+'Angular ';
  Writeln(fin,s+' Spectrum');
  Writeln(fin,'* filename'); Writeln(fin,sfn);
  Writeln(fin,'* NofSp; SpTyp; a1,   a2,  a11,  a22');
  Writeln(fin,isp:4,smosp:4,a1:7,a2:7,a11:7,a22:7);
  IF(mriamode IN [0,2])THEN
   BEGIN s:='* Fpath(m)  delay(chan)  chwidth(mks)  Bragg(th)';
   IF(tofang=1)THEN s:='* Lambda(A)  0-shift(deg)  chan_width(deg)  0';
   Writeln(fin,s); IF(tofang=1)THEN
    Writeln(fin,lambda:10:5,' ',delay:8:2,' ',chw:7:3,' 0')
                               ELSE
    Writeln(fin,FPath:10:5,' ',delay:8:2,' ',chw:7:1,' ',theta:9:3);
   Writeln(fin,
    '* W0,   dW0,  W1,  dW1, dback  abs1  abs2    shape(0=cyl.)');
   Writeln(fin,W0:7:2,' ',dW0:7:2,' ',W1:7:3,' ',dW1:7:3,' ',dback:4,
    ' ',abs1:8:5,' ',abs2:8:5,' ',shape:3);
   END;
  IF(mriamode=3)THEN
   BEGIN Writeln(fin,'* W0,   dW0,  W1,  dW1, dback');
   Writeln(fin,W0:7:2,' ',dW0:7:2,' ',W1:7:3,' ',dW1:7:3,' ',dback:4);
   END;
  END;
 {FOR isp:=1 TO nsp DO} WITH spec[isp] DO IF(efn<>vmdir)THEN
  BEGIN Writeln(fin,'.......Info about the Variance');
  Writeln(fin,'* filename'); Writeln(fin,efn);
  Writeln(fin,'* NofSp;   SpTyp;   Error type');
  Writeln(fin,isp:4,emosp:4,vartype:4);
  END;
 {*}
 ok:=false; {FOR isp:=1 TO nsp DO} IF(spec[isp].tofang=0)THEN ok:=true;
 IF((mriamode IN [0,2])AND(ok))THEN
  BEGIN WITH spec[0] DO IF((sfn<>vmdir)AND(sfn<>'DN2-vanadium'))THEN
   BEGIN Writeln(fin,'.......Info about the Effective Spectrum');
   Writeln(fin,'* filename'); Writeln(fin,sfn);
   Writeln(fin,'* SpTyp; a1, a2, Ncons, Fpath(m), delay(chan),'+
    '  chwidth(mks), Bragg(th)');
   Writeln(fin,smosp:4,a1:7,a2:7,nconst:9:3,
    FPath:11:5,' ',delay:8:2,' ',chw:7:1,' ',theta:9:3);
   END;
  {FOR isp:=1 TO nsp DO} WITH spec[isp] DO
    IF((sfn<>vmdir)AND(tofang<>1)AND(effn))THEN
   BEGIN Writeln(fin,
    '.......Normalize the Spectrum and Correct for Absorption');
   Writeln(fin,'* isp'); Writeln(fin,isp:4);
   END;
  END;
 IF(mriamode IN [0,2])THEN
  {*}
  BEGIN Writeln(fin,'.......Info about the Lattice Parameters');
  FOR iph:=1 TO nph DO WITH lat[iph] DO WITH lpd DO
   BEGIN
   Writeln(fin,'* A  B  C  alpha  beta  gamma of phase '+IntToStr(iph));
   Writeln(fin,a:10:5,' ',b:10:5,' ',c:10:5,' ',alpha:7:2,' ',
    beta:7:2,' ',gamma:7:2);
   Writeln(fin,'* nsg  sett  n_atoms  keycos  cpw');
   Writeln(fin,nsg:4,sett:4,nat:5,'   0        0'{,pmod[iph].cpw:8:3});
   END;
  {*}
  FOR iph:=1 TO nph DO IF(keyma[iph]=1)THEN WITH lat[iph] DO
   BEGIN Writeln(fin,'.......Set Magnetic Phase');
   Writeln(fin,'* phase N   symmetry');
   Writeln(fin,iph:5,syng:5);
   Writeln(fin,'* h0    k0    l0');
   Writeln(fin,h0:8:2,' ',k0:8:2,' ',l0:8:2);
   Writeln(fin,'* mag.space group filename');
   Writeln(fin,spgfn);
   FOR i:=1 TO nat DO Writeln(fin,atoms[i,iph].ionname);
   Writeln(fin,'* Magnetic moments');
   FOR i:=1 TO nat DO WITH atoms[i,iph] DO
    Writeln(fin,mgmom:10:4);
   END;
   BEGIN Writeln(fin,'.......Set the Width and Background Modes');
   Writeln(fin,keyWdt:5,keyBck:5);
   END;
  IF(anis_mod)THEN
  FOR iph:=1 TO nph DO IF(anisma[iph])THEN WITH lat[iph] DO
   BEGIN Writeln(fin,'.......Set Anisotropic Phase');
   Writeln(fin,'* Anis-phase N');
   Writeln(fin,iph:5);
   Writeln(fin,'* anis_pars: 1...9');
   FOR i:=1 TO 5 DO Write(fin,' ',anisa[i]:10:3); Writeln(fin);
   FOR i:=6 TO 9 DO Write(fin,' ',anisa[i]:10:3); Writeln(fin);
   END;
  IF(use_m2)THEN
   BEGIN Writeln(fin,'.......Set M2 Mode');
   Writeln(fin,'* m"_pars: 1...2');
   FOR i:=1 TO 2 DO Write(fin,' ',m2para[i]:10:3); Writeln(fin);
   END;
  Writeln(fin,'.......Info about the Atomic Parameters');
  FOR iph:=1 TO nph DO FOR i:=1 TO lat[iph].nat DO WITH atoms[i,iph] DO
   BEGIN Writeln(fin,'* Element name;     atom '+IntToStr(i)+
    ',  phase '+IntToStr(iph)); Writeln(fin,name); Writeln(fin,
  '* Occ   x        y       z     t11   t12  t13  t22  t23  t33  scat');
   Writeln(fin,occ:7:3,' ',x:8:4,' ',y:8:4,' ',z:8:4,' ',t11:8:3);
   Writeln(fin,t12:8:3,' ',t13:8:3,' ',t22:8:3,' ',t23:8:3,' ',t33:8:3);
   Writeln(fin,scat:14:5);
   END;
  IF(mriamode=2)THEN Writeln(fin,'.......Form the HKLs');
  END;
 {*}
 IF(mriamode<>2)THEN ParsOut(gfit.npar<>0); {Parameters}
 {*}
 FOR i:=0 TO nph DO IF(pmod[i].typ<>1)THEN  {Peak Models}
  BEGIN MakePeakInfo(i);
  END;
 {*}
 IF(mriamode IN [0])THEN
  BEGIN {Atomic}
  i:=0; FOR iph:=1 TO nph DO i:=i+lat[iph].nat; IF(i=0)THEN GOTO Lpb;
  Writeln(fin,'.......Get Atomic Info from Par.Array');
  Writeln(fin,
   '* atom names for phases 1,2,. & scat.lengths(if non-stand.)');
  FOR iph:=1 TO nph DO
   BEGIN IF(nph>1)THEN Writeln(fin,'* Phase',iph:1);
   FOR i:=1 TO lat[iph].nat DO
    WITH atoms[i,iph] DO Writeln(fin,name,scat:12:4);
   END;
  {*}
  Lpb: IF(mriamode=0)THEN Writeln(fin,'.......Form the HKLs');
  END;
 {*}
 IF((mriamode=3)AND(npeak<>0))THEN                 {UPEAK}
  BEGIN GetRealUpNMod(i); IF(i>1)THEN
   BEGIN Writeln(fin,'.......Input Peak Model Assignments');
   FOR i:=1 TO npeak DO
    BEGIN Write(fin,tam[i]:2); IF((i MOD 30)=0)THEN Writeln(fin);
    IF(i>=npeak)THEN BREAK;
    END;
   IF((npeak MOD 30)<>0)THEN Writeln(fin);
   END;
  END;
 Lpa: IF(NOT mo)THEN
  BEGIN Writeln(fin,'.......STOP'); CloseFile(fin); Exit;
  END;
 {*}
 Writeln(fin,'.......Info about the Main Fit Controls');
 Writeln(fin,'*  N_iter    step       damp');
 WITH cw DO Writeln(fin,gnit:7,' ',step:10:6,' ',damp:15:10);
 Writeln(fin,'.......STOP');
 CloseFile(fin);
 END;
msinf:=inifn+' ini-file created';
IF(mriamode=2)THEN msinf:=msinf+' without parameters';
END;
PROCEDURE IniSetNSpectrum;
VAR i,j:INTEGER; r:REAL;
BEGIN EnterStr(fin); Valz(sedz,r,i); recog:=true;
j:=Round(r); IF(NOT j IN [1..4])THEN j:=1;
IF(j<>1)THEN
  BEGIN i:=MessageDlg(strmsa,MtWarning,[mbYes,mbNo],0);
  IF(i=mrYes)THEN nsp:=j;
  END;
END;
PROCEDURE IniSetNPhase;
VAR i:INTEGER; r:REAL;
BEGIN EnterStr(fin); Valz(sedz,r,i); recog:=true;
IF(i<>0)THEN nph:=Round(r)
        ELSE ShowMess('N of phases: wrong data format');
END;
PROCEDURE IniSetNPeaks;
VAR i:INTEGER; r:REAL;
BEGIN EnterStr(fin); Valz(sedz,r,i); recog:=true; npeak:=Round(r);
nexp:=0;
END;
PROCEDURE IniSetNExps;
VAR i:INTEGER; r:REAL;
BEGIN EnterStr(fin); Valz(sedz,r,i); recog:=true; nexp:=Round(r);
END;
PROCEDURE IniSetMode;
{Set vmria mode}
VAR i:INTEGER; r:REAL;
BEGIN EnterStr(fin); Valz(sedz,r,i); recog:=true; j:=Round(r);
IF((i<>0)AND(j IN [0..3]))THEN mriamode:=j
                          ELSE ShowMess('Wrong Mode');
END;
PROCEDURE IniInfoZeroWeight;
VAR i,i1,i2,isp:INTEGER;
BEGIN fffin(fin,1,3,i,onl);
isp:=Round(onl[1]); i1:=Round(onl[2]); i2:=Round(onl[3]);
FOR i:=i1 TO i2 DO spec[isp].e[i]:=0; recog:=true;
END;
PROCEDURE IniSetWidthBackModes;
VAR i:INTEGER;
BEGIN fffin(fin,1,2,i,onl); recog:=true;
IF(Round(onl[1]) IN [0..2])THEN keyWdt:=Round(onl[1])
                           ELSE ShowMess('Wrong Width Mode');
IF(Round(onl[2]) IN [0..1])THEN keyBck:=Round(onl[2])
                           ELSE ShowMess('Wrong Background Mode');
END;
PROCEDURE IniInputSp(ta:INTEGER);
VAR i,kp:INTEGER; s:STRING; ont:ARRAY[1..4] OF REAL;
BEGIN EnterStr(fin); s:=sedz; Compress(s); UpCaseStr(s);
kp:=18; IF(mriamode=3)THEN kp:=11; fffin(fin,1,kp,i,onl);
IF(i<>kp)THEN
 BEGIN ShowMess('INI: Too little data in IS-command'); Exit;
 END;
numsp:=Round(onl[1]); FOR i:=3 TO 6 DO ont[i-2]:=onl[i];
WITH spec[numsp] DO
 BEGIN smosp:=Round(onl[2]); sfn:=s; sfn:=s;
 a1:=Round(onl[3]); a2:=Round(onl[4]);
 a11:=Round(onl[5]); a22:=Round(onl[6]); tofang:=ta; spvar:=0;
 IF((s<>'DUMMY')AND(NOT FileExists(s)))THEN ShowMess('No file '+s)
                                       ELSE InputSpectrumData(1);
 a11:=Round(ont[3]); a22:=Round(ont[4]);
 ic1:=a1; ic2:=a2; cadl:=ic2-ic1+1;
 CheckSpecIntBounds(ic1,ic2,ok); IF(NOT ok)THEN Exit;
 CASE mriamode OF
 0,2: BEGIN FPath:=onl[7]; delay:=onl[8]; chw:=onl[9]; theta:=onl[10];
      W0:=onl[11]; dW0:=onl[12]; W1:=onl[13]; dW1:=onl[14];
      dback:=Round(onl[15]);
      abs1:=onl[16]; abs2:=onl[17]; shape:=Round(onl[18]);
      IF(ta=1)THEN lambda:=onl[7];
      END;
 3: BEGIN W0:=onl[7]; dW0:=onl[8]; W1:=onl[9]; dW1:=onl[10];
    dback:=Round(onl[11]); tofang:=2;
    END;
 ELSE END;
 CheckErrorsFor0; CheckToFAInfo(numsp,ok); IF(ok)THEN argff:=false;
 spin:=true; effn:=false; absn:=false;
 END;
ncl:=0; nsp:=MAX0(nsp,numsp); recog:=true;
WITH spec[numsp] DO IF((smosp<>4)AND(tofang=1))THEN
 ShowMess('Reminder! Not forget to execute "Assign 2thetas"');
END;
PROCEDURE IniInputVariance;
VAR i:INTEGER; s:STRING;
BEGIN EnterStr(fin); s:=sedz;
EnterStr(fin); fffins(i,sedz);
i:=Round(onl[1]); spec[i].efn:=s; spec[i].emosp:=Round(onl[2]);
spec[numsp].efn:=s; IF(i>2)THEN vartype:=Round(onl[3]);
IF(NOT FileExists(s))THEN
 BEGIN ShowMess('No file '+s); Exit;
 END;
spvar:=1; InputSpectrumData(2); recog:=true; errset:=true;
END;
PROCEDURE IniInputEffectSp;
VAR i,j:INTEGER; s:STRING;
BEGIN EnterStr(fin); s:=sedz; fffin(fin,1,8,i,onl);
IF(NOT FileExists(s))THEN
 BEGIN ShowMess('No file '+s); Exit;
 END;
IF(i<8)THEN
 BEGIN ShowMess('INI: Too little data in IS-command'); Exit;
 END;
WITH spec[0] DO
 BEGIN smosp:=Round(onl[1]); a1:=Round(onl[2]); a2:=Round(onl[3]);
 a11:=a1; a22:=a2; nconst:=onl[4]; FPath:=onl[5]; delay:=onl[6];
 chw:=onl[7]; theta:=onl[8]; sfn:=s;
 END;
j:=numsp; numsp:=0; spvar:=0; InputSpectrumData(0); numsp:=j;
recog:=true;
END;
PROCEDURE IniAssign2Thetas;
VAR i:INTEGER; r,q:REAL;
BEGIN EnterStr(fin); fffins(i,sedz); r:=onl[1]; q:=onl[2];
recog:=true; WITH spec[numsp] DO
 FOR i:=Round(r) TO a2 DO spec[numsp].x[i]:=q+(i-1)*chw;
END;
PROCEDURE IniInfoRealModel(mo:INTEGER);
VAR i,nmod:INTEGER;
BEGIN fffin(fin,1,6,i,onl); nmod:=Round(onl[4]); recog:=true;
WITH pmrec DO WITH pmod[nmod] DO
 BEGIN im1:=Round(onl[1]); im2:=Round(onl[2]); Lbk:=Round(onl[3]);
 lam:=onl[5]; ns:=Round(onl[6]); numsp:=ns;
 IF(mo=0)THEN ndsign:=true ELSE ndsign:=false;
 IF(mo=0)THEN typ:=0 ELSE typ:=-1;
 camod(spec[numsp],im1,im2,Lbk,lam);
 END;
END;
PROCEDURE IniEnterRealModel(mo:INTEGER);
VAR i,nm,mt:INTEGER;
 PROCEDURE PrintErr;
 BEGIN ShowMess('Most probably the real model is wrong');
 END;
BEGIN recog:=true; i:=1; IF(mo=2)THEN i:=2; fffin(fin,1,i,nm,onl);
nm:=Round(onl[1]); IF(NOT(nm IN [0..6]))THEN
 BEGIN PrintErr; Exit;
 END;
IF(mo=2)THEN
 BEGIN mt:=Round(onl[2]); IF(NOT(mt IN [1..10]))THEN
  BEGIN ShowMess('Wrong number for special model'); Exit;
  END;
 IF(mt IN [4,5,8])THEN
  BEGIN fffin(fin,1,1,i,onl); rvoigt:=onl[1];
  END;
 WITH pmod[nm] DO
  BEGIN nmod:=nm; typ:=mt; makesm;
  END;
 Exit;
 END;
EnterStr(fin); fffins(i,sedz); WITH pmod[nm] DO
 BEGIN nl:=Round(onl[1]); rl:=onl[2]; cs:=onl[3]; wi:=onl[4];
 ac:=onl[5]; typ:=0; nmod:=nm; {cpw:=AMAX1(3,ABS(onl[6]));}
 fffin(fin,1,193,i,onl); IF(i<>193)THEN
  BEGIN PrintErr; Exit;
  END;
 FOR i:=1 TO 193 DO morr[i]:=onl[i]; ndsign:=false; typ:=-1;
 IF(mo=0)THEN ndsign:=true ELSE ndsign:=false;
 IF(mo=0)THEN typ:=0 ELSE typ:=-1;
 END;
END;
PROCEDURE IniNormCorrAbsor(mo:INTEGER);
VAR i,i1,i2:INTEGER;
BEGIN IF(mo=0)THEN
 BEGIN fffin(fin,1,1,i,onl); numsp:=Round(onl[1]);
 END;
recog:=true; DefineBounds(i1,i2);
L0rec:=''; MakeForm(0);
s:=' Is spectrum normalizing really needed? '; Form2.Color:=clGray;
OuttoLabel(Form2.Label5,25,100,clGray,clWhite,s);
s:=' Cancel if the spectrum already normalized.';
OuttoLabel(Form2.Label6,25,220,clGray,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=2; ar[1]:='Normalize'; ar[2]:='Correct for absorption';
 END;
MakeCheckListBox(25,150,250,40);
WITH Form2 DO WITH CheckListBox1 DO
 BEGIN Checked[0]:=true; Checked[1]:=true;
 ShowModal; IF(ModalRes=0)THEN Exit;
 IF(Checked[0])THEN DoNormalizing(0,numsp,i1,i2);
 IF(Checked[1])THEN CorrectforAbsorption(numsp,i1,i2);
 END;
END;
PROCEDURE IniSetAnisoPhase;
VAR iph,i:INTEGER;
BEGIN recog:=true; EnterStr(fin); fffins(i,sedz);
IF(NOT (i IN [1..6]))THEN
 BEGIN ShowMess('Wrong anisotropic info'); Exit;
 END;
iph:=Round(onl[1]); anisma[iph]:=true; anis_mod:=true;
fffin(fin,1,npani,i,onl);
WITH lat[iph] DO FOR i:=1 TO npani DO anisa[i]:=onl[i];
END;
PROCEDURE IniSetM2Mode;
VAR i:INTEGER;
BEGIN recog:=true; fffin(fin,1,2,i,onl); use_m2:=true;
FOR i:=1 TO 2 DO m2para[i]:=onl[i];
END;
PROCEDURE IniSetMagnPhase;
VAR iph,i,j:INTEGER;
BEGIN fffin(fin,1,2,i,onl); recog:=true;
iph:=Round(onl[1]); IF((iph<2)OR(iph>nph))THEN
 BEGIN ShowMess('Wrong magnetic phase number'); Exit;
 END;
keyma[iph]:=1; i:=Round(onl[2]);
IF(NOT(i IN [1..7]))THEN
 BEGIN ShowMess('Wrong magnetic symmetry'); Exit;
 END;
lat[iph].syng:=i;
fffin(fin,1,3,i,onl); WITH lat[iph] DO
 BEGIN h0:=onl[1]; k0:=onl[2]; l0:=onl[3];
 END;
EnterStr(fin); s:=sedz; UpCaseStr(s);
IF((s<>'DUMMY')AND(NOT FileExists(s)))THEN
 BEGIN ShowMess('No file '+s);
 END;
spgfn:=sedz;
FOR i:=1 TO lat[iph].nat DO
 BEGIN EnterStr(fin); Compress(sedz); atoms[i,iph].ionname:=sedz;
 WITH atoms[i,iph] DO FOR j:=1 TO formfacaN DO WITH formfaca[j] DO
  IF(ionn=ionname)THEN
   BEGIN Ab:=ffaca[1]; al:=ffaca[2]; Bb:=ffaca[3]; bl:=ffaca[4];
   Cb:=ffaca[5]; cl:=ffaca[6]; Db:=ffaca[7];
   END;
 END;
FOR i:=1 TO lat[iph].nat DO WITH atoms[i,iph] DO
 BEGIN EnterStr(fin); fffins(j,sedz); mgmom:=onl[1];
 END;
END;
PROCEDURE IniInfoLattice;
VAR i,iph:INTEGER;
BEGIN recog:=true; FOR iph:=1 TO nph DO WITH lat[iph] DO
 BEGIN fffin(fin,1,11,i,onl); WITH lpd DO
  BEGIN a:=onl[1]; b:=onl[2]; c:=onl[3];
  alpha:=onl[4]; beta:=onl[5]; gamma:=onl[6];
  IF(alpha*beta*gamma=0)THEN
   BEGIN ShowMess('Error, cell angle=0'); Exit;
   END;
  END;
 nsg:=Round(onl[7]); sett:=Round(onl[8]); nat:=Round(onl[9]);
 IF((nsg=777)AND(nph=1))THEN
  BEGIN ShowMess('777 reserved only for magnetic phase (>1)');
  nsg:=1;
  END;
 IF((nsg=777)AND(iph>=2))THEN
  BEGIN keyma[iph]:=1;; EnterStr(fin); Compress(sedz); spgfn:=sedz;
  EnterSpaceGroupInfo(iph,1);
  END                    ELSE
   BEGIN SetSpaceGroupInfo(iph); syng:=syngon(nsg,sett);
   END;
 WITH lpd DO GetAlBeGa(alpha,beta,gamma,syng);
 vol:=getvol(lpd); lpd0:=lpd;
 InverseLatPar(lpd,lpi,voli,0); FormLatMatrix(iph); nophasi:=false;
 IF((mriamode=2)AND(nat=0))THEN WITH atoms[1,iph] DO
  BEGIN IF(name=' ')THEN name:='A'+IntToStr(iph);
  IF(scat=0)THEN scat:=1; IF(occ=0)THEN occ:=1;
  END;
 END;
END;
PROCEDURE GetAtomsPar;  {From parameters}
VAR i,iph:INTEGER; s:STRING; r:REAL;
BEGIN recog:=true; IF((inipar[0]=0)AND(mriamode=0))THEN
 BEGIN ShowMess('No atomic parameters yet initialized'); Abort;
 END;
FOR iph:=1 TO nph DO FOR i:=1 TO lat[iph].nat DO
 BEGIN EnterStr(fin); s:=Copy(sedz,4,72); Compress(s);
 sedz:=Copy(sedz,1,2); UpCaseStr(sedz);
 Compress(sedz); IF(Length(sedz)=1)THEN sedz:=' '+sedz;
 IF(sedz='')THEN sedz:='  '; atoms[i,iph].name:=sedz;
 IF(s<>'')THEN
  BEGIN r:=StrToFloat(s); atoms[i,iph].scat:=r;
  END;
 ProcAtomName(sedz,iph,i,ok);
 END;
UpDateLatAt;
END;
PROCEDURE IniInfoAtoms;
VAR   i,iat,iph:INTEGER;
BEGIN recog:=true; IF(nophasi)THEN
 BEGIN ShowMess('No phase information available'); Exit;
 END;
FOR iph:=1 TO nph DO
 BEGIN IF(lat[iph].nat=0)THEN
  BEGIN ShowMess('0 atoms set for phase '+IntToStr(iph)); CONTINUE;
  END;
 FOR iat:=1 TO lat[iph].nat DO WITH atoms[iat,iph] DO
  BEGIN EnterStr(fin); name:=sedz;
  FOR i:=1 TO 11 DO onl[i]:=0; fffin(fin,1,11,i,onl);
  occ:=onl[1]; x:=onl[2]; y:=onl[3]; z:=onl[4]; t11:=onl[5];
  t12:=onl[6]; t13:=onl[7]; t22:=onl[8]; t23:=onl[9]; t33:=onl[10];
  IF((i=11)AND(onl[11]<>0))THEN scat:=onl[11];
  ProcAtomName(name,iph,iat,ok);
  END;
 END;
CheckForIsotropy(0);
END;
PROCEDURE IniNonStandScatts;
VAR   i,iat,iph:INTEGER;
BEGIN recog:=true; FOR iph:=1 TO nph DO
 BEGIN IF(lat[iph].nat=0)THEN
  BEGIN ShowMess('0 atoms set for phase '+IntToStr(iph)); CONTINUE;
  END;
 FOR iat:=1 TO lat[iph].nat DO
  BEGIN fffin(fin,1,1,i,onl); WITH atoms[iat,iph] DO
   IF(onl[1]<>0)THEN atoms[iat,iph].scat:=onl[1];
  END;
 END;
END;
PROCEDURE IniHKLs;
VAR i,iph:INTEGER; d1,d2:REAL;
BEGIN recog:=true; IF(nophasi)THEN
 BEGIN ShowMess('No phase information available'); Exit;
 END;
{d1:=spec[numsp].chtod(FLOAT(spec[numsp].a11));
d2:=spec[numsp].chtod(FLOAT(spec[numsp].a22));}
CalcDmaxn(d1,d2); IF(d2<d1)THEN Arrange2(d1,d2);
FOR iph:=1 TO nph DO WITH lat[iph] DO
 BEGIN IF(nat=0)THEN
  BEGIN ShowMess('Warning, no atomic information yet available');
  nat:=1; SetIniAtom(iph);
  END;
 FormMillerIndices(d1,d2,iph);
 END;
CalcHKLNMax;
END;
                  {Auto Indexing}
PROCEDURE IniEnterDSpacings;
VAR i,j,kk:INTEGER; tt:REAL;
BEGIN recog:=true; i:=0; fail:=false; fffin(fin,1,7,kk,onl);
IF(kk<>7)THEN fail:=true;
dstype:=Round(onl[1]); IF(NOT(dstype IN [0..3]))THEN fail:=true;
IF(fail)THEN
 BEGIN ShowMess('Wrong data '+sedz); Exit;
 END;
keylatt:=Round(onl[7]); IF(NOT((keylatt=0)OR(keylatt=1)))THEN
 ShowMess('Warning, keylatt not in [0,1]');
WITH spec[numsp] DO
 BEGIN Fpath:=onl[2]; lambda:=onl[3]; theta:=onl[4]; delay:=onl[5];
 chw:=onl[6]; tofang:=0; IF(dstype IN [1,2])THEN tofang:=1;
 REPEAT FOR j:=1 TO 6 DO onl[j]:=0;
 EnterStr(fin); IF(sedz[1]='/')THEN BREAK; fffins(kk,sedz);
 Inc(i); keyAuto:=0; WITH dspa[i] DO
  BEGIN d:=onl[1]; e:=onl[2]; x:=onl[3]; IF(d=0)THEN
   BEGIN
   CASE dstype OF
   1,3: tt:=x;
   2: tt:=x/2;
   ELSE END;
   d:=lambda*0.5/SIN((tt+delay)/radian);
   END;
  h:=Round(onl[4]); k:=Round(onl[5]); l:=Round(onl[6]);
  END;
 UNTIL(EoF(fin));
 END;
mdsp:=i; ArrangeDSpacings;
END;
PROCEDURE MakeaFrameofINIFile;
VAR i:INTEGER;
BEGIN L0rec:='Frame for INI-file';
SaveHelp(SavIni_n,SavIni); GetDir(0,fn); GetFilename(fn,1);
IF(ModalRes=0)THEN Exit;
AssignFile(ft,fn); Rewrite(ft);
FOR i:=1 TO 49 DO Writeln(ft,iniframe[i]);
CloseFile(ft);
END;
PROCEDURE IniInfoFitControls;
BEGIN recog:=true; fffin(fin,1,3,i,onl);
cw.gnit:=Round(onl[1]); cw.step:=onl[2]; cw.damp:=onl[3];
cb_init[mriamode+1]:=true;
END;
PROCEDURE IniSetSymmAI;
VAR i:INTEGER;
BEGIN fffin(fin,1,nph,i,onl); recog:=true;
IF(i<nph)THEN
 BEGIN ShowMess('Less symmetries than phases'); Exit;
 END;
FOR i:=1 TO nph DO
 IF(Round(onl[i]) IN [1..7])THEN lat[i].syng:=Round(onl[i])
                            ELSE ShowMess('Wrong symmetry');
END;
PROCEDURE IniSetVolumes;
VAR i:INTEGER;
BEGIN fffin(fin,1,nph,i,onl); recog:=true;
IF(i<nph)THEN
 BEGIN ShowMess('Less volumes than phases'); Exit;
 END;
FOR i:=1 TO nph DO
 IF(onl[i]<>0)THEN
  BEGIN vmax[i]:=onl[i]; autovol:=false;
  END         ELSE ShowMess('Wrong volumes');
END;
PROCEDURE IniSetVolumeMin;
VAR i:INTEGER;
BEGIN fffin(fin,1,nph,i,onl); recog:=true;
IF(i<nph)THEN
 BEGIN ShowMess('Less volume minimizers than phases'); Exit;
 END;
FOR i:=1 TO nph DO vmin[i]:=onl[i];
END;
PROCEDURE IniSetHKLBounds;
CONST sdia:STRING = 'Wrong HKL bounds';
VAR i,j,k:INTEGER;
BEGIN fffin(fin,1,nph*5,k,onl); recog:=true; FOR i:=1 TO nph DO
 BEGIN IF((onl[1]<onl[2])OR(onl[3]<onl[4])OR(onl[5]<0)OR(k<nph*5))THEN
  BEGIN ShowMess(sdia); Exit;
  END;
 j:=(i-1)*5; hmax[i]:=Round(onl[j+1]); hmin[i]:=Round(onl[j+2]);
 kmax[i]:=Round(onl[j+3]); kmin[i]:=Round(onl[j+4]);
 lmax[i]:=Round(onl[j+5]);
 END;
aubhkl:=false;
END;
PROCEDURE IniSetDeterMode;
VAR iph,ii,j,k:INTEGER;
BEGIN recog:=true; FOR iph:=1 TO nph DO
 BEGIN j:=lat[iph].syng; ii:=7; IF(iph>1)THEN ii:=6;
 fffin(fin,1,ii,k,onl); WITH aufit DO
  BEGIN FOR k:=1 TO 3 DO dstepnst[iph,k]:=Round(onl[1]);
  FOR k:=4 TO 6 DO dstepnst[iph,k]:=1;
  CASE j OF
  1: FOR k:=1 TO 6 DO dstepnst[iph,k]:=Round(onl[k]);
  2: BEGIN FOR k:=1 TO 3 DO dstepnst[iph,k]:=Round(onl[k]);
     dstepnst[iph,5]:=Round(onl[5]);
     END;
  3: FOR k:=1 TO 3 DO dstepnst[iph,k]:=Round(onl[k]);
  4,6: BEGIN dstepnst[iph,2]:=1;
       dstepnst[iph,3]:=Round(onl[3]);
       END;
  5: BEGIN dstepnst[iph,2]:=1; dstepnst[iph,3]:=1;
     END;
  7: BEGIN FOR k:=1 TO 3 DO dstepnst[iph,k]:=Round(onl[1]);
     FOR k:=4 TO 6 DO dstepnst[iph,k]:=Round(onl[4]);
     END;
  ELSE END;
  IF(iph=1)THEN ntrnd_0:=MAX0(1,Round(onl[7]));
  END;
 END;
nstact:=true;
END;
PROCEDURE IniFitS;
BEGIN {FittingRPM(mriamode);}
END;
PROCEDURE IniInpPeakModAss;    {U}
{Input peak model assignments}
VAR i:INTEGER;
BEGIN fffin(fin,1,npeak,i,onl); recog:=true; fail:=false;
IF(i<>npeak)THEN
 BEGIN ShowMess('Less model numbers than peaks'); Exit;
 END;
FOR i:=1 TO npeak DO
 BEGIN tam[i]:=Round(onl[i]); IF(NOT(tam[i] IN [1..4]))THEN fail:=true;
 END;
IF(fail)THEN
 BEGIN ShowMess(Wrnum+' peak models'); FOR i:=1 TO npeak DO tam[i]:=1;
 END;
END;
PROCEDURE MRIAInputSp;
VAR i:INTEGER; s:STRING;
BEGIN fffin(fin,1,5,i,onl); EnterStr(fin); s:=sedz;
Compress(s); UpCaseStr(s); IF(NOT FileExists(s))THEN
 BEGIN ShowMess('No file '+s); Exit;
 END;
numsp:=Round(onl[5]); WITH spec[numsp] DO
 BEGIN smosp:=Round(onl[3]); sfn:=s;
 a1:=Round(onl[1]); a2:=Round(onl[2]); a11:=a1; a22:=a2; tofang:=0;
 spvar:=0; InputSpectrumData(1); ic1:=a1; ic2:=a2; cadl:=ic2-ic1+1;
 CheckToFAInfo(numsp,ok); IF(ok)THEN argff:=false;
 spin:=true; effn:=false; absn:=false;
 END;
ncl:=0; nsp:=MAX0(nsp,numsp); recog:=true;
END;
PROCEDURE MRIAskip(n:INTEGER);
VAR i:INTEGER;
BEGIN fffin(fin,1,n,i,onl); recog:=true;
END;
PROCEDURE MRIAiac;
VAR i:INTEGER;
BEGIN recog:=true; FOR i:=1 TO nsp DO WITH spec[i] DO
 BEGIN fffin(fin,1,3,j,onl); chw:=onl[1]; theta:=onl[2];
 END;
END;
PROCEDURE MRIAscdm;
VAR i:INTEGER;
BEGIN recog:=true; fffin(fin,1,13,i,onl);
WITH cw DO
 BEGIN skip:=Round(onl[1]); gnit:=Round(onl[2]); eps:=onl[3];
 chi:=onl[4]; step:=onl[8]; damp:=onl[9]; ipr:=Round(onl[10]);
 delta:=onl[12]; beta:=onl[13];
 END;
cb_init[mriamode+1]:=true;
END;
PROCEDURE MRIAieffspn;
VAR i:INTEGER;
BEGIN fffin(fin,1,11,i,onl); EnterStr(fin);
numsp:=Round(onl[3]); IniNormCorrAbsor(1); recog:=true;
END;
PROCEDURE MRIAfpm(mo:INTEGER);
VAR i,nmod:INTEGER;
BEGIN fffin(fin,1,9,i,onl); nmod:=Round(onl[6]); recog:=true;
WITH pmrec DO WITH pmod[nmod] DO
 BEGIN im1:=Round(onl[2]); im2:=Round(onl[3]); Lbk:=Round(onl[4]);
 lam:=onl[5]; ns:=Round(onl[9]); numsp:=ns;
 IF(mo=0)THEN ndsign:=true ELSE ndsign:=false;
 IF(mo=0)THEN typ:=0 ELSE typ:=-1;
 camod(spec[numsp],im1,im2,Lbk,lam);
 END;
END;
PROCEDURE MRIAsna;
VAR i:INTEGER;
BEGIN recog:=true; FOR i:=1 TO nph DO WITH lat[i] DO
 BEGIN fffin(fin,1,1,j,onl); nat:=Round(onl[1]);
 END;
END;
PROCEDURE MRIAisgi(mo:INTEGER);
VAR i:INTEGER;
BEGIN recog:=true; i:=nph; IF(mo=1)THEN i:=2*nph;
fffin(fin,1,i+1,j,onl); nophasi:=false;
FOR i:=1 TO nph DO WITH lat[i] DO
 BEGIN
 CASE mo OF
 0: BEGIN nsg:=ABS(Round(onl[i])); sett:=1; IF(onl[i]<0)THEN sett:=2;
    END;
 1: BEGIN nsg:=Round(onl[(i-1)*2+1]); sett:=Round(onl[(i-1)*2+2]);
    END;
 ELSE END;
 syng:=syngon(nsg,sett);
 END;
END;
PROCEDURE MRIAicsa;
VAR iph,j,k,l,jj:INTEGER;
BEGIN recog:=true; fffin(fin,1,1,j,onl);
REPEAT EnterStr(fin); UNTIL sedz[1]<>'*'; FCompress(sedz);
FOR iph:=1 TO nph DO WITH lat[iph] DO
 BEGIN FOR j:=1 TO nat DO WITH atoms[j,iph] DO
  BEGIN l:=length(sedz); IF(l<=0)THEN
   BEGIN REPEAT EnterStr(fin); UNTIL sedz[1]<>'*'; FCompress(sedz);
   l:=length(sedz);
   END;
  k:=1; WHILE((NOT(sedz[k] IN [',',' ']))AND(k<=l))DO Inc(k);
  s:=Copy(sedz,1,k); Compress(s); Delete(sedz,1,k); FCompress(sedz);
  Val(s,r,jj); IF(jj<>0)THEN name:=s ELSE scat:=r;
  END;
 END;
END;
PROCEDURE MRIAssib;
VAR i:INTEGER;
BEGIN recog:=true; FOR i:=1 TO nsp DO WITH spec[i] DO
 BEGIN fffin(fin,1,2,j,onl); a11:=Round(onl[1]); a22:=Round(onl[2]);
 END;
END;
PROCEDURE ReadParLines(VAR ft:TEXTFILE; np:INTEGER);
VAR   i,j:INTEGER;
LABEL Lend;
BEGIN i:=0; WHILE(NOT EoF(ft))DO
 BEGIN EnterStr(ft); fffins(j,sedz);
 IF((i=0)AND(onl[1]<>1))THEN GOTO Lend; Inc(i); PutParameterI(i);
 IF(i=np)THEN BREAK;
 END;
IF(i<>np)THEN GOTO Lend; SetIniPar(0,1); noprep[1]:=false; Exit;
Lend: ShowMess('Wrong parameter array');
END;
PROCEDURE MRIAiipf;
VAR i,np,i0,iph:INTEGER;
BEGIN recog:=true; GetNumofPar(np,0); EnterStr(fin); Compress(sedz);
gfit.npar:=np; IF(sedz<>'0')THEN
 BEGIN IF((NOT FileExists(sedz))OR(sedz=''))THEN
  BEGIN ShowMess('No parameter file '+sedz); Exit;
  END;
 AssignFile(ft,sedz); {$I-} Reset(ft); {$I+};
 ReadParLines(ft,np); CloseFile(ft);
 END         ELSE ReadParLines(fin,np);
FOR iph:=1 TO nph DO
  BEGIN i0:=Geti0(iph); wparr[1]:=parar[i0+2];
  wparr[2]:=parar[i0+5]; IF(parar[i0+5].n=(i0+5))THEN wparr[2].n:=i0+3;
  wparr[3]:=parar[i0+7]; IF(parar[i0+7].n=(i0+7))THEN wparr[3].n:=i0+4;
  wparr[4]:=parar[i0+6]; IF(parar[i0+6].n=(i0+6))THEN wparr[4].n:=i0+5;
  wparr[5]:=parar[i0+4]; IF(parar[i0+4].n=(i0+4))THEN wparr[5].n:=i0+6;
  wparr[6]:=parar[i0+3]; IF(parar[i0+3].n=(i0+3))THEN wparr[6].n:=i0+7;
  FOR i:=1 TO 6 DO parar[i0+i+1]:=wparr[i];
  IF((ABS(wparr[1].p)>1)OR(ABS(wparr[2].p)>1)OR(ABS(wparr[3].p)>1))THEN
   ChangeCellPars;
  FOR i:=1 TO lat[iph].nat DO ProcAtomName(' ',iph,i,ok);
  END;
MakeParComments; FOR i:=1 TO np DO gfit.par[i]:=parar[i]; UpDateLatAt;
END;
PROCEDURE MRIAbhkl(mo:INTEGER);
VAR i,j:INTEGER;
BEGIN recog:=true; IF(mo=0)THEN j:=2 ELSE j:=17;
fffin(fin,1,j,i,onl); IniHKLs;
END;
PROCEDURE MRIAfs;
VAR i,j:INTEGER;
BEGIN recog:=true; {FOR i:=1 TO nsp DO} WITH spec[{i}numsp] DO
 BEGIN EnterStr(fin); fffins(j,sedz); {IF(j=3)THEN pmod[i].cpw:=onl[3];}
 IF(onl[1]<>0)THEN a11:=Round(onl[1]);
 IF(onl[2]<>0)THEN a22:=Round(onl[2]);
 END;
END;
PROCEDURE MRIAisv;
VAR i:INTEGER; s:STRING;
BEGIN recog:=true; fffin(fin,1,3,i,onl); EnterStr(fin); s:=sedz;
Compress(s); UpCaseStr(s); IF(NOT FileExists(s))THEN
 BEGIN ShowMess('No file '+s); Exit;
 END;
numsp:=Round(onl[3]); spvar:=1; WITH spec[numsp] DO
 BEGIN emosp:=Round(onl[1]); efn:=s; InputSpectrumData(2);
 END;
END;
PROCEDURE MRIAinsp;
VAR j:INTEGER;
BEGIN recog:=true; fffin(fin,1,1,j,onl); nsp:=Round(onl[1]);
END;
PROCEDURE MRIAnfs;
VAR i:INTEGER;
BEGIN recog:=true; fffin(fin,1,10,i,onl); WITH spec[0] DO
 BEGIN chw:=onl[5]; delay:=onl[6];
 END;
numsp:=Round(onl[7]); WITH spec[numsp] DO
 BEGIN chw:=onl[8]; delay:=onl[9];
 DoNormalizing(0,numsp,a1,a2);
 END;
END;
PROCEDURE MRIAac;
VAR j:INTEGER;
BEGIN recog:=true; fffin(fin,1,6,j,onl); numsp:=Round(onl[6]);
WITH spec[numsp] DO
 BEGIN shape:=Round(onl[1]); FPath:=onl[2]; abs1:=onl[3]; abs2:=onl[4];
 CorrectforAbsorption(numsp,a1,a2);
 END;
END;
PROCEDURE MRIAinpap;
VAR i:INTEGER;
BEGIN recog:=true; fffin(fin,1,1,i,onl);
nph:=MIN0(4,MAX0(1,Round(onl[1])));
fffin(fin,1,nph,i,onl); FOR i:=1 TO nph DO lat[i].nat:=Round(onl[i]);
fffin(fin,1,nph,i,onl); FOR i:=1 TO nph DO lat[i].nhkl:=Round(onl[i]);
END;
PROCEDURE MRIAzw;
VAR i,i1,i2:INTEGER;
BEGIN recog:=true; fffin(fin,1,3,i,onl);
numsp:=Round(onl[3]); i1:=Round(onl[1]); i2:=Round(onl[2]);
FOR i:=i1 TO i2 DO spec[numsp].e[i]:=0;
END;
PROCEDURE MRIAsmw;
VAR i:INTEGER;
BEGIN recog:=true; fffin(fin,1,1,i,onl); keyWdt:=Round(onl[1]);
END;
PROCEDURE MRIAupf;
BEGIN recog:=true; EnterStr(fin);
END;
PROCEDURE MRIAsnp;
VAR j:INTEGER;
BEGIN recog:=true; fffin(fin,1,1,j,onl);
nph:=MAX0(1,MIN0(4,Round(onl[1])));
END;

PROCEDURE InputInifile(iniq:BOOLEAN);
VAR   i:INTEGER; s,ss:STRING; stepw,okp:BOOLEAN;
LABEL L1,L2,L3;
BEGIN ModalRes:=1; IF(inifn=' ')THEN inifn:=''; stepw:=false;
CheckSavings(ok,s); IF(NOT ok)THEN
 BEGIN i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0); IF(i=mrNo)THEN Exit;
 END;
L1: s:='ini'; ss:='Files(.ini)|*.ini|All|*.*|Dat|*.dat';
OpenFileDial(Form2.OpenDialog1,inifn,s,vmdir,ss);
IF(ModalRes=0)THEN Exit;
IF(Pos('.',inifn)=0)THEN inifn:=inifn+'.ini';
s:=ExtractFileExt(inifn); UpCaseStr(s); IF((s<>'.INI')AND(iniq))THEN
 BEGIN s:=s+' is no ini extention. Still proceed?';
 i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0); IF(i=mrNo)THEN GOTO L1;
 END;
IF(NOT FileExists(inifn))THEN
 BEGIN ShowMess('No file '+inifn); ModalRes:=0; Exit;
 END;
AssignFile(fin,inifn); {$I-} Reset(fin); {$I+}; IF(IOResult<>0)THEN
 BEGIN ShowMess(inifn+' can not be opened'); ModalRes:=0; Exit;
 END;

ResetVMria;
L0rec:='Input of ini-file'; MakeForm(1); SaveHelp(SavIni_n,SavIni);
s:='Ini-file= '+inifn; OuttoLabel(Form2.Label5,5,50,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=2;
 ar[1]:=' Proceed step-wise '; ar[2]:=' No error diagnostics ';
 END;
MakeCheckListBox(30,100,270,38); WITH Form2 DO WITH CheckListBox1 DO
 BEGIN Checked[0]:=stepw; Checked[1]:=skipmo;
 ShowModal; IF(ModalRes=0)THEN
  BEGIN CloseFile(fin); Exit;
  END;
 stepw:=Checked[0]; skipmo:=Checked[1]; mriamode:=0;
 END;
Writeln(fout,s+' input'); ResetAtoms;
WHILE(NOT EoF(fin))DO
 BEGIN EnterStr(fin); IF(sedz[1]='*')THEN CONTINUE;
 ss:=sedz; IF(stepw)THEN
  BEGIN i:=MessageDlg(ss,MtInformation,[mbOK,mbAbort],0);
  IF(i=mrAbort)THEN BREAK;
  END;
 GetCapitals(sedz,s); recog:=false;
 IF(s='STOP')THEN Break;
 IF(NOT iniq)THEN GOTO L2;
 IF(s='AT')THEN IniAssign2Thetas;
 IF(s='SM')THEN IniSetMode;
 IF(s='SNS')THEN IniSetNSpectrum;
 IF(s='SNP')THEN IniSetNPhase;
 IF(s='ENSSA')THEN IniNonStandScatts;
 IF(s='FHKL')THEN IniHkls;
 IF(s='FS')THEN IniFitS;
 IF(s='GAIPA')THEN GetAtomsPar;
 IF(s='IS')THEN IniInputSp(0);
 IF(s='IAS')THEN IniInputSp(1);
 IF(s='IV')THEN IniInputVariance;
 IF(s='IES')THEN IniInputEffectSp;
 IF((s='IAP')OR(s='IAI'))THEN IniInfoAtoms;
 IF(s='ILP')THEN IniInfoLattice;
 IF(s='IRM')THEN IniInfoRealModel(0);
 IF((s='IDRM')OR(s='IDSRM'))THEN IniInfoRealModel(1);
 IF(s='IERM')THEN IniEnterRealModel(0);
 IF((s='IEDRM')OR(s='IEDM'))THEN IniEnterRealModel(1);
 IF(s='IESM')THEN IniEnterRealModel(2);
 IF(s='IMFC')THEN IniInfoFitControls;
 IF(s='IZW')THEN IniInfoZeroWeight;
 IF(s='IPA')THEN IniInputParameterArray(0,okp);
 IF(s='IP')THEN IniInputParameterArray(1,okp);
 IF(s='NSCA')THEN IniNormCorrAbsor(0);
 IF(s='SAP')THEN IniSetAnisoPhase;
 IF(s='SMM')THEN IniSetM2Mode;
 IF(s='SMP')THEN IniSetMagnPhase;
 IF(s='SWBM')THEN IniSetWidthBackModes;
 IF(s='SDM')THEN IniSetDeterMode;
 IF(s='SNPU')THEN IniSetNPeaks; {U}
 IF(s='SNEU')THEN IniSetNExps;  {U}
 IF(s='IPMA')THEN IniInpPeakModAss;  {U}
 IF(s='EDS')THEN IniEnterDSpacings; {AI}
 IF(s='SSAI')THEN IniSetSymmAI;     {AI}
 IF(s='SV')THEN IniSetVolumes;      {AI}
 IF(s='SVM')THEN IniSetVolumeMin;   {AI}
 IF(s='SHKLB')THEN IniSetHKLBounds; {AI}
 GOTO L3;
 L2: {Old mria dat file}
 IF(s='IS')THEN MRIAInputSp;
 IF(s='SMRI')THEN MRIAskip(1);
 IF(s='SCDM')THEN MRIAscdm;
 IF(s='IAC')THEN MRIAiac;
 IF(s='IESN')THEN MRIAieffspn;
 IF(s='FPM')THEN MRIAfpm(0);
 IF(s='FDSPM')THEN MRIAfpm(1);
 IF(s='SNA')THEN MRIAsna;
 IF(s='ISGI')THEN MRIAisgi(0);
 IF(s='ESGI')THEN MRIAisgi(1);
 IF(s='ICSA')THEN MRIAicsa;
 IF(s='SSIB')THEN MRIAssib;
 IF(s='IIPF')THEN MRIAiipf;
 IF(s='BHKL')THEN MRIAbhkl(0);
 IF(s='FHKL')THEN MRIAbhkl(1);
 IF(s='FS')THEN MRIAfs;
 IF(s='OMAD')THEN recog:=true;
 IF((s='DCVP')OR(s='DIEA'))THEN MRIAskip(1);
 IF((s='GRFD')OR(s='GFD'))THEN MRIAskip(3);
 IF(s='ISV')THEN MRIAisv;
 IF(s='INSP')THEN MRIAinsp;
 IF(s='NFS')THEN MRIAnfs;
 IF(s='AC')THEN MRIAac;
 IF(s='INPAP')THEN MRIAinpap;
 IF(s='ZW')THEN MRIAzw;
 IF(s='SMW')THEN MRIAsmw;
 IF(s='UPF')THEN MRIAupf;
 IF(s='SNP')THEN MRIAsnp;
 L3: IF((NOT recog)AND(NOT skipmo))THEN
  BEGIN s:='Wrong command ';
  i:=MessageDlg(s,MtInformation,[mbOK,mbAbort],0);
  IF(i=mrAbort)THEN BREAK;
  END;
 END;
CloseFile(fin);
CASE mriamode OF
0,2: IF((inipar[mriamode]=1)AND(NOT nophasi))THEN UpDateLatAt;
1:   Exit;
ELSE END;
IF(grst<>0)THEN grst:=1;
END;

BEGIN {fnout:='';}
END.



C*****     Input the Fourier Spectrum and its Variance
      IF(comm.EQ.'IFSV')THEN
      ok=.true.
      CALL insfin(rcomm)
      ENDIF
