UNIT vmriartv;
INTERFACE
USES Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
     Dialogs, StdCtrls, ExtCtrls, Grids,   vzlocom,  vmria0,   vmria2,
     vmriasp, vmriarit, vgfit,    vmriafl, vmriahkl, vmriahlp, vmriainf,
     vspectr, vpmodel,  varfun,   vpeaksr, vmriaini, vmriacry, vmriasgm,
     vstdcons,vmria00;

PROCEDURE RietveldMatchAnalysis(mRiPM:INTEGER);
PROCEDURE FittingRPM(mRiPM:INTEGER);
PROCEDURE ShowFitResults;
PROCEDURE SaveFitResults(mRiPM,mo:INTEGER);
PROCEDURE UpDateParFile;
PROCEDURE CheckParameters;
PROCEDURE NumberEffPeaks(VAR reff:REAL);
PROCEDURE SendParClipBrd;
PROCEDURE LoadParClipBrd;
PROCEDURE PrintAtomDistances(iph:INTEGER);
PROCEDURE GetMagParStrings(iph:INTEGER; VAR s2:ARRAY OF STRING);

CONST amagm:STRING =' Mag.moment angles,hkl (degr.)';

IMPLEMENTATION
PROCEDURE RietveldMatchAnalysis(mRiPM:INTEGER);      {GENERAL DRIVER}
{mRiPM = 0: Rietveld,  mRiPM = 2: PowderMatch}
CONST fmpre:STRING = 'First make the preparation';
VAR   i,j,isp,iph,iop,m:INTEGER; ss:STRING; ok:BOOLEAN; ch1,ch2:REAL;
LABEL Lbeg;
BEGIN iop:=1; sinf:=''; WITH spec[numsp] DO IF(tofang=0)THEN
 BEGIN s:='Spectrum '; ok:=NOT effn OR NOT absn;
 IF(NOT effn)THEN s:=s+' not normalized; ';
 IF(NOT absn)THEN s:=s+' not corrected for absorption.';
 IF(ok)THEN
  BEGIN j:=MessageDlg(s+' Proceed?',MtWarning,[mbYes,mbNo],0);
  IF(j=mrNo)THEN Exit; effn:=true; absn:=true;
  END;
 END;
CheckAtHKL;  {Check for atoms+hkls}
isp:=numsp; WITH spec[isp] DO
 BEGIN IF((a11<>do1[isp])OR(a22<>do2[isp]))THEN
  BEGIN ss:='HKLs formed for other interval. Reform?';
  j:=MessageDlg(ss,MtWarning,[mbYes,mbNo],0); IF(j=mrYes)THEN Formhkls;
  END;
 FOR iph:=1 TO nph DO  {Check overlap}
  BEGIN ch2:=dtoch(hkla[lat[iph].nhkl,iph].dk);
  ch1:=dtoch(hkla[1,iph].dk); IF(ch1>ch2)THEN Arrange2(ch1,ch2);
  IF((ch1>FLOAT(a22))OR(ch2<FLOAT(a11)))THEN
   BEGIN ShowMess('HKL-range and spec.'+IntToStr(isp)+
   ' interval don''t overlap,phase '+IntToStr(iph)+'   Make new hkls');
   Formhkls;
   END;
  END;
 END;

FOR i:=1 TO nph DO IF(pmod[i].typ=6)THEN
 BEGIN j:=MessageDlg('Peak model '+IntToStr(i)+' exponential. Proceed?',
 MtWarning,[mbYes,mbNo],0); IF(j=mrNo)THEN Exit;
 END;
Lbeg:   {L O O P}
WITH spec[isp] DO m:=a22-a11+1; gfit.mpoint:=m; ss:=modestr[mRiPM];
L0rec:=ss; MakeForm(1); SaveHelp(Rietv_n,Rietv);
IF(sinf<>'')THEN OuttoLabel(Form2.Label5,50,350,clBlue,clWhite,sinf);
OuttoLabel(Form2.Label1,5,10,clGreen,clWhite,selops);
OuttoLabel(Form2.Label3,200,10,clBlue,clWhite,
 'Spectrum '+IntToStr(numsp));
WITH CB1rec DO
 BEGIN indx:=iop; nitems:=12;
 ar[1]:=' Prepare the '+ss;
 ar[2]:=' Make the '+ss;
 ar[3]:=' Show the Quality of '+ss;
 ar[4]:=' Save the Results of '+ss;
 ar[5]:=' Exit and show graphs';
 ar[6]:=' ...... Send Parameters to Clipboard';
 ar[7]:=' ...... Save Parameters to a file';
 ar[8]:=' ...... Change Cell Parameters';
 ar[9]:=' ...... Save atomic distances';
 ar[10]:=' ...... Load Parameters from Clipboard';
 ar[11]:=' ...... Impose links between phases';
 ar[12]:=' ...... Check Parameter Array';
 MakeRadioGroup(1,0,5,30,300,40+25*nitems);
 END;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit; i:=RadioGroup1.ItemIndex;
 END;
CASE i OF
0: BEGIN CheckSavings(ok,ss); IF(NOT ok)THEN Exit;
   mriamode:=mRiPm; CheckSpecErr(numsp); IF(ModalRes=0)THEN Exit;
   PrepareRfPm(mRiPM,ok); IF(ok)THEN ShowParameterArray; iop:=2;
   END;
1: BEGIN IF(noprep[mRiPM+1])THEN
    BEGIN ShowMess('First make the preparation'); iop:=1; GOTO Lbeg;
    END;
   ShowFitControls; gfit.cb:=cw; IF(ModalRes=0)THEN Exit;
   FittingRPM(mRiPM); {Rietveld / PowderMatch}
   grst:=2; ic1:=spec[numsp].a11; ic2:=spec[numsp].a22;
   butar:='0000111111'; iop:=3;
   END;
2,3,8: BEGIN IF(nofit[mRiPM+1])THEN
   BEGIN ShowMess('First make the fitting'); iop:=2; GOTO Lbeg;
   END;
   iop:=5; IF(i=2)THEN
    BEGIN ShowFitResults; iop:=4;
    END;
   IF(i=3)THEN SaveFitResults(mRiPM,0);
   IF(i=8)THEN SaveFitResults(mRiPM,1);
       END;
4: Exit;
5,6: BEGIN IF(gfit.npar=0)THEN
    BEGIN ShowMess('First make the parameter array'); iop:=2; GOTO Lbeg;
    END;
   IF(i=6)THEN
    BEGIN UpDateParFile;
    IF(mRiPM=0)THEN nosavedR:=false ELSE nosavedS:=false;
    END   ELSE SendParClipBrd;
   iop:=5;
     END;
7: BEGIN IF(noprep[mRiPM+1])THEN
    BEGIN ShowMess('First make the preparation'); iop:=1; GOTO Lbeg;
    END;
   FOR i:=1 TO gfit.npar DO parar[i]:=gfit.par[i];
   ChangeCellPars; iop:=2;
   IF(ModalRes<>0)THEN FOR i:=1 TO gfit.npar DO gfit.par[i]:=parar[i];
   END;
9: LoadParClipBrd;
10: BEGIN IF(gfit.npar=0)THEN
     BEGIN ShowMess(fmpre); iop:=1; GOTO Lbeg;
     END;
    IF(nph=1)THEN
     BEGIN ShowMess('Only 1 phase'); iop:=2; GOTO Lbeg;
     END;
    ImposeLinks; iop:=2;
    END;
11: BEGIN {SetNumberofSpectra; iop:=1; j:=nsp;
    FOR i:=1 TO j DO IF(spec[i].NoSpectrum(i))THEN} nsp:=1;
    ShowParameterArray;
    END;
ELSE END;
GOTO Lbeg;
END;
PROCEDURE CheckFittedPars;
VAR i,iph,j:INTEGER;
 PROCEDURE React(kg:INTEGER; CONST s0:STRING);
 BEGIN WITH gfit DO WITH par[kg] DO
  IF((ABS(e)>=(0.5*ABS(p)))AND(ABS(p*e)>0))THEN
   BEGIN s:=s0+' parameter '+IntToStr(kg)+': error more than 50%!'+crc+
            'fix it to zero?';
   j:=MessageDlg(s,MtWarning,[mbYes,mbNo],0); IF(j=mrYes)THEN
    BEGIN pl:=0; pu:=0; p:=0;
    END;
   END;
 END;
{*****************}
BEGIN FOR i:=1 TO 6 DO React(i+3,'Background');
IF(anis_mod)THEN FOR iph:=1 TO nph DO IF(anisma[iph])THEN
 BEGIN j:=GetNAddiPar(1)+(iph-1)*9; FOR i:=1 TO 9 DO React(j+i,'Aniso');
 END;
END;
PROCEDURE FittingRPM(mRiPM:INTEGER);
{Purpose: to make the fitting/matching.
 Version: February 5 1991; Delphi = Sep 17 2000}
VAR   i,j,l2,iph,i0:INTEGER; boo:BOOLEAN;
LABEL L21,L32;
{ ---------------------------------------------------------------}
BEGIN CheckParameters; IF(ModalRes=0)THEN Exit; l2:=0; Nittot:=0;
WITH spec[numsp] DO
 BEGIN celx1:=0; IF(chw>1E-10)THEN celx1:=1/chw;
 celx0:=a11-x[a11]*celx1;
 END;
CheckForIsotropy(1);
{Determine the multiplicities of atoms}{diequa(p,onl,anp,0)}
WITH gfit DO
 BEGIN GetNFreePar(i); IF(i>npmax)THEN
  BEGIN ShowMess('More than '+IntToStr(npmax)+' free parameters');
  ModalRes:=0; Exit;
  END;
 cb.ipr:=0; IF(debugV.cbipr)THEN cb.ipr:=1;
 {cb.dbg.matr:=true; cb.derv:=1;}
 L21: MakeCurrInfo; Form2.Show; cb.cmprs:=1;
 LeastSquaresFit(armrit,regmria); Nittot:=Nittot+rb.gnit;
 Form2.Close; cb.cmprs:=0; CheckConvergence;
 boo:=NOT((nocnv)OR(noinv)OR(noch)OR(noeps)OR(noequ));
 IF(v_stop)THEN GOTO L32; IF(cb.gnit<=1)THEN
  BEGIN s:='Repeat fitting?';
  i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0); IF(i=mrNo)THEN GOTO L32;
  END;
 {Powder Match}
 IF(mriamode=2)THEN WITH gfit DO FOR iph:=1 TO nph DO WITH lat[iph] DO
  BEGIN i0:=Geti0(iph)+10; FOR i:=i0+1 TO i0+nhkl DO WITH par[i] DO
   BEGIN IF(pl=p)THEN pl:=pl/3; {IF(p<Athresh)THEN
    BEGIN pl:=0; p:=0; pu:=0;
    END;}
   END;
  END;
 CheckFittedPars;
 UpdateLatAt; IF(boo OR(l2<>0))THEN GOTO L32; rincc;
 {if process did not converge, an attempt to minimize once more}
 l2:=1; GOTO L21;
 L32: FOR i:=1 TO npar DO parar[i]:=par[i];
 FOR i:=1 TO 6 DO spec[numsp].bkpar[i]:=parar[i+3].p;
 END;
IF(mRiPM=0)THEN nosavedR:=true ELSE nosavedS:=true;
FOR i:=0 TO 3 DO inipar[i]:=0; inipar[mRiPM]:=1;
i:=numsp;
frb[i]:=frp[i]/AMAX1(frb[i],0.01);
frp[i]:=frp[i]/AMAX1(fie[i],0.01);
frw[i]:=SQRT(frw[i]/AMAX1(fi2[i],0.01));
fre[i]:=fre[i]/AMAX1(fie[i],0.01);
MakeForm(1); i:=1; WITH LB1rec DO
 BEGIN ar[i]:=' '; Inc(i); j:=numsp;
  BEGIN ConvertStr(FLOAT(spec[j].a11),6,0);
  s:='   INTERVAL = '+sedz+' -';
  ConvertStr(FLOAT(spec[j].a22),6,0); s:=s+sedz; ar[i]:=s; Inc(i);
  END;
 END;
MakeFitResLB(i); MakeListBox(5,10,305,260);
MakeBevel(5,270,300,90,1); WITH CB1rec DO
 BEGIN nitems:=2; ar[1]:=' Repeat fitting with smaller step';
 ar[2]:=' Update the spectral info';
 END;
MakeCheckListBox(20,280,270,72);
WITH Form2.CheckListBox1 DO
 BEGIN Checked[0]:=false; Checked[1]:=true;
 END;
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
WITH Form2.CheckListBox1 DO
 BEGIN IF(Checked[1])THEN UpdateSpectroInfo;
 IF(Checked[0])THEN
  BEGIN gfit.cb.step:=cw.step*0.5; GOTO L21;
  END;
 END;
SetNoFit(13,true); nofit[mRiPM+1]:=false;

WITH gfit DO
 BEGIN cb.gnit:=cw.gnit; cb.step:=cw.step; cb.damp:=cw.damp;
 END;
END;
PROCEDURE FormSaveStr(r,e:REAL; nf:INTEGER; VAR s:STRING);
VAR ss:STRING;
BEGIN ConvertStr(r,10,nf); ss:=sedz; ConvertStr(e,10,nf);
 s:=ss+' +- '+sedz;
END;
PROCEDURE AnisoParOut(iph,mo:INTEGER);
{mo=0 -> to fout,   mo=2 -> to Memo}
VAR i,j,k:INTEGER; s:STRING;
BEGIN j:=GetNAddiPar(1)+(iph-1)*9;
s:='   Anisotropic parameters, phase='+IntToStr(iph); StringOut(s,mo);
FOR i:=1 TO npani DO
 BEGIN FormSaveStr(parar[j+i].p,parar[j+i].e,4,s);
 StringOut(' '+parar[j+i].com+'='+s,mo);
 END;
j:=GetNAddiPar(2); IF(use_m2)THEN FOR i:=1 TO 2 DO
 BEGIN FormSaveStr(parar[j+i].p,parar[j+i].e,4,s);
 StringOut(' '+parar[j+i].com+'='+s,mo);
 END;
END;
PROCEDURE CriteriaOut(mo:INTEGER);
VAR i,iph,n:INTEGER; s:STRING;
BEGIN WITH gfit DO
 BEGIN ConvertStr(FLOAT(spec[numsp].a11),6,0); s:=sedz;
 ConvertStr(FLOAT(spec[numsp].a22),6,0);
 s:='    Interval = '+s+' - '+sedz; StringOut(s,mo);
 s:=bblank+IntToStr(Nittot)+' iterations'; StringOut(s,mo);
 ConvertStr(rb.chi2,12,2); Compress(sedz);
 StringOut(bblank+'Chi^2 = '+sedz,mo);
 ConvertStr(rb.chipl,10,2); Compress(sedz);
 StringOut(bblank+'Chi+  = '+sedz,mo);
 StringOut('',mo);
 StringOut('    R - factors',mo); i:=numsp;
 ConvertStr(frp[i]*100,8,2); StringOut(bblank+'R_p = '+sedz+'%',mo);
 ConvertStr(frb[i]*100,8,2); StringOut(bblank+'R_b = '+sedz+'%',mo);
 ConvertStr(frw[i]*100,8,2); StringOut(bblank+'R_w = '+sedz+'%',mo);
 ConvertStr(fre[i]*100,8,2); StringOut(bblank+'R_e = '+sedz+'%',mo);
 StringOut('',mo);
 NumberEffPeaks(r); ConvertStr(r,7,1);
 StringOut('Number of efficient peaks: '+sedz,mo);
 GetNFreePar(n);StringOut('Number of free parameters= '+IntToStr(n),mo);
 IF(nph>1)THEN
  BEGIN StringOut('',mo);
  StringOut('Interphase ABS Str.Fac.Relations',mo);
  InterPhAStrF; FOR iph:=1 TO nph DO
   BEGIN ConvertStr(onl[iph],9,4);
   StringOut('  Phase'+IntToStr(iph)+'='+sedz,mo);
   END;
  END;
 END;
END;
PROCEDURE CellParOut(iph,mo:INTEGER);
BEGIN WITH lat[iph] DO
 BEGIN s:='    Unit cell parameters'; StringOut(s,mo);
 ConvertStr(vol,10,2); Compress(sedz);
 s:=' Phase '+IntToStr(iph)+bblank+'Vol= '+sedz; StringOut(s,mo);
 StringOut('',mo);
 FormSaveStr(lpd.a,lper.a,5,s); s:=' A     = '+s; StringOut(s,mo);
 FormSaveStr(lpd.b,lper.b,5,s); s:=' B     = '+s; StringOut(s,mo);
 FormSaveStr(lpd.c,lper.c,5,s); s:=' C     = '+s; StringOut(s,mo);
 FormSaveStr(lpd.alpha,lper.alpha,2,s); s:=' alpha = '+s;
 StringOut(s,mo);
 FormSaveStr(lpd.beta,lper.beta,2,s); s:=' beta  = '+s; StringOut(s,mo);
 FormSaveStr(lpd.gamma,lper.gamma,2,s);s:=' gamma = '+s;StringOut(s,mo);
 StringOut('',mo);
 END;
END;
PROCEDURE ShowFitResults;
VAR   i,iph,iat:INTEGER; r:REAL;
LABEL Lext;
BEGIN L0rec:='Output of fitting results'; MakeForm(1);
UpdateLatAt; SaveHelp(ShFitRes_n,ShFitRes); MakeMemo(3,315);
CriteriaOut(2);
Form2.ShowModal; IF(ModalRes=0)THEN Exit;

FOR iph:=1 TO nph DO WITH lat[iph] DO WITH Form2.Memo1 DO
 BEGIN Clear; CellParOut(iph,2);
 Form2.ShowModal; IF(ModalRes=0)THEN Exit;
 IF(mriamode<>0)THEN GOTO Lext;
 FOR iat:=1 TO nat DO WITH atoms[iat,iph] DO
  BEGIN Clear;
  Lines.Add('      Atom '+name+'   No '+IntToStr(iat));
  Lines.Add(''); Lines.Add('');
  ConvertStr(occ,8,4); s:=sedz;
  r:=eoc; IF((iph>1)AND(keyma[iph]=1))THEN r:=0; ConvertStr(r,7,4);
  Lines.Add('Occupation = '+s+'  +-'+sedz);
  IF((iph>1)AND(keyma[iph]=1))THEN
   BEGIN ConvertStr(mgmom,8,4); s:=sedz; ConvertStr(eoc,7,4);
   Lines.Add('Mag.moment = '+s+'  +-'+sedz);
   END;
  ConvertStr(x,8,4); s:=sedz; ConvertStr(ex,7,4);
  Lines.Add('   X       = '+s+'  +-'+sedz);
  ConvertStr(y,8,4); s:=sedz; ConvertStr(ey,7,4);
  Lines.Add('   Y       = '+s+'  +-'+sedz);
  ConvertStr(z,8,4); s:=sedz; ConvertStr(ez,7,4);
  Lines.Add('   Z       = '+s+'  +-'+sedz);
  ConvertStr(t11,8,4); s:=sedz; ConvertStr(e11,7,4);
  Lines.Add('  T11      = '+s+'  +-'+sedz);
  IF(NOT isotr)THEN
   BEGIN ConvertStr(t12,8,4); s:=sedz; ConvertStr(e12,7,4);
   Lines.Add('  T12      = '+s+'  +-'+sedz);
   ConvertStr(t13,8,4); s:=sedz; ConvertStr(e13,7,4);
   Lines.Add('  T13      = '+s+'  +-'+sedz);
   ConvertStr(t22,8,4); s:=sedz; ConvertStr(e22,7,4);
   Lines.Add('  T22      = '+s+'  +-'+sedz);
   ConvertStr(t23,8,4); s:=sedz; ConvertStr(e23,7,4);
   Lines.Add('  T23      = '+s+'  +-'+sedz);
   ConvertStr(t33,8,4); s:=sedz; ConvertStr(e33,7,4);
   Lines.Add('  T33      = '+s+'  +-'+sedz);
   END;
  Form2.ShowModal; IF(ModalRes=0)THEN Exit;
  END;
 Lext: IF(anisma[iph])THEN
  BEGIN Clear; AnisoParOut(iph,2);
  Form2.ShowModal; IF(ModalRes=0)THEN Exit;
  END;
 IF((keyma[iph]=1)AND(mriamode=0))THEN
  BEGIN Clear; GetMagParStrings(iph,strgrT);
  Lines.Add(strgrT[1]); Lines.Add('');
  FOR i:=1 TO 3 DO Lines.Add(strgrT[i+1]);
  Form2.ShowModal;
  END;
 END;
END;
PROCEDURE SaveFitResults(mRiPM,mo:INTEGER);
CONST ressav:STRING ='Results already saved';
VAR   iat,iph,i,j,i0:INTEGER; s:STRING; r,rc:REAL;
LABEL Lan;
{------}
BEGIN IF(nofit[1] AND nofit[3])THEN
 BEGIN sinf:='No fit yet performed'; Exit;
 END;
IF(mo=1)THEN  {save only atomic distances}
 BEGIN Writeln(fout,'     Distances between atoms (in Angst)');
 FOR iph:=1 TO nph DO IF(lat[iph].nat>1)THEN PrintAtomDistances(iph);
 Exit;
 END;
IF(((mriamode=0)AND(NOT nosavedR))OR((mriamode=2)AND(NOT nosavedS)))THEN
 BEGIN i:=MessageDlg(ressav+' Still save?',MtWarning,[mbYes,mbNo],0);
 IF(i=mrNo)THEN Exit;
 END;
UpdateLatAt; UpdateSpectroInfo;
s:='Rietveld analysis'; IF(mRiPm=2)THEN s:='Powder match';
Writeln(fout,' ':20,s+' of '+spec[numsp].sfn);
CriteriaOut(0); Writeln(fout);
                {Backgr+widths etc out}
s:=' background:'; IF(keyBck=1)THEN s:='Real'+s ELSE s:='Polynomial'+s;
Writeln(fout,s); WITH gfit DO
 BEGIN FOR i:=1 TO 6 DO Write(fout,par[i+3].p:10:2); Writeln(fout);
 Write(fout,'+-'); FOR i:=1 TO 6 DO Write(fout,par[i+3].e:10:2);
 Writeln(fout);
 Writeln(fout,'D0 parameter= ',par[3].p:12:4,' +- ',par[3].e:12:4);
 Writeln(fout,'Sp.Corr. par= ',par[10].p:12:4,' +- ',par[10].e:12:4);
 Writeln(fout,' Parameters:  PhaseScale     W0       W1       W2');
 FOR iph:=1 TO nph DO WITH gfit DO
  BEGIN Write(fout,'  '); i0:=Geti0(iph);
  Writeln(fout,'Phase',iph:1,'   ',par[i0+1].p:10:2,par[i0+8].p:10:2,
   par[i0+9].p:10:2,par[i0+10].p:10:2);
  Writeln(fout,'     +-  ',par[i0+1].e:10:2,par[i0+8].e:10:2,
   par[i0+9].e:10:2,par[i0+10].e:10:2);
  END;
 Writeln(fout);
 END;
                {Cell and Magnetic}
FOR iph:=1 TO nph DO
 BEGIN CellParOut(iph,0); IF(keyma[iph]=1)THEN
  BEGIN GetMagParStrings(iph,strgrT);
  Writeln(fout,strgrT[1]); Writeln(fout);
  FOR i:=1 TO 3 DO Writeln(fout,strgrT[i+1]); Writeln(fout);
  END;
                {Anisotropic}
 IF(anisma[iph])THEN
  BEGIN AnisoParOut(iph,0); Writeln(fout);
  END;
 IF(mriamode=2)THEN
  BEGIN Writeln(fout,'   h   k   l  mul      dk        Area');
  FOR j:=1 TO lat[iph].nhkl DO
   BEGIN {GetSingleFk(j,iph,rc,rs);}
   i0:=Geti0(iph)+10; rc:=ABS(gfit.par[i0+j].p);
    WITH hkla[j,iph] DO
   Writeln(fout,h:4,k:4,l:4,mul:4,dk:10:5,rc:15:4);
   END;
  nosavedS:=false; GOTO Lan;
  END;
 Writeln(fout,' ':20,'Atomic parameters,   phase '+IntToStr(iph));
 FOR iat:=1 TO lat[iph].nat DO WITH atoms[iat,iph] DO
  BEGIN s:='Atom = '+name; Writeln(fout,' ':14,s);
  r:=eoc; IF((iph>1)AND(keyma[iph]=1))THEN r:=0;
  FormSaveStr(occ,r,5,s); Writeln(fout,'Occupation= '+s);
  IF((iph>1)AND(keyma[iph]=1))THEN
   BEGIN FormSaveStr(mgmom,eoc,5,s);
   Writeln(fout,'Mag.moment= '+s);
   END;
  FormSaveStr(x,ex,5,s); Writeln(fout,'X         = '+s);
  FormSaveStr(y,ey,5,s); Writeln(fout,'Y         = '+s);
  FormSaveStr(z,ez,5,s); Writeln(fout,'Z         = '+s);
  FormSaveStr(t11,e11,5,s); Writeln(fout,'T11       = '+s);
  IF(NOT isotr)THEN
   BEGIN FormSaveStr(t12,e12,5,s); Writeln(fout,'T12       = '+s);
   FormSaveStr(t13,e13,5,s); Writeln(fout,'T13       = '+s);
   FormSaveStr(t22,e22,5,s); Writeln(fout,'T22       = '+s);
   FormSaveStr(t23,e23,5,s); Writeln(fout,'T23       = '+s);
   FormSaveStr(t33,e33,5,s); Writeln(fout,'T33       = '+s);
   END;
  END;
 Lan:
 Writeln(fout);
 END;
nosavedR:=false;
END;
PROCEDURE GetMagParStrings(iph:INTEGER; VAR s2:ARRAY OF STRING);
VAR i,j:INTEGER;
BEGIN j:=GetNAddiPar(0)+(iph-1)*3+1; s2[0]:=phas+IntToStr(iph)+amagm;
GetMagMomAngles(iph,1); FOR i:=j TO j+2 DO WITH gfit DO
 BEGIN ConvertStr(par[i].p,8,5); s:=sedz; ConvertStr(par[i].e,7,5);
 s:='Phi_'+Chr(Ord('a')+i-j)+' = '+s+' +-'+sedz;
 ConvertStr(har[i-j+1],6,2); s:=s+' ('+sedz+')'; s2[i-j+1]:=s;
 END;
END;
PROCEDURE SendParClipBrd;
BEGIN MakeMemo(5,290); WITH Form2.Memo1 DO
 BEGIN Lines.Add('SERVER   =   VMRIA');
 Lines.Add('TOPIC    =   PARAMETERS');
 OutputParameters(fout,Form2.Memo1,1); SelectAll; CopyToClipBoard;
 END;
END;
PROCEDURE PrintAtomDistances(iph:INTEGER);
VAR k,kk,ii,i0,iat:INTEGER; x2,y2,z2,vx2,vy2,vz2,rrr,dis,err:REAL;
    a11,a12,a13,a22,a23,a33,e11,e12,e13,e22,e23,e33:REAL;
BEGIN i0:=Geti0(iph)+10; WITH gfit DO
 BEGIN a11:=par[i0+2].p; a22:=par[i0+3].p; a33:=par[i0+4].p;
 a23:=par[i0+5].p; a13:=par[i0+6].p; a12:=par[i0+7].p;
 e11:=par[i0+2].e; e22:=par[i0+3].e; e33:=par[i0+4].e;
 e23:=par[i0+5].e; e13:=par[i0+6].e; e12:=par[i0+7].e;
 IF(nph<>1)THEN Writeln(fout,'Phase =',iph:2);
 FOR iat:=1 TO lat[iph].nat DO
  BEGIN k:=(iat-1)*10+i0+1; FOR ii:=iat+1 TO lat[iph].nat DO
   BEGIN kk:=(ii-1)*10+i0+1; x2:=par[k+1].p-par[kk+1].p;
   y2:=par[k+2].p-par[kk+2].p; z2:=par[k+3].p-par[kk+3].p;
   vx2:=SQR(par[k+1].e)+SQR(par[kk+1].e);
   vy2:=SQR(par[k+2].e)+SQR(par[kk+2].e);
   vz2:=SQR(par[k+3].e)+SQR(par[kk+3].e);
   rrr:=(a11*x2+a12*y2+a13*z2)*x2+(a22*y2+a23*z2)*y2+a33*z2*z2;
   dis:=SQRT(ABS(rrr));
   err:=SQR(x2)*SQR(e11)+SQR(2*x2*a11)*vx2;
   err:=err+SQR(y2)*SQR(e22)+SQR(2*y2*a22)*vy2;
   err:=err+SQR(z2)*SQR(e33)+SQR(2*z2*a33)*vz2;
   err:=(1/AMAX1(dis,0.00001))*SQRT(err);
   Writeln(fout,'Atoms ',iat:3,'(',atoms[iat,iph].name:3,') -',ii:3,'(',
    atoms[ii,iph].name:3,')   Distance= ',dis:8:5,'  Err= ',err:8:5);
   END;
  END;
 Writeln(fout);
 END;
END;
PROCEDURE UpDateParFile;
{To update the parameter file for VMRIA,  Version: Dec 28 2001}
VAR s:STRING; ft:TEXTFILE;
BEGIN IF(nofit[1] AND nofit[3])THEN
 BEGIN ShowMess('No fitting yet performed'); Exit;
 END;
L0rec:='Enter the parameter file name'; L1rec:=' File name';
SaveHelp(UpDParF_n,UpDParF);
s:='If m.res, parameters -> res-file';
OuttoLabel(Form2.Label5,5,150,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=2; indx:=1;
 ar[1]:=' Save to res-file ';
 ar[2]:=' Save to a file ';
 END;
MakeRadioGroup(1,0,20,20,270,80);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i:=RadioGroup1.ItemIndex;
 IF(i=0)THEN  {To res-file}
  BEGIN OutputParameters(fout,Form2.Memo1,0); Exit;
  END;
 END;
s:=parfn; GetFilename(s,1); IF(ModalRes=0)THEN Exit; {To a file}
parfn:=s;
AssignFile(ft,parfn); {$I-} ReWrite(ft); {$I+}; ok:=(IOresult=0);
IF(NOT ok)THEN ShowMess('Wrong filename') ELSE
 BEGIN OutputParameters(ft,Form2.Memo1,0); CloseFile(ft);
 END;
END;
PROCEDURE CheckParameters;
{Purpose: To check whether the initial parameters are correct
 Version: 4 Jun 1990,  delphi = Sep 23 2000}
VAR   i,ii,iph,isp,kph,i0,j0,j,ne:INTEGER; xf,yf,zf,wr:BOOLEAN;
CONST s1:STRING='   atom '; s2:STRING='coordinates for phase ';
 PROCEDURE ChCoo(x:BOOLEAN);
 BEGIN IF(NOT x)THEN
  BEGIN Inc(ne); LB1rec.ar[ne+1]:=s+IntToStr(iph);
  END;
 END;
BEGIN ModalRes:=1; IF(mriamode=2)THEN Exit; ne:=0;
FOR iph:=1 TO nph DO WITH LB1rec DO{Check for atoms}
 BEGIN i0:=Geti0(iph); j0:=i0+10;
 {Check for occupations} wr:=false; FOR i:=1 TO lat[iph].nat DO
  BEGIN kph:=j0+(i-1)*10+1; WITH parar[kph] DO IF(pl=pu)THEN wr:=true;
  END;
 s:='   occupations for phase '; ChCoo(wr);
 {Check for coordinate parameters}
 xf:=false; yf:=false; zf:=false; FOR i:=1 TO lat[iph].nat DO
  BEGIN kph:=j0+(i-1)*10+2; WITH parar[kph] DO IF(pl=pu)THEN xf:=true;
  WITH parar[kph+1] DO IF(pl=pu)THEN yf:=true;
  WITH parar[kph+2] DO IF(pl=pu)THEN zf:=true;
  END;
 s:=s1+'X-'+s2; ChCoo(xf); s:=s1+'Y-'+s2; ChCoo(yf);
 s:=s1+'Z-'+s2; ChCoo(zf);
 {Check for isotropic thermal parameters}
 wr:=false; FOR i:=1 TO lat[iph].nat DO
  BEGIN kph:=j0+(i-1)*10+5; {FOR j:=0 TO 5 DO} WITH parar[kph{+j}] DO
   IF(pl=pu)THEN wr:=true;
  END;
 s:='   thermal parameters for phase '; ChCoo(wr);
 IF(ne>0)THEN ar[1]:='Warning! There are no fixed:' ELSE ar[1]:=' ';
 {Check for scatterings} FOR i:=1 TO lat[iph].nat DO
  WITH atoms[i,iph] DO IF((scat=0)AND(keyma[iph]<>1))THEN
   BEGIN Inc(ne); ar[ne+1]:='* '+name+' has 0-scattering';
   END;
 IF(keyma[iph]=1)THEN
  BEGIN j:=GetNAddiPar(0)+(iph-1)*3; wr:=true;
  FOR i:=1 TO 3 DO WITH parar[j+i] DO IF(pl=pu)THEN wr:=false;
  IF(wr)THEN
   BEGIN Inc(ne); ar[ne+1]:='Error, one of h0, k0, l0 should be fixed';
   END;
  END;
 END;
{Get n_par and check: n_par < n_reflection?}
FOR iph:=1 TO nph DO WITH gfit DO WITH LB1rec DO
 BEGIN i0:=Geti0(iph); kph:=0; ii:=10*lat[iph].nat;
 FOR j:=2 TO 7 DO WITH par[j+i0] DO
  IF((pl<>pu)AND((j+i0)=n))THEN Inc(kph); j0:=i0+10;
 FOR j:=1 TO ii DO WITH par[j+j0] DO
  IF((pl<>pu)AND((j+j0)=n))THEN Inc(kph);
 IF(kph>lat[iph].nhkl)THEN
  BEGIN Inc(ne); ar[ne+1]:='* Phase'+IntToStr(iph)+' has '+
  IntToStr(kph)+' free cryst.parameters';
  Inc(ne); ar[ne+1]:='         - more than reflections';
  END;
 END;
IF(ne=0)THEN Exit;
L0rec:=''; MakeForm(1); LB1rec.nitems:=ne+1;
MakeListBox(10,10,320,360); Form2.ShowModal;
END;
PROCEDURE NumberEffPeaks(VAR reff:REAL);
{Number of efficiently measured peaks, Version Aug 8 2001}
VAR i,j,k,iph,ncl:INTEGER; w,d,ch,p_k,p_i,reffp:REAL;
BEGIN ncl:=0; FOR iph:=1 TO nph DO
FOR i:=1 TO lat[iph].nhkl DO WITH hkla[i,iph] DO
 BEGIN d:=dk; ch:=spec[numsp].dtoch(d); Inc(ncl); onl[ncl]:=ch;
 END;
marran(ncl,1); marran(ncl,0); w:=spec[1].w0; IF(w<1)THEN w:=1;
reff:=0; FOR k:=1 TO ncl DO
 BEGIN p_k:=onl[k]; reffp:=0;
 FOR j:=1 TO ncl DO IF(k<>j)THEN p_i:=onl[j]; IF(ABS(p_k-p_i)<(3*w))THEN
  reffp:=reffp+EXP(-AMIN1(SQR((p_k-p_i)/w)*0.5,77));
 reff:=reff+1/(1+reffp);
 END;
END;
PROCEDURE LoadParClipBrd;
BEGIN {MakeMemo(5,290); WITH Form2.Memo1 DO
 BEGIN Lines.Add('SERVER   =   VMRIA');
 Lines.Add('TOPIC    =   PARAMETERS');
 OutputParameters(fout,Form2.Memo1,1); SelectAll; CopyToClipBoard;
 END;}
END;

END.

IF(anis_mod)THENE
{IF(keyWdt IN [0..2])THEN FOR iph:=1 TO nph DO anisma[iph]:=false;
IF(keyWdt=3)THEN
 BEGIN L0rec:=''; MakeForm(1);
 q3:=100000; q1:=-q3;
 FOR iph:=1 TO nph DO IF(anisma[iph])THEN
  BEGIN s:='Phase '+IntToStr(iph);
  OuttoLabel(Form2.Label5,60,15,clMaroon,clWhite,s);
  s:='Set anisotropic width coefficients + limits';
  OuttoLabel(Form2.Label6,5,28,clMaroon,clWhite,s);
  OuttoLabel(Form2.Label8,75,70,clMaroon,clWhite,
  ' lower lim. coefficient   upper lim.');
  strgrW[0]:=50; strgrW[1]:=80; strgrW[2]:=80; strgrW[3]:=80;
  strgrT[1]:=' c_h'; strgrT[3]:=' c_l'; strgrT[2]:=' c_k';
  FOR j:=1 TO 3 DO
   BEGIN strgrNn[j,1]:=dcanal[iph,j]; strgrNn[j,2]:=lat[iph].canhkl[j];
   strgrNn[j,3]:=dcanau[iph,j];
   END;
  PuttoTable(10,88,3,3,3,8);
  Form2.ShowModal; IF(ModalRes=0)THEN Exit;
  FOR i:=1 TO 3 DO Zval(Form2.StringGrid1.Cells[1,i-1],har[i]);
  FOR i:=1 TO 3 DO lat[iph].canhkl[i]:=har[i];
  FOR i:=1 TO 3 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
  FOR i:=1 TO 3 DO dcanal[iph,i]:=har[i];
  FOR i:=1 TO 3 DO Zval(Form2.StringGrid1.Cells[2,i-1],har[i]);
  FOR i:=1 TO 3 DO dcanau[iph,i]:=har[i];
  END;
 END;}
 {r:=morr[1]; FOR i:=1 TO 193 DO r:=AMAX1(r,ABS(morr[i]));
 FOR i:=2 TO 192 DO sd[i]:=(morr[i-1]-2*morr[i]+morr[i+1])/r*1000;
 sd[1]:=0; sd[193]:=0; pmod[0].ndsign:=false; pmod[0].camod_Make(193);}

