UNIT vmriatr;

INTERFACE

USES Windows, Messages, SysUtils, Classes,  Graphics, Controls, Forms,
     Dialogs, StdCtrls, ExtCtrls, Grids,    vzlocom,  vmria0,   vmria2,
     vmriasp, vmriarit, vgfit,    vmriahlp, varfun,   vspectr,  vpeaksr,
     vstdcons,vmria00;

PROCEDURE DefineBounds(VAR i1,i2:INTEGER);
PROCEDURE NormalizeSpectrum;
FUNCTION absorb(ich,isp:INTEGER; aa1,aa2:REAL; mode:INTEGER):REAL;
PROCEDURE DoNormalizing(im,isp:INTEGER; VAR i1,i2:INTEGER);
PROCEDURE CalculateAbsorpCoefs;
PROCEDURE FittheTailofEfficSpectrum;
PROCEDURE CorrectforAbsorption(isp,i1,i2:INTEGER);
PROCEDURE SpectrumArithmetic;
PROCEDURE EventsToSpectrum;
PROCEDURE SpectrumFunctions;
PROCEDURE CompresstheSpectrum(ll,ns:INTEGER);
PROCEDURE CorrectOutliers;
PROCEDURE MakeABSFourier(ns:INTEGER);
PROCEDURE SmoothingOperation(mo,ns:INTEGER);
PROCEDURE InterpolateSpectrum(iout,i1,i2:INTEGER);
PROCEDURE SpecialAnalysis(iout,i1,i2:INTEGER);
PROCEDURE S_d_To_S_ch(iout,i1,i2,mo:INTEGER);

VAR sfindx,saindx,resindx,ii1,ii2,is1,is2:INTEGER;
    errsp:BOOLEAN = false;    {errors or counts }
    subtenv:BOOLEAN = false;  {subtract envelope?}
    supprneg:BOOLEAN = false; {suppress negative?}
    findper:BOOLEAN  = false; {find period.?}
    makesmo:BOOLEAN  = false; {Fourier smooth.?}
    rfou:REAL        = 0.5;   {fraction for Fourier smooth.}

IMPLEMENTATION
PROCEDURE S_d_To_S_ch(iout,i1,i2,mo:INTEGER);
{mo=0: S(d) -> S(chan)    mo=1: S(chan) -> S(d)}
VAR   i,j,k,iou:INTEGER; dc,d1,d2,a,b,v:REAL;
BEGIN iou:=iout; IF(iout=numsp)THEN
 BEGIN s:='Current spectrum is output one.'+
  ' Can spectrum 4 be used as buffer? If no, abort.';
 i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0); IF(i=mrNo)THEN Exit; iou:=4;
 END;
IF(mo=0)THEN FOR i:=is1 TO is2 DO WITH spec[numsp] DO
 IF(NOT rinfun(x[i],0.1,100))THEN
  BEGIN ShowMess('Spectrum is no d-one. Check it'); Exit;
  END;
FOR i:=i1 TO i2 DO WITH spec[iou] DO
 BEGIN y[i]:=0; e[i]:=0;
 END;
a:=(i2-i1)/(is2-is1); b:=i1-a*is1; d1:=0; d2:=0;
FOR i:=is1 TO is2 DO WITH spec[numsp] DO
 BEGIN v:=y[i]/100; err:=e[i]/100; d1:=d1+y[i];
 FOR j:=1 TO 100 DO
  BEGIN r:=Float(i)+0.01*j; k:=Round(a*r+b)+1;
  IF(infun(k,i1,i2))THEN WITH spec[iout] DO
   BEGIN y[k]:=y[k]+v; e[k]:=e[k]+err;
   END;
  END;
 dc:=x[i]; IF(mo=1)THEN dc:=chtod(i); k:=Round(a*i+b)+1;
 IF(infun(k,i1,i2))THEN spec[iout].x[k]:=dc;
 {Writeln(fout,i:5,k:5,x[k]:11:4,y[k]:11:4,a:10:4,b:10:3,dc:10:3);}
 END;
FOR i:=i1 TO i2 DO WITH spec[iout] DO d2:=d2+y[i];
ShowMess(FloatToStr(d1)+'   '+FloatToStr(d2));
IF(iou=4)THEN CopySpectrum(4,iout);
WITH spec[iout] DO
 BEGIN FOR i:=1 TO i1-1 DO y[i]:=0; FOR i:=i2+1 TO nspch DO y[i]:=0;
 a1:=i1; a2:=i2; fismax1; a11:=a1; a22:=a2; spin:=true;
 delay:=delay+is1-i1; chw:=chw*a;
 END;
END;
PROCEDURE MakeABSFourier(ns:INTEGER);
VAR i,k,i1,i2,m,m2,n1,n2:INTEGER; r,d:REAL;
BEGIN i1:=spec[numsp].a11; i2:=spec[numsp].a22; m:=i2-i1+1;
IF(m >= 16384)THEN
 BEGIN s:='Interval too long. Set it to 16384 ?';
 i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0); IF(i=mrNo)THEN Exit;
 i2:=MIN0(i1+16384-1,i2); m:=i2-i1+1;
 END;
FOR i:=i1 TO i2 DO
 BEGIN arr[i-i1+1]:=spec[numsp].y[i]; ari[i-i1+1]:=0;
 END;
n1:=0; n2:=0; sfft(m,1,n1,n2);
m:=n1*n2; m2:=m DIV 2; FOR i:=1 TO m2 DO
 BEGIN r:=AMAX1(ABS(orr[i]),ABS(ori[i]));
 IF(r<>0)THEN d:=SQRT(SQR(orr[i]/r)+SQR(ori[i]/r));
 spec[ns].y[i]:=d*r; spec[ns].e[i]:=1; onl[i]:=d*r;
 END;
WITH spec[ns] DO
 BEGIN a1:=1; a2:=m2; fismax1; a11:=a1; a22:=a2; spin:=true;
 END;
sinf:='|Fourier| -> spectr.'+IntToStr(ns);

IF(findper)THEN
 BEGIN IF(NOT psclass)THEN peaksr:=TPeakSearch.Create; psclass:=true;
 peaksr.FindPeriods(m2,3,5,1); L0rec:=''; MakeFormV(250,20,330,430,1);
 ListBsav:=false; s:='Periods detected';
 OuttoLabel(Form2.Label5,5,10,clMaroon,clWhite,s); WITH LB1rec DO
  BEGIN ar[1]:='    area     pos  width  period';
  nitems:=nper+1; FOR i:=1 TO nper DO WITH peria[i] DO
   BEGIN ConvertStr(area,8,1); s:=sedz;
   ConvertStr(pos,8,1); s:=s+sedz; ConvertStr(width,7,1); s:=s+sedz;
   ConvertStr(per,8,1); s:=s+sedz; ar[i+1]:=s;
   END;
  END;
  MakeListBox(10,25,290,330); Form2.ShowModal;
 END;

IF(makesmo)THEN
 BEGIN CopySpectrum(numsp,4); k:=MIN0(m2-3,Round(m*rfou/2));
 IF(Even(m))THEN
  BEGIN orr[m2+1]:=0; ori[m2+1]:=0; FOR i:=2 TO k DO
   BEGIN j:=m2-i+2; orr[j]:=0; ori[j]:=0;
   j:=m2+i+1; orr[j]:=0; ori[j]:=0;
   END;
  END      ELSE FOR i:=1 TO k DO
   BEGIN j:=m2-i+1; orr[j]:=0; ori[j]:=0;
   j:=m2+i; orr[j]:=0; ori[j]:=0;
   END;
 FOR i:=1 TO m DO
  BEGIN arr[i]:=orr[i]; ari[i]:=ori[i];
  END;
 sfft(m,-1,n1,n2);
 {FOR i:=1 TO m DO Writeln(fout,i:5,spec[1].y[i]:10:0,orr[i]:10:0);}
 FOR i:=1 TO m DO
  BEGIN r:=AMAX1(ABS(orr[i]),ABS(ori[i]));
  IF(r<>0)THEN d:=SQRT(SQR(orr[i]/r)+SQR(ori[i]/r));
  spec[4].y[i1+i-1]:=d*r; spec[4].e[i1+i-1]:=1;
  spec[3].y[i1+i-1]:=orr[i];
  END;
 sinf:=sinf+'.   Smooth -> spectr.4';
 END;
END;
PROCEDURE SpectrumFunctions;
VAR   i,j,im,iout,ll,n:INTEGER;
LABEL L1;
BEGIN IF(spec[numsp].NoSpectrum(numsp))THEN Exit; sinf:='';
L1: L0rec:='Function of Spectrum '+IntToStr(numsp);
MakeForm(1); SaveHelp(SpFunc_n,SpFunc);
s:=SelOps; OuttoLabel(Form2.Label5,5,5,clMaroon,clWhite,s);
IF(sinf<>'')THEN OuttoLabel(Form2.Label9,5,320,clBlue,clWhite,sinf);
WITH CB1rec DO
 BEGIN nitems:=8; indx:=sfindx;
 ar[1]:='Compress the spectrum';
 ar[2]:='Correct the marked outliers';
 ar[3]:='Smooth the spectrum';
 ar[4]:='Build the envelope from below';
 ar[5]:='Make ABS of Fourier transform';
 ar[6]:='Interpolate the spectrum';
 ar[7]:='Special analysis';
 ar[8]:='       E X I T';
 END;
MakeRadioGroup(1,0,20,25,280,240);
s:='To shift the spectrum click on Interpolate,';
OuttoLabel(Form2.Label8,5,280,clMaroon,clWhite,s);
s:='To convert Sp(chan) to Sp(d) click on Interpolate';
OuttoLabel(Form2.Label7,5,300,clMaroon,clWhite,s);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit; j:=RadioGroup1.ItemIndex;
 END;
IF(j=7)THEN Exit; L0rec:=CB1rec.ar[j+1]; MakeForm(1);
CB1rec:=Num4Rec; CB1rec.indx:=resindx;
s:=' Put the result to Spectrum: ';
OuttoLabel(Form2.Label6,50,20,clMaroon,clWhite,s);
MakeRadioGroup(2,0,245,0,70,100);

strgrW[0]:=150; strgrW[1]:=90; s:=' Enter auxiliary data ';
OuttoLabel(Form2.Label7,50,100,clMaroon,clWhite,s); n:=3;
FOR i:=1 TO 5 DO
 BEGIN strgrT[i]:=' '; strgrNn[i,1]:=0;
 END;
strgrT[2]:=' Interval_I1 ';  strgrNn[2,1]:=spec[numsp].a11;
strgrT[3]:=' Interval_I2 ';  strgrNn[3,1]:=spec[numsp].a22;
IF(j=0)THEN
 BEGIN strgrT[1]:=' Compressor= '; strgrNn[1,1]:=2;
 strgrNn[2,1]:=spec[numsp].a1; strgrNn[3,1]:=spec[numsp].a2;
 END;
IF(j=1)THEN
 BEGIN strgrT[1]:=' Marked points= '; strgrNn[1,1]:=npeak;
 END;
IF(j IN [2..3])THEN
 BEGIN strgrT[1]:=' Smoother= '; strgrNn[1,1]:=rsmooth;
 END;
IF(j=4)THEN
 BEGIN strgrT[1]:=' Fraction for smooth '; strgrNn[1,1]:=rfou;
 END;
IF(j IN [5..6])THEN
 BEGIN strgrT[4]:=' New I1 = '; strgrNn[4,1]:=spec[numsp].a1;
 strgrT[5]:=' New I2 = '; strgrNn[5,1]:=spec[numsp].a2; n:=5;
 strgrNn[2,1]:=spec[numsp].a1; strgrNn[3,1]:=spec[numsp].a2;
 END;
PuttoTable(10,118,n,n,1,8);
IF(j=3)THEN  {Envel.}
 BEGIN WITH CB1rec DO
  BEGIN nitems:=1; ar[1]:=' Subtract envelope, result to Spectrum 4';
  END;
 MakeCheckListBox(5,250,315,20);
 Form2.CheckListBox1.Checked[0]:=subtenv;
 END;
IF(j=4)THEN  {Four.}
 BEGIN WITH CB1rec DO
  BEGIN nitems:=2; ar[1]:=' Find periodicities';
  ar[2]:=' Restore smoothed data';
  END;
 MakeCheckListBox(5,250,315,40);
 Form2.CheckListBox1.Checked[0]:=findper;
 Form2.CheckListBox1.Checked[1]:=makesmo;
 END;
IF(j=5)THEN {Interpol.}
 BEGIN WITH CB1rec DO
  BEGIN nitems:=3; indx:=1;
  ar[1]:=' Simple interpolation';
  ar[2]:=' Spectrum(d) -> Spectrum(chan)';
  ar[3]:=' Spectrum(chan) -> Spectrum(d)';
  END;
 s:=' Select the interpolation mode ';
 OuttoLabel(Form2.Label8,50,233,clMaroon,clWhite,s);
 MakeRadioGroup(1,0,30,250,250,80);
 END;

WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 im:=RadioGroup1.ItemIndex; iout:=RadioGroup2.ItemIndex+1;
 sfindx:=j+1; resindx:=iout;
 FOR i:=1 TO 5 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 ll:=MAX0(Round(har[1]),1);
 IF(j IN [2..3])THEN rsmooth:=har[1];
 IF(j=3)THEN subtenv:=CheckListBox1.Checked[0];
 IF(j=4)THEN
  BEGIN findper:=CheckListBox1.Checked[0];
  makesmo:=CheckListBox1.Checked[1]; rfou:=AMIN1(har[1],1);
  END;
 IF(j IN [5..6])THEN
  BEGIN ii1:=MAX0(1,Round(har[4])); ii2:=MIN0(nintmax,Round(har[5]));
  IF(ii2<=ii1)THEN
   BEGIN ShowMess('Wrong new spectrum bounds'); Exit;
   END;
  END;
 END;
CopySpectrum(numsp,iout);
CASE j OF
0: CompresstheSpectrum(ll,iout);
1: CorrectOutliers;
2: SmoothingOperation(0,iout);
3: SmoothingOperation(1,iout);
4: MakeABSFourier(iout);
5: BEGIN is1:=Round(har[2]); is2:=Round(har[3]);
   IF(im=1)THEN S_d_To_S_ch(iout,ii1,ii2,0) ELSE
   IF(im=2)THEN S_d_To_S_ch(iout,ii1,ii2,1) ELSE
    InterpolateSpectrum(iout,ii1,ii2);
   END;
6: SpecialAnalysis(iout,ii1,ii2);
ELSE END;
sfindx:=8; GOTO L1;
END;
PROCEDURE SpectrumArithmetic;
VAR   i,j,k,iop,i1,i2:INTEGER; r:REAL; ss:STRING;
LABEL L1;
BEGIN SaveHelp(SpArith_n,SpArith);
L1: L0rec:='Spectrum arithmetic'; MakeForm(1);
OuttoLabel(Form2.Label6,5,5,clGreen,clAqua,selops);
WITH CB1rec DO
 BEGIN nitems:=12; indx:=saindx;
 ar[1]:='Move the spectra';
 ar[2]:='   Add the spectra';
 ar[3]:='   Subtract the spectra';
 ar[4]:='   Multiply the spectra';
 ar[5]:='   Divide the spectra';
 ar[6]:='Make constant spectrum/errors';
 ar[7]:='Operation: spectrum * constant';
 ar[8]:='   Exchange 2 spectra';
 ar[9]:='Turn errors to counts';
 ar[10]:='LN of the spectrum';
 ar[11]:='  Make Poisson variance';
 ar[12]:='           E X I T ';
 END;
MakeRadioGroup(1,0,30,25,250,340);
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
iop:=Form2.RadioGroup1.ItemIndex; L0rec:=CB1rec.ar[iop+1];
MakeForm(1); saindx:=iop+1; IF(iop=11)THEN
 BEGIN numsp:=1; Exit;
 END;
CASE iop OF
0: s:='sp_i  - > sp_j';
1..4: s:='sp_i * sp_j -> sp_4';
5: s:=' c  - > sp_i';
6: s:='sp_i * c  - > sp_i';
7: s:='sp_i < - > sp_j';
8: s:='sp_i.e < - > sp_j.y';
9: s:='ln( sp_i)  - > sp_i';
10: s:='sqrt( sp_i)  - > err_i';
ELSE END; ss:=s; s:='  '+s+'  ';
OuttoLabel(Form2.Label6,100,10,clMaroon,clWhite,s);
s:='Spectrum '; WITH CB1rec DO
 BEGIN nitems:=5; indx:=numsp+1;
 ar[1]:='   Eff.'+s; FOR i:=1 TO 4 DO ar[i+1]:=s+IntToStr(i);
 END;
OuttoLabel(Form2.Label5,10,40,clGreen,clWhite,'Select sp i');
MakeRadioGroup(1,0,5,70,135,120);
IF(NOT(iop IN [5,6,9,10]))THEN
 BEGIN CB1rec.indx:=3; MakeRadioGroup(2,0,165,70,135,120);
 OuttoLabel(Form2.Label7,190,40,clGreen,clWhite,'Select sp j');
 IF(iop=2)THEN
  BEGIN WITH CB1rec DO
   BEGIN nitems:=1; ar[1]:='Suppress negative values in difference';
   END;
  MakeCheckListBox(5,250,300,20);
  Form2.CheckListBox1.Checked[0]:=supprneg;
  END;
 END;
IF((iop=5)OR(iop=6))THEN
 BEGIN L1rec:=' Constant = '; E1rec:='1'; MakeEdits(80,180,340,70,1);
 END;
IF(iop IN [5,6])THEN
 BEGIN WITH CB1rec DO
  BEGIN nitems:=1; ar[1]:=' Apply operation to errors';
  END;
 MakeCheckListBox(30,315,250,20); Form2.CheckListBox1.Checked[0]:=errsp;
 END;
IF(iop=6)THEN
 BEGIN WITH CB1rec DO
  BEGIN nitems:=6; indx:=5;
  ar[1]:=' + const';
  ar[2]:=' - const (res>0)';
  ar[3]:=' * const';
  ar[4]:=' / const';
  ar[5]:=' - min';
  ar[6]:=' shift C';
  END;
 OuttoLabel(Form2.Label7,170,60,clBlue,clWhite,' Select operation ');
 MakeRadioGroup(2,0,165,90,135,140);
 END;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i1:=RadioGroup1.ItemIndex; i2:=RadioGroup2.ItemIndex;
 IF(iop=2)THEN supprneg:=CheckListBox1.Checked[0];
 IF(iop IN [5,6])THEN
  BEGIN s:=Edit1.Text; Zval(s,r); errsp:=CheckListBox1.Checked[0];
  END;
 END;
IF((iop<>5)AND(spec[i1].NoSpectrum(i1)))THEN Exit;
IF(iop IN [1,2,3,4,7])THEN
 IF((spec[i1].NoSpectrum(i1))OR(spec[i2].NoSpectrum(i2)))THEN Exit;
amn:=1E15; IF((iop=6)AND(i2=4))THEN WITH spec[i1] DO
 FOR i:=a1 TO a2 DO amn:=AMIN1(amn,y[i]);
IF(iop=0)THEN CopySpectrum(i1,i2);
IF(iop IN [1..4])THEN CopySpectrum(i1,4);
FOR i:=spec[i1].a1 TO spec[i1].a2 DO
 CASE iop OF
 0: BEGIN spec[i2].y[i]:=spec[i1].y[i]; spec[i2].e[i]:=spec[i1].e[i];
    END;
 1: BEGIN spec[4].y[i]:=spec[i1].y[i]+spec[i2].y[i];
    spec[4].e[i]:=SQRT(SQR(spec[i1].e[i])+SQR(spec[i2].e[i]));
    END;
 2: BEGIN r:=spec[i1].y[i]-spec[i2].y[i];
    IF(supprneg)THEN r:=AMAX1(r,0); spec[4].y[i]:=r;
    spec[4].e[i]:=SQRT(SQR(spec[i1].e[i])+SQR(spec[i2].e[i]));
    END;
 3: BEGIN spec[4].y[i]:=spec[i1].y[i]*spec[i2].y[i]; spec[4].e[i]:=
     SQRT(SQR(spec[i2].y[i]*spec[i1].e[i])+SQR(spec[i1].y[i]*
     spec[i2].e[i]));
    END;
 4: IF(spec[i2].y[i]=0)THEN
     BEGIN spec[4].y[i]:=0; spec[1].e[i]:=0;
     END                ELSE
     BEGIN spec[4].y[i]:=spec[i1].y[i]/spec[i2].y[i];
     spec[4].e[i]:=
      SQRT(SQR(spec[i2].y[i]*spec[i1].e[i])+SQR(spec[i1].y[i]
       *spec[i2].e[i]))/AMAX1(SQR(spec[i2].e[i]),1);
     END;
 5: IF(NOT errsp)THEN
     BEGIN spec[i1].y[i]:=r; spec[i1].e[i]:=1;
     END    ELSE spec[i1].e[i]:=r;
 6: BEGIN ff:=spec[i1].y[i]; err:=spec[i1].e[i];
    CASE i2 OF
    0: ff:=ff+r;
    1: ff:=AMAX1(ff-r,0);
    2: BEGIN ff:=ff*r; err:=err*r;
       END;
    3: IF(r<>0)THEN
        BEGIN ff:=ff/r; err:=err/r;
        END;
    4: ff:=AMAX1(ff-amn,0);
    5: WITH spec[i1] DO
        BEGIN j:=i; IF(r>0)THEN j:=a2-i+1; k:=Round(r);
        IF(infun(j+k,1,nspch))THEN
         BEGIN y[j+k]:=y[j]; e[j+k]:=e[j]; y[j]:=0; e[j]:=0;
         END;
        END;
    ELSE END;
    WITH spec[i1] DO IF(i2 IN [0..4])THEN
     IF(NOT errsp)THEN
      BEGIN y[i]:=ff; e[i]:=err;
      END     ELSE e[i]:=err         ELSE ;
    END;
 7: BEGIN ZExchange(spec[i1].y[i],spec[i2].y[i]);
    ZExchange(spec[i1].e[i],spec[i2].e[i]);
    ZExchange(spec[i1].x[i],spec[i2].x[i]);
    END;
 8: spec[i2].y[i]:=spec[i1].e[i];
 9: BEGIN r:=ABS(spec[i1].y[i])+1; spec[i1].y[i]:=LN(r);
    spec[i1].e[i]:=(1/r)*spec[i1].e[i];
    END;
 10: spec[i1].e[i]:=SQRT(ABS(spec[i1].y[i]+1));
 ELSE END;
CASE iop OF
1..4: spec[4].fismax1;
5: BEGIN spec[i1].spin:=true; spec[i1].fismax1;
   END;
0,7,8: BEGIN spec[i2].spin:=true; spec[i1].fismax1; spec[i2].fismax1;
   IF(iop=0)THEN WITH spec[i2] DO
    BEGIN a1:=spec[i1].a1; a2:=spec[i1].a2;
    a11:=spec[i1].a11; a22:=spec[i1].a22;
    END;
       END;
ELSE spec[i1].fismax1; END;
saindx:=12;
Writeln(fout,'I1,I2= '+IntToStr(i1)+','+IntToStr(i2)+'  '+ss);
GOTO L1;
END;
PROCEDURE InterpolateSpectrum(iout,i1,i2:INTEGER);
VAR i,j,m:INTEGER; a,b,x,v:REAL;
BEGIN m:=is2-is1+1; i:=nintmax DIV 2; WITH spec[numsp] DO
 IF((a2-a1)>i)THEN
  BEGIN is2:=i+is1-1;
  ShowMess('Interpolated array too long; cut to '+IntToStr(i));
  END;
FOR i:=is1 TO is2 DO
 BEGIN j:=i-is1+1; onl[j]:=spec[numsp].y[i]; onl[j+m]:=j;
 END;
a:=i2-i1; a:=(is2-is1)/a; b:=i1-a*is1;
FOR i:=i1 TO i2 DO
 BEGIN x:=a*i+b; lapin(onl,m,x,v); spec[iout].y[i]:=v;
 spec[iout].e[i]:=a*spec[numsp].e[i];
 END;
WITH spec[iout] DO
 BEGIN a1:=i1; a2:=i2; fismax1; a11:=a1; a22:=a2; spin:=true;
 END;
END;
PROCEDURE SmoothingOperation(mo,ns:INTEGER);
VAR   m1,m,i,i1,i2,kx,kn,lx:INTEGER; amx,amn:REAL;
      mof:INTEGER; sta:BOOLEAN; indi:STRING[5];
      {mo=0 -> smoothing,   mo=1 -> envelope}
LABEL L1,Lend;
BEGIN lx:=upintx; {IF(mo=1)THEN lx:=lx*2;} sta:=true; mof:=3;
WITH spec[numsp] DO
 BEGIN ic1:=a11; ic2:=a22;
 END;
Bitmap:=TBitmap.Create; WITH Bitmap DO
 BEGIN Width:=exs(516); Height:=exs(323);
 END;
REPEAT i1:=ic1;
L1: i2:=MIN0(i1+lx-1,ic2); m:=i2-i1+1;
FOR i:=i1 TO i2 DO sa[i-i1+1]:=spec[numsp].y[i];
IF((ic2-ic1+1)>lx)THEN
 BEGIN m1:=MIN0(1+(m DIV 3)*2,m); FindMxn(sa,m1,m,amx,amn,kx,kn);
 i2:=i1+kn-1;
 END;
m:=i2-i1+1; IF(sta)THEN
 BEGIN IF(mo=1)THEN AutoEnvelope(m,10)
               ELSE AutoSmooth(m,rsmooth,2,ok);
 rsmooth:=qq.q1; sta:=false;
 END;
IF(mo=1)THEN GetEnvelope(m,10,rsmooth,0.5,0.5)
        ELSE smooth(m,0,rsmooth,q1,q2);
FOR i:=i1 TO i2 DO spec[ns].y[i]:=sd[i-i1+1];
i1:=i2+1; IF(i1<ic2)THEN GOTO L1;  {Loop end}
IF((mo=1)AND(subtenv))THEN WITH spec[numsp] DO FOR i:=a11 TO a22 DO
 BEGIN spec[4].y[i]:=AMAX1(0,y[i]-spec[ns].y[i]);
 spec[4].e[i]:=e[i]; spec[4].x[i]:=x[i];
 END;
WITH spec[ns] DO
 BEGIN a11:=ic1; a22:=ic2; spin:=true; fismax1;
 END;
L0rec:=' Graph of both spectra'; MakeFormV(90,0,530,450,0);
s:=' Set the smoother '; OuttoLabel(Form2.Label5,5,5,clGreen,clWhite,s);
strgrW[0]:=110; strgrW[1]:=90;
strgrT[1]:=' Smoother= '; strgrNn[1,1]:=rsmooth;
PuttoTable(35,25,1,1,1,10);
WITH CB1rec DO
 BEGIN nitems:=3; indx:=mof;
 ar[1]:=' Less smoothing'; ar[2]:=' More smoothing';
 ar[3]:=' Quit + Put Res to Spec'+IntToStr(ns);
 END;
MakeRadioGroup(1,0,280,0,230,80);
indi:=bblank; indi[numsp+1]:='x'; indi[ns+1]:='x'; ssmaxn(indi,amx,amn);

WITH Form2.Image2.Canvas DO
 BEGIN Brush.Style:=bsSolid; Brush.Color:=0;
 FillRect(Rect(0,0,exs(516),exs(300)));
 END;
Form2.Image2.Visible:=true; {pixelm:=0;}
MakeBMGraph(amx,amn,indi); Form2.Image2.Canvas.Draw(0,0,Bitmap);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN GOTO Lend;
 mof:=RadioGroup1.ItemIndex+1; s:=IntToStr(ns); IF(mof=3)THEN
  BEGIN IF(mo=0)THEN s:='The smooothed spectrum 1 put to spectrum '+s
                ELSE s:='Envelope from below put to spectrum '+s;
  sinf:=s; GOTO Lend;
  END;
 IF(mof=1)THEN rsmooth:=rsmooth*1.5 ELSE rsmooth:=rsmooth/1.5;
 END;
UNTIL false;
Lend: Bitmap.Free;
IF((mo=1)AND(subtenv))THEN WITH spec[4] DO
 BEGIN a11:=ic1; a22:=ic2; CopySpectrVar(numsp,4); fismax1;
 END;
END;
PROCEDURE FittheTailofEfficSpectrum;
VAR i,j,k,iter,i1,i2,nit:INTEGER;
 PROCEDURE deriv(i:INTEGER);
 BEGIN r:=i-i1; r:=r/(i2-i1+1);
 ffr[1]:=1; ffr[2]:=EXP(-r*pa[3]); ffr[3]:=-r*pa[2]*ffr[2];
 fth:=pa[1]+pa[2]*EXP(-r*pa[3]);
 END;
LABEL Lagain;
BEGIN step:=0.5; IF(NOT spec[0].spin)THEN
 BEGIN ShowMess('No eff. spectrum'); Exit;
 END;
IF((grst<>0)AND(numsp<>0))THEN
 ShowMess('Warning, the graphed spectrum is not effective');
WITH spec[0] DO
 BEGIN FOR i:=a1+250 TO a2 DO IF(y[i]<(spx*0.05))THEN
  BEGIN i1:=i; BREAK;
  END;
 L0rec:='Fitting Effective Spectrum Tail';
 MakeForm(1); SaveHelp(FitET_n,FitET);
 WITH CB1rec DO
  BEGIN nitems:=1; ar[1]:='Replace the tail of eff. spectrum';
  END;
 MakeCheckListBox(10,150,280,30);
 strgrW[0]:=180; strgrW[1]:=100;
 strgrT[1]:=' Tail beginning (chan.)= '; strgrNn[1,1]:=i1;
 strgrT[2]:=' Number of iterations= '; strgrNn[2,1]:=25;
 strgrT[3]:=' Step in iterations= '; strgrNn[3,1]:=step;
 PuttoTable(10,210,3,3,1,8);
 WITH Form2 DO
  BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
  FOR i:=1 TO 3 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
  i1:=Round(har[1]); nit:=Round(har[2]);
  step:=AMAX1(0.00001,AMIN1(har[3],1));
  END;
 pa[1]:=spn; pa[2]:=AMAX1(spec[0].y[i1]-spn,spn); pa[3]:=3;
  chio:=1E10;
 i1:=MAX0(i1,2); i2:=MAX0(a22,a2-2);
 Lagain: FOR iter:=1 TO nit DO
  BEGIN chi:=0; FOR i:=1 TO 3 DO
   BEGIN vec3[i]:=0; FOR j:=1 TO 3 DO mat3[i,j]:=0;
   END;
  FOR j:=i1 TO i2 DO
   BEGIN fex:=spec[0].y[j]; sigi:=0.01; deriv(j);
   FOR i:=1 TO 3 DO
    BEGIN vec3[i]:=vec3[i]+sigi*(fex-fth)*ffr[i];
    FOR k:=1 TO 3 DO mat3[i,k]:=mat3[i,k]+sigi*ffr[i]*ffr[k];
    END;
   chi:=chi+sigi*SQR(fex-fth);
   END;
  FOR i:=1 TO 3 DO mat3[i,i]:=mat3[i,i]*1.1; InvertMatrix3(ok,true,det);
  IF(NOT ok)THEN ShowMess('not ok  det= '+FloatToStr(det));
  FOR i:=1 TO 3 DO
   BEGIN dp[i]:=0; FOR j:=1 TO 3 DO dp[i]:=dp[i]+mat3[i,j]*vec3[j];
   END;
  eps:=0; FOR i:=1 TO 3 DO
   BEGIN pa[i]:=pa[i]+step*dp[i]; eps:=eps+SQR(dp[i]);
   END;
  eps:=SQRT(eps);
  IF(pa[1]<0)THEN pa[1]:=0; IF(pa[2]<0.1)THEN pa[2]:=0.1;
  {ShowMess('chi= '+FloatToStr(chi/(i2-i1-2)));
  Writeln(fout,'eps,chi= ',eps:10:2,chi:10:2,'   par= ',
   pa[1]:10:2,pa[2]:10:5,pa[3]:10:5);}
  IF((chi>chio)OR(eps<0.001))THEN BREAK;
  END; {Loop end}
 ConvertStr(chi/AMAX0(1,i2-i1-1),10,2);
 i:=MessageDlg('Chi^2= '+sedz+'; Continue?',MtWarning,[mbYes,mbNo],0);
 IF(i=mrYes)THEN GOTO Lagain;
 CopySpectrum(0,4); CopySpectrum(0,3);
 FOR i:=a1 TO a2 DO spec[3].y[i]:=AMAX1(spec[3].y[i]-pa[1],0.0001);
 FOR i:=a1 TO a2 DO {Form the fitted tail}
  BEGIN IF(i>=i1)THEN
   BEGIN deriv(i); spec[4].y[i]:=fth;
   END;
  spec[4].y[i]:=AMAX1(spec[4].y[i]-pa[1],0.0001);
  END;
 spec[4].fismax1; spec[4].spin:=true;
 IF(Form2.CheckListBox1.Checked[0])THEN CopySpectrum(4,0);
 FOR i:=1 TO 4 DO spec[i].effn:=false;
 END;
MakeFormV(170,20,400,430,0); WITH LB1rec DO
 BEGIN nitems:=9; FOR i:=1 TO 13 DO ar[i]:=' ';
 ar[1]:='   The formula= p_1 + p_2*exp(-x/p_3)'; ar[2]:='';
 ConvertStr(chi/AMAX0(1,i2-i1-1),10,2); Compress(sedz);
 ar[3]:=' Chi^2= '+sedz+'   ';
 ConvertStr(eps,10,5); ar[3]:=ar[3]+'Eps= '+sedz;
 ar[4]:=' The fitted parameters p_i:'; ar[5]:='  ';
 FOR i:=1 TO 3 DO
  BEGIN ConvertStr(pa[i],10,1); Compress(sedz); ar[5]:=ar[5]+sedz+'  ';
  END;
 ar[6]:=' Eff.sp. with fitted tail.-> Spectrum 4.';
 ar[7]:=' Eff.sp. without const    -> Spectrum 3';
 ar[8]:=' Graph both them and if OK,';
 ar[9]:=' repeat fitting with replace.'; ar[10]:='';
 IF(Form2.CheckListBox1.Checked[0])THEN
  BEGIN ar[11]:='   Tail replaced.'; ar[8]:=' ';  ar[9]:=' ';
  ar[12]:='Enter and normalize the spectrum anew.';
  ar[13]:='Recommend: save eff.spectrum for further use';
  nitems:=13;
  END;
 END;
MakeListBox(3,40,380,300); Form2.ShowModal;
END;
PROCEDURE CompresstheSpectrum(ll,ns:INTEGER);
VAR s,sv:REAL; i,j,l1,l2:INTEGER;
BEGIN L0rec:='Spectrum compression'; IF(ll<1)THEN
 BEGIN ShowMess('Wrong compression factor'); ModalRes:=0; Exit;
 END;
{Do} WITH spec[numsp] DO
 BEGIN l1:=((a1-1) DIV ll)+1; l2:=((a2-1) DIV ll)+1; FOR i:=l1 TO l2 DO
  BEGIN s:=0; sv:=0; spec[ns].x[i]:=x[(i-1)*ll+a1]; FOR j:=1 TO ll DO
   BEGIN k:=(i-1)*ll+a1+j-1; sv:=sv+SQR(e[k]); s:=s+y[k];
   END;
  spec[ns].e[i]:=SQRT(sv); spec[ns].y[i]:=s;
  END;
 END;
FOR i:=1 TO l1-1 DO
 BEGIN spec[ns].e[i]:=1; spec[ns].y[i]:=0;
 END;
FOR i:=l2+1 TO spec[numsp].a2 DO
 BEGIN spec[ns].e[i]:=1; spec[ns].y[i]:=0;
 END;
WITH spec[ns] DO
 BEGIN a1:=l1; a11:=l1; a2:=l2; a22:=l2; spin:=true;
 fismax1;
 END;
spec[ns].effn:=spec[numsp].effn;
spec[ns].absn:=spec[numsp].absn;
spec[ns].theta:=spec[numsp].theta;
spec[ns].FPath:=spec[numsp].FPath;
spec[ns].dback:=spec[numsp].dback;
spec[ns].acor:=spec[numsp].acor/ll;
spec[ns].chw:=spec[numsp].chw*ll;
spec[ns].delay:=spec[numsp].delay/ll;
spec[ns].w0:=spec[numsp].w0/ll;
spec[ns].dw0:=spec[numsp].dw0/ll;
MakeForm(0);
WITH LB1rec DO
 BEGIN nitems:=4;
 ar[1]:='Spectrum '+IntToStr(numsp)+'  '+IntToStr(ll)+
        '-compressed to Spectrum '+IntToStr(ns);
 ar[2]:='';
 ar[3]:='New bounds= '+IntToStr(spec[ns].a1)+' - '+
  IntToStr(spec[ns].a2);
 ar[4]:='New max= '+IntToStr(Round(spec[ns].spx));
 END;
MakeListBox(0,40,320,100); Form2.ShowModal;
END;
PROCEDURE EventsToSpectrum;
{To form the gamma-ray spectrum from event data,
 Version: Aug 15 1997  Mar 1 2001, Feb 23 2002}
{Get event file name}
VAR   i,j,iout,ioum,k,ic,lsp,ich:INTEGER;
      bounds:ARRAY[1..4] OF BOUNDA; log:ARRAY[1..4] OF BOOLEAN;
LABEL Lend;
BEGIN {evfn:='\zlok\mor.evf';}
GetFilename(evfn,0); IF(ModalRes=0)THEN Exit; lsp:=4096;
AssignFile(ft,evfn); {$I-} Reset(ft); {$I+};
FOR i:=1 TO 16384 DO spec[1].y[i]:=0; iout:=2; FOR i:=1 TO 4 DO
 BEGIN bounds[i].bl:=0; bounds[i].br:=16384;
 END;

L0rec:='Transform Events to the Spectrum';
MakeForm(1); Form2.Color:=clTeal; SaveHelp(EvToSp_n,EvToSp);
strgrW[0]:=120; strgrW[1]:=80; strgrW[2]:=80;
FOR i:=1 TO 4 DO
 BEGIN strgrNn[i,1]:=bounds[i].bl; strgrNn[i,2]:=bounds[i].br;
 strgrT[i]:=' Range '+IntToStr(i);
 END;
OuttoLabel(Form2.Label5,5,30,clTeal,clYellow,
 'Check the bounds:        Left           Right');
PuttoTable(20,50,4,4,2,{ndig}8);

s:='Select the sampling';
OuttoLabel(Form2.Label7,5,150,clTeal,clYellow,s);
OuttoLabel(Form2.Label8,5,168,clTeal,clYellow,' column');
CB1rec:=Num4Rec; MakeRadioGroup(1,0,10,186,120,140);
OuttoLabel(Form2.Label9,160,200,clTeal,clWhite,'Select output format');
WITH CB1rec DO
 BEGIN nitems:=2; ar[1]:=' counts'; ar[2]:=' channel, counts';
 END;
MakeRadioGroup(2,0,160,220,150,70);

L1rec:=' Enter the Spectrum Length '; E1rec:=IntToStr(lsp);
MakeEdits(30,220,340,70,1);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 iout:=RadioGroup1.ItemIndex+1; ioum:=RadioGroup2.ItemIndex+1;
 FOR i:=1 TO 4 DO Zval(Form2.StringGrid1.Cells[0,i-1],bounds[i].bl);
 FOR i:=1 TO 4 DO Zval(Form2.StringGrid1.Cells[1,i-1],bounds[i].br);
 Zval(Edit1.Text,r); lsp:=Round(r);
 END;
{Loop} ic:=0; ActivateForm2(250,300,150);
WHILE(NOT EoF(ft))DO
 BEGIN EnterStr(ft); fffins(k,sedz); ich:=Round(onl[iout]); Inc(ic);
 FOR i:=1 TO k DO
  BEGIN log[i]:=false;
  IF((onl[i]>=bounds[i].bl)AND(onl[i]<=bounds[i].br))THEN log[i]:=true;
  END;
 ok:=true; FOR i:=1 TO k DO IF(i<>iout)THEN ok:=ok AND log[i];
 IF(ok AND(ich<16001))THEN spec[1].y[ich]:=spec[1].y[ich]+1;
 IF((ic MOD 1000)=0)THEN
  Form2.Caption:='   '+IntToStr(ic)+' events read in';
 END;
CloseFile(ft);
{Save the spectrum}
fn:=vmdir; L1rec:='Output Result Spectrum Name';
GetFilename(fn,1); ExtractFN(fn,fn1); ExtractFN(evfn,fn2);
IF(fn1=fn2)THEN
 BEGIN ShowMess(fn+' is input-file; output to tmp.spc');
 fn:='tmp.spc';
 END;
IF(ModalRes=0)THEN GOTO Lend;
{Get the mode for spectrum output}
AssignFile(ft,fn); Rewrite(ft);
IF(ioum=1)THEN
 BEGIN k:=lsp DIV 10; FOR i:=1 TO k DO
  BEGIN FOR j:=1 TO 10 DO Write(ft,spec[1].y[(i-1)*10+j]:7:0);
  Writeln(ft);
  END;
 FOR j:=k*10+1 TO lsp DO Write(ft,spec[1].y[j]:7:0);
 END      ELSE FOR i:=1 TO lsp DO Writeln(ft,i:6,' ',spec[1].y[i]:8:0);
CloseFile(ft);
Lend: MakeForm(1); WITH LB1rec DO
 BEGIN nitems:=1;
 ar[1]:=IntToStr(ic)+' events scanned for column = '+IntToStr(iout);
 END;
MakeListBox(20,40,270,70); Form2.ShowModal;
END;
PROCEDURE CalculateAbsorpCoefs;
{Purpose: to calculate absorption coefficients  mui = (ro'/ro)*R*nui
 Version: 20 Apr 1990 }
CONST lambda:REAL = 1.7982;
      avogad:REAL = 0.602204;
VAR   i,iph,iatom:INTEGER; EfRad,ros,nu1,nu2,mu1,mu2,ro,sinc:REAL;
      z:ARRAY[1..4] OF REAL;
BEGIN IF(nophasi)THEN
 BEGIN ShowMess('No phase information'); Exit;
 END;
FOR i:=1 TO nph DO IF(lat[i].nat=0)THEN
 BEGIN ShowMess('No atomic information for phase '+IntToStr(i)); Exit;
 END;
L0rec:='Calculation of absorption coefficients'; MakeForm(1);
SaveHelp(AbsCoef_n,AbsCoef); MakeBevel(5,10,303,100,1);
s:='Enter the data'; OuttoLabel(Form2.Label5,70,20,clGreen,clAqua,s);
L1rec:='Spectrum number ='; E1rec:=IntToStr(numsp);
L2rec:='Effective cylinder radius(cm)='; E2rec:='0.4';
L3rec:='Experimental density (g/cm3) ='; E3rec:='3.6799';
MakeEdits(10,230,40,70,3);
MakeBevel(5,130,303,70+20*nph,2); s:='Enter numbers of formulae';
OuttoLabel(Form2.Label6,10,140,clGreen,clAqua,s);
strgrW[0]:=120; strgrW[1]:=100; FOR i:=1 TO nph DO
 BEGIN strgrT[i]:='  For phase '+IntToStr(i); strgrNn[i,1]:=1;
 END;
PuttoTable(40,170,nph,nph,1,8);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 Zval(Edit1.Text,r); numsp:=Round(r);
 Zval(Edit2.Text,r); EfRad:=r; Zval(Edit3.Text,r); ros:=r;
 FOR i:=1 TO nph DO
  BEGIN Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
  z[i]:=har[i]; IF(har[i]<=0)THEN
   BEGIN ShowMess('Wrong number of formulae '+FloatToStr(har[i]));
   Exit;
   END;
  END;
 END;
{Compute the monocrystall density and linear absorption constants}
mu1:=0; mu2:=0; FOR iph:=1 TO nph DO
 BEGIN ro:=0; nu1:=0; nu2:=0;
 FOR iatom:=1 TO lat[iph].nat DO WITH atoms[iatom,iph] DO
  BEGIN ro:=ro+occ*aw; sinc:=sigs-2*pi2*SQR(scat);
  nu1:=nu1+occ*sinc; nu2:=nu2+occ*siga;
  END;
 nu1:=nu1*z[iph]/lat[iph].vol; nu2:=nu2*z[iph]/lat[iph].vol/lambda;
 ro:=ro*z[iph]/lat[iph].vol/avogad;
 mu1:=mu1+ros*EfRad*nu1/ro; mu2:=mu2+ros*efRad*nu2/ro;
 END;
mu1:=mu1/nph; mu2:=mu2/nph; WITH spec[numsp] DO
 BEGIN abs1:=mu1; abs2:=mu2;
 END;
WITH LB1rec DO
 BEGIN nitems:=5;
 ar[1]:=''; ar[2]:=' Absorption coefficients:'; ar[3]:='';
 ConvertStr(mu1,15,7); Compress(sedz); ar[4]:='      abs1 = '+sedz;
 ConvertStr(mu2,15,7); Compress(sedz); ar[5]:='      abs2 = '+sedz;
 END;
MakeForm(1); MakeListBox(20,40,270,120); Form2.ShowModal;
END;
PROCEDURE DefineBounds(VAR i1,i2:INTEGER);
VAR t,t1,t2:REAL;
BEGIN WITH spec[0] DO t1:=(a1+delay)*chw;
WITH spec[numsp] DO t2:=(a1+delay)*chw; t:=AMAX1(t1,t2);
WITH spec[0] DO t1:=(a2+delay)*chw;
WITH spec[numsp] DO t2:=(a2+delay)*chw; t2:=AMIN1(t1,t2); t1:=t;
WITH spec[numsp] DO
 BEGIN i1:=MAX1(FLOAT(a1),(t1-delay*chw)/chw);
 i2:=MIN1(FLOAT(a2),(t2-delay*chw)/chw);
 END;
END;
PROCEDURE NormalizeSpectrum;
VAR   i1,i2,i,isp,ic,isa:INTEGER;
BEGIN isp:=numsp; L0rec:='Spectrum normalization';
MakeForm(1); SaveHelp(NormSp_n,NormSp);
IF(isp=0)THEN
 BEGIN ShowMess
  ('Error, make the graph of the spectrum to be normalized'); Exit;
 END;
IF(spec[isp].NoSpectrum(isp))THEN Exit; IF(spec[isp].tofang=2)THEN Exit;
{*}
MakeForm(1); OuttoLabel(
 Form2.Label6,10,10,clGreen,clAqua,'Click if needed:');
WITH CB1rec DO
 BEGIN nitems:=1; {ar[2]:='Normalize as DN2 Spectrum';}
 ar[1]:='Correct for absorption';
 END;
MakeCheckListBox(45,30,230,20);
{*}
MakeBevel(5,90,300,130,1);
OuttoLabel(Form2.Label7,10,100,clGreen,clAqua,
 'Check the spectrum '+IntToStr(isp)+' and efficient one');
WITH spec[isp] DO
 BEGIN L1rec:='Channel width (mks/deg) = '; E1rec:=FloatToStr(chw);
 IF(tofang=1)THEN E1rec:=FloatToStr(x[a1+1]-x[a1]);
 L2rec:='Spectrum delay(chan) = '; E2rec:=FloatToStr(delay);
 END;
WITH spec[0] DO
 BEGIN L3rec:='Effic.Channel width (mks)  = '; E3rec:=FloatToStr(chw);
 L4rec:='Effic.Spectrum delay(chan) = '; E4rec:=FloatToStr(delay);
 END;
MakeEdits(25,225,120,70,4);
{*}
MakeBevel(5,225,300,55,2);
OuttoLabel(Form2.Label8,10,230,clGreen,clAqua,'Select the sample type');
CB1rec:=SampleTypeRec; CB1rec.indx:=spec[isp].shape+1;
MakeCombo(80,250,200);
{*}
MakeBevel(5,290,300,75,3);
OuttoLabel(Form2.Label9,10,295,clGreen,clAqua,
'Specify the absorption parameters');
strgrT[1]:='Abs1 ='; strgrNn[1,1]:=spec[isp].abs1;
strgrT[2]:='Abs2 ='; strgrNn[2,1]:=spec[isp].abs2;
strgrW[0]:=90; strgrW[1]:=100; PuttoTable(80,315,2,2,1,9);
{*}
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 IF(CheckListBox1.Checked[0])THEN ic:=1 ELSE ic:=0;
 FOR i:=1 TO 2 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 spec[isp].abs1:=har[1]; spec[isp].abs2:=har[2];
 IF((ABS(har[1])+ABS(har[2])=0)AND(ic=1))THEN
  BEGIN ShowMess('Error, absorption coefficients = 0'); ic:=0;
  END;
 s:=Edit1.Text; Zval(s,r);
 IF(ModalRes=0)THEN Exit ELSE spec[isp].chw:=ABS(r);
 s:=Edit2.Text; Zval(s,r);
 IF(ModalRes=0)THEN Exit ELSE spec[isp].delay:=r;
 s:=Edit3.Text; Zval(s,r);
 IF(ModalRes=0)THEN Exit ELSE spec[0].chw:=ABS(r);
 s:=Edit4.Text; Zval(s,r);
 IF(ModalRes=0)THEN Exit ELSE spec[0].delay:=r;
 isa:=ComboBox1.ItemIndex; spec[isp].shape:=isa;
 END;
WITH spec[isp] DO IF((chw*spec[0].chw)=0)THEN
 BEGIN ShowMess('Error, channel width = 0'); Exit;
 END;
IF((spec[isp].effn)AND(ic=0))THEN
 BEGIN ShowMess('Spectrum already normalized'); IF(ic=0)THEN Exit;
 END;
IF((ic=1)AND(spec[isp].absn))THEN
 BEGIN ShowMess('Spectrum already corrected for absorption'); Exit;
 END;
DefineBounds(i1,i2);
WITH spec[isp] DO IF((NOT effn)AND(tofang=0))THEN
  DoNormalizing({id2}0,isp,i1,i2);
IF((ic=1)AND(NOT spec[isp].absn))THEN CorrectforAbsorption(isp,i1,i2);
MakeForm(1); WITH LB1rec DO
 BEGIN ar[1]:='    Spectrum '+IntToStr(isp)+', range =   '+IntToStr(i1)+
 ' - '+IntToStr(i2); ar[2]:=' ';
 ar[3]:='normalized;'; IF(NOT spec[isp].effn)THEN ar[3]:='not '+ar[3];
 ar[3]:='* '+ar[3];
 ar[4]:='corrected for absorption';
 IF(NOT spec[isp].absn)THEN ar[4]:='not '+ar[4]; ar[4]:='* '+ar[4];
 nitems:=4; IF(spec[isp].absn)THEN
  BEGIN ar[5]:='  Min,max absorption correction:';
  ar[6]:=sedz; nitems:=6;
  END;
 END;
MakeListBox(10,40,290,120); Form2.ShowModal;
END;
PROCEDURE DoNormalizing(im,isp:INTEGER; VAR i1,i2:INTEGER);
VAR   i,j,N:INTEGER; t,dN,v,amx,amn,r,v1,v2:REAL;
BEGIN IF(NOT spec[0].spin)THEN
 BEGIN ShowMess('No eff.spectrum'); ModalRes:=0; Exit;
 END;
IF(im=1)THEN  {DN2}
 BEGIN FOR i:=i1 TO i2 DO WITH spec[isp] DO
  BEGIN r:=chw/spec[0].chw; r:=r*i-spec[0].delay; j:=Round(r);
  IF((j>=i1)AND(j<=i2))THEN
   BEGIN v2:=AMAX1(spec[0].y[j],0.000001); v1:=spec[isp].y[i];
   r:=(v1/v2)*{1000}spec[0].nconst; spec[isp].y[i]:=r;
   spec[isp].e[j]:=AMIN1(spec[isp].e[j]/v2*{1000}spec[0].nconst,46340);
   END;
  END;
 END    ELSE  {Normal}
 BEGIN amx:=0; amn:=1E17; FOR i:=i1 TO i2 DO
  BEGIN amn:=AMIN1(amn,spec[isp].y[i]); amx:=AMAX1(amx,spec[0].y[i]);
  END;
 amx:=AMAX1(amx,1); amn:=AMAX1(amn,0); FOR i:=i1 TO i2 DO
  BEGIN t:=(i+spec[isp].delay)*spec[isp].chw;
  t:=(t-spec[0].delay*spec[0].chw)/spec[0].chw; N:=Trunc(t);
  IF(infun(N,i1,i2))THEN
   BEGIN v1:=spec[0].y[N+1]; v2:=spec[0].y[N]; dN:=t-N;
   v:=(v1-v2)*dN+v2; {r:=spec[isp].y[i];} v:=AMAX1(v,0.000001)/amx;
   spec[isp].y[i]:=(spec[isp].y[i]-amn)/v+amn;
   spec[isp].e[i]:=AMIN1(spec[isp].e[i]/v,46340);
   {Writeln(fout,i:6,v:9:4,r:10:1,spec[isp].y[i]:10:1);}
   END;
  END;
 END;
spec[isp].fismax1; spec[isp].effn:=true;
END;
FUNCTION absorb(ich,isp:INTEGER; aa1,aa2:REAL; mode:INTEGER):REAL;
{Purpose: To compute the absorption correction in the channel ich
          aa1,aa2      -  absorption coefficients
          theta        -  Bragg angle
 mode = c : cylinder, mode = p : plane, mode = s : sphere
 Version: 10.8.1989  Version: 2 Jun 1990}
CONST
 r:ARRAY[1..5] OF REAL = (0.0985351,0.3045357,0.5620252,0.8019866,
                          0.9601901);
 b:ARRAY[1..5] OF REAL = (0.0314958,0.1478177,0.2927740,0.3343493,
                          0.1935632);
 bs:ARRAY[1..9] OF REAL = (1,4,2,4,2,4,2,4,1);
 cosbl:ARRAY[1..9] OF REAL =(1,0.9238795,0.7071067,0.3826833,-0.0000002,
                            -0.3826836,-0.7071069,-0.9238796,-1);
 sinbl:ARRAY[1..9] OF REAL = (0,0.3826835,0.7071068,0.9238796,1,
                              0.9238794,0.7071066,0.3826833,-0.0000003);
 asph:ARRAY[1..17,1..7] OF REAL =
     ((1,1,1,1,1,1,1),
      (0.862,0.862,0.862,0.862,0.862,0.862,0.862),
      (0.741,0.746,0.746,0.746,0.752,0.752,0.752),
      (0.641,0.645,0.654,0.654,0.658,0.662,0.662),
      (0.556,0.559,0.562,0.571,0.578,0.588,0.588),
      (0.481,0.485,0.493,0.503,0.515,0.524,0.526),
      (0.317,0.322,0.334,0.353,0.372,0.388,0.392),
      (0.243,0.248,0.264,0.286,0.308,0.326,0.332),
      (0.128,0.136,0.155,0.181,0.207,0.228,0.236),
      (0.0714,0.0794,0.1,0.126,0.152,0.173,0.182),
      (0.0420,0.05,0.069,0.0935,0.118,0.138,0.147),
      (0.026,0.0334,0.0513,0.0735,0.0962,0.115,0.123),
      (0.0116,0.0179,0.0323,0.0505,0.0694,0.0855,0.0926),
      (0.00599,0.0112,0.0229,0.0379,0.0541,0.068,0.0746),
      (0.00347,0.0787,0.0176,0.0303,0.0441,0.0562,0.0621),
      (0.00146,0.00469,0.0118,0.0215,0.0322,0.0418,0.0467),
      (0.00075,0.00325,0.00885,0.0165,0.0256,0.0332,0.0375));
 amr:ARRAY[1..17] OF REAL =
   (0,0.1,0.2,0.3,0.4,0.5,0.8,1.0,1.5,2.0,2.5,3.0,4.0,5.0,6.0,8.0,10.0);
 atet:ARRAY[1..7] OF REAL =
   (0,0.5235988,1.0471976,1.5707964,2.094395,2.617994,3.141593);
VAR tet,dt,dmr,st,ct,a,h,d,dfi,dfj,f1,f2,f3:REAL;
    c1,b1,c2,b2,si,w,cf,sf,x,y,tft,t1,t2,ft1,ft2,fa:REAL;
 PROCEDURE abscyl(VAR a:REAL; theta:REAL);
 {Purpose: To compute the absorption coefficient for cylinder
  Version: 27 Jun 1990}
 VAR i,k,m,n:INTEGER;
 BEGIN a:=0; IF(dmr<=1)THEN
 {Approximate formula}
  BEGIN c1:=1.7133; b1:=-0.0368; c2:=-0.0927; b2:=-0.375;
  si:=SIN(theta); si:=si*si;
  a:=EXP(-(c1+b1*si)*dmr-(c2+b2*si)*dmr*dmr);
  END      ELSE
 {Compute the integral}
  BEGIN m:=9; n:=5;
  FOR i:=1 TO m DO
   BEGIN w:=0; cf:=cosbl[i]; sf:=sinbl[i];
   FOR k:=1 TO n DO
    BEGIN x:=r[k]*cf; y:=r[k]*sf; tft:=AMIN1(SQR(x*st+y*ct),1);
    t1:=x-x*ct+y*st; t2:=SQRT(1-y*y)+SQRT(1-tft);
    ft1:=EXP(-dmr*t1); ft2:=EXP(-dmr*t2);
    fa:=(ft1+1/ft1)*ft2; w:=w+b[k]*fa;
    END;
   a:=a+bs[i]*w;
   END;
  a:=a/((m-1)*3)*0.5;
  END;
 END;
 PROCEDURE abspl(VAR a:REAL; theta:REAL);
 {Purpose: To compute the absorption coefficient for plane
  Version: 2 Jun 1990}
 BEGIN si:=SIN(theta); a:=si*(1-EXP(-AMIN1(2*dmr/si,64)))*0.5/dmr;
 END;
 PROCEDURE abssph(VAR a:REAL; theta:REAL);
 {Purpose: To compute the absorption coefficient for sphere
  Version: 2 Jun 1990}
 VAR   i,j,i0,j0:INTEGER;
 LABEL L2,L4,L5;
 BEGIN {Find the dmr-range}
 FOR i:=1 TO 16 DO IF((dmr>=amr[i])AND(dmr<amr[i+1]))THEN
  BEGIN i0:=i; GOTO L2;
  END;
 GOTO L5;
 {Find the theta-range}
 L2: FOR j:=1 TO 6 DO
  IF((theta>=atet[j])AND(theta<atet[j+1]))THEN
   BEGIN j0:=j; GOTO L4;
   END;
 GOTO L5;
 {Interpolate}
 L4: h:=amr[i0+1]-amr[i0]; d:=atet[j0+1]-atet[j0];
 dfi:=(asph[j0,i0+1]-asph[j0,i0])/h; dfj:=(asph[j0+1,i0]-asph[j0,i0])/d;
 f1:=(dmr-amr[i0])*dfi; f2:=(theta-atet[j0])*dfj; f3:=asph[j0,i0];
 a:=f1+f2+f3; Exit;
 {Beyond the range}
 L5: a:=0.01; { dmr,theta; FORMAT(2X,'Point ', out of range');}
 END;
{function body}
BEGIN WITH spec[isp] DO
 BEGIN tet:=theta*0.01745329; dt:=2*theta*0.01745329;
 dmr:=aa1+aa2*2*chw/(2*252.778*FPath)*ich;
 END;
CASE mode OF
0: BEGIN st:=SIN(dt); ct:=COS(dt); abscyl(a,tet); {Cylinder case}
   END;
1: abspl(a,tet); {Plane case}
2: abssph(a,dt);  {Sphere case}
ELSE END;
absorb:=a;
END;
PROCEDURE CorrectforAbsorption(isp,i1,i2:INTEGER);
VAR i,isa:INTEGER; absc,acn,acm,r,spc1,ab1,ab2:REAL;
BEGIN WITH spec[isp] DO
 BEGIN ab1:=abs1; ab2:=abs2; isa:=shape;
 END;
acm:=0; acn:=10000000; FOR i:=i1 TO i2 DO {WITH spec[isp] DO }
 BEGIN spc1:=spec[isp].y[i]; absc:=absorb(i,isp,ab1,ab2,isa);
 acn:=AMIN1(acn,absc); acm:=AMAX1(acm,absc);
 spec[isp].y[i]:=spc1/absc; spec[isp].e[i]:=spec[isp].e[i]/absc;
 {Writeln(fout,i:4,absc:9:6,spec[1].y[i]:9:1,spec[1].e[i]:9:1);}
 END;
spec[isp].fismax1; spec[isp].absn:=true; r:=acn; ConvertStr(r,8,4);
s:=sedz; r:=acm; ConvertStr(r,8,4); sedz:=s+',  '+sedz;
END;
PROCEDURE CorrectOutliers;
VAR i,j,k,i1,i2,m:INTEGER;
BEGIN IF(npeak=0)THEN
 BEGIN ShowMess('No marked points.'); ModalRes:=0; Exit;
 END;
L0rec:='Count correction'; MakeForm(0);
s:='Specify the correction mode';
OuttoLabel(Form2.Label5,5,30,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=2; indx:=1;
 ar[1]:='Set to zero';
 ar[2]:='Replace by halfsum';
 END;
MakeRadioGroup(1,0,15,50,300,60);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 m:=RadioGroup1.ItemIndex;
 END;
i1:=spec[numsp].a1; i2:=spec[numsp].a2; k:=npeak;
FOR i:=1 TO npeak DO
 BEGIN j:=Round(marka[i]);
 IF(infun(j,i1+1,i2-1))THEN WITH spec[numsp] DO
 CASE m OF
 0: BEGIN y[j]:=0; e[j]:=1;
    END;
 1: BEGIN y[j]:=(y[j-1]+y[j+1])*0.5;
    e[j]:=SQRT((SQR(e[j-1])+SQR(e[j+1])))*0.5;
    END;
 ELSE END              ELSE Dec(k);
 END;
ShowMess(IntToStr(k)+' spectrum blunder(s) corrected');
END;
PROCEDURE SpecialAnalysis(iout,i1,i2:INTEGER);
{Transformation from t-spectrum to E-spectrum is E=A/t^2. Constant A
 depends on t and E units and the flight path, therefore is introduced
 by the user. For example in our case, when t-bin=1ms, and
 the energy is in neV, flight path is 80 cm, A=3.3e6.
 Correspondingly the bin transformation is: dE=A/t^3.
 Transformation from t to v is v=B/t, transformation
 of bins is: dv=B/t^2. B=8.e4 (v in cm/s)}
VAR i,j,k,n,is1,is2,m,mo:INTEGER; su1,su2,A,ec,e1,e2,r,v:REAL;
BEGIN IF(i2<=i1)THEN
 BEGIN ShowMess('Wrong spectrum bounds'); Exit;
 END;
i:=nintmax DIV 2; is1:=spec[numsp].a1; is2:=spec[numsp].a2;
WITH spec[numsp] DO IF((a2-a1)>i)THEN
 BEGIN is2:=i+is1-1;
 ShowMess('Interpolated array too long; cut to '+IntToStr(i));
 END;
n:=is2-is1+1; FOR i:=is1 TO is2 DO sa[i]:=spec[numsp].y[i];
m:=i2-i1+1; A:=3.3E6; e1:=1/SQR(FLOAT(is2)); e2:=1/SQR(FLOAT(is1));
L0rec:=' Special analysis'; MakeForm(0);
s:='Secify the energy channel mode';
OuttoLabel(Form2.Label5,5,30,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=3; indx:=1;
 ar[1]:=' t -> E,  E=(m*C)/t^2 ';
 ar[2]:=' t -> v,  E=(C)/t ';
 ar[3]:=' ';
 END;
MakeRadioGroup(1,0,30,50,270,100);
strgrW[0]:=120; strgrW[1]:=100;
strgrT[1]:=' Coefficient C = '; strgrNn[1,1]:=1;
PuttoTable(40,180,1,1,1,8);
s:='Number of channels in E-axis = '+IntToStr(m);
OuttoLabel(Form2.Label6,5,300,clMaroon,clWhite,s);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 mo:=RadioGroup1.ItemIndex; Zval(Form2.StringGrid1.Cells[0,0],r);
 END;
su1:=0; su2:=0; FOR i:=1 TO m*Round(r) DO spec[iout].y[i]:=0;
FOR i:=is1 TO is2 DO FOR j:=0 TO 999 DO
 BEGIN v:=spec[numsp].y[i]/1000; su1:=su1+v; su2:=su2+ABS(v);
 step:=i+0.001*j;
 CASE mo OF
 0: ec:=r*SQR(FLOAT(m)/step);
 1: ec:=1/step;
 ELSE END;
 k:=Round(ec)+1; IF(infun(k,1,nintmax))THEN WITH spec[iout] DO
  BEGIN y[k]:=y[k]+v; x[k]:=A/SQR(step);
  END;
 END;
spec[iout].a1:=i1; spec[iout].a2:=i2;
su1:=0; su2:=0; FOR i:=i1 TO i2 DO
 BEGIN v:=spec[iout].y[i]; su1:=su1+v; su2:=su2+ABS(v);
 END;
END;

BEGIN sfindx:=1; resindx:=2; saindx:=1; ii1:=1; ii2:=8192;
END.
