UNIT vstdcons;

INTERFACE

USES Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
     Dialogs, StdCtrls, ExtCtrls, Grids,   CheckLst, Comctrls,
     vzlocom;
PROCEDURE MakeEdit(CONST T:TEdit; x,y,w:INTEGER; CONST s:STRING);
PROCEDURE OuttoLabel(CONST L:TLabel; x,y,cl,clf:INTEGER;
                     CONST st:STRING);
PROCEDURE MakeStringGrid(CONST SG1,SG2:TStringGrid;
                         x,t,nf,n,mm,ndig:LONGINT);
PROCEDURE ClearCells(CONST SG1:TStringGrid; nr,nc:INTEGER);
PROCEDURE BuildRG(T:TRadioGroup; m,x,y,w,h:LONGINT);
PROCEDURE Make_Memo(CONST Me:TMemo; x,w:INTEGER);
PROCEDURE Make_Rich(CONST Re:TRichEdit; x,w:INTEGER);
PROCEDURE MaketheButton(CONST B:TButton; x,y,w,h:LONGINT;
                        CONST s:STRING);
PROCEDURE Make_Bevel(CONST Be:TBevel; x,y,w,h:INTEGER);
PROCEDURE Make_ListBox(CONST LB:TListBox; ix,it,iw,ih:LONGINT);
PROCEDURE Make_CheckListBox(CONST CLB:TCheckListBox;
                            ix,it,iw,ih:LONGINT);
PROCEDURE MakeComboBox(CONST CB:TComboBox; x,y,w:LONGINT);
PROCEDURE SaveFileDial(CONST sd:TSaveDialog; VAR fn:STRING;
                       VAR ow:BOOLEAN);
PROCEDURE OpenFileDial(CONST od:TOpenDialog; VAR fn,fe,fd,filt:STRING);
PROCEDURE MakeParStrGr(CONST SG:TStringGrid; np:INTEGER);

IMPLEMENTATION
PROCEDURE MakeParStrGr(CONST SG:TStringGrid; np:INTEGER);
BEGIN WITH SG DO
 BEGIN Left:=exs(5); Top:=0; Width:=exs(577);
 IF(np>16)THEN Width:=exs(596); Height:=exs(360);
 Visible:=true; ColCount:=7; RowCount:=np+1;
 FixedRows:=0; IF(RowCount>1)THEN FixedRows:=1; Color:=clBlack;
 Font.Color:=clLime; Font.Size:=fntsize; Font.Style:=[fsBold];
 ClearCells(SG,RowCount,ColCount);
 ColWidths[0]:=exs(120); ColWidths[1]:=exs(50); ColWidths[2]:=exs(95);
 ColWidths[3]:=exs(100); ColWidths[4]:=exs(95); ColWidths[5]:=exs(55);
 ColWidths[6]:=exs(55);
 Cells[1,0]:=' N'; Cells[2,0]:='Lower limit'; Cells[3,0]:='Parameter';
 Cells[4,0]:='Upper limit'; Cells[5,0]:=' a'; Cells[6,0]:=' b';
 END;
END;
PROCEDURE MakeComboBox(CONST CB:TComboBox; x,y,w:LONGINT);
VAR i,j:INTEGER;
BEGIN WITH CB DO
 BEGIN Left:=exs(x); Top:=exs(y); Width:=exs(w); Visible:=true; Clear;
 j:=CB1rec.nitems; DropDownCount:=MIN0(8,j);
 Font.Size:=fntsize; Font.Pitch:=fpDefault; Font.Color:=clAqua;
 Brush.Color:=clBlack;
 FOR i:=1 TO j DO Items.Add(CB1rec.ar[i]); k:=CB1rec.indx;
 Text:=Items[MIN0(k,j)-1]; ItemIndex:=k-1;
 END;
END;
PROCEDURE Make_CheckListBox(CONST CLB:TCheckListBox;
                            ix,it,iw,ih:LONGINT);
VAR i:INTEGER;
BEGIN WITH CLB DO
 BEGIN Left:=exs(ix); Top:=exs(it); Width:=exs(iw); Height:=exs(ih);
 Brush.Color:=clYellow; Clear;
 Font.Size:=fntsize; Font.Color:=clBlack; Font.Pitch:=fpDefault;
 Font.Style:=[fsBold];
 FOR i:=1 TO CB1rec.nitems DO Items.Add(CB1rec.ar[i]); Visible:=true;
 END;
END;
PROCEDURE Make_ListBox(CONST LB:TListBox; ix,it,iw,ih:LONGINT);
VAR i:INTEGER;
BEGIN WITH LB DO
 BEGIN Left:=exs(ix); Top:=exs(it); Width:=exs(iw); Height:=exs(ih);
 Clear; Font.Color:=clAqua; Font.Style:=[fsBold]; Font.Size:=fntsize;
 Brush.Color:=clBlack; Font.Pitch:=fpFixed; MultiSelect:=false;
 FOR i:=1 TO LB1rec.nitems DO Items.Add(LB1rec.ar[i]); Visible:=true;
 END;
END;
PROCEDURE MaketheButton(CONST B:TButton; x,y,w,h:LONGINT;
                        CONST s:STRING);
BEGIN WITH B DO
 BEGIN Left:=exs(x); Top:=exs(y); Width:=exs(w); Height:=exs(h);
 Visible:=true; Caption:=s; Enabled:=true;
 Font.Pitch:=fpDefault; Font.Style:=[fsBold]; Font.Size:=fntsize;
 END;
END;
PROCEDURE Make_Bevel(CONST Be:TBevel; x,y,w,h:INTEGER);
BEGIN WITH Be DO
 BEGIN Left:=exs(x); Top:=exs(y); Width:=exs(w); Height:=exs(h);
 Visible:=true;
 END;
END;
PROCEDURE Make_Memo(CONST Me:TMemo; x,w:INTEGER);
BEGIN WITH Me DO
 BEGIN Left:=exs(x); Top:=2; Width:=exs(w); Height:=exs(360);
 Font.Style:=[fsBold]; Font.Size:=fntsize; Font.Pitch:=fpFixed;
 Font.Color:=clAqua; Brush.Color:=clBlack; Visible:=true; Clear;
 END;
END;
PROCEDURE Make_Rich(CONST Re:TRichEdit; x,w:INTEGER);
BEGIN WITH Re DO
 BEGIN Left:=exs(x); Top:=2; Width:=exs(w); Height:=exs(360);
 Font.Style:=[fsBold]; Font.Size:=fntsize; Font.Pitch:=fpFixed;
 Font.Color:=clLime; Brush.Color:=clBlack; Visible:=true; Clear;
 Color:=clBlack;
 END;
END;
PROCEDURE BuildRG(T:TRadioGroup; m,x,y,w,h:LONGINT);
VAR i,n:INTEGER;  {m = number of columns}
BEGIN n:=CB1rec.nitems; WITH T DO
 BEGIN Left:=exs(x); Top:=exs(y); Width:=exs(w); Height:=exs(h);
 Visible:=true; Items.Clear; FOR i:=1 TO n DO Items.Add(CB1rec.ar[i]);
 ItemIndex:=CB1rec.indx-1; Columns:=m; IF(m=0)THEN Columns:=1;
 Font.Size:=fntsize; Font.Pitch:=fpDefault; Font.Style:=[fsBold];
 END;
END;
PROCEDURE ClearCells(CONST SG1:TStringGrid; nr,nc:INTEGER);
VAR i,j:INTEGER;
BEGIN FOR i:=0 TO nc-1 DO FOR j:=0 TO nr-1 DO SG1.Cells[i,j]:=' ';
END;
PROCEDURE OuttoLabel(CONST L:TLabel; x,y,cl,clf:INTEGER;
                     CONST st:STRING);
BEGIN WITH L DO
 BEGIN Left:=exs(x); Top:=exs(y); Caption:=st; Visible:=true;
 Color:=cl; Font.Color:=clf; Font.Size:=fntsize; Font.Pitch:=fpDefault;
 Font.Style:=[fsBold];
 END;
END;
PROCEDURE MakeEdit(CONST T:TEdit; x,y,w:INTEGER; CONST s:STRING);
BEGIN WITH T DO
 BEGIN Left:=exs(x); Top:=exs(y); Width:=exs(w); Height:=exs(20);
 Text:=s; Visible:=true; Font.Size:=fntsize; Font.Pitch:=fpDefault;
 END;
END;
PROCEDURE MakeStringGrid(CONST SG1,SG2:TStringGrid;
                         x,t,nf,n,mm,ndig:LONGINT);
{nf=cell number to display; n=number of quantities;
 mm=number of columns; if negative FixedRows=1}
VAR i,j,k,i0,m,lh:INTEGER; s:STRING; r:REAL;
BEGIN k:=0; m:=ABS(mm); FOR i:=1 TO m DO k:=k+strgrW[i];
k:=k+2*m; IF(n>nf)THEN k:=k+23;
WITH SG2 DO
 BEGIN Left:=exs(x); Top:=exs(t);
 FixedRows:=0; ColCount:=2; FixedCols:=1; Width:=exs(strgrW[0]+2);
 ColWidths[0]:=exs(strgrW[0]);
 j:=(MIN0(n,nf)+FixedRows)*21+1; Height:=exs(j);
 RowCount:=n+FixedRows; lh:=exs(DefaultRowHeight);
 Font.Style:=[fsBold]; Font.Size:=fntsize; Font.Color:=clWhite;
 Color:=clMaroon; Visible:=true; BorderStyle:=bsNone;
 Font.Pitch:=fpDefault; FixedColor:=clMaroon;
 i0:=0; FOR i:=1 TO n DO Cells[0,i-1+i0]:=strgrT[i];
 FOR i:=0 TO n-1 DO RowHeights[i]:=lh;
 END;
WITH SG1 DO
 BEGIN Left:=exs(x+strgrW[0]+2);
 Top:=exs(t+1); IF(mm<0)THEN Top:=exs(t+21);
 Width:=exs(k); Height:=exs(j); ClearCells(SG1,n,m);
 FixedRows:=0; FixedCols:=0; RowCount:=n; ColCount:=m; Visible:=true;
 Color:=clBtnFace; Font.Color:=clBlack; BorderStyle:=bsNone;
 Font.Size:=fntsize; Font.Style:=[fsBold]; Font.Pitch:=fpDefault;
 Options:=Options+[goEditing];
 FOR i:=0 TO m-1 DO ColWidths[i]:=exs(strgrW[i+1]);
 FOR i:=0 TO n-1 DO RowHeights[i]:=lh;
 FOR i:=1 TO n DO FOR j:=0 TO m-1 DO
  BEGIN r:=strgrNn[i,j+1];
  IF(Trunc(r)=r)THEN ConvertStr(r,ndig,0) ELSE fltostr(r,ndig,sedz);
  IF(Pos('*',sedz)<>0)THEN ftos(r,12,7,sedz); Cells[j,i-1+i0]:=sedz;
  END;
 END;
END;
PROCEDURE SaveFileDial(CONST sd:TSaveDialog; VAR fn:STRING;
                       VAR ow:BOOLEAN);
BEGIN ModalRes:=1; ow:=true; WITH sd DO
 BEGIN Title:=L0rec; FileName:=''; IF(FileExists(fn))THEN FileName:=fn;
 IF(Execute)THEN fn:=FileName
            ELSE
  BEGIN ModalRes:=0; ow:=false; Exit;
  END;
 IF(FileExists(fn))THEN
  BEGIN IF(OWriteFile(fn))THEN ow:=true ELSE ow:=false;
  END;
 END;
END;
PROCEDURE OpenFileDial(CONST od:TOpenDialog; VAR fn,fe,fd,filt:STRING);
BEGIN ModalRes:=1; WITH od DO
 BEGIN Options:=Options-[ofAllowMultiSelect];
 IF(FileExists(fn))THEN FileName:=fn ELSE FileName:='';
 DefaultExt:=fe; InitialDir:=fd; Filter:=filt;
 IF(Execute)THEN fn:=FileName ELSE
  BEGIN ModalRes:=0; Exit;
  END;
 IF(NOT FileExists(fn))THEN
  BEGIN ShowMess('No file '+fn); ModalRes:=0;
  END;
 END;
END;

BEGIN
END.
